subroutine map_polar(line,comm,error)
  use gkernel_interfaces
  use image_def
  !---------------------------------------------------------------------
  ! TASK  
  !   Derive 
  !   1) Polarized fraction
  !   2) Polarization angle
  ! from I,Q,U (and V ?) polarization images
  !
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line, comm
  logical, intent(inout) :: error  
  !
  real, parameter :: pi=acos(-1.0)
  ! Local
  character(len=filename_length) :: stokes, fich
  integer :: n
  type(gildas) :: hi, hu, hq, hf, ha
  real :: seuil, threshold, pnoise, p2, pa
  integer :: ip, ix, iy
  !------------------------------------------------------------------------
  ! Code:
  call sic_ch(line,0,1,stokes,n,.true.,error)
  if (error) return
  threshold = 2.0
  call sic_r4(line,0,2,threshold,.false.,error)
  if (error) return
  !
  call gildas_null(hi)
  call gildas_null(hu)
  call gildas_null(hq)
  call gildas_null(hf)
  call gildas_null(ha)
  !
  fich = trim(stokes)//'-I'
  call sic_parse_file(fich,' ','.lmv-clean',hi%file)
  fich = trim(stokes)//'-U'
  call sic_parse_file(fich,' ','.lmv-clean',hu%file)
  fich = trim(stokes)//'-Q'
  call sic_parse_file(fich,' ','.lmv-clean',hq%file)
  !
  call gdf_read_header(hi,error)
  if (error) return
  call gdf_read_header(hu,error)
  if (error) return
  call gdf_read_header(hq,error)
  if (error) return
  if (hi%gil%ndim.ne.3) then
    call gdf_trim_header(hi,3,error)
    if (error) return
    call gdf_trim_header(hu,3,error)
    if (error) return
    call gdf_trim_header(hq,3,error)
    if (error) return
  endif
  !
  call gdf_copy_header(hi,hf,error)
  if (error) return
  call gdf_copy_header(hi,ha,error)
  if (error) return
  fich = trim(stokes)//'-P'
  call sic_parse_file(fich,' ','.lmv-clean',hf%file)
  fich = trim(stokes)//'-A'
  call sic_parse_file(fich,' ','.lmv-clean',ha%file)
  !
  call gdf_allocate(hi,error)
  if (error) return
  call gdf_allocate(hu,error)
  if (error) return
  call gdf_allocate(hq,error)
  if (error) return
  call gdf_allocate(hf,error)
  if (error) return
  call gdf_allocate(ha,error)
  if (error) return
  !
  call gdf_read_data(hi,hi%r3d,error)
  if (error) return
  call gdf_read_data(hu,hu%r3d,error)
  if (error) return
  call gdf_read_data(hq,hq%r3d,error)
  if (error) return
  !
  seuil = threshold*max(hi%gil%rms,hi%gil%noise)
  Print *,'Seuil ',seuil,' Noise ',max(hi%gil%rms,hi%gil%noise),' Threshold ',threshold
  !
  pnoise = sqrt(max(hu%gil%noise,hu%gil%rms) * max(hq%gil%noise,hq%gil%rms) )
  pnoise = (2.0*pnoise)**2
  !
  do ip=1,hi%gil%dim(3)
    do iy=1,hi%gil%dim(2)    
      do ix=1,hi%gil%dim(1)
        if (hi%r3d(ix,iy,ip).gt.seuil) then
          p2 = hu%r3d(ix,iy,ip)**2 + hq%r3d(ix,iy,ip)**2
          if (p2.lt.pnoise) then
            hf%r3d(ix,iy,ip) = 0
            ha%r3d(ix,iy,ip) = -2.*pi
          else
            ! Get the fractional polarization
            p2 = sqrt(p2-pnoise)          ! De-bias the polarized intensity
            hf%r3d(ix,iy,ip) = p2/hi%r3d(ix,iy,ip)  ! Go to fraction
            !
            ! Polarization angle is atan(U/Q)/2 in the [0,pi[ domain
            ! see Hull & Plambeck 2015, DOI:10.1142/S2251171715500051
            pa = atan2(hu%r3d(ix,iy,ip),hq%r3d(ix,iy,ip)) 
            if (pa.lt.0) pa = pa+2*pi
            ha%r3d(ix,iy,ip) = 0.5*pa 
          endif
        else
          hf%r3d(ix,iy,ip) = 0
          ha%r3d(ix,iy,ip) = -2.*pi
        endif
      enddo
    enddo
  enddo
  !
  hf%gil%bval = 0.
  hf%gil%eval = 0.
  call cube_minmax('FRACTION',hf,error)
  !
  ha%gil%bval = -2.*pi
  ha%gil%eval = 0.1*pi
  call cube_minmax('ANGLE',ha,error)
  !
  call gdf_write_image(hf,hf%r3d,error)
  if (error) return
  call gdf_write_image(ha,ha%r3d,error)
end subroutine map_polar

subroutine sub_major(method,hdirty,hresid,hclean,   &
     &    hbeam,hprim,hmask,dcct,mask,list,error,        &
     &    major_plot, next_flux)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>sub_major
  use clean_def
  use image_def
  use gbl_message
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING Clean/Mosaic
  !     Perfom a CLEAN based on all CLEAN algorithms,
  !     except the MRC (Multi Resolution CLEAN)
  !     which requires a different tool
  !     Works for mosaic also, except for the Multi Scale clean
  !     (not yet implemented for this one, but feasible...)
  !--------------------------------------------------------------
  external :: major_plot
  external :: next_flux
  !
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: hdirty
  type (gildas), intent(inout) :: hbeam
  type (gildas), intent(inout) :: hclean
  type (gildas), intent(inout) :: hresid
  type (gildas), intent(in) :: hprim
  type (gildas), intent(in) :: hmask
  real, intent(inout) :: dcct(:,:,:) ! (3,hclean%gil%dim(3),*)
  logical, intent(in), target :: mask(:,:)
  integer, intent(in), target :: list(:)
  logical, intent(inout) ::  error
  !
  character(len=*), parameter :: rname='SUB_MAJOR'
  character(len=64) :: mess
  integer :: ith
  logical :: parallel
  !
  ith = 1024
  parallel = .false.
  !$ parallel = .true.
#ifndef GAG_USE_STATICLINK
  !$ call sic_get_inte('OMP_SIZE',ith,error)
#endif
  error = .false.
  if (hdirty%gil%dim(1)*hdirty%gil%dim(2).gt.ith**2) then
    if (parallel) then
      mess = 'Using sequential code with Open-MP in-plane parallel mode'
    else
      mess = 'Using non-parallel mode'
    endif
    call map_message(seve%i,method%method,mess)
    call sub_major_lin(method,hdirty,hresid,hclean,   &
     &    hbeam,hprim,hmask,dcct,mask,list,error,        &
     &    major_plot, next_flux)
  else
    if (parallel) then
      mess = 'Using Open-MP parallel code'
    else
      mess = 'Using Open-MP capable code in Non-Parallel mode'
    endif
    call map_message(seve%i,method%method,mess)
    call sub_major_omp(method,hdirty,hresid,hclean,   &
     &    hbeam,hprim,hmask,dcct,mask,list,error,        &
     &    major_plot, next_flux)
  endif
end subroutine sub_major
!
subroutine sub_major_omp(inout_method,hdirty,hresid,hclean,   &
     &    hbeam,hprim,hmask,dcct,mask,list,error,        &
     &    major_plot, next_flux)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>sub_major_omp
  use clean_def
  use clean_default
  use clean_support
  use image_def
  use gbl_message
  !$ use omp_lib
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING Clean/Mosaic
  !     Perfom a CLEAN based on all CLEAN algorithms,
  !     except the MRC (Multi Resolution CLEAN)
  !     which requires a different tool
  !     Works for mosaic also, except for the Multi Scale clean
  !     (not yet implemented for this one, but feasible...)
  !--------------------------------------------------------------
  external :: major_plot
  external :: next_flux
  !
  type (clean_par), intent(inout) :: inout_method
  type (gildas), intent(in) :: hdirty
  type (gildas), intent(inout) :: hbeam
  type (gildas), intent(inout) :: hclean
  type (gildas), intent(inout) :: hresid
  type (gildas), intent(in) :: hprim
  type (gildas), intent(in) :: hmask
  real, intent(inout) :: dcct(:,:,:) ! (3,hclean%gil%dim(3),*)
  logical, intent(in), target :: mask(:,:)
  integer, intent(in), target :: list(:)
  logical, intent(inout) ::  error
  !
  real, pointer :: dirty(:,:)  ! Dirty map
  real, pointer :: resid(:,:)  ! Iterated residual
  real, pointer :: clean(:,:)  ! Clean Map
  real, pointer :: beam(:,:)   ! Beam
  real, pointer :: d3prim(:,:,:)    ! Primary beam
  real, pointer :: d3beam(:,:,:)    ! Dirty beam (per field)
  real, pointer :: weight(:,:) ! Mosaic weight
  !
  real, allocatable :: w_fft(:)    ! TF work area
  complex, allocatable :: w_work(:,:)  ! Work area
  type(cct_par), allocatable :: w_comp(:)
  real, allocatable :: w_cct(:,:)
  logical, allocatable :: s_mask(:,:)
  real, allocatable :: s_beam(:,:,:), t_beam(:,:), s_resi(:,:)
  real, allocatable :: tfbeam(:,:,:)
  integer, allocatable :: mymask(:,:)
  integer :: f_iter, m_iter
  !
  type (clean_par), save :: method
  real, target :: dummy_prim(1,1,1), dummy_weight(1,1)
  integer iplane
  integer nx,ny,np,nl,mx,my,nc
  integer ip, ier, ix, iy, lc, i, jcode
  real fhat, limit, flux
  logical do_fft
  character(len=message_length) :: chain
  character(len=16) :: cmethod
  character(len=48) :: cthread
  character(len=24) :: cname
  character(len=*), parameter :: rname = 'CLEAN'
  integer :: ibeam, ithread, mthread, nplane
  logical :: omp_nested
  ! Mask & List per thread
  integer :: nmask, j
  logical, allocatable, target :: masks(:,:,:)
  integer, allocatable, target :: lists(:,:)
  logical dotruc
  logical, pointer :: lmask(:,:)
  integer, pointer :: llist(:)
  integer :: iii
  !
  type (cct_par), allocatable :: tcc(:)
  real, save :: major,minor,angle
  !
  error = .false.
  !
  method = inout_method
  !
  cmethod = method%method
  do_fft = cmethod.ne.'HOGBOM'
  !
  ! Local variables
  nx = hclean%gil%dim(1)
  ny = hclean%gil%dim(2)
  mx = hbeam%gil%dim(1)
  my = hbeam%gil%dim(2)
  nl = method%nlist
  nc = nx*ny
  np = max(1,hprim%gil%dim(1))
  !
  ! TFBEAM cannot be on the Call sequence here because 
  ! it must be PRIVATE in parallel sections
  if (do_fft) then
    allocate(w_work(nx,ny),w_fft(2*max(nx,ny)),tfbeam(nx,ny,np),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Memory allocation error for TFBEAM')
      error = .true.
      return
    endif
  else
    allocate(w_work(1,1),w_fft(1),tfbeam(1,1,1),stat=ier)  
  endif
  if (ier.ne.0) then
    call map_message(seve%e,rname,'FFT Memory allocation failure')
    error = .true.
    return
  endif
  !
  ier = 0
  select case (cmethod)
  case ('CLARK')
    allocate(w_comp(nc),w_cct(1,1),mymask(1,1), &
    & s_mask(1,1),s_resi(1,1),t_beam(1,1), &
    & s_beam(1,1,3),stat=ier)
  case ('SDI')
    allocate(w_comp(nc),w_cct(nx,ny),mymask(nx,ny), &
    & s_mask(1,1),s_resi(1,1),t_beam(1,1), &
    & s_beam(1,1,3),stat=ier)
  case ('MULTI')
    allocate (w_comp(1),w_cct(nx,ny),mymask(nx,ny), &
      & s_mask(nx,ny),s_resi(nx,ny),t_beam(nx,ny), &
      & s_beam(nx,ny,3),stat=ier)
  case default
    allocate(w_comp(1), w_cct(1,1),mymask(1,1), &
    & s_mask(1,1),s_resi(1,1),t_beam(1,1), &
    & s_beam(1,1,3),stat=ier)
  end select
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Work Arrays Memory allocation failure')
    error = .true.
    return
  endif
  !
  ! Clean component work array
  allocate(tcc(method%m_iter),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation error for TCC')
    error = .true.
    return
  endif
  !
  !
  mthread = 1
  ithread = 1
  !$  mthread = omp_get_max_threads()
  nplane = method%last-method%first+1
  !$  omp_nested = omp_get_nested()
  if (nplane.eq.1) then
    !$  call omp_set_nested(.true.)
  else
    !$  call omp_set_nested(.false.)
  endif
  !
  ! Global aliases: SHARED here
  if (support_type.eq.support_mask) then    
    !
    ! Allocate the Masks and List per-thread
    nmask = min(hmask%gil%dim(3),nplane,mthread)
    if (nmask.gt.1) then
      allocate(masks(nx,ny,nmask),lists(nx*ny,nmask),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Mask & List memory allocation error')
        return
      endif
    endif
  else
    !
    ! Keep the global association
    nmask = 0
  endif
  !
  cname = method%method
  ! 
  ! I had parallel block crashing if there were more threads
  ! than DO loop index (it should not but I could not find why).
  ! Seems to have disappeared with newer version of gfortran and/or
  ! extended stack
  !
  ! However, the common code is executed MTHREAD times
  ! Only loops are executed NPLANE times in this case,
  ! so limiting the MTHREAD would be good - but then
  ! number of threads must be reset at end.
  ! 
  !$ !  if (nplane.lt.mthread) call omp_set_num_threads(nplane)
  !$ !  Print *,'Number of threads ',omp_get_num_threads()
  !
  !
  ! I need some CLEAN beam parameters
  if (omp_debug) Print *,'Getting SOME beam parameters '
  iplane = method%first
  ibeam = beam_for_channel(iplane,hdirty,hbeam)
  d3beam  => hbeam%r4d(:,:,:,ibeam)
  call get_clean (inout_method, hbeam, d3beam, error) !! TEST
  if (omp_debug) Print *,'Got SOME beam parameters '
  !
  ! Loop here if needed
  !$OMP PARALLEL IF (nplane.gt.1) DEFAULT(none) & !! IF (nplane.ge.mthread) &
  !$OMP & SHARED(hdirty,hclean,hbeam,hprim,hresid,hmask) & ! Headers
  !$OMP & SHARED(dummy_prim,dummy_weight,dcct) & ! Big arrays
  !$OMP & SHARED(fhat, nx,ny,mx,my,np,nc, omp_debug) &
  !$OMP & SHARED(inout_method)  & ! A modified structure
  !$OMP & SHARED(major,minor,angle,cmethod) &
  !$OMP & SHARED(nmask,masks,lists,mask,list) &
  !$OMP & PRIVATE(method, dotruc)  &  ! A modified structure
  !$OMP & PRIVATE(iplane, ibeam, error, nl, chain, cthread, cname) &
  !$OMP & PRIVATE(tfbeam,w_work,w_fft,w_comp,w_cct,tcc) &   ! Arrays
  !$OMP & PRIVATE(flux,f_iter,m_iter,limit,ithread,jcode) &
  !$OMP & PRIVATE(ix,iy,i,j) &  ! These were NOT diagnosed by the DEFAULT(none)
  !$OMP & PRIVATE(d3beam,d3prim) &
  !$OMP & PRIVATE(mymask,s_mask,s_beam,s_resi,t_beam)  & ! Arrays
  !$OMP & PRIVATE(dirty,resid,clean) PRIVATE(weight,llist,lmask)  ! Pointers
  !
  ! Global aliases: PRIVATE inside
  if (.not.method%mosaic) then
    weight => dummy_weight
  endif
  !
  ! Re-Define the method (in parallel mode, private entities are uninitialized)
  method = inout_method
  if (nmask.gt.1) then
    method%imask = 0 ! Mask is undefined at beginning if more than 1 plane
  endif
  !
  ithread = 1
  !$  ithread = omp_get_thread_num()+1
  !
  !$OMP DO SCHEDULE(STATIC,1) !! SCHEDULE(DYNAMIC,1)
  do iplane = inout_method%first, inout_method%last
    !
    method%iplane = iplane
    !
    call get_stopping(method%m_iter,method%ares,iplane)
    !$ write(cthread,'(A,I2)') ', Thread ',ithread
    !$ write(cname,'(A,A,I0,A)') trim(cmethod),'(',iplane,')' 
    !
    if (omp_debug) then
      !$OMP CRITICAL
      Print *,'Calling beam_plane '//cthread
      call mapping_print_debug(method)
      Print *,'Done beam_plane '//cthread
      !$OMP END CRITICAL
    endif
    !
    !THAT IS CRASHING ! call beam_plane(method,hbeam,hdirty)
    ibeam = beam_for_channel(iplane,hdirty,hbeam)
    method%ibeam = ibeam
    !
    ! Get the new mask
    if (nmask.gt.1) then
      lmask => masks(:,:,ithread)
      llist => lists(:,ithread)
    else
      lmask => mask
      llist => list
    endif
    !$ if (omp_debug) Print *,'Calling get_maskplane - OMP'
    call get_maskplane(method,hmask,hdirty,lmask,llist)    
    nl = method%nlist
    !$ if (omp_debug) Print *,'Thread ',ithread,' NL ',nl
    !
    ! Local aliases
    if (method%imask.ge.1) then
      write(chain,'(A,A,I0,A,I0,A,I0,1x,I0)') 'Planes: ', & 
          & '  Image ',method%iplane, & 
          & ', - Beam ', method%ibeam, & 
          & ', - Mask ', method%imask, nl
    else
      write(chain,'(A,A,I0,A,I0,A,I0)') 'Planes: ', & 
          & '  Image ',method%iplane, & 
          & ', - Beam ', method%ibeam
    endif
    !$ chain = trim(chain)//cthread
    call map_message(seve%i,cname,chain)
    !
    ! Local aliases
    dirty => hdirty%r3d(:,:,iplane)
    resid => hresid%r3d(:,:,iplane)
    clean => hclean%r3d(:,:,iplane)
    !
    ! Initialize to Dirty map
    resid = dirty
    !
    d3beam  => hbeam%r4d(:,:,:,ibeam)
    if (method%mosaic) then
      d3prim => hprim%r4d(:,:,:,ibeam)
    else
      d3prim => dummy_prim
    endif
    !
    if (method%pcycle) call init_plot (method,hdirty,resid)
    !
    ! Prepare beam parameters - subroutine is not Thread safe though...
    !$OMP CRITICAL
    !$ if (omp_debug) Print *,'Critical get_clean '//cthread
    error = .false.
    call get_clean (method, hbeam, d3beam, error)
    !$ if (omp_debug) Print *,'end Critical get_clean '//cthread
    !$OMP END CRITICAL
    if (error) then
      !return !Oops, cannot do that in a DO parallel...
      cycle
    endif
    !$ if (omp_debug) Print *,'start get_beam '//cthread
    call get_beam (method,hbeam,hresid,hprim,   &
        &        tfbeam,w_work,w_fft,fhat,error, lmask)
    !$ if (omp_debug) Print *,'end get_beam '//cthread
    ! Empty beam case
    if (error) then
      error = .false.
      clean = resid
      !return !Oops, cannot do that in a DO parallel...
      cycle
    endif
    !
    ! Mosaic case
    if (method%mosaic) then
      !$ if (omp_debug) Print *,'Setting weight for ',method%ibeam
      ! Reset search list as the mask may have been altered
      call lmask_to_list (lmask,nx*ny,llist,method%nlist)
      nl = method%nlist
      weight => method%weight(:,:,method%ibeam)
      !$ if (omp_debug) Print *,'Done weight for ',method%ibeam
      resid = resid * weight
    endif
    !
    ! Performs decomposition into components only
    ! if NL # 0 
    if (nl.ne.0) then
      !$ if (omp_debug) Print *,'Select case '//cmethod//cthread
      select case (cmethod)
      case('HOGBOM')
        call hogbom_cycle90 (cname,method%pflux,   &   ! Plot flux
           &        d3beam,mx,my,   & ! Beam and size
           &        resid,nx,ny,   & ! Residual and size
           &        method%beam0(1),method%beam0(2),   & ! Beam center
           &        method%box, method%fres, method%ares,   &
           &        method%m_iter, method%p_iter, method%n_iter,   &
           &        method%gain, method%keep,   &    !
           &        tcc,   &         ! Component Structure
           &        lmask,   & ! Search mask
           &        llist,   & ! Search list
           &        nl,   &          ! and its size
           &        np,   &          ! Number of fields
           &        d3prim,   &      ! Primary beams
           &        weight,   &      ! Weight
           &        method%trunca, flux, jcode, next_flux)
      case('CLARK')
        !
        ! Find components
        call major_cycle90 (cname,method,hclean,   &   !
             &        clean,   &       ! Final CLEAN image
             &        d3beam,  &       ! Dirty beams
             &        resid,nx,ny,   & ! Residual and size
             &        tfbeam, w_work,   &  ! FT of dirty beam + Work area
             &        w_comp, nc,       &  ! Component storage + Size
             &        method%beam0(1),method%beam0(2),   & ! Beam center
             &        method%patch(1), method%patch(2), method%bgain,   &
             &        method%box,   &
             &        w_fft,   &       ! Work space for FFTs
             &        tcc,   &         ! Component table
             &        llist, nl,   &   ! Search list (truncated...)
             &        np,                & ! Number of fields
             &        d3prim,            & ! Primary beams
             &        weight,            & ! Weight
             &        major_plot,        & ! Plotting routine
             &        next_flux)
      case('SDI')
        !
        ! Find components
        call major_sdi90 (cname,method,hclean,   &
             &        clean,   &       ! Final CLEAN image
             &        d3beam,  &       ! Dirty beams
             &        resid,nx,ny,   & ! Residual and size
             &        tfbeam, w_work,   &  ! FT of dirty beam + Work area
             &        w_comp, nc,       &  ! Component storage + Size
             &        method%beam0(1),method%beam0(2),   & ! Beam center
             &        method%patch(1), method%patch(2), method%bgain,   &
             &        method%box,   &
             &        w_fft,   &       ! Work space for FFTs
             &        w_cct,   &       ! Clean Component Image
             &        llist, nl,   &   ! Search list (truncated...)
             &        np,                & ! Number of fields
             &        d3prim,            & ! Primary beams
             &        weight,            & ! Weight
             &        major_plot)          ! Plotting routine
      case('MULTI')
        !
        ! Performs decomposition into components
        call amaxmask (resid,lmask,nx,ny,ix,iy)
        limit = max(method%ares,method%fres*abs(resid(ix,iy)))
        call map_message(seve%i,cname,chain)
        if (limit.eq.method%ares) then
          write (chain,'(A,1PG10.3,A)')  'Cleaning down to ',limit,' from ARES'
        else
          write (chain,'(A,1PG10.3,A,I7,I7)')  'Cleaning down to ',limit,' from FRES at ',ix,iy
        endif
        call map_message(seve%i,cname,chain)
        !
        call major_multi90 (cname,method,hclean,   &
             &        hdirty%r3d(:,:,iplane),   &
             &        hresid%r3d(:,:,iplane),   &
             &        hbeam%r4d(:,:,:,method%ibeam),                  &
             &        lmask,           & ! Check definition of this mask...
             &        hclean%r3d(:,:,iplane),   &
             &        nx,ny,                    &
             &        tcc,   &         ! Clean component
             &        method%m_iter,   &   ! Maximum number of components
             &        limit,   &       ! Residual
             &        method%n_iter,   &   ! Number of components
             &        s_mask,   &      ! Smoothed mask
             &        s_resi,   &      ! Smoothed residual,
             &        t_beam,   &      ! Translated beam
             &        w_work,   &      ! Complex work space
             &        s_beam,   &      ! Smoothed beams
             &        tfbeam,   &      ! Beam Fourier Transform (real)
             &        w_fft)
      ! Need to add
      !             &        np,   &          ! Number of fields
      !             &        d3prim,   &      ! Primary beams
      !             &        weight)          ! Weight
        w_cct(:,:) = clean
      end select
      !$ if (omp_debug) Print *,'End Select case '//cmethod//cthread
    else
      ! Empty search area: No Clean components...
      method%n_iter = 0
      flux = 0.0
    endif
    !
    ! Add clean components and residuals to produce clean map
    if (method%n_iter.ne.0) then
      !$ if (omp_debug) Print *,'Critical clean_make '//cthread
      call clean_make90 (method, hclean, clean, tcc)
      !$ if (omp_debug) Print *,'End clean_make '//cthread
      if (np.le.1) then
        clean = clean + resid
      else
        clean = clean + resid*weight
        where (weight.eq.0) clean = hclean%gil%bval ! Undefined pixel there
      endif
    else
      if (np.le.1) then
        clean = resid
      else
        clean = resid*weight
        where (weight.eq.0) clean = hclean%gil%bval ! Undefined pixel there
      endif
    endif
    !$ if (omp_debug) Print *,'Finishing '//cthread
    !
    ! Put the TCC structure into its final place
    if (cmethod.eq.'MULTI' .or. cmethod.eq.'SDI') then
      if (method%n_iter.eq.0) then
        dcct(3,iplane,1) = 0
        write (chain,'(A,1PG10.3,A,I6,A,A,I6)')  'Cleaned ',0.0,   &
            &        ' Jy with ',method%n_iter,' components ' &
            &       ,' Plane ',iplane
      else
        if (cmethod.eq.'MULTI') then
          m_iter = method%ninflate*method%m_iter
        else
          m_iter = method%m_iter
        endif
        where (w_cct.ne.0)
          mymask = 1
        elsewhere
          mymask = 0
        end where
        f_iter = sum(mymask)
        if (f_iter.gt.m_iter) then
          write(chain,'(A,I8,A,I8)') 'Iterations overflow ',f_iter, &
              &  ' > ',m_iter
          call map_message(seve%w,cname,chain)
          dcct(3,iplane,1) = 0
          chain = 'UV_RESTORE will not work, consider increasing INFLATE'
        else
          i = 0
          flux = 0
          do iy=1,ny
            do ix=1,nx
              if (w_cct(ix,iy).ne.0) then
                i = i+1
                dcct(1,iplane,i) = (dble(ix) -   &
                 & hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
                 & hclean%gil%convert(2,1)
                dcct(2,iplane,i) = (dble(iy) -   &
                 & hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
                 & hclean%gil%convert(2,2)
                dcct(3,iplane,i) = w_cct(ix,iy)
                flux = flux+w_cct(ix,iy)
              endif
            enddo
          enddo
          method%n_iter = i
          write (chain,'(A,1PG10.3,A,I6,A,A,I6)')  'Cleaned ',flux,   &
              &        ' Jy with ',method%n_iter,' components ' &
              &       ,' Plane ',iplane
        endif
      endif
      !$ chain = trim(chain)//cthread
      call map_message(seve%i,cname,chain)
    else if (cmethod.ne.'MRC') then
      do i=1,method%n_iter
        dcct(1,iplane,i) = (dble(tcc(i)%ix) -   &
            & hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
            & hclean%gil%convert(2,1)
        dcct(2,iplane,i) = (dble(tcc(i)%iy) -   &
            & hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
            & hclean%gil%convert(2,2)
        dcct(3,iplane,i) = tcc(i)%value
      enddo
      if (method%n_iter.lt.method%m_iter) then
        dcct(3,iplane,method%n_iter+1) = 0
      endif
      if (cmethod.eq.'HOGBOM') then
        write (chain,'(A,1PG10.3,A,I6,A,A,I6)')  'Cleaned ',flux,   &
          &        ' Jy with ',method%n_iter,' components ' &
          &       ,' Plane ',iplane
        !$ chain = trim(chain)//cthread
        call map_message(seve%i,cname,chain)
      endif
      !
    endif
    !$ if (omp_debug) Print *,'End loop '//cthread
  enddo
  !$OMP END DO
  ! There is no OMP FIRST_AND_LASTPRIVATE
  !$OMP MASTER
  major = method%major
  minor = method%minor
  angle = method%angle
  !$OMP END MASTER
  !!Print *,'Major ',major,minor,angle
  !$OMP END PARALLEL
  inout_method%major = major
  inout_method%minor = minor
  inout_method%angle = angle
  !$  call omp_set_nested(omp_nested)
  !$  if (nplane.lt.mthread) call omp_set_num_threads(mthread)
  !
  if (allocated(masks)) then
    deallocate(masks,lists)
  endif
  !
  ! PHAT
  !!Print *,'sub_major PHAT ',method%phat
  ! This logic is only valid for One beam for all...
  if (method%phat.ne.0) then
    fhat = 1.0/fhat
    if (method%mosaic) then
      d3beam = d3beam*fhat
      do ip=1,np
        d3beam(method%beam0(1),method%beam0(2),ip) =   &
            &          d3beam(method%beam0(1),method%beam0(2),ip) -   &
            &          method%phat
      enddo
    else
      d3beam = d3beam*fhat
    endif
  endif
  !
  ! Set the blanking value for Mosaics
  if (method%mosaic) then
    hclean%gil%eval = 0
  endif
  !
  ! Clean work space: in principle, Fortran 95 does it for you
  deallocate(w_comp,w_cct,mymask, &
    &  s_mask,s_resi,t_beam,s_beam, &
    &  w_work,w_fft, stat=ier)
  !
end subroutine sub_major_omp
!
!
subroutine sub_major_lin(method,hdirty,hresid,hclean,   &
     &    hbeam,hprim,hmask,dcct,mask,list,error,        &
     &    major_plot, next_flux)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>sub_major_lin
  use clean_def
  use image_def
  use gbl_message
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING Clean/Mosaic
  !     Perfom a CLEAN based on all CLEAN algorithms,
  !     except the MRC (Multi Resolution CLEAN)
  !     which requires a different tool
  !     Works for mosaic also, except for the Multi Scale clean
  !     (not yet implemented for this one, but feasible...)
  !--------------------------------------------------------------
  external :: major_plot
  external :: next_flux
  !
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: hdirty
  type (gildas), intent(inout) :: hbeam
  type (gildas), intent(inout) :: hclean
  type (gildas), intent(inout) :: hresid
  type (gildas), intent(in) :: hprim
  type (gildas), intent(in) :: hmask
  real, intent(inout) :: dcct(:,:,:) ! (3,hclean%gil%dim(3),*)
  logical, intent(in), target :: mask(:,:)
  integer, intent(in), target :: list(:)
  logical, intent(inout) ::  error
  !
  real, pointer :: dirty(:,:)  ! Dirty map
  real, pointer :: resid(:,:)  ! Iterated residual
  real, pointer :: clean(:,:)  ! Clean Map
  real, pointer :: d3prim(:,:,:)   ! Primary beam (for one frequency)
  real, pointer :: d3beam(:,:,:)   ! Dirty beam (for one frequency)
  real, pointer :: weight(:,:)     ! Mosaic weight
  !
  real, allocatable :: tfbeam(:,:,:)
  real, allocatable :: w_fft(:)    ! TF work area
  complex, allocatable :: w_work(:,:)  ! Work area
  type(cct_par), allocatable :: w_comp(:)
  real, allocatable :: w_cct(:,:)
  logical, allocatable :: s_mask(:,:)
  real, allocatable :: s_beam(:,:,:), t_beam(:,:), s_resi(:,:)
  integer, allocatable :: mymask(:,:)
  integer :: f_iter, m_iter
  !
  real, target :: dummy_prim(1,1,1), dummy_weight(1,1)
  integer iplane
  integer nx,ny,np,nl,mx,my,nc
  integer ip, ier, ix, iy, lc, i, jcode
  real fhat, limit, flux
  logical do_fft
  character(len=message_length) :: chain
  character(len=12) :: cname 
  integer :: nplane
  !
  type (cct_par), allocatable :: tcc(:)
  real, save :: major,minor,angle
  !
  integer, pointer :: llist(:)
  logical, pointer :: lmask(:,:)
  !
  error = .false.
  do_fft = method%method.ne.'HOGBOM'
  cname = method%method
  !
  llist => list
  lmask => mask
  !
  ! Local variables
  nx = hclean%gil%dim(1)
  ny = hclean%gil%dim(2)
  mx = hbeam%gil%dim(1)
  my = hbeam%gil%dim(2)
  nl = method%nlist
  nc = nx*ny
  np = max(1,hprim%gil%dim(1)) ! or ! np = hbeam%gil%dim(3)
  !
  if (do_fft) then
    allocate(w_work(nx,ny),w_fft(2*max(nx,ny)),tfbeam(nx,ny,np),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,cname,'Memory allocation error for TFBEAM')
      error = .true.
      return
    endif
  else
    allocate(w_work(1,1),w_fft(1),tfbeam(1,1,1),stat=ier)  
  endif
  if (ier.ne.0) then
    call map_message(seve%e,cname,'FFT Memory allocation failure')
    error = .true.
    return
  endif
  !
  if (method%method.eq.'CLARK') then
    allocate(w_comp(nc), &
    & w_cct(1,1),mymask(1,1),s_mask(1,1),s_resi(1,1),t_beam(1,1), &
    & s_beam(1,1,3),stat=ier)
  elseif  (method%method.eq.'SDI') then
    allocate(w_comp(nc),w_cct(nx,ny),mymask(nx,ny), &
    & s_mask(1,1),s_resi(1,1),t_beam(1,1), &
    & s_beam(1,1,3),stat=ier)
  elseif  (method%method.eq.'MULTI') then
    allocate (s_mask(nx,ny),s_resi(nx,ny),t_beam(nx,ny), &
      & s_beam(nx,ny,3),w_cct(nx,ny),mymask(nx,ny), &
      & w_comp(1), stat=ier)
  else
    allocate(w_comp(1), &
    & w_cct(1,1),mymask(1,1),s_mask(1,1),s_resi(1,1),t_beam(1,1), &
    & s_beam(1,1,3),stat=ier)
  endif
  if (ier.ne.0) then
    call map_message(seve%e,cname,'Work Arrays Memory allocation failure')
    error = .true.
    return
  endif
  !
  ! Clean component work array
  allocate(tcc(method%m_iter),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,cname,'Memory allocation error for TCC')
    error = .true.
    return
  endif
  !
  nplane = method%last-method%first+1
  !
  ! Global aliases
  if (method%mosaic) then
    d3prim => dummy_prim
  else
    d3prim => dummy_prim
    weight => dummy_weight
  endif
  !
  cname = method%method
  !
  do iplane = method%first, method%last
    !
    method%iplane = iplane
    call beam_plane(method,hbeam,hdirty)
    ! Get the new mask (if any...)
    call get_maskplane(method,hmask,hdirty,lmask,llist)    
    nl = method%nlist
    !
    ! Local aliases
    if (method%imask.ge.1) then
      write(chain,'(A,I6,I6,I6,A,I2)') 'Image, Beam & Mask planes ',   &
          &      method%iplane,method%ibeam,method%imask
    else
      write(chain,'(A,I6,I6,A,I2)') 'Image & Beam planes ',   &
          &      method%iplane,method%ibeam
    endif
    call map_message(seve%i,cname,chain)
    dirty => hdirty%r3d(:,:,iplane)
    resid => hresid%r3d(:,:,iplane)
    clean => hclean%r3d(:,:,iplane)
    d3beam => hbeam%r4d(:,:,:,method%ibeam)
    if (method%mosaic) d3prim => hprim%r4d(:,:,:,method%ibeam)
    !
    ! Initialize to Dirty map
    resid = dirty
    if (method%pcycle) call init_plot (method,hdirty,resid)
    !
    ! Prepare beam parameters - subroutine is not Thread safe though...
    call get_clean (method, hbeam, d3beam, error)
    if (error) then
      !return !Oops, cannot do that in a DO parallel...
      cycle
    endif
    call get_beam (method,hbeam,hresid,hprim,   &
        &        tfbeam,w_work,w_fft,fhat,error, lmask)
    ! Empty beam case
    if (error) then
      error = .false.
      clean = resid
      !return !Oops, cannot do that in a DO parallel...
      cycle
    endif
    !
    ! Mosaic case
    if (method%mosaic) then
      ! Reset search list as the mask may have been altered
      call lmask_to_list (lmask,nx*ny,llist,method%nlist)
      weight=> method%weight(:,:,method%ibeam)
      resid = resid * weight
    endif
    !
    !
    ! Performs decomposition into components
    select case (method%method)
    case('HOGBOM')
      call hogbom_cycle90 (cname,method%pflux,   &   ! Plot flux
           &        d3beam,mx,my,   & ! Beam and size
           &        resid,nx,ny,   & ! Residual and size
           &        method%beam0(1),method%beam0(2),   & ! Beam center
           &        method%box, method%fres, method%ares,   &
           &        method%m_iter,  method%p_iter, method%n_iter,   &
           &        method%gain, method%keep,   &    !
           &        tcc,   &         ! Component Structure
           &        lmask,   & ! Search mask
           &        llist,   & ! Search list
           &        nl,   &          ! and its size
           &        np,   &          ! Number of fields
           &        d3prim,   &       ! Primary beams
           &        weight,   &      ! Weight
           &        method%trunca, flux, jcode, next_flux)
    case('CLARK')
      !
      ! Find components
      call major_cycle90 (cname,method,hclean,   &   !
           &        clean,   &       ! Final CLEAN image
           &        d3beam,   &       ! Dirty beams
           &        resid,nx,ny,   & ! Residual and size
           &        tfbeam, w_work,   &  ! FT of dirty beam + Work area
           &        w_comp, nc,       &  ! Component storage + Size
           &        method%beam0(1),method%beam0(2),   & ! Beam center
           &        method%patch(1), method%patch(2), method%bgain,   &
           &        method%box,   &
           &        w_fft,   &       ! Work space for FFTs
           &        tcc,   &         ! Component table
           &        llist, nl,   &   ! Search list (truncated...)
           &        np,                & ! Number of fields
           &        d3prim,            & ! Primary beams
           &        weight,            & ! Weight
           &        major_plot,        & ! Plotting routine
           &        next_flux)
    case('SDI')
      !
      ! Find components
      call major_sdi90 (cname,method,hclean,   &
           &        clean,   &       ! Final CLEAN image
           &        d3beam(:,:,method%ibeam),   & ! Dirty beams
           &        resid,nx,ny,   & ! Residual and size
           &        tfbeam, w_work,   &  ! FT of dirty beam + Work area
           &        w_comp, nc,       &  ! Component storage + Size
           &        method%beam0(1),method%beam0(2),   & ! Beam center
           &        method%patch(1), method%patch(2), method%bgain,   &
           &        method%box,   &
           &        w_fft,   &       ! Work space for FFTs
           &        w_cct,   &       ! Clean Component Image
           &        llist, nl,   &   ! Search list (truncated...)
           &        np,                & ! Number of fields
           &        d3prim,            & ! Primary beams
           &        weight,            & ! Weight
           &        major_plot)          ! Plotting routine
    case('MULTI')
      !
      ! Performs decomposition into components
      call amaxmask (resid,lmask,nx,ny,ix,iy)
      limit = max(method%ares,method%fres*abs(resid(ix,iy)))
      call map_message(seve%i,method%method,chain)
      if (limit.eq.method%ares) then
        write (chain,'(A,1PG10.3,A)')  'Cleaning down to ',limit,' from ARES'
      else
        write (chain,'(A,1PG10.3,A,I7,I7)')  'Cleaning down to ',limit,' from FRES at ',ix,iy
      endif
      call map_message(seve%i,cname,chain)
      !
      call major_multi90 (cname,method,hclean,   &
           &        hdirty%r3d(:,:,iplane),   &
           &        hresid%r3d(:,:,iplane),   &
           &        hbeam%r4d(:,:,:,method%ibeam),                  &
           &        lmask,              & ! Check definition of this mask...
           &        hclean%r3d(:,:,iplane),   &
           &        nx,ny,                    &
           &        tcc,   &         ! Clean component
           &        method%m_iter,   &   ! Maximum number of components
           &        limit,   &       ! Residual
           &        method%n_iter,   &   ! Number of components
           &        s_mask,   &      ! Smoothed mask
           &        s_resi,   &      ! Smoothed residual,
           &        t_beam,   &      ! Translated beam
           &        w_work,   &      ! Complex work space
           &        s_beam,   &      ! Smoothed beams
           &        tfbeam,   &      ! Beam Fourier Transform (real)
           &        w_fft)
    ! Need to add
    !             &        np,   &          ! Number of fields
    !             &        d3prim,   &      ! Primary beams
    !             &        weight)          ! Weight
      w_cct(:,:) = clean
    end select
    !
    ! Add clean components and residuals to produce clean map
    if (method%n_iter.ne.0) then
      call clean_make90 (method, hclean, clean, tcc)
      if (np.le.1) then
        clean = clean + resid
      else
        clean = clean + resid*weight
        where (weight.eq.0) clean = hclean%gil%bval ! Undefined pixel there
      endif
    else
      if (np.le.1) then
        clean = resid
      else
        clean = resid*weight
      endif
    endif
    !
    ! Put the TCC structure into its final place
    if (method%method.eq.'MULTI' .or. method%method.eq.'SDI') then
      if (method%method.eq.'MULTI') then
        m_iter = method%ninflate*method%m_iter
      else
        m_iter = method%m_iter
      endif
      where (w_cct.ne.0)
        mymask = 1
      elsewhere
        mymask = 0
      end where
      f_iter = sum(mymask)
      if (f_iter.gt.m_iter) then
        write(chain,'(A,I8,A,I8)') 'Iterations overflow ',f_iter, &
            &  ' > ',m_iter
        call map_message(seve%w,cname,chain)
        dcct(3,iplane,1) = 0
        chain = 'UV_RESTORE will not work, consider increasing INFLATE'
        call map_message(seve%i,cname,chain)
      else
        i = 0
        flux = 0
        do iy=1,ny
          do ix=1,nx
            if (w_cct(ix,iy).ne.0) then
              i = i+1
              dcct(1,iplane,i) = (dble(ix) -   &
               & hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
               & hclean%gil%convert(2,1)
              dcct(2,iplane,i) = (dble(iy) -   &
               & hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
               & hclean%gil%convert(2,2)
              dcct(3,iplane,i) = w_cct(ix,iy)
              flux = flux+w_cct(ix,iy)
            endif
          enddo
        enddo
        method%n_iter = i
        write (chain,'(A,1PG10.3,A,I6,A,A,I6,A,I2)')  'Cleaned ',flux,   &
            &        ' Jy with ',method%n_iter,' components ' &
            &       ,' Plane ',iplane
        call map_message(seve%i,cname,chain)
      endif
    else if (method%method.ne.'MRC') then
      do i=1,method%n_iter
        dcct(1,iplane,i) = (dble(tcc(i)%ix) -   &
            & hclean%gil%convert(1,1)) * hclean%gil%convert(3,1) + &
            & hclean%gil%convert(2,1)
        dcct(2,iplane,i) = (dble(tcc(i)%iy) -   &
            & hclean%gil%convert(1,2)) * hclean%gil%convert(3,2) + &
            & hclean%gil%convert(2,2)
        dcct(3,iplane,i) = tcc(i)%value
      enddo
      if (method%n_iter.lt.method%m_iter) then
        dcct(3,iplane,method%n_iter+1) = 0
      endif
      if (method%method.eq.'HOGBOM') then
        write (chain,'(A,1PG10.3,A,I6,A,A,I6,A,I2)')  'Cleaned ',flux,   &
          &        ' Jy with ',method%n_iter,' components ' &
          &       ,' Plane ',iplane
        call map_message(seve%i,cname,chain)
      endif
      !
    endif
  enddo
  !
  ! PHAT
  if (method%phat.ne.0) then
    fhat = 1.0/fhat
    if (method%mosaic) then
      d3beam = d3beam*fhat
      do ip=1,np
        d3beam(method%beam0(1),method%beam0(2),ip) =   &
            &          d3beam(method%beam0(1),method%beam0(2),ip) -   &
            &          method%phat
      enddo
    else
      d3beam = d3beam*fhat
    endif
  endif
  !
  ! Set the blanking value for Mosaics
  if (method%mosaic) then
    hclean%gil%eval = 0
  endif
  !
  ! Clean work space: in principle, Fortran 95 does it for you
  if (method%method.eq.'CLARK') then
    deallocate(w_comp,stat=ier)
  elseif  (method%method.eq.'SDI') then
    deallocate(w_comp,w_cct,mymask)
  elseif  (method%method.eq.'MULTI') then
    deallocate (s_mask,s_resi,t_beam,s_beam,w_cct,mymask)
  endif
  if (do_fft) then
    deallocate(w_work,w_fft)
  endif
  !
end subroutine sub_major_lin
!
!
subroutine get_beam(method,hbeam,hresid,hprim,  &
     &    tfbeam,w_work,w_fft,fhat,error, mask)
  use gkernel_interfaces
  use mapping_interfaces, except_this => get_beam
  use clean_def
  use image_def
  use gbl_message
  !-----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !    Get beam related information
  !-----------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in)  :: hbeam
  type (gildas), intent(in)  :: hresid
  type (gildas), intent(in)  :: hprim
  real, intent(inout) :: tfbeam(hbeam%gil%dim(1),hbeam%gil%dim(2),hbeam%gil%dim(3))
  complex, intent(inout) :: w_work(hbeam%gil%dim(1),hbeam%gil%dim(2))
  real, intent(inout) :: fhat,w_fft(:)
  logical, intent(inout) :: error
  logical, optional, intent(inout) :: mask(:,:)
  !
  ! Note that HRESID is unused here...
  integer ip,ib,nx,ny,np,nb
  real beam_min,beam_max,beam_area,f
  integer ix_min,ix_max,iy_min,iy_max
  logical do_fft
  character(len=message_length) :: chain
  character(len=*), parameter :: rname = 'CLEAN'
  real, pointer :: d2beam(:,:)      ! Beam (single field & frequency)
  real, pointer :: d3prim(:,:,:)    ! Primary beams (per frequency)
  real, pointer :: d3beam(:,:,:)    ! Dirty beam (per frequency)
  real, pointer :: weight(:,:,:)
  !
  nx = hbeam%gil%dim(1)
  ny = hbeam%gil%dim(2)
  np = hbeam%gil%dim(3)
  nb = hbeam%gil%dim(4)
  !
  weight=> method%weight
  do_fft = method%method.ne.'HOGBOM'   &
       &    .and. method%method.ne.'MX'
  !
  if (method%mosaic) then
    if (.not.present(mask)) then
      call map_message(seve%f,rname,'Programming error: Missing MASK argument with MOSAIC mode')
      error = .true.
      return
    endif
    !
    d3beam => hbeam%r4d(:,:,:,method%ibeam)
    !
    np = hprim%gil%dim(1)
    !
    ! Analyze beam
    do ip = 1,np
      if (method%verbose) then
        write(chain,101) 'Field ',ip,'/',np
        call map_message(seve%i,rname,chain)
      endif
      call maxmap(d3beam(:,:,ip),nx,ny,method%bzone,   &
           &        beam_max,ix_max,iy_max,beam_min,ix_min,iy_min)
      if (method%verbose) then
        write(chain,'(A,1PG10.3,A,I6,I6,A,1PG10.3,A,I6,I6)') &
          &   'Beam max. ',beam_max,' at ',ix_max,iy_max,  &
          &   ', Min. ',beam_min,' at ',ix_min,iy_min
        call map_message(seve%i,rname,chain)
      endif
      if (do_fft) then
        call init_convolve (ix_max,iy_max,nx,ny,   &
            &          d3beam(:,:,ip),w_work,beam_area,w_fft)
        tfbeam(:,:,ip) = real(w_work)
        if (method%verbose) then
          write(chain,102) 'Beam area is ',beam_area
          call map_message(seve%i,rname,chain)
        endif
      endif
      !
      ! Prussian Hat - NOT SUPPORTED HERE
    enddo
    !
    if (method%method.ne.'HOGBOM') then
      call mos_sidelobe (d3beam(:,:,1),nx,ny,ix_max,iy_max,   &
           &        method%patch(1),method%patch(2),method%bgain,np)
      write(chain,102) 'Sidelobe is ',method%bgain
      call map_message(seve%i,rname,chain)
    endif
    !
    ! Define the weight function and truncate the mask
    do ib=1,nb
      d3prim => hprim%r4d(:,:,:,ib)
      call set_weight(nx,ny,np,weight(:,:,ib),d3prim,mask,   &
          &      method%search,method%restor,method%trunca)
    enddo
    !
    !
  else
    d2beam  => hbeam%r4d(:,:,1,method%ibeam)
    if (method%verbose) then
      Print *,'Beam center ',hbeam%r4d(nx/2+1,ny/2+1,1,method%ibeam)
    endif
    !
    ! Simple case
    call maxmap(d2beam,nx,ny,method%bzone,   &
        &      beam_max,ix_max,iy_max,   &
        &      beam_min,ix_min,iy_min)
    if (method%verbose) then
      write(chain,'(A,1PG10.3,A,I6,I6,A,1PG10.3,A,I6,I6)') &
        &   'Beam max. ',beam_max,' at ',ix_max,iy_max,  &
        &   ', Min. ',beam_min,' at ',ix_min,iy_min
      call map_message(seve%i,rname,chain)
    endif
    if (beam_max.eq.0.0) then
      call map_message(seve%w,rname,'Beam is empty')
      error = .true.
      return
    endif
    call comshi (d2beam,nx,ny,ix_max,iy_max,method%bshift)
    if (do_fft) then
      call init_convolve (ix_max,iy_max,nx,ny,   &
           &        d2beam,w_work,beam_area,w_fft)
      tfbeam(:,:,1)  = real(w_work)
      if (method%verbose) then
         write(chain,102) 'Beam area is ',beam_area
         call map_message(seve%i,rname,chain)
      endif
    endif
    !
    ! Prussian Hat
    if (method%phat.ne.0) then
      d2beam(ix_max,iy_max) = d2beam(ix_max,iy_max)   &
           &         + method%phat
      f = 1.0/d2beam(ix_max,iy_max)
      d2beam(:,:) = d2beam*f
    else
      f = 1.0
    endif
    !
    if (method%method.ne.'HOGBOM') then
      call find_sidelobe (d2beam,nx,ny,ix_max,iy_max,   &
           &        method%patch(1),method%patch(2),method%bgain)
      write(chain,102) 'Sidelobe is ',method%bgain
      call map_message(seve%i,rname,chain)
    endif
  endif
  method%beam0 = (/ix_max,iy_max/)
  if (method%phat.ne.0) fhat = f
  error = .false.
  return
  !
101 format(a,i3,a,i3)
102 format(a,1pg10.3,a,i6,i6)
end subroutine get_beam
!
subroutine get_stopping(miter,ares,iplane)
  use clean_arrays
  !
  integer, intent(inout) :: miter
  real, intent(inout) :: ares
  integer, intent(in) :: iplane
  !
  if (iplane.ge.1 .and. iplane.le.niter_listsize) then
    miter = niter_list(iplane)
  endif
  if (iplane.ge.1 .and. iplane.le.ares_listsize) then
    ares = ares_list(iplane)
  endif
end subroutine get_stopping

module last_flux
  real(8) :: iter_counter
  real(8) :: cumulative_flux
  character(len=12) :: last_operation
  integer :: old_clean_type
  !
  integer :: iter_size=0  ! Size of arrays
  integer :: iter_curr=0  ! Current iteration #
  real(4) :: iter_limit, flux_limit         ! Plot limits
  real(4), allocatable :: iter_number(:)
  real(4), allocatable :: iter_flux(:)
end module last_flux
!
subroutine init_flux90 (method,head,ylimn,ylimp,ipen)
  use gkernel_interfaces
  use clean_def
  use image_def
  use last_flux
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for deconvolution
  !   Create or reuse the <FLUX window
  !---------------------------------------------------------------------
  type (clean_par), intent(in) :: method
  type (gildas), intent(in)    :: head
  real, intent(in)             :: ylimn, ylimp
  integer, intent(out)         :: ipen
  ! Local
  character(len=80) chain
  logical :: error
  !
  if (.not.gtexist('<FLUX')) then
    call gr_execl('CREATE DIRECTORY <FLUX /PLOT_PAGE 20 20 /GEOMETRY 256 256')
    call gr_execl('CHANGE DIRECTORY <FLUX')
  else
    call gr_execl('CHANGE DIRECTORY <FLUX')
    call gr_execl('CLEAR DIRECTORY')  ! Empty the directory (rm *)
  endif
  call gr_execl('CHANGE POSITION 7')
  call gr_exec1('SET BOX 2 19 2 19')
  iter_limit = max(1,min(500,method%m_iter))
  write(chain,'(A,F12.0,1X,1PG12.5,1X,1PG12.5)')   &
              'LIMITS 0 ',iter_limit,ylimn,ylimp
  flux_limit = ylimp
  call gr_exec1(chain)
  call gr_exec1('BOX')
  !
  ! Open a dummy RUNNING segment. If this is not done here, MAPPING
  ! crashes for unknown reasons when re-using the FLUX window...  
  ! Perhaps some drawing action is done in other parts of the code before any call 
  ! to next_flux...
  ipen = gr_spen(3)
  error = .false.
  call gr_segm('RUNNING',error)
  if (error)  return
  iter_counter = 0.d0
  cumulative_flux = 0.d0
  call relocate(iter_counter, cumulative_flux)
  last_operation = 'INIT_FLUX'
  old_clean_type = 3
  !
  iter_curr = 0
end subroutine init_flux90
  !
subroutine plot_multi90(niter,flux,is)
  use gkernel_interfaces
  use clean_def
  use image_def
  use last_flux
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for deconvolution
  !   Plot in the <FLUX window
  !---------------------------------------------------------------------
  integer, intent(in) :: is
  integer, intent(in) :: niter
  real, intent(in) :: flux
  !
  integer :: lpen
  logical :: error
  !
  if (niter.eq.1 .or. is.ne.old_clean_type) then
    error = .false.
    !!Print *,'Closing segment at PLOT_MULTI90'
    call gr_segm_close(error)   ! It may be empty, though
    lpen = gr_spen(is)
    old_clean_type = is
    error = .false.
    call gr_segm('RUNNING',error)
    if (error)  return
    if (niter.eq.1) call relocate(0.d0,0.d0)
  endif
  iter_counter = niter
  cumulative_flux = flux
  call draw(iter_counter, cumulative_flux)
  call gr_out
  last_operation = 'PLOT_MULTI90'
  !
end subroutine plot_multi90
!
subroutine connect_flux
  use gkernel_interfaces
  use last_flux
  !
  logical :: error
  !
  !!Print *,'Connecting to FLUX, last '//last_operation,iter_counter, cumulative_flux 
  call gr_execl('CHANGE DIRECTORY <FLUX')
  call gr_segm('RUNNING',error)  ! Open a new segment
  call relocate(iter_counter, cumulative_flux)
  last_operation = 'Connect_Flux '
  !
end subroutine connect_flux
!
subroutine next_flux90(niter,cum)
  use gkernel_interfaces
  use last_flux
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Draw in the <FLUX window
  !---------------------------------------------------------------------
  integer, intent(in) :: niter
  real, intent(in) :: cum
  !
  logical :: error
  real(8), parameter :: fact=4.d0 ! sqrt(2.d0)
  real(4), allocatable :: tmp(:)
  character(len=80) :: chain
  integer :: jsize, ier
  !
  if (iter_curr.ge.iter_size) then
    if (iter_size.eq.0) then
      !!Print *,'First allocation '
      iter_size = 500
      allocate(iter_flux(iter_size),iter_number(iter_size),stat=ier)
      !!Print *,'First allocation DONE '
    else
      !!Print *,'Expansion allocation '
      jsize = nint(fact*dble(iter_size))
      allocate (tmp(jsize))
      tmp(1:iter_size) = iter_number
      call move_alloc(from=tmp,to=iter_number)
      !!Print *,'Expansion allocation DONE (1)'
      allocate (tmp(jsize))
      tmp(1:iter_size) = iter_flux
      call move_alloc(from=tmp,to=iter_flux)
      iter_size = jsize
      !!Print *,'Expansion allocation DONE (2)'
    endif
    !
  endif
  !
  if (iter_curr.gt.iter_limit) then
    iter_limit = max(200.0,fact*real(iter_limit))    
    flux_limit = max(flux_limit,1.2d0*cum)
    !
    ! Erase the FLUX window
    call gr_segm_close(error)   ! It may be empty, though
    call gr_execl('CHANGE DIRECTORY <FLUX')
    call gr_execl('CLEAR DIRECTORY')  ! Empty the directory (rm *)
    call gr_execl('CHANGE POSITION 7')
    call gr_exec1('SET BOX 2 19 2 19')
    !
    ! Enlarge it
    write(chain,'(A,F12.0,A,1PG12.5)')   &
              'LIMITS 0 ',iter_limit,' = ',flux_limit 
    call gr_exec1(chain)
    call gr_exec1('BOX')
    !
    ! Plot the existing values
    error = .false.
    call gr_segm('RUNNING',error)
    if (error)  return
    call gr4_connect(iter_curr,iter_number,iter_flux,0.0,-1.0)
  endif
  !
  if (mod(niter,100).eq.1) then
    error = .false.
    !!Print *,'Closing segment at NEXT_FLUX, last '//last_operation
    call gr_segm_close(error)   ! It may be empty, though
    error = .false.
    call gr_segm('RUNNING',error)
    if (error)  return
    if (niter.eq.1) call relocate(0.d0,0.d0)
  endif
  !
  iter_counter = niter
  cumulative_flux = cum
  call draw(iter_counter, cumulative_flux)
  if (mod(niter,10).eq.0) call gr_out
  last_operation = 'NEXT_FLUX'
  !
  iter_curr = iter_curr+1
  iter_number(iter_curr) = iter_curr
  iter_flux(iter_curr) = cumulative_flux
end subroutine next_flux90
!
subroutine close_flux90(ipen,error)
  use gkernel_interfaces
  use last_flux
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Close the <FLUX segments
  !---------------------------------------------------------------------
  integer, intent(in)    :: ipen   ! New pen to be used
  logical, intent(inout) :: error  ! Logical error flag
  ! Local
  integer :: oldpen
  !
  !!Print *,'Closing segment at CLOSE_FLUX, last '//last_operation
  call gr_segm_close(error)
  oldpen = gr_spen(ipen)
  call gr_execl('CHANGE DIRECTORY <GREG')
  !
end subroutine close_flux90
!
subroutine re_mask(method,head,nl,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>re_mask
  use clean_def
  use image_def
  use last_flux
  use clean_support
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for Clean
  !   Re-compute mask in Major Cycles
  !---------------------------------------------------------------------
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: head
  integer, intent(inout) :: nl
  logical, intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='CLARK'
  character(len=80) :: comm
  integer :: n
  !
  if (.not.method%qcycle) goto 100 
  !
  comm = ' '
  call sic_wprn('I-CLARK,  Press RETURN, C for cursor, '//   &
     &    ' or new polygon name ',comm,n)
  if (n.eq.0) goto 100
  n = len_trim(comm)
  if (n.eq.0) goto 100
  call gr_execl ('CHANGE DIRECTORY <CLARK')
  call gr_exec1 ('LIMITS /RGDATA')
  if (comm(1:n).eq.'C' .or. comm(1:n).eq.'c') then
    call greg_poly_define(rname,' ',.false.,supportpol,supportvar,error)
  else
    call greg_poly_define(rname,comm,.true.,supportpol,supportvar,error)
  endif
  if (error) goto 100
  !
  method%do_mask = .true.
  call check_mask(method,head)
  !
  ! This subroutine is called by CLARK but also SDI
100 continue
  if (method%pflux) then
    call gr_out
    call gr_execl ('CHANGE DIRECTORY <FLUX')
    call relocate(iter_counter, cumulative_flux) 
    call gr_out
  endif
  nl = method%nlist
end subroutine re_mask
!
subroutine init_plot(method,head,pdata)
  use gkernel_interfaces
  use clean_def
  use image_def
  use last_flux
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Create or reuse the <CLARK window, and draw in it. Then go back
  !   to <FLUX if needed.
  !---------------------------------------------------------------------
  type (clean_par), intent(in) :: method
  type (gildas), intent(in)    :: head
  real, intent(in)             :: pdata(head%gil%dim(1),head%gil%dim(2))
  ! Local
  real :: r1,r2
  logical :: error,exist
  character(len=80) :: chain
  ! Data
  real, save :: old_r1=-1.0
  real, save :: old_r2=+1.0
  !
  error = .false.
  !
  ! First, close the segment opened in <FLUX
  if (method%pflux) then
    !!Print *,'Closing segment at INIT_PLOT, last '//last_operation
    call gr_segm_close(error)
    error = .false.
  endif
  !
  if (head%gil%dim(1).eq.head%gil%dim(2)) then
    r1 = 1
    r2 = 1
  elseif (head%gil%dim(1).lt.head%gil%dim(2)) then
    r1 = float(head%gil%dim(1))/head%gil%dim(2)
    r2 = 1
  else
    r1 = 1
    r2 = float(head%gil%dim(2))/head%gil%dim(1)
  endif
  !
  ! Re-create, Re-use, or Modify directory
  exist = gtexist('<CLARK')
  if (exist) then
    if (old_r1.eq.r1 .and. old_r2.eq.r2) then
      call gr_execl ('CHANGE DIRECTORY <CLARK')
    else
      call gr_execl ('DESTROY DIRECTORY <CLARK')
      exist = .false.
    endif
  endif
  if (.not.exist) then
    write(chain,1000) 20.*r1,20.*r2,nint(384.0*r1),nint(384.0*r2)
    call gr_execl (chain)
    call gr_execl ('CHANGE DIRECTORY <CLARK')
    call gr_execl ('CHANGE POSITION 9')
  endif
  write(chain,1001) 20.*r1,20.*r2
  call gr_exec1 (chain)
  old_r1 = r1
  old_r2 = r2
  !
  call sic_delvariable('MRC',.false.,error) ! Program request
  call sic_def_real('MRC',pdata,2,head%gil%dim,.true.,error)
  call gr_exec2('PLOT MRC /SCALING LINE CLEAN_DMIN CLEAN_DMAX')
  call sic_delvariable('MRC',.false.,error)
  !
  ! Go back to <FLUX and open a new segment there
  if (method%pflux) then
    call gr_execl('CHANGE DIRECTORY <FLUX')
    call gr_segm('RUNNING',error)  ! Open a new segment
  endif
  !
1000  format('CREATE DIRECTORY <CLARK /PLOT_PAGE ',f5.1,1x,f5.1,  &
        ' /GEOMETRY ',i5,i5)
1001  format('SET BOX 0 ',f5.1,' 0 ',f5.1)
end subroutine init_plot
!
!
subroutine major_plot90 (method,head   &
     &    ,conv,niter,nx,ny,np,tcc  &
     &    ,clean,resid,poids)
  use gkernel_interfaces
  use clean_def
  use image_def
  use gbl_message
  !---------------------------------------------------------
  ! @ private
  !
  ! MAPPING 
  !   Plot result of Major Cycle
  !---------------------------------------------------------
  type (clean_par), intent(inout) :: method
  type (gildas), intent(in) :: head
  !
  logical, intent(inout) :: conv        ! Convergence status
  integer, intent(in) ::  niter         ! Number of iterations
  integer, intent(in) ::  nx            ! X size
  integer, intent(in) ::  ny            ! Y size
  integer, intent(in) ::  np            ! Number of planes
  real, intent(inout) :: clean(nx,ny)      ! Clean image
  real, intent(inout) :: resid(nx,ny)      ! Residuals
  real, intent(in) :: poids(nx,ny)         ! Weight image
  type (cct_par), intent(in) :: tcc(niter)
  !
  character(len=80) :: comm
  character(len=message_length) :: chain
  integer n,ier
  integer(kind=index_length) :: dim(4)
  real gain
  logical error,doplot
  !
  ! Will we plot something in the window <CLARK?
  doplot = method%pmrc .or. method%pclean .or. method%pcycle
  !
  ! Close the segment opened in <FLUX (if any)
  if (method%pflux .and. doplot)  then
    !!call gr_execl('DISPLAY DIRECTORY',error)
    call gr_segm_close(error)
    error = .false.
  endif
  !
  ! MRC plot
  dim = 0
  dim(1) = nx
  dim(2) = ny
  if (method%pmrc.or.method%pclean) then
    ! Plot clean map
    if (method%pmrc) then
      call map_message(seve%w,'MAJOR_CYCLE','MRC Not yet DEBUGGED')
    endif
    error = .false.
    !
    ! Add clean components to clean map
    if (method%n_iter.ne.0) then
      call clean_make90 (method, head, clean, tcc)
      if (np.le.1) then
        clean = clean+resid
      else
        clean = clean+resid*poids
      endif
    else
      if (np.le.1) then
        clean = resid
      else
        clean = resid*poids
      endif
    endif
    call gr_execl ('CHANGE DIR <CLARK')
    call sic_delvariable('MRC',.false.,error) ! Program request
    call sic_def_real('MRC',clean,2,dim,.true.,error)
    call gr_exec2 ('PLOT MRC /SCALING LIN CLEAN_DMIN CLEAN_DMAX')
  elseif (method%pcycle) then
    !
    ! Plot residuals only
    call gr_execl ('CHANGE DIR <CLARK')
    call sic_delvariable('MRC',.false.,error)
    call sic_def_real('MRC',resid,2,dim,.true.,error)
    call gr_exec2 ('PLOT MRC /SCALING LIN CLEAN_DMIN -CLEAN_DMIN')
  endif
  !
  ! Reconnect to the <FLUX directory if needed
  if (method%pflux .and. doplot) then
    call connect_flux
  endif
  !
  if (conv .or. .not.method%qcycle) return
  !
  ! Query mode:
  !
  ! Change loop gain if needed
  gain = -1.0
  do while (gain.lt.0.02 .or. gain.gt.0.8)
    comm = ' '
    call sic_wprn('I-CLARK,  Press RETURN, Q to Stop, '//   &
     &      ' or new gain value ',comm,n)
    if (n.eq.0) return
    call sic_upper (comm)
    if (comm(1:1).eq.'Q') then
      conv = .true.
      return
    elseif (len_trim(comm).eq.0) then
      return
    endif
    read(comm(1:lenc(comm)),*,iostat=ier) gain
    if (ier.ne.0) then
      gain = -1.0
    else
      write(chain,'(A,F4.2)') 'Gain is now ',gain
      call map_message(seve%i,'CLARK',chain)
    endif
  enddo
  method%gain = gain
end subroutine major_plot90
!
subroutine plot_mrc(method,head,array,code)
  use image_def
  use clean_def
  use imager_interfaces, except_this=>plot_mrc
  !----------------------------------------------------------------
  ! 
  ! @ private
  !
  ! MAPPING
  !   Dispatch the various plotting actions in MRC
  !----------------------------------------------------------------
  type(clean_par), intent(in) :: method
  type(gildas), intent(in) :: head
  integer, intent(in) :: code
  real, intent(in) :: array(head%gil%dim(1),head%gil%dim(2))
  !
  integer, save :: ipen
  logical :: error
  integer :: nx,ny
  !
  nx = head%gil%dim(1)
  ny = head%gil%dim(2)
  !
  if (code.eq.0) then
    ipen = 0
    if (method%pcycle) call init_plot (method,head,array)
  else if (code.eq.1) then  
    if (method%pflux) then
      !!Print *,'Calling close_flux '
      call close_flux90(ipen,error)
    endif
    call mrc_plot(array,nx,ny,1,'Difference')
    if (method%pflux) then
      !!Print *,'Back to <FLUX #1'
      call gr_execl('CHANGE DIREC <FLUX')
      call relocate(0.d0,0.d0)
      !!Print *,'Calling GR_OUT'  
      call gr_out
    endif
  else if (code.eq.2) then
    if (method%pflux) then
      !!Print *,'Calling close_flux '
      call close_flux90(ipen,error)
    endif
    call mrc_plot(array,nx,ny,2,'Smooth')
  else if (code.eq.3) then
    call mrc_plot(array,nx,ny,3,'Clean')
  endif
end subroutine  plot_mrc
!    
!
subroutine mrc_clear
  call gr_execl ('CHANGE DIRECTORY <MRC')
  call gr_execl ('CLEAR DIRECTORY')  ! Empty the directory (rm *)
end subroutine mrc_clear
!
subroutine mrc_plot(image,nx,ny,type,name)
  use gildas_def
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Plot the smooth and difference final clean image in <MRC
  !   so as to keep them visible
  !---------------------------------------------------------------------
  integer, intent(in) :: nx,ny,type
  real, intent(in) :: image(nx*ny)
  character(len=*) name
  !
  integer, parameter :: npixel=256
  real rr1,rr2
  real old_rr1,old_rr2,rmin,rmax
  integer(kind=index_length) :: dim(4)
  integer :: i
  logical exist,error
  character(len=80) chain
  !
  save old_rr1,old_rr2,rmin,rmax
  data old_rr1/-1./,old_rr2/+1./
  !
  ! Create SIC variables
  !!Print *,'Into MRC_PLOT '
  error = .false.
  dim(1) = nx
  dim(2) = ny
  call sic_def_real('MY_MRC',image,2,dim,.true.,error)
  !
  ! Image min and max (and scale factor)
  rmin = image(1)
  rmax = image(1)
  do i=1,nx*ny
    if (image(i).gt.rmax) rmax = image(i)
    if (image(i).lt.rmin) rmin = image(i)
  enddo
  if (rmin.eq.rmax) then
    rmin = -0.1
    rmax = 0.1
  endif
  !
  ! Window size
  if (nx.eq.ny) then 
    rr1 = 3
    rr2 = 1
  elseif (nx.lt.ny) then 
    rr1 = 3*float(nx)/float(ny) 
    rr2 = 1
  else
    rr1 = 3
    rr2 = float(ny)/float(nx) 
  endif
  !
  exist = gtexist('<MRC')
  if (exist) then
    !!Print *,'<MRC exists'
    if (old_rr1.eq.rr1 .and. old_rr2.eq.rr2) then
      call gr_execl ('CHANGE DIREC <MRC')
    else
      call gr_execl ('DESTROY DIRECTORY <MRC')
      exist = .false.
    endif
  endif
  if (.not.exist) then
    !!Print *,'<MRC is being created'
    write(chain,1000) 20.*rr1,20.*rr2,nint(npixel*rr1),   &
     &      nint(npixel*rr2)
    call gr_execl (chain)
    call gr_execl ('CHANGE DIREC <MRC')
    call gr_execl ('CHANGE POSITION 9')
  endif
  !
  ! Premier passage
  if (type.eq.1) then
    old_rr1 = rr1
    old_rr2 = rr2
    write(chain,1001) 0.0,20./3.*rr1,0.0,20.*rr2
    call gr_exec1(chain)
    !
    write(chain,'(A,1PG11.4,1X,1PG11.4)')   &
     &      'PLOT MY_MRC /SCALING LINEAR ',   &
     &      rmin, rmax
    !!Print *,trim(chain)
    call gr_exec2 (chain)
    call gr_exec1 ('BOX N N N N')
    !
    write(chain,1006) rmin,rmax
    call gr_exec1 ('SET EXPAND 2')
    call gr_exec1 (chain)
    write(chain,1007) name
    call gr_exec1 (chain)
    call gr_exec1 ('SET EXPAND 1')
  else
    !
    ! Smooth plot (TYPE=2) and Final plot (TYPE=3). <MRC exists
    call gr_execl ('CHANGE DIREC <MRC')
    write(chain,1001) 20./3.*(type-1)*rr1,20./3.*type*rr1,   &
     &      0.0,20.*rr2
    !!Print *,trim(chain)
    call gr_exec1(chain)
    !
    write(chain,'(A,1PG11.4,1X,1PG11.4)')   &
     &      'PLOT MY_MRC /SCALING LINEAR ',   &
     &      rmin, rmax
    !!Print *,trim(chain)
    call gr_exec2 (chain)
    call gr_exec1 ('BOX N N N N')
    !
    write(chain,1006) rmin,rmax
    if (type.ge.2) then
      call gr_exec1 ('SET EXPAND 2')
      call gr_exec1 (chain)
      write(chain,1007) name
      call gr_exec1 (chain)
      call gr_exec1 ('SET EXPAND 1')
    endif
  endif
  !
  old_rr1 = rr1
  old_rr2 = rr2
  call sic_delvariable('MY_MRC',.false.,error)
  !
  1000  format('CREATE DIREC <MRC /PLOT_PAGE ',f5.1,1x,f5.1,   &
          ' /GEOMETRY ',i5,i5)
  1001  format('SET BOX ',f5.1,1x,f5.1,1x,f5.1,1x,f5.1)
  1004  format('DRAW TEXT ',f5.1,1x,f5.1,' "Difference" 5 /BOX 1')
  1005  format('DRAW TEXT ',f5.1,1x,f5.1,' "Smooth" 5 /BOX 1')
  1006  format('DRAW TEXT 0 1 "',1pg10.3,1x,1pg10.3,'" 5 /CHAR 2')
  1007  format('DRAW TEXT 0 -1 "',a,'" 5 /CHAR 8')
  !
end subroutine mrc_plot

subroutine gtemplate_load
  !---------------------------------------------------------------------
  ! Define and load languages of the package.
  !---------------------------------------------------------------------
  ! Global
  external :: gtemplate_run
  logical, external :: gtemplate_error
  ! Local
  ! Define commands of a new language
  integer, parameter :: mcom=4
  character(len=12) :: vocab(mcom)
  data vocab /                      &
    ' DUMMY', '/OPT1', '/OPT2',     &  ! A command with 2 options
    ' VOID' /                          ! A standalone command
  !
  ! Load the new language:
  call sic_begin(           &
    'TEMPLATE',             &  ! Language name
    'GAG_HELP_GTEMPLATE',   &  !
    mcom,                   &  ! Number of commands + options in language
    vocab,                  &  ! Array of commands
    '1.0    27-Oct-2008 ',  &  ! Some version string
    gtemplate_run,          &  ! The routine which handles incoming commands
    gtemplate_error)           ! The error status routine of the library
  !
end subroutine gtemplate_load
!<FF>
subroutine gtemplate_run(line,comm,error)
  !---------------------------------------------------------------------
  ! Support routine for the language GTEMPLATE.
  ! This routine is able to call the routines associated to each
  ! command of the language GTEMPLATE
  !---------------------------------------------------------------------
  use gbl_message
  character(len=*),  intent(in)    :: line   ! Command line to send to support routines
  character(len=12), intent(in)    :: comm   ! Command resolved by the SIC interpreter
  logical,           intent(inout) :: error  ! Logical error flag
  !
  call gtemplate_message(seve%c,'GTEMPLATE',line)
  !
  ! Call appropriate subroutine according to COMM
  select case(comm)
  case('DUMMY')
    call gtemplate_dummy(line,error)
  case('VOID')
    call gtemplate_void(line,error)
  case default
    call gtemplate_message(seve%e,'GTEMPLATE_RUN','Unimplemented command '//comm)
    error = .true.
  end select
  !
end subroutine gtemplate_run
!<FF>
function gtemplate_error()
  !---------------------------------------------------------------------
  ! Support routine for the error status of the library. Does nothing
  ! here.
  !---------------------------------------------------------------------
  logical :: gtemplate_error
  !
  gtemplate_error = .false.
  !
end function gtemplate_error

subroutine sub_alma_quad (   &
     &    l_method,l_hdirty,l_hresid,l_hclean,   &
     &    l_hbeam,l_hprim,l_tfbeam, l_list,  &
     &    c_method,c_hdirty,c_hresid,c_hclean,   &
     &    c_hbeam,c_hprim,c_tfbeam, c_list,  &
     &    error,tcc)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_alma_quad
  use clean_def
  use image_def
  use gbl_message
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Clean/Mosaic
  !     Perfom a CLEAN based on all CLEAN algorithms,
  !     except the Multi Resolution which requires a different tool
  !     Works for mosaic also, except for the Multi Scale clean
  !     (not yet implemented for this one, but feasible...)
  !--------------------------------------------------------------
  type (clean_par), intent(inout) :: l_method, c_method
  type (gildas), intent(inout)  :: l_hdirty, l_hbeam, l_hresid, l_hprim
  type (gildas), intent(inout)  :: l_hclean
  type (gildas), intent(inout)  :: c_hdirty, c_hbeam, c_hresid, c_hprim
  type (gildas), intent(inout)  :: c_hclean
  real, intent(inout) :: l_tfbeam(l_hbeam%gil%dim(2),l_hbeam%gil%dim(3),l_hbeam%gil%dim(1))
  real, intent(inout) :: c_tfbeam(c_hbeam%gil%dim(2),c_hbeam%gil%dim(3),c_hbeam%gil%dim(1))
  logical, intent(inout) :: error
  type (cct_par), intent(inout) :: tcc(l_method%m_iter)
  integer, intent(in) :: l_list(:)  ! List of searched pixels
  integer, intent(in) :: c_list(:)  ! List of searched pixels (compact array)
  !
  real, pointer :: c_dirty(:,:)    ! Dirty map
  real, pointer :: c_resid(:,:)    ! Iterated residual
  real, pointer :: c_clean(:,:)    ! Clean Map
  real, pointer :: c_dprim(:,:,:)  ! Primary beam
  real, pointer :: c_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: c_atten(:,:)
  !
  real, pointer :: l_dirty(:,:)    ! Dirty map
  real, pointer :: l_resid(:,:)    ! Iterated residual
  real, pointer :: l_clean(:,:)    ! Clean Map
  real, pointer :: l_beam(:,:) ! Beam for fit
  real, pointer :: l_dprim(:,:,:)  ! Primary beam
  real, pointer :: l_dbeam(:,:,:)  ! Dirty beam (per field)
  real, pointer :: l_atten(:,:)
  !
  real, allocatable :: w_fft(:) ! TF work area
  complex, allocatable :: w_work(:,:)  ! Work area
  complex, allocatable :: c_work(:,:)  ! Expansion of residual
  real, allocatable :: r_work(:,:) ! Expansion of residual
  type(cct_par), allocatable :: w_comp(:)
  real, allocatable :: w_cctw(:,:), w_cctf(:,:)
  real, allocatable :: w_resid(:,:)
  type (cct_par), allocatable :: w_tcc(:)
  !
  integer icase, iext
  real last_flux, max_var, cpu0, cpu1
  integer iplane,ibeam
  integer nx,ny,np,mx,my,mp,nc
  integer ier, ix, iy, jx, jy, ncc
  real l_max, c_max
  logical do_fft, ok
  character(len=message_length) :: chain
  character(len=4) :: rname = 'ALMA'
  character(2) ans
  integer nker,mker
  parameter (mker=13)
  real smooth, default_thre
  real, allocatable :: kernel(:,:)
  integer, allocatable :: labelo(:,:)
  real, allocatable :: values(:)
  integer, allocatable :: xcoord(:),ycoord(:)
  real noise,scale,fhat,long,compact, factor, thre
  integer n_ext, kx, ky, kf, n_areas
  logical do_long, more
  integer type_long, type_compact,last_type
  parameter (type_long=1)
  parameter (type_compact=2)
  !
  error = .false.
  do_fft = .true.
  factor = 0.0
  chain = 'Using SUB_ALMA_QUAD of 20-Nov-2001'
  call map_message(seve%i,rname,chain)
  !
  ! Local variables
  nx = l_hclean%gil%dim(1)
  ny = l_hclean%gil%dim(2)
  np = l_hprim%gil%dim(1)
  mx = c_hbeam%gil%dim(1)
  my = c_hbeam%gil%dim(2)
  mp = c_hprim%gil%dim(1)
  nc = nx*ny
  !
  allocate (w_work(nx,ny),stat=ier)
  allocate (r_work(nx,ny),stat=ier)
  allocate (c_work(mx,my),stat=ier)
  allocate (w_fft(max(nx,ny)),stat=ier)
  allocate (w_comp(nc),stat=ier)
  !
  ! Global residuals
  allocate (w_resid(nx,ny),stat=ier)
  !
  allocate (w_tcc(nx*ny),stat=ier) ! Temporary Clean Component Array
  allocate (w_cctf(nx,ny),stat=ier)    ! Final Clean Components
  allocate (w_cctw(nx,ny),stat=ier)
  !
  ! Some global pointers
  l_dprim => l_hprim%r3d
  l_dbeam => l_hbeam%r3d
  l_atten => l_method%atten(:,:,1)
  c_dprim => c_hprim%r3d
  c_dbeam => c_hbeam%r3d
  c_atten => c_method%atten(:,:,1)
  !
  ! Relative noise contributions
  long = 1.0/l_hdirty%gil%noise**2
  compact = 1.0/c_hdirty%gil%noise**2
  noise = sqrt(long/compact)   ! Mean noise RATIO
  scale = long+compact
  long = long/scale
  compact = compact/scale
  !
  ! Initialize the kernel
  smooth = c_method%smooth
  if (smooth.eq.0) then
     nker = 1
  elseif  (smooth.lt.2) then
     nker = 5
  elseif  (smooth.lt.4) then
     nker = 9
  else
     nker = 13
  endif
  !
  allocate(kernel(nker,nker),stat=ier)
  call init_kernel(kernel,nker,nker,smooth)
  !
  kx = mx/2
  ky = my/2
  kf = kx*ky
  allocate (labelo(kx,ky),stat=ier)
  allocate (xcoord(kf),ycoord(kf),values(kf),stat=ier)
  !
  do_long = c_method%n_major.gt.0
  last_type = type_long
  tcc%type = 1
  !
  max_var = 0.005              ! Default value of flux stability
  call sic_get_real('F_THRES',max_var,error)
  default_thre = 0
  call sic_get_real('D_THRES',default_thre,error)
  if (default_thre.lt.0 .or. default_thre.gt.0.9) default_thre = 0.0
  !
  call gag_cpu (cpu0)
  if (l_method%pcycle) then
     call mrc_plot(c_resid,mx,my,1,'Compact')
  endif
  !
  ! Loop here if needed
  do iplane = l_method%first, l_method%last
     last_flux = 0.0
     more = .false.
     icase = 0
     write(chain,'(A,I6)') 'Starting loop ',iplane
     call map_message(seve%i,rname,chain)
     l_method%flux = 0.0
     c_method%flux = 0.0
     l_method%n_iter= 0
     c_method%n_iter= 0
     !
     l_method%iplane = iplane
     c_method%iplane = iplane
     call beam_plane(l_method,l_hbeam,l_hdirty)
     ibeam = l_method%ibeam
     c_method%ibeam = ibeam ! Was missing S.Guilloteau
     !
     ! Local aliases
     l_dirty => l_hdirty%r3d(:,:,iplane)
     l_resid => l_hresid%r3d(:,:,iplane)
     l_clean => l_hclean%r3d(:,:,iplane)
     l_beam  => l_hbeam%r3d(:,:,ibeam)
     !
     c_dirty => c_hdirty%r3d(:,:,iplane)
     c_resid => c_hresid%r3d(:,:,iplane)
     c_clean => c_hclean%r3d(:,:,iplane)
     !
     ! Initialize to Dirty map
     l_resid = l_dirty
     c_resid = c_dirty
     !
     ! Prepare beam parameters
     call get_clean (l_method, l_hbeam, l_beam, error)
     if (error) return
     !!Print *,'Done GET_CLEAN'
     !!Print *,'_______'
     !!Print *,'L_METHOD'
     !!call debug (l_method)
     call get_beam (l_method,l_hbeam,l_hresid,l_hprim,   &
          &        l_tfbeam,w_work,w_fft,fhat,error)
     if (error) return
     !
     !!Print *,'Done GET_BEAM Long'
     !!Print *,'_______'
     !!Print *,'C_METHOD'
     !!call debug (c_method)
     call get_beam (c_method,c_hbeam,c_hresid,c_hprim,   &
          &        c_tfbeam,w_work,w_fft,fhat,error)
     if (error) return
     !!Print *,'Done GET_BEAM Compact'
     l_resid = l_resid * l_atten
     c_resid = c_resid * c_atten
     !
     ! Performs decomposition into components:
     ! Only one major cycle per iteration, with a limited number
     ! of components ?
     !
     ans = ' '
     l_method%ngoal = 1000
     !
     ! Locate the maximum of the Compact & Normal images
     l_max = imaxlst (l_method,l_list,l_resid,nx,ny,ix,iy)
     c_max = imaxlst (c_method,c_list,c_resid,mx,my,jx,jy)
     ok = l_max.gt.l_method%ares .or. c_max.gt.c_method%ares
     do while (ok)
        !
        ! Plot for debug
        if (l_method%pcycle) then
           call mrc_clear
           call mrc_plot(c_resid,mx,my,2,'Compact')
           call mrc_plot(l_resid,nx,ny,3,'Long')
        endif
        !
        ! NOISE is the Noise RATIO (mean value over the beams)
        !
        if (l_max.gt.c_max/noise .or. do_long) then
           last_type = type_long  ! Use LONG baselines
        else
           ! May be using Compact baselines only. Check sign however
           l_max = l_resid(ix,iy)
           c_max = c_resid(jx,jy)
           if (default_thre.ne.0) then
              thre = default_thre
           else
              thre = min(0.3,c_method%bgain)
           endif
           last_type = type_compact
           if (c_max*l_max .lt. 0) then
              ! Use higher threshold
              last_type = type_compact
              thre = max(0.7,thre)
           endif
        endif
        !
        if (last_type.eq.type_long) then
           l_max = abs(l_max)
           if (l_method%verbose) then
              write(chain,*) 'Using LONG baselines ',   &
                   &            l_max,c_max/noise
              call map_message(seve%i,rname,chain)
           endif
           if (l_method%qcycle) then
              call sic_wpr('WAIT ? ',ans)
           endif
           !
           ! Find components in LONG baseline image
           !!Print *,'Calling ONE_CYCLE90'
           call one_cycle90 (l_method,l_hclean,   &   !
                &          l_clean,   &   ! Final CLEAN image
                &          l_dbeam,   &   ! Dirty beams
                &          l_resid,nx,ny,   & ! Residual and size
                &          l_tfbeam, w_work,   &  ! FT of dirty beam + Work area
                &          w_comp, nc,   &    ! Component storage + Size
                &          l_method%beam0(1),l_method%beam0(2),   &   ! Beam center
                &          l_method%patch(1),l_method%patch(2),   &
                &          l_method%bgain,l_method%box,   &
                &          w_fft,   &     ! Work space for FFTs
                &          tcc,   &       ! Component table
                &          l_list, l_method%nlist,   & ! Search list
                &          np,   &        ! Number of fields
                &          l_dprim,   &   ! Primary beams
                &          l_atten,   &  ! Weight
                &          l_max)
           !
           if (l_method%verbose) then
              write(chain,*) 'Flux ',last_flux,l_method%flux
              call map_message(seve%i,rname,chain)
           endif
           l_max = imaxlst (l_method,l_list,l_resid,nx,ny,ix,iy)
           !
           ! Define component type
           tcc(c_method%n_iter+1:l_method%n_iter)%type = 0
           ! Remove from COMPACT baselines
           !!Print *,'Calling REMOVE_INCOMPACT'
           call remove_incompact(c_method,c_resid,mx,my,   &
                &          c_tfbeam, w_fft,mp,c_dprim,c_atten,   &
                &          tcc,c_method%n_iter+1,l_method%n_iter,nx,ny)
           ! Transform Clean Components to Map Type Storage
           !!Print *,'Calling LONG_TO_IMAGE ', l_method%n_iter-c_method%n_iter
           call  long_to_image (tcc(c_method%n_iter+1),   &
                &          l_method%n_iter-c_method%n_iter,w_cctw,nx,ny)
           ! Add them to Final Clean Storage
           !!Print *,'Moving CCT'
           w_cctf(:,:) = w_cctf + w_cctw
           ! Define number of iterations and type
           tcc(c_method%n_iter+1:l_method%n_iter)%type = 0
           c_method%n_iter = l_method%n_iter
           c_method%flux = l_method%flux
           !
           do_long = .false.
           ! SG Test
           ! Force recomputation of SDI scaling factor
           factor = 0.0
           !
           ! Long baseline
           !!Print *,'Moving to next'
        else
           if (l_method%verbose) then
              write(chain,*) 'Using COMPACT baselines ',   &
                   &            l_max,c_max/noise
              call map_message(seve%i,rname,chain)
           endif
           if (l_method%qcycle) then
              call sic_wpr('WAIT ? ',ans)
           endif
           !
           ! Select extended area around this maximum
           thre = thre * c_max
           !
           xcoord = 0
           labelo = 0
           !
           !!Print *,'Calling THRESHOLD'
           call sub_threshold (c_resid,mx,my,   & ! Initial image and size
                &          c_method%blc,c_method%trc,   & ! Image area
                &          labelo,kx,ky,   &  ! Subset Image of area numbers
                &          n_areas,   &   ! Number of areas
                &          xcoord,   &    ! Work space for area numbers
                &          ycoord,kf,   & ! Area numbers
                &          thre,0.0,-1.0) ! Threshold and blanking
           if (l_method%verbose) then
              write(chain,*) 'Found ',n_areas,' areas above ',thre
              call map_message(seve%i,rname,chain)
           endif
           !
           ! Test
           if (more) icase = 1
           !
           ! Select the appropriate region and put them to TCC array
           ! Gain is not applied yet
           call label_to_cct (c_resid,mx,my,   &
                &          c_method,   &  ! Image area
                &          labelo,kx,ky,   &  ! Subset Image of area numbers
                &          w_tcc,n_ext,jx,jy, icase)
           write(chain,'(A,I6,A,1pg10.3)')   &
                &  'Selected ',n_ext,' components above ',thre
           call map_message(seve%i,'COMPACT',chain)
           !
           ! Compute the scale factor
           call cct_normal (w_tcc,n_ext,   &
                &          w_work,c_tfbeam,mx,my,w_fft,factor)
           factor = abs(c_max)/factor
           ! Scale the components
           do iext=1,n_ext  ! Circumvent GFORTRAN bug
              w_tcc(iext)%value = w_tcc(iext)%value *   &
                   &          c_method%gain * factor
           enddo
           !
           ! Transform Clean Components to Map Type Storage
           call  compact_to_image (c_method,mx,my,   &
                &          w_tcc,n_ext,   &
                &          r_work,nx,ny)
           !
           ! Smooth them by a kernel
           call smooth_kernel(r_work,w_cctw,nx,ny,nker,nker,kernel)
           !
           ! Transform them back to the TCC representation
           call image_to_long(w_cctw,nx,ny,w_tcc,nx*ny,ncc)
           !
           ! Compute flux, and plot
           call display_cct(c_method,w_tcc,ncc,l_method%n_iter)
           !
           ! Store component (temporary patch)
           if (l_method%n_iter+ncc-1.le.l_method%m_iter) then
              c_method%n_iter = l_method%n_iter+ncc-1
              tcc(l_method%n_iter+1:c_method%n_iter) = w_tcc(1:ncc)
              l_method%n_iter = c_method%n_iter
           else
              ok = .false.
           endif
           !
           ! Remove List in Compact Baselines
           call remove_incompact(c_method,c_resid,mx,my,   &
                &          c_tfbeam, w_fft,mp,c_dprim,c_atten,   &
                &          w_tcc,1,ncc,nx,ny)
           !
           ! Remove List in Long Baselines
           call remove_inlong(l_method,l_resid,nx,ny,   &
                &          l_tfbeam, w_fft,np,l_dprim,l_atten,   &
                &          w_tcc,1,ncc)
           !
           ! Add to final component representation
           w_cctf(:,:) = w_cctf + w_cctw
           ! Define number of components
           !                  L_METHOD%N_ITER = C_METHOD%N_ITER
           l_method%flux = c_method%flux
           write(chain,'(A,1PG11.4,A,I6,A)')  'Cleaned ',c_method%flux,   &
           &  ' Jy in ',c_method%n_iter,' components'
           call map_message(seve%i,'COMPACT',chain)
           !
        endif
        ! Stop if done
        l_max = imaxlst (l_method,l_list,l_resid,nx,ny,ix,iy)
        c_max = imaxlst (c_method,c_list,c_resid,mx,my,jx,jy)
        ok = ok .and. (l_max.gt.l_method%ares   &
             &        .or. c_max.gt.c_method%ares)
        if (l_method%n_iter.ge.l_method%m_iter) ok = .false.
        if (sic_ctrlc()) ok = .false.
        !
        if (ans.eq.'Q') ok = .false.
        ! Continue with ALMA only if not enough components yet
        if (l_method%n_iter .lt. c_method%n_major)   &
             &        do_long = .true.
        !
        ! Define Compact Cycle Type
        more = abs ((last_flux-l_method%flux)   &
             &        /l_method%flux).lt.max_var
        if (l_method%verbose) then
           write(chain,*) (last_flux-l_method%flux)/l_method%flux,   &
                &          max_var,more
           call gagout(chain)
        endif
        last_flux = l_method%flux
     enddo
     !
     ! Add clean components and residuals to produce clean map
     if (l_method%n_iter.ne.0) then
        call alma_make (l_method, l_hclean, tcc)
     else
        l_clean = 0
     endif
     !
     ! Which residual should be added ?...
     ! We do not want to add noise, but to combine it properly...
     ! We may need to go to the full combined gridding business here...
     l_clean = l_clean + l_resid * l_atten * long
     c_clean = c_resid * c_atten * compact
     call expand (nx,ny,r_work,w_work,mx,my,c_clean,c_work,w_fft)
     where (l_atten.lt.l_method%trunca)
        r_work = 0
     end where
     l_clean = l_clean + r_work
  enddo
  call gag_cpu (cpu1)
  write(chain,*) 'CPU used ',cpu1-cpu0
  call map_message(seve%i,rname,chain)
  !
  ! Cleanup
  deallocate (w_work,r_work,c_work)
  deallocate (w_fft,w_comp,w_resid)
  deallocate (kernel)
  deallocate (labelo,xcoord,ycoord,values)
end subroutine sub_alma_quad
!
subroutine label_to_cct (image,nx,ny,c_method,label,mx,my,   &
     &    tcc,nv,ix,iy, icase)
  !
  use clean_def
  use gbl_message
  ! @ private
  type (clean_par), intent(in) :: c_method
  type (cct_par), intent(inout) :: tcc(*)
  integer, intent(in) :: nx,ny,mx,my,ix,iy
  integer, intent(out) :: nv
  real(4), intent(in) :: image(nx,ny)
  integer, intent(in) :: label(mx,my)
  integer, intent(in) :: icase
  !
  integer i,j,ii,jj,label0,i0,j0
  logical doit
  character(len=message_length) :: chain
  character(len=4) :: rname = 'ALMA'
  !
  i0 = c_method%blc(1)
  j0 = c_method%blc(2)
  label0 = label(ix-i0+1,iy-j0+1)
  nv = 0
  if (icase.eq.0) then
    write(chain,'(A,I6,A)') 'Selected field ',label0,' only'
  else
    chain = 'Selected all fields'
  endif
  call map_message(seve%i,rname,chain)
  !
  do j=1,my
    do i=1,mx
      if (icase.eq.0) then
        doit = label(i,j).eq.label0
      else
        doit = label(i,j).ne.0
      endif
      if (doit) then
        nv = nv+1
        ii = i0+i-1
        jj = j0+j-1
        tcc(nv)%value = image(ii,jj) *   &
            &          c_method%atten(ii,jj,1)*c_method%gain
        tcc(nv)%ix = ii
        tcc(nv)%iy = jj
      endif
    enddo
  enddo
end subroutine label_to_cct
!
subroutine long_to_image (tcc,ncc,image,nx,ny)
  use clean_def
  ! @ private
  integer, intent(in) :: nx,ny,ncc
  type (cct_par), intent(in) :: tcc(ncc)
  real, intent(inout) :: image(nx,ny)
  !
  integer ix,iy,ic
  image = 0.0
  do ic = 1,ncc
    ix = tcc(ic)%ix
    iy = tcc(ic)%iy
    image(ix,iy) = image(ix,iy) + tcc(ic)%value
  enddo
end subroutine long_to_image
!
subroutine image_to_long (image,nx,ny,tcc,mcc,ncc)
  use clean_def
  ! @ private
  integer, intent(in) :: nx,ny,mcc
  integer, intent(out) :: ncc
  type (cct_par), intent(out) :: tcc(mcc)
  real, intent(in) :: image(nx,ny)
  !
  integer ix,iy,ic
  ic = 0
  do iy=1,ny
    do ix=1,nx
      if (image(ix,iy).ne.0.0) then
        ic = ic+1
        tcc(ic)%ix = ix
        tcc(ic)%iy = iy
        tcc(ic)%value = image(ix,iy)
      endif
    enddo
  enddo
  ncc = ic
end subroutine image_to_long
!
subroutine display_cct(method,tcc,ncc,ioff)
  use clean_def
  ! @ private
  integer, intent(in) :: ncc
  type(clean_par), intent(inout) :: method
  type(cct_par), intent(in) :: tcc(ncc)
  integer, intent(in) :: ioff
  ! Local
  integer ic
  !$$$ character(1) ans
  !
  do ic=1,ncc
    method%flux = method%flux + tcc(ic)%value
    !$$$         IF (METHOD%FLUX.LT.0) THEN
    !$$$            PRINT *,'Method%flux ',IC,METHOD%FLUX
    !$$$            PRINT *,IC,TCC(IC)
    !$$$            PRINT *,IC-1,TCC(IC-1)
    !$$$            PRINT *,IC-1,TCC(IC-2)
    !$$$            CALL SIC_WPR('What ',ANS)
    !$$$         ENDIF
    if (method%pflux) then
      call draw(dble(ic+ioff),dble(method%flux))
      call gr_out
    endif
  enddo
end subroutine display_cct
!
subroutine cct_normal (tcc,nc,fcomp,tfbeam,nx,ny,wfft,factor)
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS: CLEAN   Internal routine
  !   Compute the SDI normalisation factor
  !----------------------------------------------------------------------
  use clean_def
  integer, intent(in) :: nx,ny,nc
  type (cct_par), intent(in) :: tcc(nc)
  real, intent(in) :: tfbeam(nx,ny)
  complex, intent(inout) :: fcomp(nx,ny)
  real, intent(inout) :: wfft(*)
  real factor
  !
  integer i,j,k,ndim,nn(2)
  !
  fcomp = 0.0
  do k=1,nc
     fcomp(tcc(k)%ix,tcc(k)%iy) = cmplx(tcc(k)%value,0.0)
  enddo
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt(fcomp,nn,ndim,-1,0,wfft)
  fcomp = fcomp*tfbeam
  call fourt(fcomp,nn,ndim,1,1,wfft)
  factor = abs(real(fcomp(1,1)))
  do j=1,ny
    do i=1,nx
      factor = max(factor,abs(real(fcomp(i,j))))
    enddo
  enddo
end subroutine cct_normal
!
subroutine choice_to_cct (c_method,tcc,nc,xcoord,ycoord,values)
  use clean_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Internal routine
  !   Put the selected components into the TCC structure
  !----------------------------------------------------------------------
  type (clean_par), intent(in) :: c_method
  integer, intent(in) :: nc
  type (cct_par), intent(inout) :: tcc(nc)
  integer, intent(in) :: xcoord(nc), ycoord(nc)
  real, intent(in) :: values(nc)
  !
  integer ic,ix,iy
  !
  do ic = 1,nc
    ix = xcoord(ic)
    iy = ycoord(ic)
    tcc(ic)%ix = ix
    tcc(ic)%iy = iy
    tcc(ic)%value = values(ic) * c_method%atten(ix,iy,1)
  enddo
end subroutine choice_to_cct
!
subroutine compact_to_image (c_method,mx,my,tcc,ncc,image,nx,ny)
  use clean_def
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Internal routine
  !   Put the TCC values on the map grid
  !----------------------------------------------------------------------
  type (clean_par) :: c_method
  integer nx,ny,ncc,mx,my
  type (cct_par) :: tcc(ncc)
  real image(nx,ny)
  !
  integer ix,iy,lx,ly,lkx,lky,xfact,yfact, ic,i,j
  real value, rfact
  !
  xfact = nx/mx
  yfact = ny/my
  rfact = 1.0/(xfact*yfact)
  lkx = (xfact+1)/2
  lky = (yfact+1)/2
  !
  image = 0.0
  !
  do ic = 1,ncc
     value = tcc(ic)%value*rfact
     lx = xfact*(tcc(ic)%ix-1) + xfact/2
     ly = yfact*(tcc(ic)%iy-1) + yfact/2
     do j=1,yfact
        do i=1,xfact
           ix = lx-lkx+i
           iy = ly-lky+j
           image(ix,iy) = value
        enddo
     enddo
  enddo
end subroutine compact_to_image

program uv_cal
  use gildas_def
  use gkernel_interfaces
  !
  real(8) :: phase_gain, ampli_gain
  character(len=filename_length) :: uvdata, uvgain, uvcal
  logical :: flag
  logical :: error=.false.
  !
  ! Code:
  call gildas_open
  call gildas_char('UVDATA$',uvdata)
  call gildas_char('UVGAIN$',uvgain)
  call gildas_char('UVCAL$',uvcal)
  call gildas_dble('AMPLI_GAIN$',ampli_gain,1)
  call gildas_dble('PHASE_GAIN$',phase_gain,1)
  call gildas_logi('FLAG$',flag,1)
  call gildas_close
  !
  call sub_uv_cal(uvdata,uvgain,uvcal,ampli_gain,phase_gain,flag,error)
  if (error) call sysexi(fatale)
end program 
!
subroutine sub_uv_cal(uvdata,uvgain,uvcal,ampli_gain,phase_gain,flag,error)
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! GILDAS
  ! Apply gains from a table to another table.
  !       The antenna numbers must match  those of the GAIN Table.
  !       There is no specific verification about this.
  ! Input : a UV table (observed)
  ! Input : a UV table, with the gains.
  ! Output: a UV calibrated table
  !---------------------------------------------------------------------
  real(8), intent(in) :: phase_gain ! Phase Gain
  real(8), intent(in) :: ampli_gain ! Amplitude Gain
  character(len=filename_length), intent(in) :: uvdata ! Raw data
  character(len=filename_length), intent(in) :: uvgain ! Gain table
  character(len=filename_length), intent(in) :: uvcal  ! Calibrated data
  logical, intent(in) :: flag       ! Flag or Keep uncalibrated data
  logical, intent(out) :: error     ! Error return value
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  character(len=*), parameter :: rname='UV_CAL'
  ! Local
  type(gildas) :: gain,raw,self
  real(8), allocatable :: itimg(:), it(:)
  integer, allocatable :: idxg(:), idx(:)
  integer(4) ::  ib, n, nvis, ncol, nvg, ndc, ier, nblock
  character(len=filename_length) :: name
  character(len=message_length) :: mess
  !
  !
  ! print *,'Phase Gain ',phase_gain
  error = .false.
  !
  ! Input file RAW / name UVDATA 
  n = len_trim(uvdata)
  if (n.le.0) goto 999
  name = uvdata(1:n)
  call gildas_null(raw, type = 'UVT')
  call gdf_read_gildas(raw, name, '.uvt', error, data=.false.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read input UV table ')
    return
  endif
  !
  nvis = raw%gil%dim(2)
  ncol = raw%gil%dim(1)
  ndc = raw%gil%nchan
  !
  ! Prepare output calibrated table  SELF / name UVCAL
  call gildas_null (self, type = 'UVT')
  call gdf_copy_header(raw,self,error)
  n = len_trim(uvcal)
  if (n.eq.0) goto 999
  name  = uvcal(1:n)
  call sic_parsef(name,self%file,' ','.uvt')
  call gagout('I-UV_CAL,  Creating UV table '//trim(self%file))
  call gdf_create_image (self,error)
  if (error) then
    call map_message(seve%e,rname,'Cannot create Calibrated Table')
    return
  endif
  !
  ! Input file GAIN / name UVGAIN
  n = len_trim(uvgain)
  if (n.le.0) goto 999
  call gildas_null(gain, type = 'UVT')
  name = uvgain(1:n)
  call sic_parse_file(name,' ','.uvt',gain%file)
  call gagout('I-UV_CAL,  Reading Gain table '//trim(gain%file))
  call gdf_read_gildas(gain, name, '.uvt', error, data=.true.)
  if (error) then
    call map_message(seve%e,rname,'Cannot read gain Table')
    return
  endif
  nvg = gain%gil%dim(2)
  !
  ! Get a bunch of memory ...
  allocate (it(nvis), idx(nvis), stat=ier)
  if (ier.ne.0) then
    error = .true.
    call map_message(seve%e,rname,'Visibility work array allocation error')
    return
  endif
  allocate (itimg(nvg), idxg(nvg), stat=ier)
  if (ier.ne.0) then
    error = .true.
    call map_message(seve%e,rname,'Gain work array allocation error')
    return
  endif
  !
  ! Define blocking factor, on largest data file, usually the input one
  ! but not always...
  call gdf_nitems('SPACE_GILDAS',nblock,raw%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,raw%gil%dim(2))
  ! Allocate respective space for each file
  allocate (raw%r2d(raw%gil%dim(1),nblock), self%r2d(self%gil%dim(1),nblock), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',raw%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ! create the image
  call gdf_create_image(self,error)
  if (error) return
  !
  ! Loop over line table - The example assumes the same
  ! number of visibilities in Input and Output, which may not
  ! be true...
  raw%blc = 0
  raw%trc = 0
  self%blc = 0
  self%trc = 0
  !
  do ib = 1,raw%gil%dim(2),nblock
    write(mess,*) ib,' / ',raw%gil%dim(2),nblock
    call map_message(seve%d,rname,mess)
    raw%blc(2) = ib
    raw%trc(2) = min(raw%gil%dim(2),ib-1+nblock)
    self%blc = raw%blc
    self%trc = raw%trc
    nvis = raw%trc(2)-raw%blc(2)+1
    call gdf_read_data(raw,raw%r2d,error)
    !
    call do_outer_cal(ncol,nvis,raw%r2d,ndc,self%r2d, &
     &    idx, it, nvg, gain%r2d, idxg, itimg,  &
     &    ampli_gain,phase_gain,flag,error)
    !Print *,'Done do_cal ',self%blc(2),self%trc(2),self%gil%dim(2),error
    call gdf_write_data (self,self%r2d,error)
    if (error) return
  enddo
  !
  ! Enfin libre ...
  call gdf_close_image(self, error)
  call gdf_close_image(raw, error)
  if  (.not.error) call map_message(seve%i,rname,'Successful completion')
  return
  !
  999 call map_message(seve%e,rname,'Missing filename')
  error = .true.
end subroutine sub_uv_cal
!
subroutine do_outer_cal(ncol,nvis,data,ndc,cal, &
     &    index,times,nvg,gain,indg,timesg,   &
     &    ampli_gain,phase_gain,flag,error)
  !---------------------------------------------------------------------
  ! Mapping Task
  !   Apply phase and/or amplitude calibration to
  !   the "raw" UV data.   Phase and Amplitudes are stored in
  !   the "gain" UV table, and usually come from a previous
  !   use of Task uv_gain.    This subroutine allows to apply the
  !   corrections to a spectral line table, whatever the way the gains
  !   were computed before.
  !---------------------------------------------------------------------
  integer, intent(in) :: ncol            ! Visibility size
  integer, intent(in) :: nvis            ! Number of visibilities
  real, intent(in) :: data(ncol,nvis)    ! Visibility array
  integer, intent(in) :: ndc             ! Number of channels
  real, intent(out) :: cal(ncol,nvis)    ! Calibrated visibilities
  integer, intent(in) :: index(nvis)     ! Visibility Index
  real(8), intent(inout) :: times(nvis)  ! Visibility Time stamp
  integer, intent(in) :: nvg             ! Number of gains
  real, intent(in) :: gain(10,nvg)       ! Gain array
  integer, intent(out) :: indg(nvg)      ! Index in gains
  real(8), intent(out) :: timesg(nvg)    ! Gain time stamp
  real(8), intent(in) :: ampli_gain      ! Amplitude gain
  real(8), intent(in) :: phase_gain      ! Phase gain
  logical, intent(in) :: flag            ! Keep or Flag uncalibrated data 
  logical, intent(out) :: error          ! Error flag
  ! Local
  integer :: iv, jv, k, mant, ivg, jvg, ia, ja
  parameter (mant=256)  ! ALMA maximum, after renumbering
  complex :: zdata, zgain(mant,mant), zcal, zg
  real :: wg
  real(8) :: t, tg, tgold
  real(8) :: ampli, phase
  real(8) :: time_step = 1.0d0
  !
  logical :: flagged(nvis)
  !-----------------------------------------------------------------------
  !
  ! Get the chronological order, for both input tables:
  do iv=1, nvis
    times(iv) = data(4,iv)*86400.d0+data(5,iv)
  enddo
  call gr8_trie (times,index,nvis,error)
  if (error) then
    call gagout('E-UV_CAL,  Error sorting UV Table')
    return
  endif
  !
  do ivg=1, nvg
    timesg(ivg) = gain(4,ivg)*86400.d0+gain(5,ivg)
  enddo
  call gr8_trie (timesg,indg,nvg,error)
  if (error) then
    call gagout('E-UV_CAL,  Error sorting Gain Table')
    return
  endif
  !
  iv = 1
  jv = index(iv)
  ivg = 1
  tgold = timesg(ivg)
  zgain = 0.0
  !
  ! First setup CAL = DATA by default 
  ! Uncalibrated data will be kept or flagged as desired
  cal = data
  !
  ! The loop is done on calibration times, so
  ! there is no guarantee that a given data visibility is treated.
  !
  ! To handle this, we set a counter for each visibility, to
  ! check whether it has indeed been affected...
  !
  flagged(1:nvis) = .true.
  jvg = indg(1) ! To suppress compiler warning
  !
  do ivg = 1, nvg+1
    if (ivg.le.nvg) then
      jvg = indg(ivg)
      tg = timesg(ivg)
    else
      ! Last one, force a dummy time change
      tg = tgold+1e20
    endif
    !         type *, 'ivg, jvg, tg, tgold'
    !         type *, ivg, jvg, tg, tgold
    if (tg.ne.tgold) then
      ! Time change, apply calibration
      t = times(iv)
      jv = index(iv)
      do while (t-tgold.le.time_step)
        !               type *, 'iv,jv,t'
        !               type *, iv,jv,t
        if (t.ge.tgold-time_step) then
          flagged(jv) = .false.
          ia = nint(cal(6,jv))
          ja = nint(cal(7,jv))
          !                  type *, ia, ja, zgain(ia,ja)
          if (zgain(ia,ja).ne.0) then
            zg = zgain(ia,ja)
            wg = abs(zg)**2
            do k=8, 3*ndc+7, 3
              zdata = cmplx(data(k,jv),data(k+1,jv))
              zcal = zdata/zg
              cal(k,jv) = real(zcal)
              cal(k+1,jv) = aimag(zcal)
              cal(k+2,jv) = data(k+2,jv)*wg
            enddo
          else
            if (flag) cal(8:3*ndc+7,jv) = 0.0
          endif
        endif
        iv = iv+1
        if (iv.gt.nvis) goto 100 !! Proper finish, no return
        t = times(iv)
        jv = index(iv)
        ! print *, iv, jv, t-tgold
      enddo
      tgold = tg
      zgain = 0.0
    endif
    ! Always fill the baseline gain array
    ! (even if new time !)
    !
    ia = nint(gain(6,jvg))
    ja = nint(gain(7,jvg))
    ampli = sqrt(gain(8,jvg)**2+gain(9,jvg)**2)
    phase = atan2(gain(9,jvg),gain(8,jvg))
    if (gain(10,jvg).le.0) ampli = 0
    if (ampli.ne.0) then
      !
      ! Correct (a fraction of) the phase
      phase = phase_gain*phase
      zg = cmplx(cos(phase),sin(phase))
      !
      ampli = 1d0-ampli_gain+ampli*ampli_gain
      zg = ampli*zg
      !
      ! Fill both baseline directions...
      zgain(ia,ja) = zg
      zgain(ja,ia) = conjg(zg)
    else
      ! Reset Zgain to 0
      zgain = 0.0
    endif
    !            type *, ia, ja, zGAIN(IA,JA)
  enddo
  !
  ! Finish by checking what has been calibrated...
100 continue
  if (any(flagged)) then
    if (flag) then
      Print *,'Flagged visibilities '
      do iv = 1,nvis
        if (flagged(iv)) then
          Print *,iv
          cal(8:3*ndc+7,iv) = 0.0
        endif
      enddo
    else
      Print *,'Uncalibrated visibilities '
      do iv = 1,nvis
        if (flagged(iv)) then
          Print *,iv
        endif
      enddo
    endif
  endif
end subroutine do_outer_cal

module noema_tsys_parameters
  !---------------------------------------------------------------------
  ! Parameters (and variables deduced from these) which are shared by
  ! the 2 tables produced by the command NOEMA\TSYS
  !---------------------------------------------------------------------
  !
  ! Data format
  integer(kind=4), parameter :: binversion=1
  !
  ! Physical parameters
  real(kind=4),    parameter :: h0=2.560    ! [km]  NOEMA altitude
  real(kind=4),    parameter :: p0=1013.0   ! [HPa] At sea level
  real(kind=4)               :: p1          ! [HPa] At site altitude
  integer(kind=4), parameter :: nt=2        ! Number of atmosphere temperatures
  real(kind=4),    parameter :: t(nt) = (/ 273.,283. /)  ! [K]
  !
  ! Hardware
  real(kind=4),    parameter :: gim=0.05    ! [   ] Image gain ratio
  integer(kind=4), parameter :: nb=3        !       Number of bands
  real(kind=4),    parameter :: trec(nb) = (/ 35.,45.,55. /)       ! [K] Trec values
  real(kind=4),    parameter :: feff(nb) = (/ 0.96, 0.94, 0.90 /)  ! [ ] Forward efficiencies
  !
  ! Frequencies. The ranges are defined at run time thanks to
  ! the subroutine 'rec_define_noema'
  real(kind=4)              :: rf_step      ! [GHz]
  real(kind=4)              :: rf_min(nb)   ! [GHz]
  real(kind=4)              :: rf_max(nb)   ! [GHz]
  integer(kind=4)           :: nrf          !
  real(kind=4), allocatable :: rf(:)        ! [GHz]
  real(kind=4)              :: lof_step     ! [GHz]
  real(kind=4)              :: lof_min(nb)  ! [GHz]
  real(kind=4)              :: lof_max(nb)  ! [GHz]
  integer(kind=4)           :: nlof         !
  real(kind=4), allocatable :: lof(:)       ! [GHz]
  !
  ! Airmass
  real(kind=4),    parameter   :: a_step=0.5  ! [Neper]
  real(kind=4),    parameter   :: a_min=1.    ! [Neper] Elevation 90 deg
  real(kind=4),    parameter   :: a_max=6.    ! [Neper] Elevation ~9.5 deg
  integer(kind=4)              :: na          !
  real(kind=4),    allocatable :: a(:)        !
  !
  ! PWV
  real(kind=4),    parameter   :: w_step=0.5  ! [mm]
  real(kind=4),    parameter   :: w_min=2.    ! [mm]
  real(kind=4),    parameter   :: w_max=7.    ! [mm]
  integer(kind=4)              :: nw          !
  real(kind=4),    allocatable :: w(:)        !
  !
end module noema_tsys_parameters
!
subroutine noema_tsys(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_tsys
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   NOEMA\TSYS TableName [/CONTINUUM]
  ! Compute the Tsys  binary table
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TSYS'
  integer(kind=4), parameter :: optcont=1
  character(len=filename_length) :: tsysfile
  integer(kind=4) :: nc
  !
  call sic_ch(line,0,1,tsysfile,nc,.true.,error)
  if (error)  return
  !
  if (gag_inquire(tsysfile,nc).eq.0) then
    call astro_message(seve%e,rname,  &
      'File '//tsysfile(1:nc)//' already exists. Remove it first.')
    error = .true.
    if (error)  return
  endif
  !
  if (sic_present(optcont,0)) then
    call noema_tsys_continuum(tsysfile,error)
    if (error)  continue
  else
    call noema_tsys_table(tsysfile,error)
    if (error)  continue
  endif
  !
  call noema_tsys_clean()
  !
end subroutine noema_tsys
!
subroutine noema_tsys_setup(rfstep,lofstep,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_tsys_setup
  use astro_types
  use ast_line
  use noema_tsys_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Set up the parameters
  !---------------------------------------------------------------------
  real(kind=4), intent(in)    :: rfstep   !
  real(kind=4), intent(in)    :: lofstep  !
  logical,      intent(inout) :: error    !
  ! Local
  character(len=*), parameter :: rname='TSYS'
  type(receiver_t) :: rec
  integer(kind=4) :: ib,ia,iw,irf,ilof,ier
  !
  p1 = p0*2.0**(-h0/5.5)  ! [HPa] Pressure at altitude h0
  !
  ! Get receiver parameters
  call rec_define_noema(rec,noema_mode,error)
  if (error)  return
  !
  if (rec%desc%n_rbands.ne.nb) then
    ! If error, adapt Trec and Feff arrays
    call astro_message(seve%e,rname,'Number of bands not supported')
    error = .true.
    return
  endif
  !
  ! Frequency ranges
  do ib=1,rec%desc%n_rbands
    ! Compute our frequency range. Be conservative (floor/ceiling) + align
    ! to the nearest GHz (purely cosmetic) + 1 more GHz at boundary because
    ! in some cases (e.g. Doppler effect) one has to explore slightly beyond
    ! the usual limits.
    lof_min(ib) = floor(rec%desc%lohard(1,ib)/1000.)-1
    lof_max(ib) = ceiling(rec%desc%lohard(2,ib)/1000.)+1
    rf_min(ib) = floor(rec%desc%rflim(1,ib)/1000.)-1
    rf_max(ib) = ceiling(rec%desc%rflim(2,ib)/1000.)+1
  enddo
  !
  rf_step = rfstep
  lof_step = lofstep
  !
  ! Number of RF/IF frequencies
  nrf = (rf_max(rec%desc%n_rbands)-rf_min(1))/rf_step+1  ! Assume that bands are ordered increasingly
  ! Number of LO frequencies: the whole range is sampled with no gap between
  ! bands. Beware this feature is used by PMS.
  nlof = (lof_max(rec%desc%n_rbands)-lof_min(1))/lof_step+1  ! Assume that bands are ordered increasingly
  ! Number of airmasses: easy
  na = (a_max-a_min)/a_step+1
  ! Number of pwv: easy
  nw = (w_max-w_min)/w_step+1
  !
  ! Define the vectors
  allocate(rf(nrf),lof(nlof),a(na),w(nw),stat=ier)
  if (failed_allocate(rname,'dimension buffers',ier,error))  return
  ! RF frequencies
  do irf=1,nrf
    rf(irf) = rf_min(1)+(irf-1)*rf_step
  enddo
  ! LO frequencies
  do ilof=1,nlof
    lof(ilof) = lof_min(1)+(ilof-1)*lof_step
  enddo
  ! Airmasses
  do ia=1,na
    a(ia) = a_min+(ia-1)*a_step
  enddo
  ! PWV
  do iw=1,nw
    w(iw) = w_min+(iw-1)*w_step
  enddo
  !
end subroutine noema_tsys_setup
!
subroutine noema_tsys_clean()
  use noema_tsys_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Deallocate the global buffers. There is no need to keep them
  ! allocated after the command has ended
  !---------------------------------------------------------------------
  !
  if (allocated(rf))   deallocate(rf)
  if (allocated(lof))  deallocate(lof)
  if (allocated(a))    deallocate(a)
  if (allocated(w))    deallocate(w)
  !
end subroutine noema_tsys_clean
!
subroutine noema_tsys_table(file,error)
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use atm_interfaces_public
  use astro_interfaces, except_this=>noema_tsys_table
  use astro_types
  use noema_tsys_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the Tsys + Opacity table
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: file
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TSYS'
  character(len=message_length) :: mess
  integer(kind=4) :: if,ia,iw,it,ier,ib
  real(kind=4) :: temis,temii,tatm,tauox,tauw,dummy,taut
  real(kind=4), allocatable :: vtrec(:),vfeff(:)
  real(kind=4), allocatable :: tsys(:,:,:,:)
  type(time_t) :: time
  !
  ! Parameters
  real(kind=4), parameter :: intfreq=0.  ! [GHz] Intermediate frequency
  ! IF (used to compute the image frequency) is set to 0 because:
  ! 1) typical values show a Tsys difference near 0% at the center of
  !    the bands (where Tsys is flat), and less than 2% at the band
  !    sides (where Tsys varies faster in one sideband than in the
  !    other). => NB: probably not true anymore now that gim is 0.05
  ! 2) it is quite difficult/impossible to produce a generic Tsys table
  !    which would know in advance what is the image frequency distance
  !    and side (lower or upper). In other words we can not know what is
  !    the image frequency associated to a given signal frequency.
  !
  !
  ! Set up the parameters and define the frequency sampling. The RF is
  ! sampled every GHz (this produces a table of reasonable size). LO
  ! sampling is actually unused here.
  call noema_tsys_setup(1.,1.,error)
  if (error)  return
  !
  ! Vectorized Trec and Feff:
  allocate(vtrec(nrf),vfeff(nrf),stat=ier)
  if (failed_allocate(rname,'Trec & Feff buffers',ier,error))  return
  vtrec(:) = 1e4   ! Blank value: very bad Trec (but valid in computations)
  vfeff(:) = 1e-4  ! Blank value: very bad Feff (but valid in computations)
  do ib=1,nb
    where (rf.ge.rf_min(ib) .and. rf.le.rf_max(ib))
      vtrec = trec(ib)
      vfeff = feff(ib)
    end where
  enddo
  !
  call astro_message(seve%i,rname,'Computing Tsys table with')
  write (mess,10)  nrf,' frequencies  from ',rf(1),' to ',rf(nrf),' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  na,' airmasses    from ',a(1),' to ',a(na),' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  nw,' pwv          from ',w(1),' to ',w(nw),' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  nt,' temperatures from ',t(1),' to ',t(nt)
  call astro_message(seve%i,rname,mess)
10 format(I5,A,F6.2,A,F6.2,A)
  !
  ! Now compute Tsys
  allocate(tsys(nrf,na,nw,nt),stat=ier)
  if (failed_allocate(rname,'tsys buffers',ier,error))  return
  !
  call gtime_init(time,nt*nw*na*nrf,error)
  if (error)  return
  !
  do it=1,nt
    call atm_atmosp(t(it),p1,h0)
    do iw=1,nw
      do ia=1,na
        do if=1,nrf
          ! Signal
          call atm_transm(w(iw),a(ia),rf(if),temis,tatm,tauox,tauw,taut,ier)
          ! Image
          if (intfreq.eq.0.) then
            temii = temis
          else
            call atm_transm(w(iw),a(ia),rf(if)+2.*intfreq,temii,tatm,tauox,tauw,dummy,ier)
          endif
          ! Store Tsys at current airmass
          tsys(if,ia,iw,it) = ( gim * (vfeff(if)*temii+(1.0-vfeff(if))*t(it) + vtrec(if)) +  &
                                      (vfeff(if)*temis+(1.0-vfeff(if))*t(it) + vtrec(if))    &
                              ) / vfeff(if) * exp(taut*a(ia))
          !
          call gtime_current(time)
          if (sic_ctrlc()) then
            call astro_message(seve%e,rname,'Aborted')
            error = .true.
            return
          endif
          !
        enddo
      enddo
    enddo
  enddo
  !
  call noema_tsys_write_bintable(file,error)
  if (error)  return
  !
contains
  subroutine noema_tsys_write_bintable(file,error)
    use gildas_def
    use gbl_format
    !-------------------------------------------------------------------
    !
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: file
    logical,          intent(inout) :: error
    ! Local
    integer(kind=4) :: ier,nfile,lun,currec,recpos
    character(len=message_length) :: mess
    character(len=4) :: tab_code
    integer(kind=4), parameter :: reclen=128  ! Words
    integer(kind=4) :: buffer(reclen)
    !
    ier = sic_getlun(lun)
    nfile = len_trim(file)
    open(unit=lun,file=file(1:nfile),status='NEW',access='DIRECT',   &
        form='UNFORMATTED',iostat=ier,recl=reclen*facunf)
    if (ier.ne.0) then
      call astro_message(seve%e,rname,'Filename: '//file)
      call putios('E-ATM, Open error: ',ier)
      error = .true.
      goto 99
    endif
    !
    call gdf_getcod(tab_code)
    call chtoby(tab_code,buffer(1),4)
    call i4toi4(binversion,buffer(2),1)
    call r4tor4(p1,buffer(3),1)
    call r4tor4(gim,buffer(4),1)
    call r4tor4(intfreq,buffer(5),1)
    call i4toi4(nrf,buffer(6),1)
    call i4toi4(na,buffer(7),1)
    call i4toi4(nw,buffer(8),1)
    call i4toi4(nt,buffer(9),1)
    currec = 1
    recpos = 10
    !
    call noema_tsys_write_binarray(lun,rf,nrf,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,a,na,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,w,nw,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,t,nt,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,vtrec,nrf,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,vfeff,nrf,buffer,currec,recpos,error)
    if (error)  goto 98
    !
    call noema_tsys_write_binarray(lun,tsys,nrf*na*nw*nt,buffer,currec,recpos,error)
    if (error)  goto 98
    !
    if (recpos.ne.1) then
      ! Flush last record
      write(lun,rec=currec,iostat=ier)  buffer
      if (ier.ne.0) then
        write(mess,'(A,I0)') 'Error writing record ',currec
        call astro_message(seve%e,rname,mess)
        error = .true.
        goto 98
      endif
    endif
    !
    write(mess,'(I0,A)') currec,' records written'
    call astro_message(seve%i,rname,mess)
    !
98  close(lun)
99  call sic_frelun(lun)
  end subroutine noema_tsys_write_bintable
  !
end subroutine noema_tsys_table
!
subroutine noema_tsys_continuum(file,error)
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use atm_interfaces_public
  use astro_interfaces, except_this=>noema_tsys_continuum
  use noema_tsys_parameters
  !---------------------------------------------------------------------
  ! @ private
  ! Compute the Tsys + Opacity table
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: file
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TSYS'
  character(len=message_length) :: mess
  integer(kind=4) :: irf,ilof,ia,iw,it,ier,ib
  real(kind=4) :: tatm,tauox,tauw
  real(kind=4), allocatable :: vtrec(:),vfeff(:),temi(:),taut(:)
  real(kind=4), allocatable :: tsys(:,:,:,:,:)
  type(time_t) :: time
  !
  ! Elements
  integer(kind=4), parameter :: ne=3  ! Number of elements stored (Tsys_aver, Tsys_min, Tsys_max)
  integer(kind=4), parameter :: imin=1   ! Index for Tsys_min
  integer(kind=4), parameter :: iaver=2  ! Index for Tsys_aver
  integer(kind=4), parameter :: imax=3   ! Index for Tsys_max
  !
  !
  ! Set up the parameters and define the frequency sampling. The RF is
  ! sampled every 0.1 GHz (this gives good estimation of the average Tsys
  ! over the side band (and this parameter does not influence the table
  ! size). The LO frequency is sampled every GHz (this produces a table
  ! of reasonable size).
  call noema_tsys_setup(0.1,1.0,error)
  if (error)  return
  !
  ! Vectorized Trec and Feff. There are just defined for bookkeeping in the
  ! output table.
  allocate(vtrec(nlof),vfeff(nlof),stat=ier)
  if (failed_allocate(rname,'Trec & Feff buffers',ier,error))  return
  vtrec(:) = 1e4   ! Blank value: very bad Trec (but valid in computations)
  vfeff(:) = 1e-4  ! Blank value: very bad Feff (but valid in computations)
  do ib=1,nb
    where (lof.ge.rf_min(ib) .and. lof.le.rf_max(ib))
      vtrec = trec(ib)
      vfeff = feff(ib)
    end where
  enddo
  !
  call astro_message(seve%i,rname,'Computing Tsys continuum table with')
  write (mess,10)  ne,  ' elements                              x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  nlof,' LO frequencies  from ',lof(1),' to ',lof(nlof),' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  na,  ' airmasses       from ',a(1),  ' to ',a(na),    ' x '
  call astro_message(seve%i,rname,mess) 
  write (mess,10)  nw,  ' pwv             from ',w(1),  ' to ',w(nw),    ' x '
  call astro_message(seve%i,rname,mess)
  write (mess,10)  nt,  ' temperatures    from ',t(1),  ' to ',t(nt)
  call astro_message(seve%i,rname,mess)
10 format(I5,A,F6.2,A,F6.2,A)
  !
  ! Now compute Tsys
  allocate(temi(nrf),taut(nrf),tsys(ne,nlof,na,nw,nt),stat=ier)
  if (failed_allocate(rname,'tsys buffers',ier,error))  return
  !
  call gtime_init(time,nt*nw*na,error)
  if (error)  return
  !
  do it=1,nt
    call atm_atmosp(t(it),p1,h0)
    do iw=1,nw
      do ia=1,na
        ! Compute Temi and Tau for each frequency. They will be used to compute
        ! the Tsys in the 2 sidebands. The sampling is done at 'if_step'
        do irf=1,nrf
          ! Signal
          call atm_transm(w(iw),a(ia),rf(irf),temi(irf),tatm,tauox,tauw,taut(irf),ier)
        enddo
        do ilof=1,nlof
          call tsys_at_lof(t(it),a(ia),lof(ilof),  &
                           tsys(iaver,ilof,ia,iw,it),   &
                           tsys(imin, ilof,ia,iw,it),   &
                           tsys(imax, ilof,ia,iw,it))
          !
          if (sic_ctrlc()) then
            call astro_message(seve%e,rname,'Aborted')
            error = .true.
            return
          endif
          !
        enddo
        call gtime_current(time)
      enddo
    enddo
  enddo
  !
  call noema_tsys_write_bintable(file,error)
  if (error)  return
  !
contains
  subroutine tsys_at_lof(temp,air,lof,tsys_aver,tsys_min,tsys_max)
    !-------------------------------------------------------------------
    ! Compute the average, minimum, and maximum Tsys for the input Flo
    !-------------------------------------------------------------------
    real(kind=4), intent(in)  :: temp
    real(kind=4), intent(in)  :: air
    real(kind=4), intent(in)  :: lof
    real(kind=4), intent(out) :: tsys_aver
    real(kind=4), intent(out) :: tsys_min
    real(kind=4), intent(out) :: tsys_max
    ! Local
    integer(kind=4) :: isb,isig,iima,ntsys
    integer(kind=size_length) :: ilof
    real(kind=4) :: fmin,fmax,foreff,temrec,tsys,tsys_sum
    ! Parameters
    integer(kind=4), parameter :: nsb=2  ! LSB+USB
    real(kind=4), parameter :: if_min=4.    ! [GHz] IF range (min)
    real(kind=4), parameter :: if_max=12.   ! [GHz] IF range (max)
    !
    ! Position of lof in the RF array
    call gr4_dicho(int(nrf,kind=size_length),rf,lof,ilof)
    if (rf(ilof).ne.lof) then
      ! It is better to have it aligned so that the signal and
      ! image frequencies are exact mirrors w/t the LO freq
      call astro_message(seve%w,rname,'LOF not on RF grid')
    endif
    !
    ntsys = 0
    tsys_sum = 0.
    tsys_min = 1e10
    tsys_max = 0.
    do isb=1,nsb
      if (isb.eq.1) then
        fmin = lof - if_max
        fmax = lof - if_min
      else
        fmin = lof + if_min
        fmax = lof + if_max
      endif
      do irf=1,nrf
        if (rf(irf).lt.fmin .or. rf(irf).gt.fmax)  cycle
        !
        ! Position of signal and image frequencies in RF array
        isig = irf
        iima = ilof + (ilof-isig)
        !
        ! Feff and Trec at signal frequency
        foreff = foeff(rf(isig))
        temrec = terec(rf(isig))
        !
        ntsys = ntsys+1
        tsys = ( gim * (foreff*temi(iima)+(1.0-foreff)*temp + temrec) +  &
                       (foreff*temi(isig)+(1.0-foreff)*temp + temrec)    &
               ) / foreff * exp(taut(isig)*air)
        tsys_sum = tsys_sum + tsys**2
        if (tsys.lt.tsys_min)  tsys_min = tsys
        if (tsys.gt.tsys_max)  tsys_max = tsys
      enddo
    enddo
    !
    ! Post-processing
    if (ntsys.eq.0) then
      tsys_aver = 0.
    elseif (gag_isreal(tsys_sum).eq.0) then
      tsys_aver = sqrt(tsys_sum/ntsys)
    else
      tsys_aver = 1e10  ! Avoid +Inf in table
    endif
    if (gag_isreal(tsys_max).eq.1)  tsys_max = 1e10  ! Trap +Inf too
    !
  end subroutine tsys_at_lof
  !
  function foeff(rf)
    real(kind=4) :: foeff
    real(kind=4), intent(in) :: rf
    ! Local
    integer(kind=4) :: ib
    !
    do ib=1,nb
      if (rf.ge.rf_min(ib) .and. rf.le.rf_max(ib)) then
        foeff = feff(ib)
        return
      endif
    enddo
    foeff = 1e-4  ! Blank value: very bad Feff (but valid in computations)
    !
  end function foeff
  !
  function terec(rf)
    real(kind=4) :: terec
    real(kind=4), intent(in) :: rf
    ! Local
    integer(kind=4) :: ib
    !
    do ib=1,nb
      if (rf.ge.rf_min(ib) .and. rf.le.rf_max(ib)) then
        terec = trec(ib)
        return
      endif
    enddo
    terec = 1e4   ! Blank value: very bad Trec (but valid in computations)
    !
  end function terec
  !
  subroutine noema_tsys_write_bintable(file,error)
    use gildas_def
    use gbl_format
    !-------------------------------------------------------------------
    ! Specific to the continuum table
    !-------------------------------------------------------------------
    character(len=*), intent(in)    :: file
    logical,          intent(inout) :: error
    ! Local
    integer(kind=4) :: ier,nfile,lun,currec,recpos
    character(len=message_length) :: mess
    character(len=4) :: tab_code
    integer(kind=4), parameter :: reclen=128  ! Words
    integer(kind=4) :: buffer(reclen)
    !
    ier = sic_getlun(lun)
    nfile = len_trim(file)
    open(unit=lun,file=file(1:nfile),status='NEW',access='DIRECT',   &
        form='UNFORMATTED',iostat=ier,recl=reclen*facunf)
    if (ier.ne.0) then
      call astro_message(seve%e,rname,'Filename: '//file)
      call putios('E-ATM, Open error: ',ier)
      error = .true.
      goto 99
    endif
    !
    call gdf_getcod(tab_code)
    call chtoby(tab_code,buffer(1),4)
    call i4toi4(binversion,buffer(2),1)
    call r4tor4(p1,buffer(3),1)
    call r4tor4(gim,buffer(4),1)
    call i4toi4(ne,buffer(5),1)
    call i4toi4(nlof,buffer(6),1)
    call i4toi4(na,buffer(7),1)
    call i4toi4(nw,buffer(8),1)
    call i4toi4(nt,buffer(9),1)
    currec = 1
    recpos = 10
    !
    ! NB: There is no description of the 'elements' which are stored.
    call noema_tsys_write_binarray(lun,lof,nlof,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,a,na,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,w,nw,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,t,nt,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,vtrec,nlof,buffer,currec,recpos,error)
    if (error)  goto 98
    call noema_tsys_write_binarray(lun,vfeff,nlof,buffer,currec,recpos,error)
    if (error)  goto 98
    !
    call noema_tsys_write_binarray(lun,tsys,ne*nlof*na*nw*nt,buffer,currec,recpos,error)
    if (error)  goto 98
    !
    if (recpos.ne.1) then
      ! Flush last record
      write(lun,rec=currec,iostat=ier)  buffer
      if (ier.ne.0) then
        write(mess,'(A,I0)') 'Error writing record ',currec
        call astro_message(seve%e,rname,mess)
        error = .true.
        goto 98
      endif
    endif
    !
    write(mess,'(I0,A)') currec,' records written'
    call astro_message(seve%i,rname,mess)
    !
98  close(lun)
99  call sic_frelun(lun)
  end subroutine noema_tsys_write_bintable
  !
end subroutine noema_tsys_continuum
!
subroutine noema_tsys_write_binarray(lun,array,n,buffer,currec,recpos,error)
  use gbl_message
  use astro_interfaces, except_this=>noema_tsys_write_binarray
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  integer(kind=4), intent(in)    :: lun
  integer(kind=4), intent(in)    :: n
  real(kind=4),    intent(in)    :: array(n)
  integer(kind=4), intent(inout) :: buffer(:)
  integer(kind=4), intent(inout) :: currec
  integer(kind=4), intent(inout) :: recpos
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='TSYS'
  integer(kind=4), parameter :: reclen=128
  character(len=message_length) :: mess
  integer(kind=4) :: nwritetot,nwritecur,ier
  !
  nwritetot = 0
  do while (nwritetot.lt.n)
    !
    nwritecur = min(n-nwritetot,reclen-recpos+1)
    call r4tor4(array(nwritetot+1),buffer(recpos),nwritecur)
    nwritetot = nwritetot+nwritecur
    recpos = recpos+nwritecur
    !
    if (recpos.gt.reclen) then
      ! print *,"Writing record ",currec
      write(lun,rec=currec,iostat=ier)  buffer
      if (ier.ne.0) then
        write(mess,'(A,I0)') 'Error writing record ',currec
        call astro_message(seve%e,rname,mess)
        error = .true.
        return
      endif
      currec = currec+1
      recpos = 1
    endif
    !
  enddo
end subroutine noema_tsys_write_binarray

subroutine map_center(line,task,huv,shift,newabs,error)
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use image_def
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !
  ! Support for commands which can interpret the MAP_CENTER string.
  !   UV_MAP,  UV_SHIFT,  UV_DEPROJECT
  ! Decode the phase center and rotation parameters, either from
  ! the MAP_CENTER string, or (if present) from the command 
  ! line arguments.
  !
  ! The MAP_CENTER string can be specified by LET MAP_CENTER,
  !
  ! The syntax can be
  !   PosX PosY UNIT [[ANGLE] AngleValue]
  !   ANGLE AngleValue [PosX PosY UNIT]
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line     ! Command line
  character(len=*), intent(in) :: task     ! Task name
  type(gildas), intent(inout) :: huv       ! UV data set
  logical, intent(out) :: shift            ! Must shift data ?
  real(kind=8), intent(inout) :: newabs(3) ! Shifting coordinates
  logical, intent(inout) :: error          ! Error flag
  !
  real(kind=8), parameter :: pi=3.14159265358979323846d0
  real(kind=8), parameter :: sec=pi/180d0/3600D0
  !
  type(projection_t) :: proj
  integer, parameter :: munit=6
  character(len=8) :: angle_type(munit), kunit
  character(len=32) :: argum
  real(kind=8) :: angle_scale(munit), off(2), dra, ddec, pang
  integer :: iunit, n, narg
  integer :: ikey, ira, idec, iang
  data angle_type /'ABSOLUTE','SECONDS','MINUTES','DEGREES','RADIANS','ANGLE'/
  !
  angle_scale = [0.d0,pi/180d0/3600d0,pi/180d0/60d0,pi/180d0,1.d0,pi/180d0]  
  !
  ! Decode the command line syntax
  !   COMMAND  PosX PosY UNIT [[ANGLE] AngleValue]
  !   COMMAND  ANGLE AngleValue [PosX PosY UNIT]
  !
  iang = 0
  ira = 0
  idec = 0
  ikey = 0
  !
  shift = .false.
  narg = sic_narg(0)
  !
  newabs = [huv%gil%a0,huv%gil%d0,huv%gil%pang]
  pang = huv%gil%pang
  !
  ! No argument, no shift to do...
  select case(narg)
  case (0)
    return
  case (2)    ! ANGLE Value
    call sic_ke(line,0,1,argum,n,.true.,error)
    call sic_ambigs(task,argum,kunit,iunit,angle_type(6:6),1,error)
    iang = 2
  case (3)    ! Ox Oy UNIT
    ikey = 3
    ira = 1
    idec = 2
  case (4)    ! Ox Oy UNIT ANGLE
    ikey = 3
    ira = 1
    idec = 2
    iang = 4
  case (5)    ! Two possibilities
    ! ANGLE AngVal Ox Oy UNIT
    !   or
    ! Ox Oy UNIT ANGLE AngVal
    !
    call sic_ke(line,0,1,argum,n,.true.,error)
    if (argum(1:1).ne.'A') then
      call sic_ke(line,0,4,argum,n,.true.,error)
      if (argum(1:1).ne.'A') error = .true.
      iang = 5
      ira = 1
      idec = 2
      ikey = 3
    else
      iang = 2
      ira = 3
      idec = 4
      ikey = 5
    endif
    if (.not.error) then
      call sic_ambigs(task,argum,kunit,iunit,angle_type(6:6),1,error)
    endif
    !
  case default
    error = .true.
  end select 
  if (error) then
    call map_message(seve%e,task,'Invalid syntax '//trim(line))
    return
  endif
  !
  ! Angle
  if (iang.ne.0) then
    call sic_r8(line,0,iang,pang,.true.,error) 
    if (error) return
    ! 
    pang = pang*angle_scale(munit)
    if (abs(pang-huv%gil%pang).le.sec) then
      shift = .false.
      pang = huv%gil%pang
    else
      shift = .true.
    endif
  endif
  !
  if (ikey.ne.0) then
    call sic_ke(line,0,ikey,argum,n,.true.,error)
    if (error) return
    call sic_ambigs(task,argum,kunit,iunit,angle_type,5,error)
    if (error) return
    !
    if (kunit.eq.'ABSOLUTE') then
      call sic_ch(line,0,ira,argum,n,.true.,error)
      call sic_decode(argum,dra,24,error)
      if (error) then
        call map_message(seve%e,task,'Input conversion error on RA phase center '//argum)
        return
      endif
      call sic_ch(line,0,idec,argum,n,.true.,error)
      call sic_decode(argum,ddec,360,error)
      if (error) then
        call map_message(seve%e,task,'Input conversion error on Dec phase center '//argum)
        return
      endif
      newabs(1) = dra
      newabs(2) = ddec
    else
      call sic_r8(line,0,ira,off(1),.true.,error)
      call sic_r8(line,0,idec,off(2),.true.,error)
      off = off*angle_scale(iunit)
      ! Projection 
      call gwcs_projec(huv%gil%a0,huv%gil%d0,huv%gil%pang,huv%gil%ptyp,proj,error)
      call rel_to_abs (proj,off(1),off(2),newabs(1),newabs(2),1)
    endif
    !
    shift = .true.
    !
  endif
  !
  newabs(3) = pang
  !
  call print_change_header('MAP_CENTER', huv, newabs, shift)
  !
end subroutine map_center
!
subroutine print_change_header(task,huv,newabs,shift)
  use image_def
  use gkernel_interfaces, only : rad2sexa
  !---------------------------------------------------------------------
  ! @ private
  !   IMAGER
  ! Debugging routine
  !---------------------------------------------------------------------  
  character(len=*), intent(in) :: task
  type(gildas), intent(in) :: huv
  real(kind=8), intent(in) :: newabs(3)
  logical, intent(in) :: shift
  !
  character :: cra*14, cdec*14, cang*8
  real(8), parameter :: pi=acos(-1d0)
  !
  call rad2sexa(huv%gil%a0,24,cra)
  call rad2sexa(huv%gil%d0,360,cdec)
  write (cang,'(F8.2)') huv%gil%pang*180./pi
  Print *,task,' OLD projection ',cra,cdec,cang
  call rad2sexa(newabs(1),24,cra)
  call rad2sexa(newabs(2),360,cdec)
  write (cang,'(F8.2)') newabs(3)*180./pi
  Print *,task,' NEW projection ',cra,cdec,cang
  Print *,task,' SHIFT          ',shift
  !
end subroutine print_change_header
!
!
subroutine map_query (line,task,map,goon,error) 
  use gbl_message
  use gkernel_interfaces
  use gkernel_types
  use image_def
  use clean_arrays
  use clean_default
  !---------------------------------------------------------------------
  ! @ private
  !
  ! Support for commands
  !   UV_MAP ?
  !     Display the imaging parameters
  ! or
  !   UV_MAP 
  !     Set the arguments for the phase center and rotation parameters
  !     if MAP_CENTER is not empty
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: line  ! Command line
  character(len=*), intent(in) :: task  ! Task name
  type(uvmap_par), intent(in) :: map    ! Mapping parameters 
  logical, intent(inout) :: goon        ! Continue or Return after ?
  logical, intent(inout) :: error       ! Error flag
  !
  character(len=1), parameter :: question_mark='?'
  !
  integer :: narg,nline,n,i,nlast,nopt
  character(len=32) :: argum,comm
  character(len=128) :: string
  !
  narg = sic_narg(0)
  goon = .true.
  if (narg.eq.1) then
    call sic_ch(line,0,1,argum,n,.false.,error)
    if (argum(1:1).eq.question_mark) then
      call exec_program("@ i_uv_map "//argum)
      goon = .false.
    endif
  else if (narg.eq.0) then
    !
    ! Reset the command line if MAP_CENTER is non null
    call sic_get_char('MAP_CENTER',string,n,error)
    if (n.eq.0) return
    !
    call sic_upper(string)
    nopt = sic_nopt(narg)
    nline = len_trim(line)
    nlast = nline
    do i=1,nopt
      if (sic_present(i,0)) then
        nlast = min(nlast,sic_start(i,0))
      endif
    enddo
    if (nlast.ne.nline)  then
      line = line(1:nlast-1)//trim(string)//line(nlast-1:)
    else
      nline = nline+2 ! Skip a space
      line(nline:) = string
    endif
    nline = len_trim(line)
    call sic_analyse(comm,line,nline,error)
  endif
end subroutine map_query

function fgauss(xvel,x)
  use gauss_parameter
  !-------------------------------------------------------------------
  ! @ private
  ! CLASS internal function
  ! Not used ?
  !-------------------------------------------------------------------
  real(kind=8) :: fgauss            ! Function value on return
  real(kind=8), intent(in) :: xvel  ! Central velocity
  real(kind=8), intent(in) :: x(*)  ! Input lines parameters
  ! Local
  integer :: i
  real :: ff,tt,vv,dd,xf,xt,xv,xd,arg
  !
  ff=0.
  tt=x(1) ! Temperature
  vv=x(2) ! Central velocity
  dd=x(3) ! FWHM
  !
  do i=1,nline
     xt = x(3*i+1) * tt
     xv = x(3*i+2) + vv
     xd = x(3*i+3) * dd
     arg = (xvel - xv) / xd
     if (abs(arg).gt.4) then
        xf = 0.
     else
        xf = exp(-arg**2)
        ff = ff + xf * xt / xd
     endif
  enddo
  fgauss = ff
end function fgauss
!
subroutine dgauss (xvel,x,g)
  use gauss_parameter
  !---------------------------------------------------------------------
  ! @ private
  ! LAS	Internal routine
  !	Function to be minimized in the gaussian fit.
  !	By using 3 hidden parameters, the method allows dependent
  !	and independent gaussians to be fitted. The computation is
  !	highly optimised, but take care of R*4 and R*8 values !...
  !	Basic parameters are Area, Position and Width.
  ! Not used ?
  !---------------------------------------------------------------------
  real(kind=8), intent(in)  :: xvel  ! X value
  real(kind=8), intent(in)  :: x(*)  ! Parameter values
  real(kind=8), intent(out) :: g(*)  ! Array of derivatives
  ! Local
  real :: tt,vv,dd,gt,gv,gd,ff
  real :: t1,v1,d1,t2,v2,d2,t3,v3,d3,t4,v4,d4,t5,v5,d5
  real :: g1,g2,g3,g4,g5,g6,g7,g8,g9,g10,g11,g12,g13,g14,g15
  real :: arg1,arg2,arg3,arg4,arg5,f1,f2,f3,f4,f5,arg
  !
  tt=x(1)
  vv=x(2)
  dd=x(3)
  gt=0.
  gv=0.
  gd=0.
  !
  t1=x(4)*tt
  v1=x(5)+vv
  d1=x(6)*dd
  g1=0.
  g2=0.
  g3=0.
  !
  if (nline.ge.2) then
    t2=x(7)*tt
    v2=x(8)+vv
    d2=x(9)*dd
    g4=0.
    g5=0.
    g6=0.
    if (nline.ge.3) then
      t3=x(10)*tt
      v3=x(11)+vv
      d3=x(12)*dd
      g7=0.
      g8=0.
      g9=0.
      if (nline.ge.4) then
        t4=x(13)*tt
        v4=x(14)+vv
        d4=x(15)*dd
        g10=0.
        g11=0.
        g12=0.
        if (nline.ge.5) then
          t5=x(16)*tt
          v5=x(17)+vv
          d5=x(18)*dd
          g13=0.
          g14=0.
          g15=0.
        endif
      endif
    endif
  endif
  !
  !
  ff = 1.0
  ! First
  arg1 = (xvel - v1) / d1
  if (abs(arg1).le.4.) then
    f1 = exp(-arg1**2)
    arg = f1*ff/d1
    g1  = g1 + arg
    gt  = gt + arg*t1
    arg = t1/d1*arg
    g3  = g3 - arg
    gd  = gd - arg*d1
    arg = arg*arg1*2.
    g2  = g2 + arg
    gv  = gv + arg
    g3  = g3 + arg*arg1
    gd  = gd + arg*arg1*d1
  endif
  !
  if (nline.ge.2) then
    ! Second
    arg2 = (xvel - v2) / d2
    if (abs(arg2).le.4.) then
      f2 = exp(-arg2**2)
      arg = f2*ff/d2
      g4  = g4 + arg
      gt  = gt + arg*t2
      arg = arg*t2/d2
      g6  = g6 - arg
      gd  = gd - arg*d2
      arg = arg*arg2*2.
      g5  = g5 + arg
      gv  = gv + arg
      g6  = g6 + arg*arg2
      gd  = gd + arg*arg2*d2
    endif
    if (nline.ge.3) then
      ! Third
      arg3 = (xvel - v3) / d3
      if (abs(arg3).le.4.) then
        f3 = exp(-arg3**2)
        arg = f3*ff/d3
        g7  = g7 + arg
        gt  = gt + arg*t3
        arg = arg*t3/d3
        g9  = g9 - arg
        gd  = gd - arg*d3
        arg = arg*arg3*2.
        g8  = g8 + arg
        gv  = gv + arg
        g9  = g9 + arg*arg3
        gd  = gd + arg*arg3*d3
      endif
      if (nline.ge.4) then
        ! Fourth
        arg4 = (xvel - v4) / d4
        if (abs(arg4).le.4.) then
          f4 = exp(-arg4**2)
          arg = f4*ff/d4
          g10 = g10 + arg
          gt  = gt + arg*t4
          arg = arg*t4/d4
          g12 = g12 - arg
          gd  = gd - arg*d4
          arg = arg*arg4*2.
          g11 = g11 + arg
          gv  = gv + arg
          g12 = g12 + arg*arg4
          gd  = gd + arg*arg4*d4
        endif
        if (nline.ge.5) then
          ! Fifth
          arg5 = (xvel - v5) / d5
          if (abs(arg5).le.4.) then
            f5 = exp(-arg5**2)
            arg = f5*ff/d5
            g13 = g13 + arg
            gt  = gt  + arg*t5
            arg = arg*t5/d5
            g15 = g15 - arg
            gd  = gd - arg*d5
            arg = arg*arg5*2.
            g14 = g14 + arg
            gv  = gv  + arg
            g15 = g15 + arg*arg5
            gd  = gd  + arg*arg5*d5
          endif
        endif                  ! 5
      endif                    ! 4
    endif                      ! 3
  endif
  !
  ! Setup values and return
  g(1)=gt/tt
  g(2)=gv
  g(3)=gd/dd
  !
  g(4)=g1*tt
  g(5)=g2
  g(6)=g3*dd
  !
  if (nline.lt.2) return
  g(7)=g4*tt
  g(8)=g5
  g(9)=g6*dd
  if (nline.lt.3) return
  g(10)=g7*tt
  g(11)=g8
  g(12)=g9*dd
  if (nline.lt.4) return
  g(13)=g10*tt
  g(14)=g11
  g(15)=g12*dd
  if (nline.lt.5) return
  g(16)=g13*tt
  g(17)=g14
  g(18)=g15*dd
end subroutine dgauss

!
subroutine no_check_mask(method,head)
  use clean_def
  use image_def
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Clean/Mosaic
  !     Check that the search mask is defined
  !--------------------------------------------------------------
  type(gildas),    intent(in)    :: head   !
  type(clean_par), intent(inout) :: method !
  !
  Print *,'Called check_mask'
end subroutine no_check_mask
!
subroutine check_mask(amethod,head)
  use clean_def
  use image_def
  use gbl_message
  use gkernel_types
  use mapping_interfaces, except_this=>check_mask
  use clean_support
  use clean_arrays
  !--------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Clean/Mosaic
  !     Check that the search mask is defined
  !--------------------------------------------------------------
  type(gildas),    intent(in)    :: head   !
  type(clean_par), intent(inout) :: amethod !
  !
  ! Local variables
  integer, save :: last_box(4)
  integer nx,ny
  character(len=10) :: rname = 'CHECK_MASK'
  !
  ! Mask
  nx = head%gil%dim(1)
  ny = head%gil%dim(2)
  if (amethod%do_mask) then
    !
    if (support_type.eq.support_mask) then
      if (hmask%gil%dim(1).ne.nx .or. hmask%gil%dim(2).ne.ny) then
        call map_message(seve%w,rname,'Mask size differ')
      endif
      !
      ! Setup the Logical mask from the Real mask and its bounding box
      call get_lmask (hmask,dmask(:,:,1),head,d_mask,amethod%box)
      call lmask_to_list(d_mask,nx*ny,d_list,amethod%nlist)
      amethod%imask = 1
    else
      !
      ! Compute the logical mask from the bounding polygon
      call gr8_glmsk(supportpol,d_mask,nx,ny,   &
                     head%gil%convert(1,1),head%gil%convert(1,2),amethod%box)
      call lmask_to_list(d_mask,nx*ny,d_list,amethod%nlist)
      amethod%imask = -1
    endif
    amethod%do_mask = .false.
    last_box = amethod%box
  else
    amethod%box = last_box
  endif
end subroutine check_mask

subroutine com_modify(line,error)
  use gkernel_interfaces
  use mapping_interfaces, only : map_message 
  use phys_const
  use clean_arrays
  use clean_types
  use gbl_message
  !-----------------------------------------------------
  ! @ private
  !
  ! MAPPING  Support for command
  !   SPECIFY KeyWord Value
  !-----------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  character(len=6) :: rname = 'SPECIFY'
  !
  integer, parameter :: nterm=3
  character(len=12) :: term(nterm),chain,key
  data term/'FREQUENCY', 'TELESCOPE', 'VELOCITY'/
  integer :: i, iterm, narg, nc
  real(8) :: freq, freq_a,freq_b,value(3)
  real(4) :: velo
  !
  if (huv%loca%size.ne.0) then
    freq = huv%gil%freq
    velo = huv%gil%voff
  endif
  if (hdirty%loca%size.ne.0) then
    freq = hdirty%gil%freq
    velo = hdirty%gil%voff
  endif
  if (hclean%loca%size.ne.0) then
    freq = hclean%gil%freq
    velo = hclean%gil%voff
  endif
  !
  narg = sic_narg(0)
  do i = 1, narg, 2
    call sic_ke(line,0,i,chain,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,chain,key,iterm,term,nterm,error)
    if (error) return
    !
    select case (key)
    case ('FREQUENCY')
      ! Modify velocity scale according to new rest frequency [MHz]
      call sic_r8(line,0,i+1,freq,.true.,error)
      !
    case ('VELOCITY')
      ! Modify Frequency scale according to new velocity (km/s)
      call sic_r4(line,0,i+1,velo,.true.,error)
      !
    case ('TELESCOPE')
      call sic_ke(line,0,i+1,chain,nc,.true.,error)
      if (error) return
      !
      ! Update current UV and Initial UV data set
      if (huv%loca%size.ne.0) then
        if (huv%gil%nteles.ge.1) then
          if (huv%gil%teles(1)%ctele .ne. chain(1:nc)) then
            call map_message(seve%i,rname,'Telescope ' &
            & //trim(huv%gil%teles(1)%ctele) &
            & //' in UV data overwritten by /TELESCOPE '//chain(1:nc)) 
            ! Undefine the telescope so that all characteristics
            ! are re-defined by gdf_addteles after
            huv%gil%teles(1)%ctele = ' '
            huvi%gil%teles(1)%ctele = ' '
          endif
        endif
        call gdf_addteles(huv,'TELE',chain(1:nc),value,error)
        call gdf_addteles(huvi,'TELE',chain(1:nc),value,error)
      endif
    end select
    if (error) return
  enddo
  !
  ! Now which ones ...
  if (huv%loca%size.ne.0) then
    freq_b = gdf_uv_frequency(huv,1.d0)
    call gdf_modify(huv,velo,freq,error=error)
    freq_a = gdf_uv_frequency(huv,1.d0)
    if (abs(freq_a-freq_b).gt.10.0) then
      Print *,'Frequency Before ',freq_b
      Print *,'Frequency After ',freq_a
      Print *,'Frequency Difference ',freq_a-freq_b
    endif
  endif
  if (hdirty%loca%size.ne.0) then
    call gdf_modify(hdirty,velo,freq,error=error)
  endif
  if (hclean%loca%size.ne.0) then
    call gdf_modify(hclean,velo,freq,error=error)
  endif
  !
end subroutine com_modify

subroutine solve_gain(line,error)
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_format
  use gbl_message
  use imager_interfaces, except_this => solve_gain
  use clean_def
  use clean_arrays
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !     S.Guilloteau & V.Pietu, from R.Lucas CLIC code
  !
  ! Support for command
  !   SOLVE Time SNR [Reference] 
  !       /MODE [Phase|Amplitude] [Antenna|Baseline] [Flag|Keep]
  !
  ! Compute Gains by comparing the UV data and the UV model.
  ! Input : a UV data (observed)
  !         a UV model
  ! Output: a UV table, with the gains.
  !         a UV self-calibrated table
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line
  logical, intent(inout) :: error
  !
  ! Local
  integer, parameter :: mant=256  ! Valid for ALMA, VLA and most others.
  integer, parameter :: mbas=mant*(mant-1)/2
  character(len=*), parameter :: rname='UV_GAIN'
  integer(4) ::  i, n, narg, ichan, nvis, ncol, ier
  !
  character(len=filename_length) :: uvdata, uvmodel, uvgain, uvcal, &
    & uvsol, name   ! File names
  real :: tinteg    ! Integration time
  real :: snr       ! Minimum SNR for a solution
  real :: snr_min   ! Minimum SNR for correction of Amplitude gains
  real :: snr_scale ! Noise scaling factor - 
  integer :: refant ! Reference antenna (0 = automatic)
  logical :: flag   ! Flag data with no solution
  logical :: do_amp ! Self calibrate amplitude
  logical :: do_pha ! Self calibrate phase
  logical :: antenna_based ! Antenna based self calibration
  !
  integer, allocatable :: index(:)  ! Sorting index (by time)
  real(8), allocatable :: itime(:)  ! Times of observations
  real, pointer :: basegain(:,:), antegain(:,:) ! Gain arrays
  integer :: ntimes   ! Number of different times in data
  integer :: nantes   ! Maximum number of antennas in data
  !
  real :: scale_gain, scale_ante
  integer :: iv
  !
  integer, parameter :: mmode=6
  integer :: nmode, conflict(mmode)
  logical :: has_mode(mmode)
  character(len=12) :: smode(mmode), mode, argum
  data smode /'AMPLITUDE','ANTENNA','BASELINE','FLAG','KEEP','PHASE'/
  data conflict/6,3,2,5,4,1/
  !
  ! Code
  uvsol = 'test.tab'  ! To be modified SG
  !
  snr_min = 1.5
  snr_scale = sqrt(2.0) ! should be 1.0, but ALMA seem to require something different
  call sic_get_real('SELF_SNOISE',snr_scale,error)
  !
  call sic_r4(line,0,1,tinteg,.true.,error)
  if (error) return
  !
  snr = 6.0
  call sic_r4(line,0,2,snr,.false.,error)
  if (error) return
  !
  refant = 0
  ichan = 0
  !
  ! Set defaults: PHASE ANTENNA KEEP 
  do_pha = .true.
  antenna_based = .true.
  flag = .false.
  !
  narg = sic_narg(1)
  has_mode(:) = .false.
  do i=1,narg
    call sic_ke(line,1,i,argum,n,.true.,error)
    call sic_ambigs (rname,argum,mode,n,smode,mmode,error)
    if (error) return
    !
    if (has_mode(conflict(n))) then
      call map_message(seve%e,rname,'Conflicting keywords '//mode// &
      & ' and '//smode(conflict(n)))
      error = .true.
      return
    endif
    has_mode(n) = .true.
    select case (mode)
    case ('AMPLITUDE')
      do_pha = .false.
    case ('BASELINE')
      antenna_based = .false.
    case ('FLAG') 
      flag = .true.
    end select
  end do
  !
  ! For the time being, do not allow Phase and Amplitude at once.
  do_amp = .not.do_pha
  !
  if (hraw%loca%size.eq.0) then
    call map_message(seve%e,rname,'HRAW not initialized, Use UV_MAP /SELF once')
    error = .true.
    return
  endif
  nvis = hraw%gil%dim(2)
  ncol = hraw%gil%dim(1)
  ichan = 1         ! We use the only channel
  !
  ! Check size of MODEL in "huvm"
  !
  if (.not.allocated(duvm)) then
    call map_message(seve%e,rname,'MODEL is not allocated')
    error = .true.
    return
  endif
  !
  ! Prepare output gain table : in "cgains" and "agains"
  call sic_delvariable ('CGAINS',.false.,error)
  if (allocated(duvbg)) deallocate(duvbg,stat=ier)
  call gildas_null(hbgain, type = 'UVT')
  call gdf_copy_header (hraw, hbgain, error)
  !
  call sic_delvariable ('AGAINS',.false.,error)
  call gildas_null(hagain) 
  !
  if (antenna_based) then
    allocate (index(nvis), itime(nvis), &
      & duvbg(10,nvis),basegain(10,nvis), stat=ier)
      antegain => duvbg
  else
    allocate (index(nvis), itime(nvis), &
      & duvbg(10,nvis),stat=ier)
      basegain => duvbg
  endif
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Cannot allocate gain arrays')
    error = .true.
    return
  endif
  !
  ! Get baseline-based gains ...
  call do_base_gain(do_amp,do_pha,nvis,ncol,ichan,itime,   &
     &    index,duvraw,duvm,basegain)
  !
  if (antenna_based) then
    !
    ! Compute antenna-based gains ...
    call do_ante_gain(do_amp,do_pha,nvis,itime,tinteg,snr,   &
     &      basegain, antegain, refant, ntimes, nantes,      &
     &      snr_min, snr_scale, flag, error)
    if (error) then
      call map_message(seve%e,rname,'No self calibration solution')
      return
    endif
    ! 
    ! Prepare the plot
    call gdf_copy_header (hraw, hagain, error)
    call do_get_cgain(ntimes,nantes,hagain,dagain,refant,scale_ante,error)
    hagain%char%unit = '(none)'
    hagain%char%code(1) = 'TIME'
    hagain%gil%xaxi = 0
    hagain%gil%yaxi = 0
    hagain%gil%faxi = 0
    !
    ! Re-normalize the gains if amplitude
    if (do_amp) then
      call do_normalize_v(10,nvis,duvbg,scale_gain)
      write(name,'(A,F8.3,A,F8.3,A)') 'Re-scaled by ',scale_gain,' (or by antennas: ',scale_ante,')'
      call map_message(seve%i,rname,name)
      scale_ante = scale_gain**2     ! Weight factor
      scale_gain = 1.0/scale_gain    ! Baseline gain factor
      do iv=1, nvis
        duvbg(8:9,iv) = duvbg(8:9,iv) * scale_gain
        duvbg(10,iv) = scale_ante * duvbg(10,iv)
      enddo
      scale_ante = sqrt(scale_gain)  ! Antenna gain factor
      do iv=1,nantes
        dagain(:,2+3*iv) = dagain(:,2+3*iv)*scale_ante 
      enddo
    else
      scale_gain = 1.0
    endif
    !
    hagain%loca%size = hagain%gil%dim(1)*hagain%gil%dim(2)
    call sic_mapgildas ('AGAINS',hagain,error,dagain)
  endif
  !
  ! Fill in calibrated table
  call do_apply_cal(ncol,1,nvis,duvraw,duvself,duvbg,flag,index)
  !
  ! Define CGAINS variable - Remember to remove trailing columns
  ! if any...
  hbgain%gil%dim(1) = 10
  if (hbgain%gil%ntrail.gt.0) then
    do i=1,code_uvt_last
      if (hbgain%gil%column_pointer(i).gt.hbgain%gil%dim(1)) then
        call map_message(seve%i,rname,'Found column '//uv_column_name(i))
        hbgain%gil%column_size(i) = 0
        hbgain%gil%column_pointer(i) = 0
      endif
    enddo
    hbgain%gil%ntrail = 0
  endif
  hbgain%loca%size = hbgain%gil%dim(1)*hbgain%gil%dim(2)
  hbgain%gil%nchan = 1
  hbgain%gil%nvisi = nvis
  hbgain%gil%nstokes = 1
  call gdf_setuv(hbgain,error)
  !
  call sic_mapgildas ('CGAINS',hbgain,error,duvbg)
  call message_colour(2)
  call map_message(seve%i,rname,'Successful completion')
  call message_colour(-1)
end subroutine solve_gain
!
subroutine do_apply_cal(ncol,nch,nvis,data,cal,gain,flag,index)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER command SOLVE
  ! Task UV_GAIN
  !
  !     Apply Gain Table to input UV data set
  !
  ! Index is the ordering of the gain. Gain(i) applies to Visi(Index(i))
  !---------------------------------------------------------------------
  integer, intent(in) :: ncol                   ! Number of column in visi
  integer, intent(in) :: nvis                   ! Number of visibilities
  integer, intent(in) :: nch                    ! Number of channels
  real, intent(in) :: data(ncol,nvis)           ! Raw data
  real, intent(out) :: cal(ncol,nvis)           ! Calibrated data
  real, intent(in) :: gain(10,nvis)             ! Gain array
  logical, intent(in) :: flag                   ! Flag data with no solution
  integer, intent(in) :: index(nvis)            ! Visibility order
  ! Local
  integer :: iv   ! Gain index
  integer :: jv   ! Visibility index
  integer :: k    ! position in visibility 
  complex :: zdata, zgain, zcal
  !-----------------------------------------------------------------------
  do iv=1, nvis
    jv = index(iv)
    do k=1, 7
      cal(k,jv) = data(k,jv)
    enddo
    zgain = cmplx(gain(8,iv),gain(9,iv))
    if (gain(10,iv).lt.0) then
      zgain = 0
    endif
    do k=8, 5+3*nch, 3
      if (zgain.ne.0) then
        zdata = cmplx(data(k,jv),data(k+1,jv))
        zcal = zdata / zgain
        cal(k,jv) = real(zcal)
        cal(k+1,jv) = aimag(zcal)
        cal(k+2,jv) = data(k+2,jv)*abs(zgain)**2
      else
        cal(k,jv) = data(k,jv)
        cal(k+1,jv) = data(k+1,jv)
        cal(k+2,jv) = data(k+2,jv)
        if (flag) cal(k+2,jv) = -abs(cal(k+2,jv))
      endif
    enddo
    if (8+3*nch.le.ncol) then
      cal(8+3*nch:ncol,jv) = data(8+3*nch:ncol,jv)
    endif
  enddo
end subroutine do_apply_cal
!
subroutine do_ante_gain(do_amp,do_pha,nvis,times,tinteg,snr, &
  & basegain,antegain,refant,ntimes,nantes,smin,scal,flag,error)
  use gildas_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER command SOLVE
  ! Task UV_GAIN
  !
  !     S.Guilloteau & V.Pietu, derived from R.Lucas CLIC code
  !
  !   Compute complex gains (antenna-based solution) from a set
  !   of initial Antenna gains, smoothing in time as needed.
  !
  !   The initial Antenna gains must be sorted by increasing time
  !---------------------------------------------------------------------
  logical, intent(in)  :: do_amp                 ! Calibrate amplitude ?
  logical, intent(in)  :: do_pha                 ! Compute phase ?
  integer, intent(in)  :: nvis                   ! Number of visibilities
  real(8), intent(in)  :: times(nvis)            ! Times of visibilities
  real, intent(in)  :: tinteg                    ! Integration time
  real, intent(in)  :: snr                       ! requested Signal to Noise 
  real, intent(in)  :: basegain(10,nvis)         ! Input baseline gain array
  real, intent(inout)  :: antegain(10,nvis)      ! Output antenna gain array
  integer, intent(in) :: refant                  ! Reference antenna
  integer, intent(out) :: ntimes                 ! Number of time steps
  integer, intent(out) :: nantes                 ! Number of antennas
  real, intent(in) :: smin  ! Min SNR for de-biasing
  real, intent(in) :: scal  ! Scale factor for SNR de-biasing 
  logical, intent(in) :: flag                    ! Flag wrong solutions ?
  logical, intent(out) :: error                  ! In case nothing left ...
  ! Global
  character(len=*), parameter :: rname='UV_GAIN'
  real(8), parameter :: pi=3.14159265358979323846d0
  ! Maximum Size of problem
  ! ALMA uses stations rather than antennas
  integer, parameter :: mant=256  
  integer, parameter :: mbas=mant*(mant-1)/2
  ! Local
  character(len=256) :: mess
  real(8) ::  t, told
  real :: ampli, phase, ug, vg, d2, dmin, maxsnr,minsnr
  integer ::  iref, iv, jv, ia, ja, ib, i, nant, nbas, j, k, nant_old
  integer ::  lia, lja, igood, isol, iflag
  integer :: ibad, kbad, icount, itest, vgood, vbad, sever
  logical :: err, ok
  !
  integer ::  al(mant)  !Physical number of Sequential number
  integer ::  la(mant)  !Sequential number of Physical number
  real :: ua(mant), va(mant), ampsnr(mant)
  real(8) ::  ca(mant), cp(mant), wp(mant)
  real(8) ::  wk2(mant,mant), wk3(mant)
  logical :: isbad(mant)
  integer :: jbad(mant)
  !
  integer ::  iant(mbas), jant(mbas)      ! Start & End antenna of baseline
  real(8) ::  x(mbas), y(mbas), w(mbas), amp(mbas), pha(mbas), wa(mbas), ss(mbas)
  ! For debug only
  integer ::  lpairs(mant), lpair(mant,mant),   array(mant), indx(mant) 
  integer :: iunit
  !-----------------------------------------------------------------------
  !
  error =.false.
  err = .false.
  !
  iunit = 4
  open(unit=iunit,file='selfcal.tmp',status='unknown')
  rewind(unit=iunit)
  !
  nbas = 0
  igood = 0
  isol = 0
  vgood = 0
  vbad = 0
  do j=2, mant
    do i=1, j-1
      nbas = nbas+1
      iant(nbas) = i
      jant(nbas) = j
    enddo
  enddo
  !
  ! The algorithm will find a better value for ref antenna,
  ! the one nearest to the array center.
  iref = refant
  !
  ! Loop on visibilities
  !
  told = -1d10  ! An impossibly old time...
  ntimes = 0
  nantes = 0
  do iv=1, nvis
    t = times(iv)
    !
    ! Time change ?
    if (told.ne.t) then
      !
      ! Identify a new time range
      ntimes = ntimes+1
      !Print *,'New output time ',iv,told,t,ntimes
      told = t
      nant_old = 0
      jv = iv
      !
      ! Find starting visibility < Told-Tinteg/2
      do while (jv.gt.1 .and. t .ge. told-tinteg/2)
        jv = jv - 1
        t = times(jv)
      enddo
      la = 0
      ca = 0.0
      cp = 0.0
      x = 0.0
      y = 0.0
      w = 0.0
      !
      ! Search how many antennas at this time, and average
      ! over all visibilities which fit the time range
      !
      ok = (jv.lt.nvis .and. t.le.told+tinteg/2.)
      lpairs = 0
      lpair  = 0
      nant = 0
      do while (ok)
        !
        ! Only Select the UN-FLAGGED data
        !
        if (basegain(10,jv).gt.0.0) then
          !
          ! Build the antenna pointer list "la" and "al"
          !
          ! In the end, we use this formula...
          !    ia = la(nint(basegain(6,iv)))
          !    ja = la(nint(basegain(7,iv)))
          ! which figures out which sequence number is each antenna
          !
          ia = nint(basegain(6,jv))
          if (la(ia).eq.0) then
            nant = nant+1
            la(ia) = nant
            al(nant) = ia ! The reverse pointer
          endif
          ja = nint(basegain(7,jv))
          if (la(ja).eq.0) then
            nant = nant+1
            la(ja) = nant
            al(nant) = ja
          endif
          !
          !! Build the antenna pairs (for debug only)
          !! lpairs(la(ia)) = lpairs(la(ia))+1
          !! lpair(lpairs(la(ia)),la(ia)) = la(ja)
          !!
          !! lpairs(la(ja)) = lpairs(la(ja))+1
          !! lpair(lpairs(la(ja)),la(ja)) = la(ia)        

          ! Here we set in UA,VA the "Antenna" U,V coordinate
          ! relative to Antenna #1
          !   Note: we do not average UA,VA over time since it
          !   is only used to determine the Reference antenna,
          !   a nearly irrelevant number.
          lia = la(ia)
          lja = la(ja)
          if (lia.eq.1) then
            ua(lja) = basegain(1,jv)
            va(lja) = basegain(2,jv)
          elseif (lja.eq.1) then
            ua(lia) = -basegain(1,jv)
            va(lia) = -basegain(2,jv)
          endif
          !
          ! Here we average the visibility into the X,Y,W buffer
          ! we also set start antenna < end antenna
          if (lia.eq.lja) then
            Print *,'Ignoring autocorrelation for ',lia,al(lia)
          else
            if (lia.lt.lja) then
              ib = (lja-1)*(lja-2)/2+lia
              y(ib) = y(ib) + basegain(9,jv)*basegain(10,jv)        
            else !! if (lja.lt.lia) then
              ib = (lia-1)*(lia-2)/2+lja
              y(ib) = y(ib) - basegain(9,jv)*basegain(10,jv)
            endif
            x(ib) = x(ib) + basegain(8,jv)*basegain(10,jv)
            w(ib) = w(ib) + basegain(10,jv)
          endif
          !
        endif  ! End selection of Un-Flagged data
        !
        jv = jv + 1
        t = times(jv)
        ok = (jv.lt.nvis .and. t.le.told+tinteg/2.)
      enddo
      !
      ! get the reference antenna, by locating the one
      ! with the shortest baselines
      !
      nbas = nant*(nant-1)/2
      !
      ! Compute the centroid of antenna positions (still relative to Antenna #1)
      ug = 0
      vg = 0
      do ia=1, nant
        ug = ug+ua(ia)
        vg = vg+va(ia)
      enddo
      ug = ug/nant
      vg = vg/nant
      dmin = 1e10
      !
      ! Locate the antenna closest to centroid (this is independent of absolute pos.)
      iref = 1
      do ia=1, nant
        d2 = (ua(ia)-ug)**2 + (va(ia)-vg)**2
        if (d2.lt.dmin) then
          dmin = d2
          iref = ia
        endif
      enddo
      !
      ! This is wrong if antenna renumbering occured
      ! It should be 
      !       la(iref) = refant
      if (refant.ne.0) iref = refant
      !
      ! Check if any antenna has no closure 
      ibad = 0
      do lia=1,nant
        icount = 0
        do lja=1,nant
          if (lia.ne.lja) then
            if (lia.lt.lja) then
              ib = (lja-1)*(lja-2)/2+lia
            else !! if (lja.lt.lia) then
              ib = (lia-1)*(lia-2)/2+lja
            endif
            if (w(ib).ne.0) then
              icount = icount+1
            endif
          endif
        enddo
        if (icount.lt.2) then
          Print *,'Antenna Seq.',lia,' (Phys. ',al(lia),') has no closure'
          ibad = ibad+1
          jbad(ibad) = lia
          isbad(lia) = .true.
        else
          isbad(lia) = .false.
        endif
      enddo
      !
      if (ibad.eq.nant) then
        Print *,'No antenna can be calibrated at this time'
      else if (ibad.ne.0) then
        Print *,ibad,' antennas with no solution'
      endif
      !
      ! Normalize the time averaged complex gains 
      do ib=1, nbas
        if (w(ib).ne.0) then
          x(ib) = x(ib)/w(ib)
          y(ib) = y(ib)/w(ib)
        endif
      enddo
      !
      !
      ! Here, normally, each antenna should have at least
      ! 2 baselines, otherwise it is not possible...
      !
      if (ibad.ne.nant) then
        ! Solve for amplitude first to estimate S/N ratio
        ! Use an intermediate weight array "wa" for this
        do ib=1, nbas
          if (w(ib).ne.0) then
            amp(ib) = log(x(ib)**2+y(ib)**2)/2.
            wa(ib)  = w(ib)*(x(ib)**2+y(ib)**2)
          else
            wa(ib) = 0.0
          endif
        enddo
        call gain_ant(1, nbas, iant, jant, iref,   &
     &          nant, amp, wa, wk2, wk3, ss, ca, wp, err)
        !
        do ia = 1, nant
          isol = isol + 1
!
! We should NOT overwrite WA here -- we can compute the SNR directly            
!            aa(ia) = exp(2*ca(ia))
!            wa(ia) = wp(ia)/aa(ia)**2
!            ampsnr(ia) = aa(ia)*sqrt(wa(ia))*1e3
! so directly
!            ampsnr(ia) = aa(ia) * sqrt(wp(ia)/aa(ia)**2)) *1e3
! which is
          ampsnr(ia) = sqrt(wp(ia)) * 1e3 ! The 1e3 is because of MHz unit
          !!Print *,'ia ',ia,wp(ia),ampsnr(ia)
          if (isbad(ia)) ampsnr(ia) = 0.0 !S.Guilloteau
          !
        enddo
        maxsnr = maxval(ampsnr(1:nant))
        minsnr = maxsnr
        do ia = 1, nant
          if (ampsnr(ia).ne.0) minsnr = min(minsnr,ampsnr(ia))
        enddo
      else
        maxsnr = 0.0
        minsnr = 0.0
      endif
      !
      if (maxsnr.gt.snr) then
        ! phases
        if (do_pha) then
          !
          ! If enough SNR, solve for the Phases for the good
          ! antennas. Use the initial weights "w" here.
          do ib=1, nbas
            if (w(ib).ne.0) then
              pha(ib) = atan2(y(ib),x(ib))
              !
              ! 1-Mar-2018 S.Guilloteau
              ! Normally, the phase error in radian is the Noise to Signal ratio,
              ! so the weight of that phase should be  (Signal/Noise)^2
              ! i.e. wa(ib) = (x(ib)^2+y(ib)^2) * w(ib)
              ! since w(ib) is the 1/Noise^2 for the (real, imaginary) parts,
              ! i.e. like used above for the Amplitude
              !
            else
              pha(ib) = 0.0
            endif
          enddo
          call gain_ant(2, nbas, iant, jant, iref,   &
     &            nant, pha, w, wk2, wk3, ss, cp, wp, err)
          iflag = 0
          !
          ! Reset amplitude to 1 now
          ca(1:nant) = 1.0
          !
        else if (do_amp) then
          ! Here, we should check that each antenna should have at least
          ! 3 baselines, otherwise it is not possible...
          !
          ! Here, we use the raw initial weights also, not the SNR weights
          ! or if we should use the SNR weights, it is already solved...
          call gain_ant(1, nbas, iant, jant, iref,   &
     &          nant, amp, w, wk2, wk3, ss, ca, wp, err)
          iflag = 0
          !
          ! Go back to Gain factors instead of their Log
          ca(1:nant) = exp(ca(1:nant))
          !
          ! De-bias from the noise < 6 sigma 
          !   
          ! The factor SCAL is  because of the convention of 
          ! the SNR (per antenna vs per baseline ?...)
          where (ampsnr.ge.smin)  
            ca(1:nant) = ca(1:nant) - 0.5*(scal/ampsnr(1:nant))**2
          end where
          !
          ! Reset Phase to Zero now
          cp(1:nant) = 0
        endif
        !
        do ia =1, nant
          !
          ! Keep only antenna solution with required snr
          if (ampsnr(ia).lt.snr) then
            cp(ia) = 0.0      ! Set phase correction to Zero
            ca(ia) = 1.0      ! Set amplitude correction to 10^0 = 1
            itest = 0
            !
            ! Check whether this antenna was already expected
            ! to be without solution or not.
            do kbad=1,ibad
              if (jbad(kbad).eq.ia) then
                !!Print *,'** OK ** NO Solution for flagged antenna ',ia,al(ia)
                itest = kbad
                exit
              endif
            enddo
            if (itest.eq.0) then
              Print *,'** Warning *** Flagged one more antenna ',ia,al(ia)
              isbad(ia) = .true.
            endif
            iflag = iflag+1
          else
            ! This was happening when AMPSNR was not set to Zero for
            ! antennas with no closure.
            !do kbad=1,ibad
            !  if (jbad(kbad).eq.ia) then
            !    Print *,'** Warning *** Solution for flagged antenna ',ia,al(ia)
            !    Print *,' Amp SNR ',ampsnr(ia),snr,aa(ia),wa(ia)
            !    exit
            !  endif
            !enddo
            igood = igood + 1
          endif
        enddo
      else 
        isbad(1:nant) = flag   ! Flag antennas if asked for...
        ca(1:nant) = 1.0 ! Insufficient SNR, reset Amplitude
        cp(1:nant) = 0.0 !    and Phase gain
        iflag = nant
      endif
      !
      if (iflag.ne.0) then
        write(mess,100) told,iref,maxsnr,minsnr,iflag
      else
        write(mess,100) told,iref,maxsnr,minsnr
      endif
      !!Print *,'SNR range ',minsnr,maxsnr
100   format('Time ',F16.1,' Ref ',i3,' SNR: Max ',F7.1,' Min ',F7.1,I5,' antennas ignored')
      call map_message(seve%i,rname,mess)
      !
      write(iunit,*) iref,told,nant  ! Reference antenna
      write(iunit,102) al(1:nant)    ! Antenna list
      write(iunit,104) ca(1:nant)
      write(iunit,101) cp(1:nant)*180.0/pi
      write(iunit,103) ampsnr(1:nant)
      !
101   format (8(2x,f9.3))
102   format(16(1x,i3))
103   format (8(1x,f9.3))
104   format (8(1x,f10.4))
      nantes = max(nantes,nant)
      !
      !!Print *,'BAD ',isbad(1:nant)
!!      Print *,'Solving for IV ',iv,nvis
!!    else
!!      Print *,'Just Filling IV ',iv,nvis
    endif
    !
    ! Fill in the antenna gains in "antegain"
    do k=1,7
      antegain(k,iv) = basegain(k,iv)
    enddo
    ia = la(nint(basegain(6,iv)))
    ja = la(nint(basegain(7,iv)))
    ampli =   ca(ia) * ca(ja)     ! After trial, this  
    phase = - cp(ia) + cp(ja)     ! is THE solution
    !! Print *,'IV ',ampli, 180*phase/3.14159
    antegain(8,iv) = ampli * cos(phase)
    antegain(9,iv) = ampli * sin(phase)
    !
    ! Flag data with no solution
    !! Print *,'IV ',iv,' IA ',ia,isbad(ia),' JA ',ja,isbad(ja)
    if (isbad(ia).or.isbad(ja)) then
       antegain(10,iv) = -abs(basegain(10,iv))
       vbad = vbad+1
    else
       antegain(10,iv) = basegain(10,iv)
       vgood = vgood+1
    endif
  enddo
  !
  ! Return an error if not enough good visibilities or no solution
  if (igood.eq.0) then
    sever = seve%e
    error = .true.
  else
    sever = seve%i
  endif
  write(mess,'(A,I0,A,I0,A)') "Found ",igood,"/",isol," good solutions"
  call map_message(sever,rname,mess)
  if (vgood.lt.100) then
    sever = seve%e
    error = .true.
  else
    sever = seve%i
  endif
  write(mess,'(A,I0,A,I0,A)') "Retained ",vgood," valid visibilities, ", &
    vbad," flagged ones"
  call map_message(sever,rname,mess)
end subroutine do_ante_gain
!
subroutine do_base_gain(do_amp,do_pha,nvis,ncol,icol,times,index,   &
     &    data,model,gain)
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER command SOLVE
  !   developped from Task UV_GAIN
  !
  !     S.Guilloteau & V.Pietu, from R.Lucas CLIC code
  !
  !   Compute the Baseline-Based Gain by comparing the Data
  !   to the Model, retaining either Amplitude or Phase
  !   (or both, but this is not used by the calling routines so far)
  ! 
  !   We use channel Icol from Data table for the Data.
  !   Model and Gain are assumed to be continuum (i.e. single-channel)
  !   tables.
  !   Gain will contain the observed baseline gains, in an increasing 
  !   time order.
  !   Times is a Real(8) array to sort out date/time 
  !   Index is an integer array yielding the ordering
  !     gain(i) = data/model (Index(i))
  !---------------------------------------------------------------------
  logical, intent(in) :: do_amp                 ! Calibrate amplitude
  logical, intent(in) :: do_pha                 ! Calibrate phase
  integer, intent(in) :: nvis                   ! Number of visibilities
  integer, intent(in) :: ncol                   ! Size of a visibility
  integer, intent(in) :: icol                   ! Reference column
  real(8), intent(out) :: times(nvis)           ! Time stamps of visibilities
  integer, intent(out) :: index(nvis)           ! Index of visibilities
  real, intent(in) :: data(ncol,nvis)           ! Raw visibilities
  real, intent(in) :: model(10,nvis)            ! Modeled visibilities
  real, intent(out) :: gain(10,nvis)            ! Gain solution
  ! Local
  logical :: error
  ! Local:
  integer :: iv, i, jv, k
  complex :: zgain, zdata, zmodel
  real :: wgain, wdata, again, date0
  !-----------------------------------------------------------------------
  !
  ! Get the chronological order:
  date0 = data(4,1)
  do iv=1, nvis
    ! Beware of Real(8) precision ...
    times(iv) = (data(4,iv)-date0)*86400.d0+data(5,iv)  
  enddo
  call gr8_trie (times,index,nvis,error)
  !
  ! Sorted data in gain:
  do iv=1,nvis
    jv = index(iv)
    do i=1, 7
      gain(i,iv) = data(i,jv)
    enddo
    k = (icol-1)*3+7
    zdata = cmplx(data(k+1,jv),data(k+2,jv))
    wdata = data(k+3,jv)
    zmodel = cmplx(model(8,jv),model(9,jv))
    if (zmodel.ne.0) then
      zgain = zdata/zmodel
      wgain = wdata*abs(zmodel)**2
      if (.not.do_amp) then
        again = abs(zmodel)
        ! Here Zgain = Zdata modified by a phase factor .
        ! If we have a good model of the data, Zgain will
        ! have module of order Unity
        zgain = zgain*again 
        wgain = wdata
      else  ! if (.not.do_pha) then
        ! Even if we are only interested in the Amplitude gain,
        ! we cannot use a simple Amplitude factor, as it is
        ! a biased estimator of this amplitude gain. Hence, 
        ! it does not average properly with time.
        ! 
        ! So we keep the Zgain as it is, without any correction
        ! and with its default weight Wgain
        !
        ! Using the Phase correction term or only the Amplitude
        ! correction term is deferred to the do_ante_gain 
        ! routine, or to a time averaging routine, which
        ! does not yet exist (as of 05-May-2018). 
      endif
    else
      zgain = 0. ! It can be anything, since Wgain is Zero
      wgain = 0.
    endif
    gain(8,iv) = real(zgain)
    gain(9,iv) = aimag(zgain)
    gain(10,iv) = wgain
  enddo
end subroutine do_base_gain
!
subroutine gain_ant(iy,nbas,iant,jant,iref,nant,y,w,wk2,wk3,ss,c,wc,error)
  use gkernel_interfaces
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER command SOLVE
  ! Task UV_GAIN
  !
  !     S.Guilloteau & V.Pietu, from R.Lucas CLIC code
  !
  ! gain_ant 
  !     computes a weighted least-squares approximation
  !     to the antenna amplitudes or phases
  !     for an arbitrary set of baseline data points.
  !---------------------------------------------------------------------
  integer, intent(in) :: iy                ! 1 for log(amplitude), 2 for phase
  integer, intent(in) :: nbas              ! the number of baselines
  integer, intent(in) :: iant(nbas)        ! start antenna for each baseline
  integer, intent(in) :: jant(nbas)        ! end  antenna for each baseline
  integer, intent(in) :: iref              ! Reference antenna for phases
  integer, intent(in) :: nant              ! the number of antennas
  real(8), intent(in) :: y(nbas)           ! the data values
  real(8), intent(in) :: w(nbas)           ! weights
  real(8), intent(inout) :: wk2(nant,nant) ! work space
  real(8), intent(inout) :: wk3(nant)      ! work space
  real(8), intent(out) :: ss(nbas)         ! rms of fit for each baseline
  real(8), intent(out) :: c(nant)          ! the gains
  real(8), intent(out) :: wc(nant)         ! the weights
  logical, intent(out) :: error            !
  ! Global
  integer, external :: zant
  character(len=*), parameter :: rname='GAIN_ANT'
  ! Local
  real(8) :: norm, tol
  !
  parameter (tol=1d-14)
  integer :: i, ia, ib, nantm1, ja, l, iter, ier
  real(8) ::  wi, ww, yi
  !------------------------------------------------------------------------
  ! Code
  !
  ss = 0.
  !
  ! Check that the weights are positive.
  !
  error = .false.
  do ib = 1, nbas
    if (w(ib).lt.0.0d0) then
      call map_message(seve%e,rname,'Weights not positive')
      error = .true.
      return
    endif
  enddo
  !
  ! Amplitude case is simple...
  !
  if (iy.eq.1) then
    wk2 = 0.0d0
    wk3 = 0.0d0
    !
    ! store the upper-triangular part of the normal equations in wk2
    ! and the right-hand side in wk3.
    do ib=1,nbas
      wi = w(ib)
      if (wi.gt.0) then
        ia = iant(ib)
        ja = jant(ib)
        wk2(ia,ia) = wk2(ia,ia)+wi
        wk2(ia,ja) = wk2(ia,ja)+wi
        wk2(ja,ia) = wk2(ja,ia)+wi
        wk2(ja,ja) = wk2(ja,ja)+wi
      endif
    enddo
    do ib=1, nbas
      ia = iant(ib)
      ja = jant(ib)
      wi = w(ib)*y(ib)
      wk3(ia) = wk3(ia) + wi
      wk3(ja) = wk3(ja) + wi
    enddo
    !
    ! Solve the system of normal equations by first computing the Cholesky
    ! factorization
    call mth_dpotrf ('GAIN_ANT','U',nant,wk2,nant,error)
    if (error) return
    call mth_dpotrs ('GAIN_ANT','U',nant,1,wk2,nant,wk3,nant,ier)
    if (ier.ne.0) return
    do i=1,nant
      c(i) = wk3(i)
      wc(i) = wk2(i,i)**2
    enddo
    !
    ! Phase is more complicated ...
  elseif (iy.eq.2) then
    nantm1 = nant-1
    do i=1,nant
      c(i) = 0.0d0
      wc(i) = 0.0d0
    enddo
    !
    ! start iterating
    norm = 1e10
    iter = 0
    do while (norm.gt.tol .and. iter.lt.100)
      iter = iter + 1
      do i=1,nantm1
        do l=1,nantm1
          wk2(l,i) = 0.0d0
        enddo
        wk3(i) = 0.0d0
      enddo
      do ib=1,nbas
        wi = w(ib)
        if (wi.gt.0) then
          ia = zant(iant(ib),iref)
          ja = zant(jant(ib),iref)
          if (ia.ne.0) then
            wk2(ia,ia) = wk2(ia,ia)+wi
          endif
          if (ja.ne.0) then
            wk2(ja,ja) = wk2(ja,ja)+wi
          endif
          if (ia.ne.0 .and. ja.ne.0) then
            wk2(ja,ia) = wk2(ja,ia)-wi
            wk2(ia,ja) = wk2(ia,ja)-wi
          endif
        endif
      enddo
      do ib=1, nbas
        if (w(ib).gt.0) then
          yi = y(ib)
          ia = iant(ib)
          ja = jant(ib)
          yi = yi+(c(ia)-c(ja))
        else
          yi = 0
        endif
        yi = sin(yi)
        ia = zant(iant(ib),iref)
        ja = zant(jant(ib),iref)
        wi = w(ib)*yi
        if (ia.ne.0) then
          wk3(ia) = wk3(ia) - wi
        endif
        if (ja.ne.0) then
          wk3(ja) = wk3(ja) + wi
        endif
      enddo
      !
      ! Solve the system of normal equations by first computing the Cholesky
      ! factorization
      call mth_dpotrf('GAIN_ANT','U',nantm1,wk2,nant,error)
      if (error) return
      call mth_dpotrs ('GAIN_ANT','U',nantm1,1,wk2,nant,   &
     &        wk3,nantm1,ier)
      if (ier.ne.0) return
      !  Add the result to c:
      norm = 0
      do ia=1,nant
        i = zant(ia,iref)
        if (i.ne.0) then
          ww = wk3(i)
          c(ia) = c(ia)+ww
          wc(ia) = wk2(i,i)**2
          norm = norm+ww**2
        endif
      enddo
    enddo
  endif
  !
end subroutine gain_ant
!
function zant(i,r)
  !
  ! Return the apparent number of Antenna #i when reference
  ! antenna is #r. Since #r is not in the list of antennas for
  ! which a solution is to be searched, this number
  ! is #i for #i < #r, and #i-1 for #i > #r
  !
  integer :: zant                   ! intent(out)
  integer, intent(in) :: i          !
  integer, intent(in) :: r          !
  if (i.eq.r) then
    zant = 0
  elseif (i.gt.r) then
    zant = i-1
  else
    zant = i
  endif
  return
end function zant
!*
!=========================================================================
! Linear Algebra: use LAPACK routines
!
subroutine mth_dpotrf (name, uplo, n, a, lda, error)
  character(len=*) :: name           !
  character(len=*) :: uplo           !
  integer :: n                       !
  integer :: lda                     !
  real(8) :: a(lda,*)                 !
  logical :: error                   !
  ! Local
  integer :: info
  !
  !  Purpose
  !  =======
  !
  !  DPOTRF computes the Cholesky factorization of a real symmetric
  !  positive definite matrix A.
  !
  !  The factorization has the form
  !     A = U**T * U,  if UPLO = 'U', or
  !     A = L  * L**T,  if UPLO = 'L',
  !  where U is an upper triangular matrix and L is lower triangular.
  !
  !  This is the block version of the algorithm, calling Level 3 BLAS.
  !
  !  Arguments
  !  =========
  !
  !  UPLO    (input) CHARACTER*1
  !          = 'U':  Upper triangle of A is stored;
  !          = 'L':  Lower triangle of A is stored.
  !
  !  N       (input) INTEGER
  !          The order of the matrix A.  N >= 0.
  !
  !  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)
  !          On entry, the symmetric matrix A.  If UPLO = 'U', the leading
  !          N-by-N upper triangular part of A contains the upper
  !          triangular part of the matrix A, and the strictly lower
  !          triangular part of A is not referenced.  If UPLO = 'L', the
  !          leading N-by-N lower triangular part of A contains the lower
  !          triangular part of the matrix A, and the strictly upper
  !          triangular part of A is not referenced.
  !
  !          On exit, if INFO = 0, the factor U or L from the Cholesky
  !          factorization A = U**T*U or A = L*L**T.
  !
  !  LDA     (input) INTEGER
  !          The leading dimension of the array A.  LDA >= max(1,N).
  !
  !  INFO    (output) INTEGER
  !          = 0:  successful exit
  !          < 0:  if INFO = -i, the i-th argument had an illegal value
  !          > 0:  if INFO = i, the leading minor of order i is not
  !                positive definite, and the factorization could not be
  !                completed.
  !
  ! Call LAPACK routine
  call dpotrf  (uplo, n, a, lda, info )
  call mth_fail(name,'MTH_DPOTRF',info,error)
end subroutine mth_dpotrf
!
subroutine mth_dpotrs (name,   &
     &    uplo, n, nrhs, a, lda, b, ldb, info )
  character(len=*) :: name           !
  character(len=*) :: uplo           !
  integer :: n                       !
  integer :: nrhs                    !
  integer :: lda                     !
  real(8) :: a(lda,*)                 !
  integer :: ldb                     !
  real(8) :: b(ldb,*)                 !
  ! Local
  integer :: info
  logical :: error
  !
  !  Purpose
  !  =======
  !
  !  DPOTRS solves a system of linear equations A*X = B with a symmetric
  !  positive definite matrix A using the Cholesky factorization
  !  A = U**T*U or A = L*L**T computed by DPOTRF.
  !
  !  Arguments
  !  =========
  !
  !  UPLO    (input) CHARACTER*1
  !          = 'U':  Upper triangle of A is stored;
  !          = 'L':  Lower triangle of A is stored.
  !
  !  N       (input) INTEGER
  !          The order of the matrix A.  N >= 0.
  !
  !  NRHS    (input) INTEGER
  !          The number of right hand sides, i.e., the number of columns
  !          of the matrix B.  NRHS >= 0.
  !
  !  A       (input) DOUBLE PRECISION array, dimension (LDA,N)
  !          The triangular factor U or L from the Cholesky factorization
  !          A = U**T*U or A = L*L**T, as computed by DPOTRF.
  !
  !  LDA     (input) INTEGER
  !          The leading dimension of the array A.  LDA >= max(1,N).
  !
  !  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
  !          On entry, the right hand side matrix B.
  !          On exit, the solution matrix X.
  !
  !  LDB     (input) INTEGER
  !          The leading dimension of the array B.  LDB >= max(1,N).
  !
  !  INFO    (output) INTEGER
  !          = 0:  successful exit
  !          < 0:  if INFO = -i, the i-th argument had an illegal value
  !
  ! Call LAPACK routine
  call dpotrs  (uplo, n, nrhs, a, lda, b, ldb, info )
  call mth_fail(name,'MTH_DPOTRF',info,error)
end subroutine mth_dpotrs
!
subroutine mth_dpbtrf (name, uplo, n, kd, ab, ldab, error)
  character(len=*) :: name             !
  character(len=*) :: uplo             !
  integer :: n                         !
  integer :: kd                        !
  integer :: ldab                      !
  real(8) :: ab(ldab,*)                 !
  logical :: error                     !
  ! Local
  integer :: info
  !
  !  Purpose
  !  =======
  !
  !  DPBTRF computes the Cholesky factorization of a real symmetric
  !  positive definite band matrix A.
  !
  !  The factorization has the form
  !     A = U**T * U,  if UPLO = 'U', or
  !     A = L  * L**T,  if UPLO = 'L',
  !  where U is an upper triangular matrix and L is lower triangular.
  !
  !  Arguments
  !  =========
  !
  !  UPLO    (input) CHARACTER*1
  !          = 'U':  Upper triangle of A is stored;
  !          = 'L':  Lower triangle of A is stored.
  !
  !  N       (input) INTEGER
  !          The order of the matrix A.  N >= 0.
  !
  !  KD      (input) INTEGER
  !          The number of superdiagonals of the matrix A if UPLO = 'U',
  !          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
  !
  !  AB      (input/output) DOUBLE PRECISION array, dimension (LDAB,N)
  !          On entry, the upper or lower triangle of the symmetric band
  !          matrix A, stored in the first KD+1 rows of the array.  The
  !          j-th column of A is stored in the j-th column of the array AB
  !          as follows:
  !          if UPLO = 'U', AB(kd+1+i-j,j) = A(i,j) for max(1,j-kd)<=i<=j;
  !          if UPLO = 'L', AB(1+i-j,j)    = A(i,j) for j<=i<=min(n,j+kd).
  !
  !          On exit, if INFO = 0, the triangular factor U or L from the
  !          Cholesky factorization A = U**T*U or A = L*L**T of the band
  !          matrix A, in the same storage format as A.
  !
  !  LDAB    (input) INTEGER
  !          The leading dimension of the array AB.  LDAB >= KD+1.
  !
  !  INFO    (output) INTEGER
  !          = 0:  successful exit
  !          < 0:  if INFO = -i, the i-th argument had an illegal value
  !          > 0:  if INFO = i, the leading minor of order i is not
  !                positive definite, and the factorization could not be
  !                completed.
  !
  !  Further Details
  !  ===============
  !
  !  The band storage scheme is illustrated by the following example, when
  !  N = 6, KD = 2, and UPLO = 'U':
  !
  !  On entry:                       On exit:
  !
  !      *    *   a13  a24  a35  a46      *    *   u13  u24  u35  u46
  !      *   a12  a23  a34  a45  a56      *   u12  u23  u34  u45  u56
  !     a11  a22  a33  a44  a55  a66     u11  u22  u33  u44  u55  u66
  !
  !  Similarly, if UPLO = 'L' the format of A is as follows:
  !
  !  On entry:                       On exit:
  !
  !     a11  a22  a33  a44  a55  a66     l11  l22  l33  l44  l55  l66
  !     a21  a32  a43  a54  a65   *      l21  l32  l43  l54  l65   *
  !     a31  a42  a53  a64   *    *      l31  l42  l53  l64   *    *
  !
  !  Array elements marked * are not used by the routine.
  !
  ! Call LAPACK routine
  call dpbtrf  (uplo, n, kd, ab, ldab, info )
  call mth_fail(name,'MTH_DPBTRF',info,error)
end subroutine mth_dpbtrf
!
subroutine mth_dpbtrs (name,   &
     &    uplo, n, kd, nrhs, ab, ldab, b, ldb, error)
  character(len=*) :: name             !
  character(len=*) :: uplo             !
  integer :: n                         !
  integer :: kd                        !
  integer :: nrhs                      !
  integer :: ldab                      !
  real(8) :: ab(ldab,*)                 !
  integer :: ldb                       !
  real(8) :: b(ldb,*)                   !
  logical :: error                     !
  ! Local
  integer :: info
  !
  !  Purpose
  !  =======
  !
  !  DPBTRS solves a system of linear equations A*X = B with a symmetric
  !  positive definite band matrix A using the Cholesky factorization
  !  A = U**T*U or A = L*L**T computed by DPBTRF.
  !
  !  Arguments
  !  =========
  !
  !  UPLO    (input) CHARACTER*1
  !          = 'U':  Upper triangular factor stored in AB;
  !          = 'L':  Lower triangular factor stored in AB.
  !
  !  N       (input) INTEGER
  !          The order of the matrix A.  N >= 0.
  !
  !  KD      (input) INTEGER
  !          The number of superdiagonals of the matrix A if UPLO = 'U',
  !          or the number of subdiagonals if UPLO = 'L'.  KD >= 0.
  !
  !  NRHS    (input) INTEGER
  !          The number of right hand sides, i.e., the number of columns
  !          of the matrix B.  NRHS >= 0.
  !
  !  AB      (input) DOUBLE PRECISION array, dimension (LDAB,N)
  !          The triangular factor U or L from the Cholesky factorization
  !          A = U**T*U or A = L*L**T of the band matrix A, stored in the
  !          first KD+1 rows of the array.  The j-th column of U or L is
  !          stored in the j-th column of the array AB as follows:
  !          if UPLO ='U', AB(kd+1+i-j,j) = U(i,j) for max(1,j-kd)<=i<=j;
  !          if UPLO ='L', AB(1+i-j,j)    = L(i,j) for j<=i<=min(n,j+kd).
  !
  !  LDAB    (input) INTEGER
  !          The leading dimension of the array AB.  LDAB >= KD+1.
  !
  !  B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)
  !          On entry, the right hand side matrix B.
  !          On exit, the solution matrix X.
  !
  !  LDB     (input) INTEGER
  !          The leading dimension of the array B.  LDB >= max(1,N).
  !
  !  INFO    (output) INTEGER
  !          = 0:  successful exit
  !          < 0:  if INFO = -i, the i-th argument had an illegal value
  !
  ! Call LAPACK routine
  call dpbtrs (uplo, n, kd, nrhs, ab, ldab, b, ldb, info )
  call mth_fail(name,'MTH_DPBTRS',info,error)
end subroutine mth_dpbtrs
! End of Linear Algebra
!
subroutine mth_fail (fac,prog,ifail,error)
  use gbl_message
  !---------------------------------------------------------------------
  ! Error handling routine
  !---------------------------------------------------------------------
  character(len=*) :: fac           !
  character(len=*) :: prog          !
  integer :: ifail                  !
  logical :: error                  !
  ! Local
  character(len=60) :: chain
  !
  if (ifail.eq.0) then
    error = .false.
  else
    write(chain,'(A,A,A,I4)')   &
     &      'ERROR in ',trim(prog),', ifail = ',ifail
    call map_message(seve%e,fac,chain)
    error = .true.
  endif
end subroutine mth_fail
!
subroutine overlap(a,n,b,m,c,k)
  !
  ! Find the intersection of ensembles A and B
  !
  integer, intent(in) :: n
  integer, intent(in) :: a(n)
  integer, intent(in) :: m
  integer, intent(in) :: b(m)
  integer, intent(inout) :: k
  integer, intent(inout) ::c(*)
  !
  integer i,j
  !
  k = 0
  do i=1,n
    do j=1,m
      if (a(i).eq.b(j)) then
        k = k+1
        c(k) = a(i)
        exit
      endif
    enddo
  enddo
  !! Print *,'Overlap ',n,m,k,' = ',c(1:K)
end subroutine overlap
!
subroutine union(a,n,b,m,c,k)
  !
  ! Find the Union of ensembles A and B
  !
  integer, intent(in) :: n
  integer, intent(in) :: a(n)
  integer, intent(in) :: m
  integer, intent(in) :: b(m)
  integer, intent(inout) :: k
  integer, intent(inout) ::c(*)
  !
  integer i,j
  logical :: found
  !
  k = n
  c(1:k) = a(1:n)
  !
  do j=1,m
    found = .false.
    do i=1,n
      if (c(i).eq.b(j)) then
        found = .true.
        exit
      endif
    enddo
    if (.not.found) then
      k = k+1
      c(k) = b(j)
    endif
  enddo
end subroutine union
!
subroutine do_get_cgain(ntimes,nantes,hsol,again,refant,scale_gain,error)
  use gildas_def
  use gkernel_interfaces
  use image_def
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-mandatory
  ! 
  ! IMAGER Command SOLVE
  ! Task UV_GAIN
  !
  ! Prepare the Solution Table: Amplitude & Phase correction per antenna.
  !
  ! Convert the formatted temporary files to a Gildas Table
  !---------------------------------------------------------------------
  integer, intent(in) :: ntimes   ! Number of times
  integer, intent(in) :: nantes   ! Maximum number of antennas
  integer, intent(in) :: refant   ! Reference antenna
  type(gildas), intent(inout) :: hsol  ! Antenna Solution table
  real, allocatable, intent(out) :: again(:,:)  ! Antenna Solution array
  real, intent(out) :: scale_gain ! Scaling Amplitude factor
  logical, intent(inout) :: error ! Error flag
  !
  character(len=*), parameter :: rname='SOLVE'
  !
  integer :: iref, nant, ier, i, j, k, l
  real(8) :: time, ztime, date, secs
  integer(4) :: jant, kant, mant, iunit
  character(len=60) :: mess
  ! A few automatic arrays, taken on the stack
  real(4) :: amplis(0:nantes) 
  real(4) :: phases(0:nantes) 
  real(4) :: ampsnr(nantes) 
  real(4) :: rphase  
  real(8) :: mean_gain, weig_gain
  integer(4) :: al(nantes)  
  !
  ! Larger allocatable arrays (one could use re-allocation instead,
  ! but they are still small anyway)
  integer(4), allocatable :: itmp(:),ialways(:)
  !
  allocate(itmp(ntimes*nantes),ialways(ntimes*nantes),stat=ier)
  if (ier.ne.0) then
    error = .true.
    return
  endif
  !
  ztime = 0
  amplis = 0.
  phases = 0.
  ampsnr = 0.
  itmp = 0
  ialways = 0
  !
  iunit = 4  ! Amplitude + Phase
  rewind(unit=iunit)
  !
  ! Find the common antennas
  read(iunit,*,iostat=ier) iref, time, nant  ! Read the time step
  read(iunit,*,iostat=ier) al(1:nant)        ! Read the antenna list
  ialways(1:nant) = al(1:nant)
  jant = nant
  read(iunit,*,iostat=ier) amplis(1:nant)
  read(iunit,*,iostat=ier) phases(1:nant)
  read(iunit,*,iostat=ier) ampsnr(1:nant)
  do i=2,ntimes
    read(iunit,*,iostat=ier) iref, time, nant  ! Read the time step
    read(iunit,*,iostat=ier) al(1:nant)        ! Read the antenna list
    call union(ialways,jant,al,nant,itmp,kant)
    jant = kant
    ialways(1:kant) = itmp(1:kant)
    read(iunit,*,iostat=ier) amplis(1:nant)
    read(iunit,*,iostat=ier) phases(1:nant)
    read(iunit,*,iostat=ier) ampsnr(1:nant)
  enddo
  rewind(iunit)
  !
  mant = maxval(ialways(1:kant))
  write(mess,'(I0,A)') kant,' antennas present:'
  call map_message(seve%i,rname,mess)
  write(*,'(16(1x,I3))') ialways(1:kant)
  if (mant.ne.kant) then
    write(mess,'(A,I0,A,I0)') 'Maximum Antenna number ',mant,' exceeds number of antennas ',kant
    call map_message(seve%w,rname,mess)
  endif
  !
  hsol%gil%ndim = 2
  hsol%gil%dim(1) = ntimes
  !
  ! This has been modified to use
  !   kant  instead of    nantes
  ! to use the unambiguous antenna number, but a backward pointer 
  ! to ialways is then needed.
  !
  hsol%gil%dim(2) = 4+3*mant  !
  !
  allocate(again(hsol%gil%dim(1),hsol%gil%dim(2)), stat=ier)
  again = 0
  mean_gain = 0.d0
  weig_gain = 0.d0
  !
  do i=1,ntimes
    read(iunit,*,iostat=ier) iref, time, nant  ! Read the time step
    read(iunit,*,iostat=ier) al(1:nant)        ! Read the antenna list
    if (ztime.eq.0) ztime = time
    time = time-ztime
    secs = mod(time,86400.d0)
    date = (time-secs)/86400.d0 
    again(i,1) = secs
    again(i,2) = date     
    again(i,3) = nant
    again(i,4) = iref
    !
    read(iunit,*) amplis(1:nant)
    read(iunit,*) phases(1:nant)
    read(iunit,*) ampsnr(1:nant)
    !
    ! Locate the reference antenna
    rphase = phases(refant)
    do l=1,kant
      if (ialways(l).eq.refant) then
        rphase = phases(refant)
        exit
      endif
    enddo
    !
    do j=1,nant
      k = j ! By default...
      ! Here we should find K such that ialways(k) == al(j)
      ! and use K instead of J for the output columns
      do l=1,kant
        if (ialways(l).eq.al(j)) then
          k = ialways(l)
          exit
        endif
      enddo
      again(i,2+3*k) = amplis(j) 
      again(i,3+3*k) = phases(j) - rphase 
      again(i,4+3*k) = ampsnr(j) 
      mean_gain = mean_gain + amplis(j)/ampsnr(j)**2
      weig_gain = weig_gain + 1./ampsnr(j)**2
    enddo
  enddo
  scale_gain = mean_gain / weig_gain  ! Per antenna
  scale_gain = scale_gain ** 2        ! Per baseline
  close(unit=iunit)
  !
  hsol%loca%size = hsol%gil%dim(1)*hsol%gil%dim(2)
end subroutine do_get_cgain
!
subroutine do_normalize_v(ncol,nvis,duvbg,scale_gain)
  use gbl_message
  use gkernel_interfaces
  !---------------------------------------------------------------------
  ! @ private
  !   IMAGER
  !     Normalize the per-baseline amplitude gains so that the Weighted 
  !   mean is 1.0
  !---------------------------------------------------------------------
  integer, intent(in) :: ncol           ! Visibility size
  integer, intent(in) :: nvis           ! Number of visibilities
  real, intent(in) :: duvbg(ncol,nvis)  ! Visibilities
  real, intent(out) :: scale_gain       ! Computed Scaling factor
  !
  real(8) :: fr,fw,w
  integer :: iv, ig, ier
  integer(kind=index_length) :: ng
  real, allocatable :: gain(:)
  real :: wmean, rmean, median
  logical :: error
  character(len=256) :: chain
  !
  allocate(gain(nvis),stat=ier)
  !
  fr = 0.
  fw = 0.
  w = 0.
  ig = 0
  do iv=1,nvis
    if (duvbg(10,iv).gt.0) then
      ig = ig+1
      gain(ig) = sqrt((duvbg(8,iv)**2+duvbg(9,iv)**2))
      fw = fw + gain(ig)*duvbg(10,iv)
      fr = fr + gain(ig)
      w = w + duvbg(10,iv)
    endif
  enddo
  wmean = fw/w
  rmean = fr/ig
  !
  ng = ig
  call gr4_median(gain,ng,0.0,-1.0,median,error)  
  !
  write(chain,'(A,F6.3,A,F6.3,A,F6.3)') 'Scale factors: Raw ',rmean, &
    & ', Weighted ',wmean,' Median ',median
  call message_colour(1)
  call map_message(seve%w,'SOLVE',chain)
  call message_colour(-1)
  !
  scale_gain = wmean ! In general, the best
end subroutine do_normalize_v

subroutine dofft_quick_debug (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  use gkernel_interfaces
  !$  use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   - Taper before gridding
  !   - Gridding with pre-computed support
  !   - Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io
  integer ixm,ixp,iym,iyp,iu,iv
  real result,resima,staper,etaper,res
  real u,v,du,dv,ufac,vfac
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  integer my,kx,ky, noper
  integer, parameter :: moper=50000  ! 0 Threshold for parallel computation
  integer ier, othread, ithread, nthread, lchunk, nchunk
  integer iy0, iy1, iyb, iyf, k
  integer, allocatable :: iy0_a(:), iy1_a(:)
  logical start_thread
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
    cx = 1.
    sx = 0
    cy = 1.
    sy = 0.
    etaper = 1
    staper = 1
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  staper = 1.0
  !
  ! Use symmetry
  my = ny/2+1
  !
  !
  ! The scheduling in Open-MP mode is made with large chunks,
  ! to avoid writing at the same location from two different threads.
  ! The u,v data being sorted in increasing v, a thread writes
  ! its largest iy values in its last visibilities, while the
  ! the next thread has written its smallest iy values (which could
  ! overlap with the previous ones) in its first visibilites.
  !
  !   With large chunks, collisions are in practice avoided.
  !   For small numbers of Visibilities, only one thread is used.
  !
  ! The proper algorithm would
  !   - determine the minimum and maximum pixel (including
  !     support) for each thread IT
  !   - or even better, the visibility VS(IT) at which it starts
  !     to touch the next thread IT+1, or the visibility VF(IT)
  !     where it finishes VF(IT) to touch the previous thread IT-1
  !   - Each thread would have two locks: a backward lock LB(IT)
  !     (used by the previous thread) and a forward lock LF(IT)
  !     (use by the next one).
  !   - At the beginning, all threads are not waiting for locks
  !     All locks are released.
  !   - Thread IT
  !       - Waits for lock FL(IT-1)  (which is normally cleared)
  !       - set the backward lock LB(IT)
  !       - when reaching VF(IT), releases LB(IT)
  !       - when reaching VS(IT), waits for LB(IT+1)
  !       - sets FL(IT)
  !       - when finishing, releases FL(IT)
  !
  ! However, the problem is that adjacent threads overlap twice
  ! Thread IT-1   !           !
  !             -----------------
  ! Thread IT                 !           !
  !                         -----[-----]-----
  ! Thread IT+1                           !          !
  !                                     ----------------
  ! so that the Clean region is only the one within brackets.
  ! This means we should check a double-support guard
  ! to define the locks...
  !
  ! The problem is that we do not know in advance where
  ! a thread finishes, unless we explicitely split our
  ! work in advance into chunks...
  noper = nv*(20+nc)
  othread = 1
  !$  othread = omp_get_max_threads()
  lchunk = (nv+othread-1)/othread
  nchunk = (nv+lchunk-1)/lchunk
  !$  Print *,'OMP -- Nthread ',othread,' Chunk ',lchunk,nchunk
  allocate (iy0_a(nchunk),iy1_a(nchunk),stat=ier)
  k =  0
  do i=1,nv,lchunk
    k = k+1
    iy0_a(k) = int((visi(jy,i)+2*sup(2))/yinc+yref)
    iy1_a(k) = int((visi(jy,min(i+lchunk-1,nv))-2*sup(2))/yinc+yref)
  enddo
  !
  Print *,'Support ',sup(2)/yinc
  Print *,'iy0 ',iy0_a
  Print *,'iy1 ',iy1_a
  !
  ! Are chunks large enough ?
  nchunk = othread
  Print *,' enter an integer < ',othread
!!  read(5,*) nchunk
  nchunk = max(1,nchunk)
  !
!!  if (noper.lt.moper) then
  if (nchunk.lt.othread) then
    !$  call omp_set_num_threads(nchunk)
    Print *,'commuting from ',othread,' to ',nchunk,' thread'
  else
    Print *,'Using ',othread,' threads ',noper,' < ',moper
  endif
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP   & SHARED(mapx,mapy,nc,nv,nx,ny,my) &
  !$OMP   & SHARED(jx,jy,cx,sx,cy,sy,etaper,do_taper,io) &
  !$OMP   & SHARED(xinc,xref,yinc,yref,sup,ubias,vbias,ufac,vfac) &
  !$OMP   & PRIVATE(i,u,v,staper,result,resima,ixp,ixm,iyp,iym) &
  !$OMP   & PRIVATE(dv,iv,du,iu,res,iin,iou,iy,ix,ic) &
  !$OMP   & SHARED(map) PRIVATE(ithread,lchunk,nthread) &
  !$OMP   & SHARED(ubuff,vbuff,visi,we) &
  !$OMP   & PRIVATE(iy0,iy1,iyb,iyf,start_thread)
  nthread = 1
  ithread = 1
  !$  nthread = omp_get_num_threads()
  !$  ithread = omp_get_thread_num() + 1
  lchunk = (nv+nthread-1)/nthread
  start_thread = .true.
  !$OMP DO SCHEDULE(STATIC,lchunk)
  ! Start with loop on observed visibilities
  do i=1,nv
    u = visi(jx,i)
    v = visi(jy,i)
    if (start_thread) then
      iy0 = int(v/yinc+yref)
      iy1 = int(visi(jy,min(i+lchunk-1,nv))/yinc+yref)
      Print *,'thread ',ithread,' iy0 ',iy0,' iy1 ',iy1
      start_thread = .false.
    endif
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
      result = staper*we(i)
    else
      result = we(i)
    endif
    !
    ! Weight and taper
    if (v.gt.0) then
      u = -u
      v = - v
      resima = -result
    else
      resima = result
    endif
    ! Channels
    ! Define map cell
    ixp = int((u-sup(1))/xinc+xref+1.0)
    ixm = int((u+sup(1))/xinc+xref)
    iym = int((v-sup(2))/yinc+yref)
    iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
    !
    ! Lock management
    iyb = int((v-2*sup(2))/yinc+yref)
    if (iyb.gt.iy0) then
      Print *,ithread,'Releasing lock for ',ithread-1,'; at ',i,iym,iyp
      iy0 = ny
    endif
    iyf = int((v+2*sup(2))/yinc+yref)
    if (iyf.gt.iy1) then
      Print *,ithread,'   Waiting for lock from ',ithread+1,'; at ',i,iym,iyp
      iy1 = 2*ny
    endif
    !
    if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
      continue
      !            PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
    else
      do iy=iym,iyp
        dv = v-mapy(iy)
        if (abs(dv).le.sup(2)) then
          iv = nint(dv*vfac+vbias)
          do ix=ixm,ixp
            du = u-mapx(ix)
            if (abs(du).le.sup(1)) then
              iu = nint(du*ufac+ubias)
              res = ubuff(iu)*vbuff(iv)
              iou = 1
              iin = io
              do ic=1,nc
                !$OMP ATOMIC
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*result*res
                iou = iou+1
                iin = iin+1
                !$OMP ATOMIC
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*resima*res
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
              !$OMP ATOMIC
              map (iou,ix,iy) = map(iou,ix,iy) +   &
     &                res*result
            endif
          enddo
        endif
      enddo
    endif
    !
    ! Borderline case: use symmetry
    u = -u
    v = -v
    resima = -resima
    if (v.le.sup(2)) then
      ! Lock management
      iyb = int((v-2*sup(2))/yinc+yref)
      if (iyb.gt.iy0) then
        Print *,ithread,'Releasing lock for ',ithread-1,'; at ',i,iym,iyp
        iy0 = ny
      endif
      iyf = int((v+2*sup(2))/yinc+yref)
      if (iyf.gt.iy1) then
        Print *,ithread,'   Waiting for lock from ',ithread+1,'; at ',i,iym,iyp
        iy1 = 2*ny
      endif
      !
      ixp = int((u-sup(1))/xinc+xref+1.0)
      ixm = int((u+sup(1))/xinc+xref)
      iym = int((v-sup(2))/yinc+yref)
      iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
      if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
        continue
        !               PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
      else
        do iy=iym,iyp
          dv = v-mapy(iy)
          if (abs(dv).le.sup(2)) then
            iv = nint(dv*vfac+vbias)
            do ix=ixm,ixp
              du = u-mapx(ix)
              if (abs(du).le.sup(1)) then
                iu = nint(du*ufac+ubias)
                res = ubuff(iu)*vbuff(iv)
                iou = 1
                iin = io
                do ic=1,nc
                  !$OMP ATOMIC
                  map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                    visi(iin,i)*result*res
                  iou = iou+1
                  iin = iin+1
                  !$OMP ATOMIC
                  map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                    visi(iin,i)*resima*res
                  iou = iou+1
                  iin = iin+2
                enddo
                ! Beam
                !$OMP ATOMIC
                map (iou,ix,iy) = map(iou,ix,iy) +   &
     &                  res*result
              endif
            enddo
          endif
        enddo
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  ! Apply symmetry  !$OMP DO
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      iou = 1
      do i=1,nc
        map(iou,ix,iy) = map(iou,kx,ky)
        iou = iou+1
        map(iou,ix,iy) = -map(iou,kx,ky)
        iou = iou+1
      enddo
      map(iou,ix,iy) = map(iou,kx,ky)  ! Beam
    enddo
  enddo
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
  do iy = 1,ny
    if (map(2*nc-1,1,iy).ne.0) then
      print *,'Invalid beam ',iy
    endif
  enddo
  !
  if (noper.lt.moper) then
    !$  call omp_set_num_threads(othread)
    Print *,'commuting from 1 to ',othread,' thread'
  endif
end subroutine dofft_quick_debug
!
subroutine dofft_quick_para (np,nv,visi,jx,jy,jo   &
     &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv,   &
     &    ubias,vbias,ubuff,vbuff)
  use gkernel_interfaces
  !$  use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  ! GILDAS  MAP_FAST
  !   Compute FFT of image by gridding UV data
  !   - Taper before gridding
  !   - Gridding with pre-computed support
  !   - Uses symmetry
  !----------------------------------------------------------------------
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  real, intent(in) :: visi(np,nv)             ! values
  integer, intent(in) :: nc                   ! number of channels
  integer, intent(in) :: jx                   ! X coord location in VISI
  integer, intent(in) :: jy                   ! Y coord location in VISI
  integer, intent(in) :: jo                   ! first channel to map
  integer, intent(in) :: nx                   ! X map size
  integer, intent(in) :: ny                   ! Y map size
  real, intent(out) :: map(2*(nc+1),nx,ny)    ! gridded visibilities
  real, intent(in) :: mapx(nx)                ! X Coordinates of grid
  real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
  real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
  real, intent(in) :: cell(2)                 ! cell size in Meters
  real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
  real, intent(in) :: we(nv)                  ! Weight array
  real, intent(in) :: vv(nv)                  ! V Values
  real, intent(in) :: ubias                   ! U gridding offset
  real, intent(in) :: vbias                   ! V gridding offset
  real, intent(in) :: ubuff(4096)             ! U gridding buffer
  real, intent(in) :: vbuff(4096)             ! V gridding buffer
  ! Global
  real(8), parameter :: pi=3.141592653589793d0
  ! Local
  integer ix,iy,ic,i,iin,iou,io
  integer ixm,ixp,iym,iyp,iu,iv
  real result,resima,staper,etaper,res
  real u,v,du,dv,ufac,vfac
  real cx,cy,sx,sy
  real(8) xinc,xref,yinc,yref
  logical do_taper
  !
  integer my,kx,ky, noper
  integer, parameter :: moper=50000  ! 0 Threshold for parallel computation
  integer othread, ithread, nthread, lchunk, nchunk
  integer iy0, iy1, iyb, iyf
  logical start_thread
  !
  ! Compute IO from first channel number
  io = 7+3*jo-2
  ufac = 100.d0/cell(1)
  vfac = 100.d0/cell(2)
  !
  if (taper(1).ne.0. .and. taper(2).ne.0.) then
    do_taper = .true.
    staper = taper(3)*pi/180.0
    if (taper(1).ne.0) then
      cx = cos(staper)/taper(1)
      sy = sin(staper)/taper(1)
    else
      cx = 0.0
      sy = 0.0
    endif
    if (taper(2).ne.0) then
      cy = cos(staper)/taper(2)
      sx = sin(staper)/taper(2)
    else
      cy = 0.0
      sx = 0.0
    endif
    if (taper(4).ne.0.) then
      etaper = taper(4)/2.0
    else
      etaper = 1
    endif
  else
    do_taper = .false.
    cx = 1.
    sx = 0
    cy = 1.
    sy = 0.
    etaper = 1
    staper = 1
  endif
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  staper = 1.0
  !
  ! Use symmetry
  my = ny/2+1
  !
  !
  ! The scheduling in Open-MP mode is made with large chunks,
  ! to avoid writing at the same location from two different threads.
  ! The u,v data being sorted in increasing v, a thread writes
  ! its largest iy values in its last visibilities, while the
  ! the next thread has written its smallest iy values (which could
  ! overlap with the previous ones) in its first visibilites.
  !
  !   With large chunks, collisions are in practice avoided.
  !   For small numbers of Visibilities, only one thread is used.
  !
  ! The proper algorithm would
  !   - determine the minimum and maximum pixel (including
  !     support) for each thread IT
  !   - or even better, the visibility VS(IT) at which it starts
  !     to touch the next thread IT+1, or the visibility VF(IT)
  !     where it finishes VF(IT) to touch the previous thread IT-1
  !   - Each thread would have two locks: a backward lock LB(IT)
  !     (used by the previous thread) and a forward lock LF(IT)
  !     (use by the next one).
  !   - At the beginning, all threads are not waiting for locks
  !     All locks are released.
  !   - Thread IT
  !       - Waits for lock FL(IT-1)  (which is normally cleared)
  !       - set the backward lock LB(IT)
  !       - when reaching VF(IT), releases LB(IT)
  !       - when reaching VS(IT), waits for LB(IT+1)
  !       - sets FL(IT)
  !       - when finishing, releases FL(IT)
  !
  ! However, the problem is that adjacent threads overlap twice
  ! Thread IT-1   !           !
  !             -----------------
  ! Thread IT                 !           !
  !                         -----[-----]-----
  ! Thread IT+1                           !          !
  !                                     ----------------
  ! so that the Clean region is only the one within brackets.
  ! This means we should check a double-support guard
  ! to define the locks...
  !
  ! The problem is that we do not know in advance where
  ! a thread finishes, unless we explicitely split our
  ! work in advance into chunks...
  noper = nv*(20+nc)
  othread = 1
  !$  othread = omp_get_max_threads()
  lchunk = (nv+othread-1)/othread
  nchunk = (nv+lchunk-1)/lchunk
  !$  Print *,'Nthread ',othread,' Chunk ',lchunk,nchunk
  !$OMP PARALLEL DEFAULT(none) &
  !$OMP   & SHARED(mapx,mapy,nc,nv,nx,ny,my) &
  !$OMP   & SHARED(jx,jy,cx,sx,cy,sy,etaper,do_taper,io) &
  !$OMP   & SHARED(xinc,xref,yinc,yref,sup,ubias,vbias,ufac,vfac) &
  !$OMP   & PRIVATE(i,u,v,staper,result,resima,ixp,ixm,iyp,iym) &
  !$OMP   & PRIVATE(dv,iv,du,iu,res,iin,iou,iy,ix,ic) &
  !$OMP   & SHARED(map) PRIVATE(ithread,lchunk,nthread) &
  !$OMP   & SHARED(ubuff,vbuff,visi,we) &
  !$OMP   & PRIVATE(iy0,iy1,iyb,iyf,start_thread)
  nthread = 1
  ithread = 1
  !$  nthread = omp_get_num_threads()
  !$  ithread = omp_get_thread_num() + 1
  lchunk = (nv+nthread-1)/nthread
  !$OMP DO SCHEDULE(STATIC,lchunk)
  ! Start with loop on observed visibilities
  do i=1,nv
    u = visi(jx,i)
    v = visi(jy,i)
    !
    if (do_taper) then
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (etaper.ne.1) staper = staper**etaper
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
      result = staper*we(i)
    else
      result = we(i)
    endif
    !
    ! Weight and taper
    if (v.gt.0) then
      u = -u
      v = - v
      resima = -result
    else
      resima = result
    endif
    ! Channels
    ! Define map cell
    ixp = int((u-sup(1))/xinc+xref+1.0)
    ixm = int((u+sup(1))/xinc+xref)
    iym = int((v-sup(2))/yinc+yref)
    iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
    !
    if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
      continue
      !            PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
    else
      do iy=iym,iyp
        dv = v-mapy(iy)
        if (abs(dv).le.sup(2)) then
          iv = nint(dv*vfac+vbias)
          do ix=ixm,ixp
            du = u-mapx(ix)
            if (abs(du).le.sup(1)) then
              iu = nint(du*ufac+ubias)
              res = ubuff(iu)*vbuff(iv)
              iou = 1
              iin = io
              do ic=1,nc
                !$OMP ATOMIC
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*result*res
                iou = iou+1
                iin = iin+1
                !$OMP ATOMIC
                map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                  visi(iin,i)*resima*res
                iou = iou+1
                iin = iin+2
              enddo
              ! Beam
              !$OMP ATOMIC
              map (iou,ix,iy) = map(iou,ix,iy) +   &
     &                res*result
            endif
          enddo
        endif
      enddo
    endif
    !
    ! Borderline case: use symmetry
    u = -u
    v = -v
    resima = -resima
    if (v.le.sup(2)) then
      !
      ixp = int((u-sup(1))/xinc+xref+1.0)
      ixm = int((u+sup(1))/xinc+xref)
      iym = int((v-sup(2))/yinc+yref)
      iyp = min(my,int((v+sup(2))/yinc+yref+1.0))
      if (ixm.lt.1.or.ixp.gt.nx.or.iym.lt.1.or.iyp.gt.ny) then
        continue
        !               PRINT *,'Visi ',I,' pixels ',IXM,IXP,IYM,IYP
      else
        do iy=iym,iyp
          dv = v-mapy(iy)
          if (abs(dv).le.sup(2)) then
            iv = nint(dv*vfac+vbias)
            do ix=ixm,ixp
              du = u-mapx(ix)
              if (abs(du).le.sup(1)) then
                iu = nint(du*ufac+ubias)
                res = ubuff(iu)*vbuff(iv)
                iou = 1
                iin = io
                do ic=1,nc
                  !$OMP ATOMIC
                  map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                    visi(iin,i)*result*res
                  iou = iou+1
                  iin = iin+1
                  !$OMP ATOMIC
                  map (iou,ix,iy) = map (iou,ix,iy) +   &
     &                    visi(iin,i)*resima*res
                  iou = iou+1
                  iin = iin+2
                enddo
                ! Beam
                !$OMP ATOMIC
                map (iou,ix,iy) = map(iou,ix,iy) +   &
     &                  res*result
              endif
            enddo
          endif
        enddo
      endif
    endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
  !
  ! Apply symmetry  !$OMP DO
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      iou = 1
      do i=1,nc
        map(iou,ix,iy) = map(iou,kx,ky)
        iou = iou+1
        map(iou,ix,iy) = -map(iou,kx,ky)
        iou = iou+1
      enddo
      map(iou,ix,iy) = map(iou,kx,ky)  ! Beam
    enddo
  enddo
  !
  ! Missing row is left empty (assume proper coverage of the UV plane)
  do iy = 1,ny
    if (map(2*nc-1,1,iy).ne.0) then
      print *,'Invalid beam ',iy
    endif
  enddo
  !
  if (noper.lt.moper) then
    !$  call omp_set_num_threads(othread)
    Print *,'commuting from 1 to ',othread,' thread'
  endif
end subroutine dofft_quick_para

subroutine store_flux(line,error)
  use gkernel_interfaces
  use gildas_def
  use classic_api  
  !---------------------------------------------------------------------
  !	Stores internal fluxes and efficiencies
  !	into observations from current index
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  ! Global
  include 'clic_parameter.inc'
  include 'clic_clic.inc'
  include 'clic_display.inc'
  include 'clic_par.inc'
  include 'gbl_pi.inc'
  ! Local
  logical :: end
  integer :: i, if, j
  character(len=80) :: chain
  integer :: dtol
  real :: frtol
  parameter (frtol=1e3, dtol=7)    ! 1 GHz ... 1 week ...
  !------------------------------------------------------------------------
  ! Code:
  call check_input_file(error)
  if (error) return
  call check_index(error)
  if (error) return
  call check_output_file(error)
  if (error) return
  call check_equal_file(error)
  if (error) return
  if (write_mode.eq.'UPDA') call check_equal_file(error)
  if (error) return
  !
  ! Check the flux list
  call sort_fluxes(error)
  if (error) return
  do i = 1, n_flux
    if (abs(flux(i)).gt.1e6 .or. abs(flux(i)).lt.1e-6) then
      write (chain,'(a,1pg12.5)')   &
        'Unlikely flux for '//c_flux(i)//' : ',flux(i)
      call message (8,3,'STORE_FLUX',chain(1:lenc(chain)))
      error = .true.
      return
    endif
  enddo
  !
  ! Loop on current index
  call get_first(.false.,error)
  if (error) return
  end = .false.
  do while (.not.end)
    !
    ! Store Fluxes
    ! Fluxes with undetermined date or frequency come first in the list.
    ! so they are overridden by values with precise frequency or date.
    if = 0
    !
    !Give priority to FIXED fluxes.
    ! exact frequency or date ? (FRTOL and DTOL should be tunable parameters)
    do i = 1, n_flux
      if (f_flux(i) .and. r_sourc.eq.c_flux(i) .and.   &
        ((freq_flux(i).le.0)  .or.   &
        abs(r_restf-freq_flux(i)).lt.frtol) .and.   &
        ((date_flux(i).lt.-100000)   &
        .or. (abs(date_flux(i)-r_dobs).le.dtol))) then
        if = i
      endif
    enddo
    ! or any frequency,
    if (if.eq.0) then
      do i = 1, n_flux
        if (f_flux(i) .and. c_flux(i).eq.r_sourc) then
          if = i
        endif
      enddo
    endif
    ! now free fluxes
    ! exact frequency or date ? (FRTOL and DTOL should be tunable parameters)
    if (if.eq.0) then
      do i = 1, n_flux
        if (r_sourc.eq.c_flux(i) .and.   &
          ((freq_flux(i).le.0)  .or.   &
          abs(r_restf-freq_flux(i)).lt.frtol) .and.   &
          ((date_flux(i).lt.-100000)   &
          .or. (abs(date_flux(i)-r_dobs).le.dtol))) then
          if = i
        endif
      enddo
    endif
    ! or any frequency,
    if (if.eq.0) then
      do i = 1, n_flux
        if (c_flux(i).eq.r_sourc) then
          if = i
        endif
      enddo
    endif
    if (if.ne.0) then
      if (f_flux(if)) then
        r_flux = abs(flux(if))
      else
        r_flux = -abs(flux(if))
      endif
    endif
    ! Store efficiencies
    !         DO J=1, R_NANT
    !            R_JYKEL(J) = JY_TO_KEL(J)
    !         ENDDO
    !
    ! Update scan
    call write_scan (.false.,error)    ! data not changed
    if (error) return
    !
    ! Next observation
    if (sic_ctrlc()) goto 999
    call get_next(end,error)
    if (error) return
  enddo
  return
  !
999 error = .true.
  return
end subroutine store_flux

subroutine rec_define_noema(rec,mode,error)
  use gbl_message
  use astro_interfaces, except_this=>rec_define_noema
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! fill in the receiver type according to input name
  !-----------------------------------------------------------------------
  type(receiver_t), intent(inout) :: rec ! receiver parameters
  character(len=*), intent(in) :: mode ! OFFLINE or ONLINE
  logical, intent(inout)        :: error
  ! local
  integer(kind=4)       :: i
  !
  rec%desc%name = 'NOEMA'
  if (mode.eq.'OFFLINE') then
    rec%desc%n_rbands = 3
  else if (mode.eq.'ONLINE') then
    rec%desc%n_rbands = 4
  endif
  rec%desc%bandname(1) = 'Band_1'
  rec%desc%bandname(2) = 'Band_2'
  rec%desc%bandname(3) = 'Band_3'
  rec%desc%bandname(4) = 'Band_4'
  rec%desc%rejection(1) = 30
  rec%desc%rejection(2) = 30
  rec%desc%rejection(3) = 30
  rec%desc%rejection(4) = 30
  rec%desc%n_sbands = 2
  rec%desc%n_bbands = 2
  rec%desc%n_polar = 2
  rec%desc%n_backends = 1
  rec%desc%iflim(1) = 3872d0
  rec%desc%iflim(2) = 11616d0
  rec%desc%ifband = rec%desc%iflim(2)-rec%desc%iflim(1)
  !basebands
  rec%desc%flo2 = 7744d0
  ! LO2 separation zone: (from commissioning output)
  ! Mark only the strong parasite
  !Attenuation 1.5chunk in INNER and OUTER defined in IF1 - not yet plotted
  rec%desc%if1conf(1) = rec%desc%flo2-10d0
  rec%desc%if1conf(2) = rec%desc%flo2+10d0
  rec%desc%bbname(1) = 'OUTER'
  rec%desc%bblim(1,1) = 7744d0
  rec%desc%bblim(2,1) = 11616d0
  rec%desc%bbref(1) = 10000d0
  rec%desc%bbname(2) = 'INNER'
  rec%desc%bblim(1,2) = 3872d0
  rec%desc%bblim(2,2) = 7744d0
  rec%desc%bbref(2) = 6000d0
  ! Polars
  rec%desc%polname(1) = 'HORIZONTAL'
  rec%desc%polname(2) = 'VERTICAL'
  !
  ! Limits as stated in the tuning tables  (Jan2017)
  rec%desc%lohard(1,1) = 82.0d3
  rec%desc%lohard(2,1) = 110d3
  rec%desc%lohard(1,2) = 136d3
  rec%desc%lohard(2,2) = 172d3
  rec%desc%lohard(1,3) = 207.744d3
  rec%desc%lohard(2,3) = 268d3
  rec%desc%lohard(1,4) = 280d3
  rec%desc%lohard(2,4) = 370d3
  !
  ! Limits from ACC = Specs from SVN noema (may2018)
  rec%desc%locall(1,1) = 82.0d3 ! to match the specs 20dec2017 (was 82.5)
  rec%desc%locall(2,1) = 108.256d3
  rec%desc%locall(1,2) = 138.616d3
  rec%desc%locall(2,2) = 171.256d3
  rec%desc%locall(1,3) = 207.744d3
  rec%desc%locall(2,3) = 264.384d3
  rec%desc%locall(1,4) = 280d3
  rec%desc%locall(2,4) = 370d3
  !
  rec%desc%lotol = 100d0
  !
  ! Wider limits to let some margin to explore the edge of the bands
  do i=1,rec%desc%n_rbands
      rec%desc%lolim(1,i) = min(rec%desc%locall(1,i),rec%desc%lohard(1,i))
      rec%desc%lolim(2,i) = max(rec%desc%locall(2,i),rec%desc%lohard(2,i))
  enddo
  !
  ! RF limits from LOLIM +- IFmax
  do i=1,rec%desc%n_rbands
      rec%desc%rflim(1,i) = rec%desc%lolim(1,i)-rec%desc%iflim(2)
      rec%desc%rflim(2,i) = rec%desc%lolim(2,i)+rec%desc%iflim(2)
  enddo
  ! RF limits from LOCALL +- IFmax
  do i=1,rec%desc%n_rbands
      rec%desc%rfcall(1,i) = rec%desc%locall(1,i)-rec%desc%iflim(2)
      rec%desc%rfcall(2,i) = rec%desc%locall(2,i)+rec%desc%iflim(2)
  enddo
  !
  rec%desc%tuninggrid = .true.
  rec%desc%gridbin = 500d0 ! MHz
  rec%desc%gridtol = 1d0     ! MHz
  !
end subroutine rec_define_noema
!
subroutine rec_define_noema_ifproc(noemaif,error)
  use gbl_message
  use astro_interfaces, except_this=>rec_define_noema_ifproc
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! if proc characteristics
  !-----------------------------------------------------------------------
  type(correlator_input_t), intent(inout) :: noemaif !
  logical, intent(inout)        :: error
  ! local
  integer(kind=4) :: i
  ! Ifproc
  noemaif%n_ifcables = 8
  noemaif%m_usercables = 0
  noemaif%mode = ''
  noemaif%defined = .false.
  do i=1,m_ifcables
    noemaif%ifc(i)%label = ''
    noemaif%ifc(i)%iband = 0
    noemaif%ifc(i)%sb_code = 0
    noemaif%ifc(i)%bb_code = 0
    noemaif%ifc(i)%pol_code = 0
  enddo
  !
end subroutine rec_define_noema_ifproc
!
subroutine noema_reset_setup(noema,error)
  use astro_interfaces, except_this=>noema_reset_setup
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! reset noema specific parameters
  !-----------------------------------------------------------------------
  type(noema_t), intent(inout) :: noema
  logical, intent(inout)        :: error
  ! Local
  integer(kind=4)       :: i
  !
  !
  !Command parameters
  noema%comm%n_tunings = 0
  do i=1,m_tunings
    noema%comm%frest(i) = 0
    noema%comm%fcent(i) = 0
  enddo
  noema%comm%zoommode = ''
  noema%comm%fz1 = 0
  noema%comm%fz2 = 0
  noema%comm%fixed_scale = .false. 
  !
  !IF PROCESSOR
  noema%ifproc%mode = ''
  noema%ifproc%defined = .false.
  do i=1,m_ifcables
    noema%ifproc%ifc(i)%label = ''
    noema%ifproc%ifc(i)%iband = 0
    noema%ifproc%ifc(i)%sb_code = 0
    noema%ifproc%ifc(i)%bb_code = 0
    noema%ifproc%ifc(i)%pol_code = 0
  enddo
  !
  !Baseband selection
  noema%selunit%n_ifsel=-1
  noema%selunit%polmode='NULL'
  do i=1,m_backunits
    noema%selunit%usel(i)=-1
  enddo
  !
end subroutine noema_reset_setup
!
subroutine rec_noema(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>rec_noema
  use astro_types
  use ast_astro
  use my_receiver_globals
  use plot_molecules_globals
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! Command to define and visualize NOEMA receiver coverage
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='TUNING'
  integer(kind=4),parameter :: optzoom=1 ! option /ZOOM
  integer(kind=4),parameter :: optpagewidth=2 ! option /PAGEWIDTH
  integer(kind=4),parameter :: optfixfreq=3 ! option /FIXED_FREQ
  integer(kind=4),parameter :: optinfo=4 ! option /INFO
  integer(kind=4) :: lpar,izoom,nzmode
  integer(kind=4), parameter :: m_zmodes=2
  integer(kind=4), parameter :: marg=3
  real(kind=8) :: fcomm
  character(len=20) ::  zmodes(m_zmodes),zmode
  logical :: noarg,doinfo,doauto
  data zmodes/'ID','BOTH'/
  !
  error = .false.
  !
  if (obsname.ne.'NOEMA') then
    call astro_message(seve%e,rname,'Inconsistency between Receiver Name and Observatory')
    error = .true.
    return
  endif
  !
  !Define receiver parameters
  call astro_def_receiver(rname,'NOEMA',rec,error)
  if (error) return
  !Define ifproc parameters
  call rec_define_noema_ifproc(noema%ifproc,error)
  if (error) return
  ! Put in memory the current ASTRO%SOURCE parameters
  rec%desc%redshift = .true. ! tuning takes into accound source redshift
  call astro_def_recsource(rname,rec,error)
  if (error) return
  !
  !Print Receiver info in the terminal
  doinfo=sic_present(optinfo,0)
  !
  !Decoding Line Command
  ! Tuning parameters
  zmode='ID'
  izoom=0
  noema%comm%n_tunings = 0
  doauto=.false.
  if (sic_narg(0).gt.marg) then
    call astro_message(seve%e,rname,'Too many arguments')
    error=.true.
    return
  else  if (sic_narg(0).eq.0) then
    noarg=.true.
    call astro_message(seve%i,rname,'Showing the coverage of NOEMA receiver bands')
  else
    noarg=.false.
    call astro_message(seve%i,rname,'Resetting tuning')
    call noema_reset_setup(noema,error)
    if (error) return
    noema%comm%n_tunings = 1
    noema%comm%name(1) = ''
    ! Get the user value
    call sic_r8(line,0,1,fcomm,.true.,error)
    if (error) return
    ! Convert input freq to rest
    call rec_inputtorest(rname,fcomm,freq_axis%main,rec%source,noema%comm%frest(1),error)
    if (error) return
    if (sic_narg(0).eq.marg) then
      ! full command
      call sic_ke (line,0,2,noema%comm%sideband(1),lpar,.true.,error)
      if (error) return
      call sic_r8(line,0,3,noema%comm%fcent(1),.true.,error)
      if (error) return
    else  if (sic_narg(0).eq.2) then
      call astro_message(seve%e,rname,'Mode not implemented. Command accepts 0,1 or 3 arguments')
      error=.true.
      return
    else 
      ! use default tuning
      doauto=.true.
    endif
  endif
  ! Options
  ! Zoom parameter
  if (sic_present(optzoom,0)) then
    if (sic_present(optzoom,1)) then
      noema%comm%zoommode = 'NULL'
      call sic_ke (line,optzoom,1,noema%comm%zoommode,lpar,.false.,error)
      if (error) return
      call sic_ambigs_sub(rname,trim(noema%comm%zoommode),zmode,nzmode,zmodes,m_zmodes,error)
      if (error) return
      if (nzmode.eq.0) then !means that keyword was not recognized
        if (sic_present(optzoom,2)) then
          zmode='FREQ'
          call sic_r8(line,optzoom,1,noema%comm%fz1,.true.,error)
          if (error) return
          call sic_r8(line,optzoom,2,noema%comm%fz2,.true.,error)
          if (error) return
        else
          if (noema%comm%n_tunings.eq.0) then
            call astro_message(seve%e,rname,'Try to zoom on a not tune band')
            error = .true.
            return
          endif
          zmode='SINGLE'
          call sic_i0(line,optzoom,1,izoom,.true.,error)
          if (error) return
        endif
      endif
    else
      if (noema%comm%n_tunings.eq.1) then
        izoom = 1
        zmode='SINGLE'
      else if (noema%comm%n_tunings.eq.2) then
        izoom = 0
        zmode='BOTH'
      else
        call astro_message(seve%e,rname,'/ZOOM option without argument is ambiguous in this case')
        error = .true.
        return
      endif
    endif
  endif
  ! /pagewidth option
  if (sic_present(optpagewidth,0)) then
    noema%comm%fixed_scale = .false.
  else
    noema%comm%fixed_scale = .true.
  endif
  !
  ! /fixed_freq option
  if (sic_present(optfixfreq,0)) then
    noema%comm%fixedfreq = .true.
  else
    noema%comm%fixedfreq = .false.
  endif
  !
  if (doauto) then
    call noema_default_tuning(rname,rec,noema%comm%n_tunings,noema%comm,error)
    if (error) return
  endif
  !Prepare for the plot and tune
  call noema_setup(rname,noema,rec,error)
  if (error) return
  !
  if (zmode.eq.'ID') then
    call rec_plot_mbands(rec,molecules,noema%comm%fixed_scale,cplot,freq_axis,error)
    if (error) return
  else if (zmode.eq.'BOTH') then
    if (rec%n_tunings.ne.2) then
      call astro_message(seve%e,rname,'Tried to zoom on a not tuned band')
      error = .true.
      return
    endif
    call rec_plot_nbands(rec,molecules,noema%comm%fixed_scale,cplot,freq_axis,error)
    if (error) return
  else if (zmode.eq.'SINGLE') then
    if (izoom.le.0.or.izoom.gt.noema%comm%n_tunings.or.noema%comm%n_tunings.eq.0) then
      call astro_message(seve%e,rname,'Tried to zoom on a not tuned band')
      error = .true.
      return
    endif
    call rec_plot_sidebands(rec,izoom,cplot,molecules,freq_axis,error)
    if (error) return
  else if (zmode.eq.'FREQ') then
    call rec_zoom(molecules,noema%comm%fz1,noema%comm%fz2,rec,cplot,freq_axis,error)
    if (error) return
  endif
  !
  if (noarg) then
    ! if no tuning was entered, reset the rec%n_tuning to 0
    ! like this ifproc/backend command will not work (need at least 1 tuning)
    rec%n_tunings = 0
  else
    ! define if ranges transported
    call noema_ifproc(rname,rec,noema,error)
    if (error) return
    ! Update the plot
    call noema_ifproc_plot(rname,noema,molecules,rec,cplot,freq_axis,error)
    if (error) return
    ! define polyfix and assign if "cables" to correlator units [only input, no mode yet]
    call noema_define_pfx(pfx,error)
    if (error) return
    call noema_reset_backend(pfx,spw%out,error)
    spw%comm%itype=-1
    if (error) return
    call noema_assign_units(rec,noema,pfx,error)
    if (error) return
  endif
  !
  if (doinfo) then
    call astro_receiver_info(rec,rname,error)
    if (error) return
  endif
  !
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  !
end subroutine rec_noema
!
subroutine noema_default_tuning(rname,rec,it,ncomm,error)
  use gbl_message
  use astro_interfaces, except_this=>noema_default_tuning
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! reset noema specific parameters
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(receiver_t), intent(in) :: rec   ! all receiver info
  integer(kind=4), intent(in)  :: it    ! index of the tuning
  type(noema_comm_t), intent(inout) :: ncomm ! command-related stuff
  logical, intent(inout)        :: error
  ! Local
  integer(kind=4)       :: iband,sbcode
  real(kind=8)          :: frf,fumin,limit(2)
  real(kind=8), parameter :: ifmargin=600d0 !to avoid placing the requested freq too close to the band edge
  !
  !
  ! Find Band
  frf = ncomm%frest(it)*rec%source%dopshift*mhzperghz
  call rec_find_band(rname,rec%desc,frf,iband,error)
  if (error) return
  !Check whether the requested frequency is in the call for proposal limits 
  ! and chose the right LO range to consider
  if (frf.ge.rec%desc%rfcall(1,iband)+ifmargin.and.frf.le.rec%desc%rfcall(2,iband)-ifmargin) then
    limit(1) = rec%desc%locall(1,iband)
    limit(2) = rec%desc%locall(2,iband)
  else
    limit(1) = rec%desc%lohard(1,iband)
    limit(2) = rec%desc%lohard(2,iband)
  endif
  !
  !Find SideBand
  fumin=rec%desc%locall(1,iband)+rec%desc%iflim(1)+rec%desc%ifband/4d0
  !Choose to switch from LSB to USB at the center of the band
  sbcode=usb_code
  if (frf.lt.fumin) then
    sbcode=lsb_code
  endif
  ncomm%sideband(it)=sideband(sbcode)
  !
  !Find FIF
  ncomm%fcent(it)=rec%desc%bbref(2) ! Inner baseband by default
  ! Check band edge
  ! LSB case
  if (sbcode.eq.lsb_code) then
    if ((frf+ncomm%fcent(it)).lt.limit(1)) then
      ncomm%fcent(it)=limit(1)-frf
    else if ((frf+ncomm%fcent(it)).gt.limit(2)) then
      ncomm%fcent(it)=limit(2)-frf
    endif
  ! USB case
  else if (sbcode.eq.usb_code) then
    if ((frf-ncomm%fcent(it)).lt.limit(1)) then
      ncomm%fcent(it)=frf-limit(1)
    else if ((frf-ncomm%fcent(it)).gt.limit(2)) then
      ncomm%fcent(it)=frf-limit(2)
    endif
  endif
  !
end subroutine noema_default_tuning
!
subroutine rec_noema_online(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>rec_noema_online
  use astro_types
  use ast_astro
  use my_receiver_globals
  use plot_molecules_globals
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! ASTRO implementation of the tuning command in OBS\LINE
  ! Decode the line and fill noema%comm structure used as input for true tuning routines
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout) :: error
  ! local
  character(len=*),parameter :: rname='LINE'
  integer(kind=4), parameter :: optrec=1        ! /RECEIVER option
  integer(kind=4) :: inputrec,izoom,itune,lname
  character(len=128) :: mess
  ! taken form obs:
  logical :: sideband_entered,fcent_entered
  integer :: ipar,lpar,harm
  real(kind=8) :: fcent,tmpnum
  character(len=12) :: par
  character(len=4) :: band
  !
  error = .false.
  !
  if (obsname.ne.'NOEMA') then
    call astro_message(seve%e,rname,'Inconsistency between Receiver Name and Observatory')
    error = .true.
    return
  endif
  !
  !Define receiver parameters
  call astro_def_receiver(rname,'NOEMA',rec,error)
  if (error) return
  !Define ifproc parameters
  call rec_define_noema_ifproc(noema%ifproc,error)
  if (error) return
  ! Put in memory the current ASTRO%SOURCE parameters
  rec%desc%redshift=.false.           ! source redshift not taken into account
  call astro_def_recsource(rname,rec,error)
  if (error) return
  ! Warning in redshift because line does not handle this
  if (rec%source%sourcetype.ne.soukind_none.and.rec%source%z.ne.0) then
    call astro_message(seve%e,rname,'LINE command does not take into account source redshift')
    call astro_message(seve%e,rname,'Change your source and try again')
    error=.true.
    return
  endif
  !
  ! Defaults for some parameters in the NOEMA_OBS case:
  call noema_reset_setup(noema,error)
  if (error) return
  noema%comm%n_tunings=1                 ! start with only 1 tuning in memory
  itune=1
  noema%comm%fixedfreq=.true.           ! no concept of tuning grid in OBS
  noema%comm%zoommode='SINGLE'
  izoom=1
  !
  ! Now parse the command line
  ! Line name
  call sic_ch(line,0,1,noema%comm%name(itune),lname,.true.,error)
  if (error) return
  ! Frequency
  call sic_r8(line,0,2,noema%comm%frest(itune),.true.,error)
  if (error) return
  !Option /RECEIVER
  inputrec=0
  call sic_i4(line,optrec,1,inputrec,.false.,error)
  if (error) return
  !
  noema%comm%sideband(itune)='USB '
  noema%comm%fcent(itune)=rec%desc%bbref(2) !center of inner baseband
  ! OBS variables - some will not be used but must be parsed
  harm = 0
  sideband_entered = .false.
  fcent_entered =  .false.
  do ipar=3,sic_narg(0)
    call sic_ke(line,0,ipar,par,lpar,.true.,error)
    if (error) return
    !
    if (par(1:1).eq.'H') then
      !
      ! HIGH
      call astro_message(seve%w,rname,  &
            'LOCK LOW|HIGH is not an input parameter anymore')
      !
    elseif (par(1:1).eq.'L') then
      !
      ! LOW
      if (lpar.ge.2.and.par(1:2).eq.'LO') then
          call astro_message(seve%w,rname, &
              'LOCK LOW|HIGH is not an input parameter anymore')
          cycle
      endif
      !
      ! LSB
      if (sideband_entered) then
        call astro_message(seve%e,rname,'Ambiguous entries: LSB or USB?')
        error = .true.
        return
      endif
! TO BE CHECKED AFTER TUNING (LIKE /RECE and found rec)
!         if (band(1:1).eq.'U') then
!            call astro_message(seve%w,rname,'Default tuning (USB) forced to LSB')
!         endif
      band = 'LSB '
      sideband_entered = .true.
      !
    elseif (par(1:1).eq.'U') then
       !
       ! USB
      if (sideband_entered) then
        call astro_message(seve%e,rname,'Ambiguous entries: LSB or USB?')
        error = .true.
        return
      endif
!         if (band(1:1).eq.'L') then
!            call astro_message(seve%w,rname,'Default tuning (LSB) forced to USB')
!         endif
      band = 'USB '
      sideband_entered = .true.
        !
    else
      ! A number...
      call sic_math_dble (par,lpar,tmpnum,error)
      if (error) then
        write (mess,'(a,1x,a)') 'Error decoding input:',par(1:lpar)
        call astro_message(seve%e,rname,mess)
        error=.true.
        return
      endif
      if (tmpnum.gt.rec%desc%iflim(1).and.tmpnum.lt.rec%desc%iflim(2)) then
        if (fcent_entered) then
          call astro_message(seve%e,rname,'IF center frequency already entered')
          error = .true.
          return
        else
          ! Fcent in MHz
          fcent = tmpnum
          fcent_entered = .true.
        endif
      elseif (tmpnum.ge.32 .and. tmpnum.le.70) then
        ! Harmonic number - old system  (<2010)
        call astro_message(seve%e,rname,'Invalid harmonic number 1')
        error = .true.
        return
      elseif (tmpnum.ge.5 .and. tmpnum.le.9) then
        ! Harmonic number - new system  (>2010)
        harm = tmpnum
      else
        write (mess,'(a,1x,a)') 'Error decoding input:',par(1:lpar)
        call astro_message(seve%e,rname,mess)
        error=.true.
        return
      endif
    endif
  enddo
  if (sideband_entered) then
    noema%comm%sideband(itune)=band
  endif
  if (fcent_entered) then
    noema%comm%fcent(itune)=fcent
  endif
  !
  !Do the tuning
  call noema_setup(rname,noema,rec,error)
  if (error) return
  !
  !Check that receiver band is OK with /RECEIVER option
  if (inputrec.ne.0.and.inputrec.ne.rec%tune(itune)%iband) then
    call astro_message(seve%e,rname,'Frequency/ReceiverBand mismatch:')
    write (mess,'(f0.3,1x,a,1x,i0)') noema%comm%frest(itune),'is not in Band',inputrec
    call astro_message(seve%e,rname,mess)
    error=.true.
    return
  endif
  !
  ! Now the plotting
  !
  if (noema%comm%zoommode.eq.'SINGLE') then
    if (izoom.le.0.or.izoom.gt.noema%comm%n_tunings.or.noema%comm%n_tunings.eq.0) then
      call astro_message(seve%e,rname,'Tried to zoom on a not tuned band')
      error = .true.
      return
    endif
    call rec_plot_sidebands(rec,izoom,cplot,molecules,freq_axis,error)
    if (error) return
  else 
    call astro_message(seve%e,rname,'Plot mode not understood')
    error = .true.
    return
  endif
  !
  ! IF transport
  ! define if ranges transported
  call noema_ifproc(rname,rec,noema,error)
  if (error) return
  ! Update the plot
  call noema_ifproc_plot(rname,noema,molecules,rec,cplot,freq_axis,error)
  if (error) return
  ! define polyfix and assign if "cables" to correlator units [only input, no mode yet]
  call noema_define_pfx(pfx,error)
  if (error) return
  call noema_reset_backend(pfx,spw%out,error)
  if (error) return
  spw%comm%itype=-1
  call noema_assign_units(rec,noema,pfx,error)
  if (error) return
  !
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  !
end subroutine rec_noema_online
!
subroutine noema_setup(rname,noema,rec,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_setup
  use astro_types
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! Check feasability and tune noema requested bands
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(noema_t), intent(inout) :: noema !command line parameters
  type(receiver_t), intent(inout) :: rec ! receiver description and tuning
  logical, intent(inout)        :: error
  ! Local
  integer(kind=4) :: it
  logical       :: ongrid,bandedge
  type(receiver_comm_t) :: gridcomm
  real(kind=8)  :: newfcent,ftune
  character(len=200) :: mess
  !
  rec%n_tunings=noema%comm%n_tunings
  if (rec%n_tunings.gt.1) then
    call astro_message(seve%e,rname,'Only 1 band can be tuned for the time being')
    error = .true.
    return
  endif
  do it=1,rec%n_tunings
    rec%comm(it)%rec_name = 'NOEMA'
    rec%comm(it)%frest = noema%comm%frest(it)
    call sic_upper(noema%comm%sideband(it))
    if (noema%comm%sideband(it)(1:1).eq.'U') then
      rec%comm(it)%sideband = 'USB'
    else if (noema%comm%sideband(it)(1:1).eq.'L') then
      rec%comm(it)%sideband = 'LSB'
    else
      call astro_message(seve%e,rname,'Problem decoding tuning sideband code (LSB or USB)')
      error = .true.
      return
    endif
    rec%comm(it)%fcent = noema%comm%fcent(it)
    rec%comm(it)%name = noema%comm%name(it)
    ! tune the bands
    call rec_resttooutput(rname,noema%comm%frest(it),freq_axis%main,rec%source,ftune,error)
    if (error) return
    if (noema%comm%fixedfreq) then
      ! ignore the grid
      call astro_tune_receiver(rname,rec%desc,rec%source,rec%comm(it),rec%tune(it),error)
      if (error) return
    else ! we shift the tuning to the grid
      ongrid = .false.
      bandedge = .false.
      gridcomm = rec%comm(it)
      do while (.not.ongrid.and..not.bandedge)
        call astro_tune_receiver(rname,rec%desc,rec%source,gridcomm,rec%tune(it),error)
        if (error) return
        write(mess,'(a,f10.5,a)') ' FLOTUNE = ',rec%tune(it)%flotune*ghzpermhz,' GHz'
        call astro_message(seve%i,rname,mess)
        call astro_tunegrid(rname,rec%desc,rec%tune(it),rec%source, &
                            bandedge,ongrid,newfcent,error)
        if (error) return
        gridcomm%fcent = newfcent
      enddo
      if (ongrid) then 
        rec%tune(it)%ongrid = .true.
      else
        rec%tune(it)%ongrid = .false.
      endif
    endif
  enddo
  !
end subroutine noema_setup
!
subroutine astro_tunegrid(rname,rdesc,rtune,rsou,bandedge,ongrid,newfcent,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>astro_tunegrid
  use astro_types
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! Check that LO is on the tuning grid, propose the right if freq
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(receiver_desc_t), intent(in) :: rdesc ! receiver description 
  type(receiver_tune_t), intent(in) :: rtune ! receiver tuning
  type(receiver_source_t), intent(in) :: rsou ! receiver tuning
  logical, intent(inout)            :: bandedge
  logical, intent(inout)            :: ongrid
  real(kind=8), intent(inout)       :: newfcent
  logical, intent(inout)        :: error
  character(len=32) :: cname
  ! Local
  real(kind=8)  :: fgrid,foutput
  character(len=200) :: mess
  !
  fgrid = nint(rtune%flotune/rdesc%gridbin)*rdesc%gridbin
  if ((fgrid.lt.rdesc%locall(1,rtune%iband).and.rtune%flotune.ge.rdesc%locall(1,rtune%iband)) &
       .or.(fgrid.gt.rdesc%locall(2,rtune%iband).and.rtune%flotune.le.rdesc%locall(2,rtune%iband)) &
       .or.(fgrid.lt.rdesc%lohard(1,rtune%iband).or.fgrid.gt.rdesc%locall(2,rtune%iband))) then
    ! don't shift to the grid if this push the LO out of the recommended or possible ranges
    bandedge=.true.
    newfcent = rtune%fcent
    call astro_message(seve%i,rname,'Tuning close to band edge. Not shifted to the grid')
    return
  endif
  if (abs(fgrid-rtune%flotune).lt.rdesc%gridtol) then
    ! Tuning is on the grid
    newfcent = rtune%fcent
    ongrid = .true.
    return
  endif
  ! Compute new IF freq to be on the tuning grid
  call astro_message(seve%i,rname,'Original tuning does not match the grid')
  newfcent = (rtune%flsr-fgrid)/sb_sign(rtune%sb_code)
  ! Check that new IF stays in the IF range
  if (newfcent.lt.rdesc%iflim(1).or.newfcent.gt.rdesc%iflim(2)) then
    ! Too close to band edge to move
    bandedge=.true.
    newfcent = rtune%fcent
  endif
  ! Write information
  write(mess,'(a,f0.3,a)') 'Tuning automatically shifted to the IF Frequency = ',newfcent,' MHz'
  call astro_message(seve%i,rname,mess)
  write(mess,'(a,f0.3,a)') 'This corresponds to a shift of ',abs(rtune%fcent-newfcent),' MHz'
  call astro_message(seve%i,rname,mess)
  call astro_message(seve%i,rname,'Actual command:')
  if (rname.eq.'NEWVEL') then
    cname='TUNING'
  else
    cname=rname
  endif
  call rec_resttooutput(rname,rtune%frest,freq_axis%main,rsou,foutput,error)
  if (error) return
  write (mess,'(a,1x,f0.3,1x,a,1x,f0.3)') trim(cname),foutput/1d3,sideband(rtune%sb_code),newfcent
  call astro_message(seve%r,rname,mess)
  !
end subroutine astro_tunegrid
!
subroutine noema_ifproc(rname,rec,noema,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_ifproc
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! define the basebands brought to the backends
  ! no flxibility with noema for the time being
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(receiver_t), intent(inout) :: rec
  type(noema_t), intent(inout) :: noema
  logical, intent(inout)        :: error
  ! local
  integer(kind=4)       :: it,is,ip,ib,icable
  integer(kind=4), parameter :: outer_code = 1
  integer(kind=4), parameter :: inner_code = 2
  integer(kind=4), parameter :: polh_code = 1
  integer(kind=4), parameter :: polv_code = 2
  integer(kind=4)       :: polcode(rec%desc%n_polar), bbcode(rec%desc%n_bbands),sb_code(rec%desc%n_sbands)
  character(len=200)    :: comm
  !
  ! Check that a tuning has been set
  if (rec%n_tunings.eq.0) then
    call astro_message(seve%e,rname,'Please define a tuning before setting the IF Processor')
    error = .true.
    return
  endif
  !
  polcode(1) = polh_code
  polcode(2) = polv_code
  !
  icable = 0
  do it = 1 ,rec%n_tunings
    do ip = 1,rec%desc%n_polar
      if (rec%desc%n_sbands.eq.2) then
        sb_code(1) = lsb_code !lsb first to match the agreement about ordering (VP 2017)
        sb_code(2) = usb_code
      else if (rec%desc%n_sbands.eq.1) then
        sb_code(1) = rec%tune(it)%sb_code
      else
        call astro_message(seve%e,rname,'Problem with number of sidebands')
        error = .true.
        return
      endif
      do is = 1,rec%desc%n_sbands
        !sort basebands by frequency to match the agreement about ordering (VP 2017)
        if (sb_code(is).eq.lsb_code) then
          bbcode(1) = outer_code
          bbcode(2) = inner_code
        else if (sb_code(is).eq.usb_code) then
          bbcode(1) = inner_code
          bbcode(2) = outer_code
        else
          call astro_message(seve%e,rname,'Problem with sideband determination')
          error = .true.
          return
        endif
        do ib = 1,rec%desc%n_bbands
          icable = icable+1
          if (icable.gt.noema%ifproc%n_ifcables) then
            call astro_message(seve%e,rname,'More basebands than available if cables')
            error=.true.
            return
          endif
          noema%ifproc%ifc(icable)%iband = rec%tune(it)%iband
          noema%ifproc%ifc(icable)%sb_code = sb_code(is)
          noema%ifproc%ifc(icable)%bb_code = bbcode(ib)
          noema%ifproc%ifc(icable)%pol_code = polcode(ip)
          write (noema%ifproc%ifc(icable)%label,'(a,i0,a,a,a)')                 &
                  rec%desc%bandname(rec%tune(it)%iband)(1:1),                   &
                  rec%tune(it)%iband,rec%desc%polname(ip)(1:1),                 &
                  sideband(sb_code(is))(1:1),rec%desc%bbname(bbcode(ib))(1:1)
        enddo ! basebands
      enddo ! sidebands
    enddo ! polar
  enddo ! receiver tunings
  !
  noema%ifproc%defined = .true.
  !
  do icable=1,noema%ifproc%n_ifcables
    write (comm,'(a,1x,i0,1x,a,1x,a)') 'Correlator input #',icable,'contains',noema%ifproc%ifc(icable)%label
    call astro_message(seve%d,rname,comm)
  enddo
  !
end subroutine noema_ifproc
!
subroutine noema_ifproc_plot(rname,noema,molecules,rec,cplot,drawaxis,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_ifproc_plot
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! identifies the correlator inputs on the plot
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(noema_t), intent(in) :: noema
  type(plot_molecules_t), intent(in) :: molecules
  type(receiver_t), intent(inout) :: rec
  type(current_boxes_t), intent(inout) :: cplot
  type(frequency_axis_t), intent(in) :: drawaxis
  logical, intent(inout) :: error
  ! local
  integer(kind=4) :: i,j,k,sb_code(m_sideband),ip,ib,ic
  character(len=200) :: comm,defchar,smallchar,molchar
  character(len=5) :: cablecode
  real(kind=8) :: fif1,frf,frest,yt,l1,l2,l3,l4,b1,b2,b3,b4
  type(draw_line_t)     :: linebb
  !
  sb_code(1) = usb_code
  sb_code(2) = lsb_code
  !
!   !Clear and redraw in case the frequency axis were changed since last command
!   call gr_execl('CLEAR DIRECTORY')
!   !
!   select case (cplot%desc%plotmode)
!   case ('RECEIVER_M')
!     call rec_plot_mbands(rec,molecules,noema%comm%fixed_scale,cplot,error)
!     if (error) return
!   case ('RECEIVER_N')
!     call rec_plot_nbands(rec,molecules,noema%comm%fixed_scale,cplot,error)
!     if (error) return
!   case ('RECEIVER_S')
!     call rec_get_itune(rec,cplot%box(1)%iband,izoom,error)
!     if (error) return
!     call rec_plot_sidebands(rec,izoom,cplot,molecules,error)
!     if (error) return
!   case ('RECEIVER_Z')
!     call rec_zoom(molecules,noema%comm%fz1,noema%comm%fz2,rec,cplot,error)
! !     if (error) return
!   end select
  if (.not.(gtexist('<GREG<BOX1'))) then
    call gr_execl('CLEAR DIRECTORY')
    call rec_plot_mbands(rec,molecules,noema%comm%fixed_scale,cplot,drawaxis,error)
    if (error) return
  endif
  !
  write (defchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%defchar
  write (smallchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%smallchar
  write (molchar,'(a,1x,f0.3)') 'SET CHARACTER',cplot%desc%molchar
  !
  call gr_exec1(defchar)
  call gr_pen(colour=adefcol,error=error)
  if (error) return
  !
  write (comm,'(a)') 'CHANGE DIRECTORY'
  call gr_execl(comm)
  if (gtexist('IFPROC')) then
    write (comm,'(a)') 'DESTROY DIRECTORY IFPROC'
    call gr_execl(comm)
  endif
  write (comm,'(a)') 'CREATE DIRECTORY IFPROC'
  call gr_execl(comm)
  do i=1,cplot%nbox
    write (comm,'(a,i0)') 'CHANGE DIRECTORY <GREG<BOX',i
    call gr_execl(comm)
    l1 = cplot%box(i)%rest%xmin
    l2 = cplot%box(i)%rest%xmax
    l3 = cplot%box(i)%rest%ymin
    l4 = cplot%box(i)%rest%ymax
    b1 = cplot%box(i)%phys%xmin
    b2 = cplot%box(i)%phys%xmax
    b3 = cplot%box(i)%phys%ymin
    b4 = cplot%box(i)%phys%ymax
    write (comm,'(a)') 'CHANGE DIRECTORY'
    call gr_execl(comm)
    write (comm,'(a)') 'CHANGE DIRECTORY IFPROC'
    call gr_execl(comm)
    write (comm,'(a,4(1x,f0.3))') 'SET BOX_LOCATION',b1,b2,b3,b4
    call gr_exec1(comm)
    write (comm,'(a,4(1x,f0.3))') 'LIMITS',l1,l2,l3,l4
    call gr_exec1(comm)
    do j=1,rec%n_tunings
      if (rec%tune(j)%iband.ne.cplot%box(i)%iband) cycle
      do k=1,rec%desc%n_sbands
          do ib=1,rec%desc%n_bbands
            do ip=1,rec%desc%n_polar
              write (cablecode,'(a,i0,a,a,a,a)') rec%desc%bandname(rec%tune(j)%iband)(1:1),            &
                  rec%tune(j)%iband,rec%desc%polname(ip)(1:1),sideband(sb_code(k))(1:1),rec%desc%bbname(ib)(1:1)
              do ic=1,noema%ifproc%n_ifcables
                if (noema%ifproc%ifc(ic)%label.ne.cablecode) cycle
                fif1 = (rec%desc%bblim(2,ib)+rec%desc%bblim(1,ib))/2d0
                yt = l3+((l4-l3)/6)*ip
                call if1torf(rec%tune(j)%flo1,fif1,sb_code(k),frf,error)
                if (error) return
                call rftorest(rec%source%dopshift,frf,frest,error)
                if (error) return
                call gr_pen(colour=abbifproccol,error=error)
                if (error) return
                call gr_exec1(smallchar)
                write (comm,'(a,1x,f0.6,1x,f0.3,1x,a,a,1x,a)')               &
                  'DRAW TEXT',frest,yt,'"',trim(cablecode),'" 5 0 /USER /CLIP'
                call gr_exec1(comm)
                call gr_exec(defchar)
                call noema_draw_confusion(rname,rec,j,ib,sb_code(k),cplot%box(i)%rest,cplot%desc,error)
                call gr_pen(colour=alowrescol,error=error)
                if (error) return
                if (error) return
                !draw the limit of the baseband
                call if1torf(rec%tune(j)%flo1,rec%desc%bblim(1,ib),sb_code(k),frf,error)
                if (error) return
                call rftorest(rec%source%dopshift,frf,linebb%xmin,error)
                if (error) return
                call if1torf(rec%tune(j)%flo1,rec%desc%bblim(2,ib),sb_code(k),frf,error)
                if (error) return
                call rftorest(rec%source%dopshift,frf,linebb%xmax,error)
                if (error) return
                linebb%ymin = cplot%box(i)%rest%ymin+(cplot%box(i)%rest%ymax-cplot%box(i)%rest%ymin)/10
                linebb%ymax = linebb%ymin
                linebb%col   = abbifproccol
                linebb%dash  = 1
                call gr_exec1(smallchar)
                call rec_draw_arrow(linebb,cplot%box(i)%rest,error)
                if (error) return
                call gr_exec1(defchar)
                frest = linebb%xmin
                linebb%xmin = linebb%xmax
                linebb%xmax = frest
                call rec_draw_arrow(linebb,cplot%box(i)%rest,error)
                if (error) return
                call gr_pen(colour=alowrescol,error=error)
                if (error) return
                call gr_exec1(defchar)
              enddo ! cable
            enddo ! polar
            !
          enddo !baseband
!        endif
      enddo !sideband
      !plot again molecules
      call gr_exec1(molchar)
      call rec_draw_molecules(molecules,cplot%box(i)%rest,error)
      if (error) return
      call gr_exec1(defchar)
      ! plot tuning frequency
      call rec_draw_linetune(rec%tune(j),cplot%box(i)%rest,error)
      if (error) return
      !
       write (comm,'(a)') 'CHANGE DIRECTORY'
      call gr_execl(comm)
    enddo !tuning
    write (comm,'(a)') 'CHANGE DIRECTORY'
    call gr_execl(comm)
  enddo ! boxes
  call gr_pen(colour=adefcol,error=error)
  if (error) return
  !
end subroutine noema_ifproc_plot
!
subroutine noema_draw_confusion(rname,rec,itune,bb_code,sb_code,fbox,cpdesc,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_draw_confusion
  use astro_types
  !-----------------------------------------------------------------------
  ! @ private
  ! identifies the confusion zone of NOEMA
  ! S18 version: only the 10MHz of the LO2 parasite
  !-----------------------------------------------------------------------
  character(len=*), intent(in) :: rname
  type(receiver_t), intent(in) :: rec
  integer(kind=4), intent(in)   :: itune
  integer(kind=4), intent(in)   :: bb_code
  integer(kind=4), intent(in)   :: sb_code
  type(frequency_box_user_t), intent(in) :: fbox ! must be rest
  type(current_boxes_desc_t), intent(in) :: cpdesc 
  logical, intent(inout) :: error
  ! Local
  real(kind=8)  :: frf,xt,yt
  type(draw_rect_t) :: confrect
  character(len=200) :: comm,smallchar,defchar
  integer(kind=4) :: iplotmode,ipos
  integer(kind=4), parameter :: outer_code=1
  integer(kind=4), parameter :: inner_code=2
  !
  iplotmode=cpdesc%plotmode
  !Compute Confusion zone in rest frame to draw rectangle
  call if1torf(rec%tune(itune)%flo1,rec%desc%if1conf(1),sb_code,frf,error)
  if (error) return
  call rftorest(rec%source%dopshift,frf,confrect%xmin,error)
  if (error) return
  call if1torf(rec%tune(itune)%flo1,rec%desc%if1conf(2),sb_code,frf,error)
  if (error) return
  call rftorest(rec%source%dopshift,frf,confrect%xmax,error)
  if (error) return
  confrect%ymin = fbox%ymin
  confrect%ymax = fbox%ymax
  confrect%col=aconfucol
  ! Draw rectangle
  call gr_pen(colour=aconfucol,error=error)
  if (error) return
  call rec_draw_frect(confrect,fbox,error)
  if (error) return
  ! Write label (depends on plotmode)
  write (defchar,'(a,1x,f0.3)') 'SET CHARACTER',cpdesc%defchar
  write (smallchar,'(a,1x,f0.3)') 'SET CHARACTER',cpdesc%smallchar
  !
  call gr_exec1(smallchar)
  if (iplotmode.eq.pm_basebands) then
    if (sb_code.eq.lsb_code.and.bb_code.eq.outer_code) ipos = 3
    if (sb_code.eq.lsb_code.and.bb_code.eq.inner_code) ipos = 1
    if (sb_code.eq.usb_code.and.bb_code.eq.inner_code) ipos = 3
    if (sb_code.eq.usb_code.and.bb_code.eq.outer_code) ipos = 1
    write (comm,'(a,1x,i0)') 'DRAW TEXT 0 -0.5 "LO2" 5 0 /character',ipos
    call gr_exec1(comm)
  else if (iplotmode.eq.pm_receiver) then
    write (comm,'(a)') 'DRAW TEXT 0 -0.75 "LO2" 5 0 /character 2'
    call gr_exec1(comm)
  else if (iplotmode.eq.pm_allbands.or.iplotmode.eq.pm_tunedbands) then
    xt=(confrect%xmax+confrect%xmin)/2d0
    yt=confrect%ymin-(confrect%ymax-confrect%ymin)/20d0
    write (comm,'(a,1x,f0.3,1x,f0.3,1x,a)') 'DRAW TEXT',xt,yt,'"LO2" 5 0 /user'
    call gr_exec1(comm)
  else if (iplotmode.eq.pm_proposal) then
    if (bb_code.eq.1) then
      xt=(confrect%xmax+confrect%xmin)/2d0
      yt=confrect%ymin-(confrect%ymax-confrect%ymin)/20d0
      write (comm,'(a,1x,f0.3,1x,f0.3,1x,a)') 'DRAW TEXT',xt,yt,'"LO2" 5 0 /user'
      call gr_exec1(comm)
    endif
  else
    call astro_message(seve%e,rname,'Problem with plot mode')
    error=.true.
    return
  endif
  call gr_pen(colour=adefcol,error=error)
  if (error) return
  call gr_exec1(defchar)
  !
end subroutine noema_draw_confusion
!
subroutine noema_baseband(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_baseband
  use astro_types
  use ast_astro
  use my_receiver_globals
  use plot_molecules_globals
  use string_parser_types
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! Baseband and mode selection (in preparation for SPW definition)
  !
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='BASEBAND'
  type(string_parser_t) :: sp
  integer(kind=4) :: iarg,lpar,narg,ncorrmode,selmode
  integer(kind=4) :: pol_sel,bb_sel,sb_sel,selband,isel,iu,it
  integer(kind=4),parameter :: m_corrmodes = 3
  character(len=12) :: par,corrmode,selcode
  character(len=12) :: corrmodes(m_corrmodes)
  character(len=200) :: mess
  integer(kind=4), parameter :: optreset=1
  logical       :: doreset,dopchanged,gotcode,gotmode,gottype,dooff
  data corrmodes/'62.5','250','OFF'/
  integer(kind=4), parameter :: ipband=1
  integer(kind=4), parameter :: ippol=2
  integer(kind=4), parameter :: ipsb=3
  integer(kind=4), parameter :: ipbb=4
  integer(kind=4), parameter :: nband=3
  integer(kind=4), parameter :: npol=2
  integer(kind=4), parameter :: nsb=2
  integer(kind=4), parameter :: nbb=2
  integer(kind=4)       :: parsecode(4)
  character(len=2) :: bb_band(nband)
  character(len=1) :: bb_pol(npol),bb_sb(nsb),bb_bb(nbb)
  data bb_band/'B1','B2','B3'/
  data bb_pol/'H','V'/
  data bb_sb/'U','L'/
  data bb_bb/'O','I'/
  !
  !Preliminary checks
  if (rec%n_tunings.eq.0) then
    call astro_message(seve%e,rname,'Please define a tuning (TUNING command) before setting up backends')
    error = .true.
    return
  endif
  if (.not.noema%ifproc%defined) then
    call astro_message(seve%e,rname,'Problem with IF Processor part')
    error = .true.
    return
  endif
  !
  !check that doppler did not changed since last tuning
  call rec_check_doppler(rec%source,rec%desc%redshift,dopchanged,error)
  if (dopchanged) then
    call astro_message(seve%e,rname,'Source changed since last tuning')
    call astro_message(seve%i,rname,'You should set again the tuning before working with backends')
    call rec_display_error('Source changed since last tuning',error)
    error = .true.
    return
  endif
  !
  narg=sic_narg(0)
  doreset=sic_present(optreset,0)
  !
  !Defaults codes
  pol_sel=0
  bb_sel=0
  sb_sel=0
  selband=0
  selcode=''
  selmode=1
  do iu=1,m_backunits
    noema%selunit%usel(iu)=-1
  enddo
  !
  !Reading arguments
  gotmode=.false.
  gotcode=.false.
  if (narg.gt.2) then
    call astro_message(seve%e,rname,'At most 2 arguments')
    error=.true.
    return
  else if (narg.gt.0) then
    do iarg=1,sic_narg(0)
      par = 'NULL'
      call sic_ke(line,0,iarg,par,lpar,.false.,error)
      if (error) return
      if (par.eq.'NULL') exit
      call sic_ambigs_sub(rname,par,corrmode,ncorrmode,corrmodes,m_corrmodes,error)
      if (error) return
      if (ncorrmode.eq.0) then
        if (gotcode) then
          call astro_message(seve%e,rname,'Selection Code already entered. Please enter all codes without spaces')
          error=.true.
          return
        endif
        selcode=par
        gotcode=.true.
      else
        if (gotmode) then
          call astro_message(seve%e,rname,'Only one mode at a once !')
          error=.true.
          return
        endif
        selmode=ncorrmode
        gotmode=.true.
      endif
    enddo
  endif
  !
  ! Check mode selection
  dooff=.false.
  corrmode=corrmodes(selmode)
  if (corrmode.eq.'OFF') then
    ! OFF CASE
    selmode=-1
    dooff=.true.
  else if (selmode.ne.1) then
    call astro_message(seve%e,rname,'Mode not yet implemented (only mode 1)')
    error=.true.
    return
  endif
  !
  !Parse the user code
  if (len_trim(selcode).ne.0) then
    call string_parser_addlist(sp,ipband,bb_band,error)
    if (error) return
    call string_parser_addlist(sp,ippol,bb_pol,error)
    if (error) return
    call string_parser_addlist(sp,ipsb,bb_sb,error)
    if (error) return
    call string_parser_addlist(sp,ipbb,bb_bb,error)
    if (error) return
    call string_parser_parse('BASEBAND',sp,selcode,.false.,parsecode,error)
    if (error) return
  else 
    parsecode(ipband)=0
    parsecode(ippol)=0
    parsecode(ipsb)=0
    parsecode(ipbb)=0
  endif
  !
  if (parsecode(ippol).eq.0) then
    noema%selunit%polmode = "B" ! BOTH polar same config
  else
    noema%selunit%polmode = "S"
  endif
  !
  ! Loop over pfx%units to put the right numbers in ifsel() and define the mode when needed
  isel=0
  do iu=1,pfx%n_units
    if (pfx%unit(iu)%iband.ne.parsecode(ipband).and.parsecode(ipband).ne.0) cycle
    if (pfx%unit(iu)%pol_code.ne.parsecode(ippol).and.parsecode(ippol).ne.0) cycle
    if (pfx%unit(iu)%sb_code.ne.parsecode(ipsb).and.parsecode(ipsb).ne.0) cycle
    if (pfx%unit(iu)%bb_code.ne.parsecode(ipbb).and.parsecode(ipbb).ne.0) cycle
    isel=isel+1
    noema%selunit%usel(isel)=iu
    if (dooff.or.doreset.or.selmode.ne.pfx%unit(iu)%imode) then
      write (mess,'(a,1x,i0)') 'Resetting unit ',iu
      call astro_message(seve%i,rname,mess)
      call pfx_reset_unit(pfx%unit(iu),spw%out,error)
      if (error) return
      if (selmode.ne.pfx%unit(iu)%imode) then
        pfx%unit(iu)%imode=selmode
      endif
      if (.not.dooff) then
        call pfx_fixed_spw(rname,rec,pfx%unit(iu),spw,error)
        if (error) return
      endif
    endif
  enddo !iu
  if (isel.eq.0) then
    call astro_message(seve%e,rname,'The selection returns nothing')
    error = .true.
    return
  endif
  ! remove empty spw (if there was a reset)
  call noema_compress_spw(spw%out,error)
  if (error) return
  ! sort spw
  call noema_sort_spw(spw%out,error)
  if (error) return
  ! look for conflicts
  call noema_check_conflicts(rname,spw%out,pfx,error)
  if (error) return
  !
  noema%selunit%n_ifsel=isel
  write (mess,'(a)') 'Selected Basebands are:'
  do iu=1,m_backunits
    if (noema%selunit%usel(iu).ne.-1) then
      write (mess,'(a,1x,a)') trim(mess),trim(noema%ifproc%ifc(noema%selunit%usel(iu))%label)
    endif
  enddo !iu
  call astro_message(seve%i,rname,mess)
  ! Find if flexible spw can be configured
  spw%comm%imode=selmode
  gottype=.false.
  do it=1,pfx%unit(noema%selunit%usel(1))%mode(selmode)%n_types
    if (.not.(pfx%unit(noema%selunit%usel(1))%mode(selmode)%chtype(it)%move_chunk)) cycle
    if (gottype) then
      call astro_message(seve%e,rname,'Several kinds of flexible chunks ??')
      error=.true.
      return
    endif
    spw%comm%itype=it 
    gottype = .true.
  enddo
  spw%comm%resol= &
    pfx%unit(noema%selunit%usel(1))%mode(pfx%unit(noema%selunit%usel(1))%imode)%chtype(spw%comm%itype)%df_chunks*1000 ! in kHz
  !
  call noema_plot_selpfx(rname,rec,noema,pfx,spw,cplot,molecules,freq_axis,error)
  if (error) return
  !
  if (rec%source%sourcetype.eq.soukind_full) then
    call noema_oplot_dopminmax(spw%out,pfx,rec,cplot,freq_axis,error)
    if (error) return
  endif
  !
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  !
end subroutine noema_baseband
!
subroutine noema_baseband_online(line,error)
  use gbl_message
  use gkernel_interfaces
  use astro_interfaces, except_this=>noema_baseband_online
  use astro_types
  use my_receiver_globals
  use plot_molecules_globals
  use string_parser_types
  use frequency_axis_globals
  !-----------------------------------------------------------------------
  ! @ private
  ! online Baseband and mode selection: as done in OBS
  ! Give a mode to the PFX units
  !-----------------------------------------------------------------------
  character(len=*), intent(inout) :: line        ! command line
  logical, intent(inout) :: error
  ! local
  character(len=*), parameter :: rname='BASEBAND'
  type(string_parser_t) :: sp
  integer(kind=4) :: iarg,lpar,narg,ncorrmode,selmode
  integer(kind=4) :: pol_sel,bb_sel,sb_sel,selband,isel,iu,inputrec
  integer(kind=4),parameter :: m_corrmodes = 3
  character(len=12) :: par,corrmode,selcode
  character(len=12) :: corrmodes(m_corrmodes)
  character(len=200) :: mess
  integer(kind=4), parameter :: optrec=1
  logical       :: dopchanged,gotcode,gotmode,dorec
  data corrmodes/'1','2','OFF'/
  integer(kind=4), parameter :: ipband=1
  integer(kind=4), parameter :: ippol=2
  integer(kind=4), parameter :: ipsb=3
  integer(kind=4), parameter :: ipbb=4
  integer(kind=4), parameter :: nband=3
  integer(kind=4), parameter :: npol=2
  integer(kind=4), parameter :: nsb=2
  integer(kind=4), parameter :: nbb=2
  integer(kind=4), parameter :: m_keys=1
  integer(kind=4)       :: parsecode(4),nkey
  character(len=2) :: bb_band(nband)
  character(len=1) :: bb_pol(npol),bb_sb(nsb),bb_bb(nbb)
  character(len=1) :: keys(m_keys),key
  data keys/'*'/
  data bb_band/'B1','B2','B3'/
  data bb_pol/'H','V'/
  data bb_sb/'U','L'/
  data bb_bb/'O','I'/
  !
  !Preliminary checks
  if (rec%n_tunings.eq.0) then
    call astro_message(seve%e,rname,'Please define a tuning (TUNING command) before setting up backends')
    error = .true.
    return
  endif
  if (.not.noema%ifproc%defined) then
    call astro_message(seve%e,rname,'Problem with IF Processor part')
    error = .true.
    return
  endif
  !
  !check that doppler did not changed since last tuning ! SHOULD DISAPPEAR in the FUTURE
  call rec_check_doppler(rec%source,rec%desc%redshift,dopchanged,error)
  if (dopchanged) then
    call astro_message(seve%e,rname,'Source changed since last tuning')
    call astro_message(seve%i,rname,'You should set again the tuning before working with backends')
    call rec_display_error('Source changed since last tuning',error)
    error = .true.
    return
  endif
  !
  narg=sic_narg(0)
  dorec=sic_present(optrec,0)
  inputrec=0
  call sic_i4(line,optrec,1,inputrec,.false.,error)
  if (error) return
  !
  !Defaults codes
  pol_sel=0
  bb_sel=0
  sb_sel=0
  selband=0
  selcode=''
  selmode=1 ! defaults is mode 1
  corrmode='1'
  do iu=1,m_backunits
    noema%selunit%usel(iu)=-1
  enddo
  !
  ! Input checks
  if (narg.ne.2) then
    call astro_message(seve%i,rname,'BASEBAND needs 2 arguments. Current state:')
    call noema_list_pfx(rname,pfx,freq_axis%main,rec%source,error)
    if (error) return
    return
  endif
  !Reading arguments
  gotmode=.false.
  gotcode=.false.
  do iarg=1,sic_narg(0)
    call sic_ke(line,0,iarg,par,lpar,.true.,error)
    if (error) return
    ! First try to recognize a correlator mode
    call sic_ambigs_sub(rname,par,corrmode,ncorrmode,corrmodes,m_corrmodes,error)
    if (error) return
    if (ncorrmode.eq.0) then ! correlator mode not recognized
      if (gotcode) then
        call astro_message(seve%e,rname,'Selection Code already entered. Please enter all codes without spaces')
        error=.true.
        return
      endif
      call sic_ambigs_sub(rname,par,key,nkey,keys,m_keys,error)
      if (error) return
      if (nkey.eq.0) then !key '*' not recognized
        selcode=par ! parameter is thus a selection code 
      else
        selcode=''
      endif
      gotcode=.true.
    else
      ! correlator mode recognized
      if (gotmode) then
        call astro_message(seve%e,rname,'Only one mode at a once !')
        error=.true.
        return
      endif
      selmode=ncorrmode
      gotmode=.true.
    endif
  enddo
  !
  ! Check mode selection
  corrmode=corrmodes(selmode)
  if (corrmode.eq.'OFF') then
    ! OFF CASE
    selmode=-1
  else if (corrmode.ne.'1') then
    call astro_message(seve%e,rname,'Mode not yet implemented (only mode 1)')
    error=.true.
    return
  endif
  !
  !Parse the user code
  if (len_trim(selcode).ne.0) then
    call string_parser_addlist(sp,ipband,bb_band,error)
    if (error) return
    call string_parser_addlist(sp,ippol,bb_pol,error)
    if (error) return
    call string_parser_addlist(sp,ipsb,bb_sb,error)
    if (error) return
    call string_parser_addlist(sp,ipbb,bb_bb,error)
    if (error) return
    call string_parser_parse('BASEBAND',sp,selcode,.false.,parsecode,error)
    if (error) return
  else 
    parsecode(ipband)=0
    parsecode(ippol)=0
    parsecode(ipsb)=0
    parsecode(ipbb)=0
  endif
  !
  ! Case with /RECEIVER option
  if (dorec) then
    if (parsecode(ipband).ne.0) then
      if (parsecode(ipband).ne.inputrec) then
        call astro_message(seve%e,rname,'Inconsistency in Band selection')
        error=.true.
        return
      endif
    else if (parsecode(ipband).eq.0) then
      ! use the option input instead of the code
      parsecode(ipband)=inputrec
    endif
  endif
  !
  ! Loop over pfx%units to put the right numbers in ifsel() and define the mode when needed
  isel=0
  do iu=1,pfx%n_units
    if (pfx%unit(iu)%iband.ne.parsecode(ipband).and.parsecode(ipband).ne.0) cycle
    if (pfx%unit(iu)%pol_code.ne.parsecode(ippol).and.parsecode(ippol).ne.0) cycle
    if (pfx%unit(iu)%sb_code.ne.parsecode(ipsb).and.parsecode(ipsb).ne.0) cycle
    if (pfx%unit(iu)%bb_code.ne.parsecode(ipbb).and.parsecode(ipbb).ne.0) cycle
    isel=isel+1
    write (mess,'(a,1x,i0)') 'Resetting unit ',iu
    call astro_message(seve%i,rname,mess)
    ! Reset unit
    call pfx_reset_unit(pfx%unit(iu),spw%out,error)
    if (error) return
    if (selmode.ne.pfx%unit(iu)%imode) then
      pfx%unit(iu)%imode=selmode
    endif
    if (selmode.ne.-1) then
      call pfx_fixed_spw(rname,rec,pfx%unit(iu),spw,error)
      if (error) return
    endif
  enddo !iu
  if (isel.eq.0) then
    call astro_message(seve%e,rname,'The selection returns nothing')
    error = .true.
    return
  endif
  ! remove empty spw (if there was a reset)
  call noema_compress_spw(spw%out,error)
  if (error) return
  ! sort spw
  call noema_sort_spw(spw%out,error)
  if (error) return
  ! look for conflicts
  call noema_check_conflicts(rname,spw%out,pfx,error)
  if (error) return
  !
  ! Now the plotting
  ! PLOT
  !Select all the units for the plot
  noema%selunit%n_ifsel=pfx%n_units
  noema%selunit%polmode='B'
  do iu=1,pfx%n_units
    noema%selunit%usel(iu)=iu
  enddo
  !
  call noema_plot_selpfx(rname,rec,noema,pfx,spw,cplot,molecules,freq_axis,error)
  if (error) return
  ! Let the user with the limits in main axis frequency frame
  call rec_set_limits(rname,cplot,freq_axis%main,error)
  if (error) return
  !
end subroutine noema_baseband_online

subroutine ctrlc_check (error)
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>ctrlc_check
  use sic_structures
  !---------------------------------------------------------------------
  ! @ private
  !  Pause if ^C has been pressed and reset CONTROLC flag to false.
  !---------------------------------------------------------------------
  logical, intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='PAUSE'
  !
  if (.not.sic_ctrlc()) return
  if (nlire.lt.maxlev) then
    call sic_message(seve%i,rname,'Generated by pressing ^C')
    if (error) then
      call sic_message(seve%w,rname,'Error returned by aborted command '//  &
      'ignored')
      error = .false.
    endif
    call break
  else
    call sic_message(seve%w,rname,'<^C> Ignored, level too deep')
  endif
end subroutine ctrlc_check

subroutine com_modify(line,error)
  use gkernel_interfaces
  use imager_interfaces, only : map_message 
  use phys_const
  use clean_arrays
  use clean_types
  use gbl_message
  !-----------------------------------------------------
  ! @ private
  !
  ! MAPPING  Support for command
  !   SPECIFY KeyWord Value
  !-----------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname = 'SPECIFY'
  integer, parameter :: icode_uv=1, icode_dirty=2, icode_clean=3, icode_sky=4
  !
  integer, parameter :: nterm=4
  character(len=12) :: term(nterm),chain,key,cline,clines(4)
  data term/'FREQUENCY', 'LINENAME', 'TELESCOPE', 'VELOCITY' /
  integer :: i, iterm, narg, nc
  real(8) :: freq, freq_a,freq_b,value(3)
  real(4) :: velo
  real(8) :: freqs(4)
  real(4) :: velos(4)
  logical :: do_freq, do_line, do_velo
  !
  freq = 0.d0
  velo = -1.e8
  do_freq = .false.
  do_line = .false.
  do_velo = .false.
  !
  if (hdirty%loca%size.ne.0) then
    freq = hdirty%gil%freq
    velo = hdirty%gil%voff
    cline = hdirty%char%line
    clines(icode_dirty) = hdirty%char%line
    freqs(icode_dirty) = freq
    velos(icode_dirty) = velo
  endif
  if (hclean%loca%size.ne.0) then
    freq = hclean%gil%freq
    velo = hclean%gil%voff
    cline = hclean%char%line
    clines(icode_clean) = hclean%char%line
    freqs(icode_clean) = freq
    velos(icode_clean) = velo
  endif
  if (hsky%loca%size.ne.0) then
    freq = hsky%gil%freq
    velo = hsky%gil%voff
    cline = hsky%char%line
    clines(icode_sky) = hsky%char%line
    freqs(icode_sky) = freq
    velos(icode_sky) = velo
  endif
  !
  ! UV data must be last, to be pre-dominant in case
  ! a new UV table is read, but Images are not recomputed.
  !
  ! Some warning should be given then
  if (huv%loca%size.ne.0) then
    if (freq.ne.0 .and. abs(freq-huv%gil%freq).gt.1.d0) then  ! MHz
      call map_message(seve%w,rname,'Images and UV data have different frequencies')
    endif
    freq = huv%gil%freq
    if (velo.ne.1.e8 .and. abs(velo-huv%gil%voff).gt.1.d-3) then ! km/s
      call map_message(seve%w,rname,'Images and UV data have different velocity frames')
    endif
    velo = huv%gil%voff
    cline = huv%char%line
    clines(icode_uv) = huv%char%line
    freqs(icode_uv) = freq
    velos(icode_uv) = velo
  endif
  !
  narg = sic_narg(0)
  do i = 1, narg, 2
    call sic_ke(line,0,i,chain,nc,.true.,error)
    if (error) return
    call sic_ambigs(rname,chain,key,iterm,term,nterm,error)
    if (error) return
    !
    select case (key)
    case ('FREQUENCY')
      ! Modify velocity scale according to new rest frequency [MHz]
      call sic_r8(line,0,i+1,freq,.true.,error)
      do_freq = .true.
      !
    case ('VELOCITY')
      ! Modify Frequency scale according to new velocity (km/s)
      call sic_r4(line,0,i+1,velo,.true.,error)
      do_velo = .true.
      !
    case ('LINENAME')
      call sic_ch(line,0,i+1,cline,nc,.true.,error)
      do_line = .true.
    case ('TELESCOPE')
      call sic_ke(line,0,i+1,chain,nc,.true.,error)
      if (error) return
      !
      ! Update current UV and Initial UV data set
      if (huv%loca%size.ne.0) then
        if (huv%gil%nteles.ge.1) then
          if (huv%gil%teles(1)%ctele .ne. chain(1:nc)) then
            call map_message(seve%i,rname,'Telescope ' &
            & //trim(huv%gil%teles(1)%ctele) &
            & //' in UV data overwritten by /TELESCOPE '//chain(1:nc)) 
            ! Undefine the telescope so that all characteristics
            ! are re-defined by gdf_addteles after
            huv%gil%teles(1)%ctele = ' '
            huvi%gil%teles(1)%ctele = ' '
          endif
        endif
        call gdf_addteles(huv,'TELE',chain(1:nc),value,error)
        call gdf_addteles(huvi,'TELE',chain(1:nc),value,error)
      endif
    end select
    if (error) return
  enddo
  !
  ! Now which ones ...
  if (do_freq) freqs = freq
  if (do_velo) velos = velo
  if (do_line) clines = cline
  !
  if (huv%loca%size.ne.0) then
    freq_b = gdf_uv_frequency(huv,1.d0)
    call gdf_modify(huv,velos(icode_uv),freqs(icode_uv),error=error)
    freq_a = gdf_uv_frequency(huv,1.d0)
    if (abs(freq_a-freq_b).gt.10.0) then
      Print *,'Frequency Before ',freq_b
      Print *,'Frequency After ',freq_a
      Print *,'Frequency Difference ',freq_a-freq_b
    endif
    huv%char%line = clines(icode_uv)
  endif
  if (hdirty%loca%size.ne.0) then
    call gdf_modify(hdirty,velos(icode_dirty),freqs(icode_dirty),error=error)
    hdirty%char%line = clines(icode_dirty)
  endif
  if (hclean%loca%size.ne.0) then
    call gdf_modify(hclean,velos(icode_clean),freqs(icode_clean),error=error)
    hclean%char%line = clines(icode_clean)
  endif
  if (hsky%loca%size.ne.0) then
    call gdf_modify(hsky,velos(icode_sky),freqs(icode_sky),error=error)
    hsky%char%line = clines(icode_sky)
  endif
  !
end subroutine com_modify

subroutine dispatch_clean(line,error)
  use gbl_message
  use gkernel_interfaces
  use imager_interfaces, except_this=>dispatch_clean
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ public
  !
  ! IMAGER   Main CLEAN routine
  !   Call appropriate subroutine according to METHOD%METHOD
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line  ! Command line
  logical,          intent(out)   :: error ! Logical error flag
  !
  character(len=1), parameter :: question_mark='?'
  character(len=12) :: cmethod
  integer :: nm, narg
  !
  narg = sic_narg(0) 
  if (narg.eq.1) then
    call sic_ch(line,0,1,cmethod,nm,.false.,error)
    if (cmethod(1:1).eq.question_mark) then
      call exec_program("@ i_clean "//cmethod)
      return
    endif
  endif
  call sic_get_char('METHOD',cmethod,nm,error)
  call sic_upper(cmethod)
  !
  select case (cmethod)
  case ('CLARK')
    call clark_clean(line,error)
  case ('HOGBOM')
    call hogbom_clean(line,error)
  case ('MRC')
    call mrc_clean(line,error)
  case ('MULTI')
    call multi_clean(line,error)
  case ('SDI')
    call sdi_clean(line,error)
  case default
    call map_message(seve%e,'CLEAN','Unsupported method '//cmethod)
    error = .true.
    return
  end select
  ! 
  ! Reset the per-plane stopping criterium
  ares_listsize = 0
  niter_listsize = 0
  !
end subroutine dispatch_clean
!
subroutine mrc_clean (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>mrc_clean
  use clean_def
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER Internal routine
  !   Implementation of Multi Resolution Clean
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  integer ratio,nx,ny
  character(len=3) :: rname = 'MRC'
  !
  if (user_method%mosaic) then
    call map_message(seve%e,rname,'Not valid for mosaic')
    error = .true.
    return
  endif
  !
  ! Data checkup
  user_method%method = 'MRC'
  call clean_data (error)
  if (error) return
  !
  ! Parameter Definitions
  call beam_unit_conversion(user_method)
  call copy_method(user_method,method)
  !
  ! Smoothing ratio : given by user or 2, 4 or 8 according to image size
  if (method%ratio.ne.0) then
    ratio = method%ratio
    if (power_of_two(ratio).eq.-1) then
      call map_message(seve%e,rname,'Smoothing ratio has to be a power of 2')
      error = .true.
      return
    endif
  else
    nx = hdirty%gil%dim(1)
    ny = hdirty%gil%dim(2)
    if (nx*ny.gt.512*512) then
      ratio = 8
    elseif (nx*ny.gt.128*128) then
      ratio = 4
    else
      ratio = 2
    endif
  endif
  method%ratio = ratio
  method%pflux = sic_present(1,0)
  method%pcycle = sic_present(2,0)
  method%qcycle = .false.
  !
  call sub_clean(line,error)
  user_method%do_mask = .true. ! important sinon CLARK ne marche plus
end subroutine mrc_clean
!
subroutine multi_clean (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>multi_clean
  use clean_def
  use clean_arrays
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER Internal routine
  !   Implementation of Multi Scale Clean
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  if (user_method%mosaic) then
    call map_message(seve%e,'MULTI','Not yet implemented for mosaic')
    error = .true.
    return
  endif
  !
  ! Data checkup
  user_method%method = 'MULTI'
  call clean_data (error)
  if (error) return
  !
  ! Parameter Definitions
  call beam_unit_conversion(user_method)
  call copy_method(user_method,method)
  method%pflux = sic_present(1,0)
  method%pcycle = .false.
  method%qcycle = .false.
  !
  method%gains = method%gain
  call sic_get_real('CLEAN_GAINS[1]',method%gains(1),error)
  call sic_get_real('CLEAN_GAINS[2]',method%gains(2),error)
  call sic_get_real('CLEAN_GAINS[3]',method%gains(3),error)
  !
  call sub_clean(line,error)
end subroutine multi_clean
!
subroutine sdi_clean (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sdi_clean
  use clean_def
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER Internal routine
  !   Implementation of Steer Dewdney Ito Clean
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  integer iv,na,m_iter
  character(len=8) :: name,argum,voc1(2)
  data voc1/'CLEAN','RESIDUAL'/
  !
  ! Save default number of components
  m_iter = user_method%m_iter
  user_method%m_iter = hdirty%gil%dim(1) * hdirty%gil%dim(2)
  !
  ! Data checkup: method must be defined first ?
  user_method%method = 'SDI'
  call clean_data (error)
  if (error) return
  !
  ! Parameter Definitions
  call beam_unit_conversion(user_method)
  call copy_method(user_method,method)
  method%pflux = .false.
  method%pcycle = sic_present(2,0)
  method%qcycle = sic_present(3,0)
  if (method%pcycle) then
    argum = 'RESIDUAL'
    call sic_ke (line,2,1,argum,na,.false.,error)
    if (error) return
    call sic_ambigs ('PLOT',argum,name,iv,voc1,2,error)
    if (error) return
    method%pclean = iv.eq.1
  else
    method%pclean = .false.
  endif
  call sub_clean(line,error)
  ! Restore default number of components
  user_method%m_iter = m_iter
end subroutine sdi_clean
!
subroutine hogbom_clean (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>hogbom_clean
  use clean_def
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER Internal routine
  !   Implementation of Hogbom Clean
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  ! Data checkup
  user_method%method = 'HOGBOM'
  call clean_data (error)
  if (error) return
  !
  ! Parameter Definitions
  call beam_unit_conversion(user_method)
  call copy_method(user_method,method)
  method%pflux = sic_present(1,0)
  method%pcycle = .false.
  method%qcycle = .false.
  call sub_clean(line,error)
end subroutine hogbom_clean
!
subroutine clark_clean (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>clark_clean
  use clean_def
  use clean_arrays
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER Internal routine
  !   Implementation of Barry Clark Clean
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  integer iv,na
  character(len=8) :: name,argum,voc1(2)
  data voc1/'CLEAN','RESIDUAL'/
  !
  ! Data checkup
  user_method%method = 'CLARK'
  call clean_data (error)
  if (error) return
  !
  ! Parameter Definitions
  call beam_unit_conversion(user_method)
  call copy_method(user_method,method)
  method%pflux = sic_present(1,0)
  method%pcycle = sic_present(2,0)
  method%qcycle = sic_present(3,0)
  if (method%pcycle) then
    argum = 'RESIDUAL'
    call sic_ke (line,2,1,argum,na,.false.,error)
    if (error) return
    call sic_ambigs ('PLOT',argum,name,iv,voc1,2,error)
    if (error) return
    method%pclean = iv.eq.1
  else
    method%pclean = .false.
  endif
  call sub_clean(line,error)
end subroutine clark_clean
!
subroutine sub_clean (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_clean
  use clean_def
  use clean_default
  use clean_arrays
  use clean_types
  use gbl_message
  !$  use omp_lib
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER Internal routine
  !     Implementation of all standard CLEAN deconvolution algorithms,
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='CLEAN'
  character(len=6) :: clist(3)=['CLEAN ','CCT   ','SKY   ']
  character(len=80) :: chain
  !
  integer ipen, nx, ny, np
  logical limits
  real ylimn,ylimp
  logical :: clean_extrema=.true.
  integer :: mthread, plot_case, nc
  !
  call map_message(seve%d,rname,'Calling SUB_CLEAN in all_clean.f90')
  call sic_get_logi('CLEAN_EXTREMA',clean_extrema,error)
  !
  if (user_method%mosaic) then
    where (method%blc.eq.0) method%blc = 17
    where (method%trc.eq.0) method%trc = hdirty%gil%dim(1:2)-16
    write(chain,'(A,4(1X,I0))') 'Set default search box to ',method%blc, method%trc
    call map_message(seve%i,rname,chain)
  endif    
  !
  ! General First Last channel selection
  call sic_get_inte('FIRST',method%first,error)
  call sic_get_inte('LAST',method%last,error)
  if (sic_present(0,1)) then
    call sic_i4(line,0,1,method%first,.false.,error)
    if (error) return
    method%last = method%first
    call sic_i4(line,0,2,method%last,.false.,error)
    if (error) return
  endif
  !
  method%thresh = 0.30
  call sic_get_real('THRESHOLD',method%thresh,error)
  if (method%first.eq.0) method%first = 1
  if (method%last.eq.0) method%last = hdirty%gil%dim(3)
  method%first = max(1,min(method%first,hdirty%gil%dim(3)))
  method%last = max(method%first,min(method%last,hdirty%gil%dim(3)))
  !
  call check_area(method,hdirty,.false.)
  call check_mask(method,hdirty)
  user_method%do_mask = method%do_mask
  !
  nc = hdirty%gil%dim(3)
  call cct_prepare(line,nc,method,rname,error)
  !
  !
  ! Set the pointers for use in subroutines
  hdirty%r3d => ddirty
  if (user_method%mosaic) then
    hclean%r3d => dsky 
  else
    hclean%r3d => dclean    
  endif  
  hbeam%r4d  => dbeam
  hresid%r3d => dresid
  hprim%r4d  => dprim
  hmask%r3d => dmask
  !
  limits = sic_present(1,0)
  if (limits) then
    call sic_r4 (line,1,1,ylimn,.true.,error)
    if (error) return
    call sic_r4 (line,1,2,ylimp,.true.,error)
    if (error) return
  else
    ylimp = sqrt (float(method%m_iter+200) *   &
     &      log(float(method%m_iter+1)) ) * method%gain
    if (-hdirty%gil%rmin.gt.1.3*hdirty%gil%rmax) then
      ! Probably negative
      ylimn = ylimp*hdirty%gil%rmin
      ylimp = 0.0
    elseif (-1.3*hdirty%gil%rmin.gt.hdirty%gil%rmax) then
      ! Probably positive
      ylimn = 0.0
      ylimp = ylimp*hdirty%gil%rmax
    else
      ! Do not know...,
      ylimn = ylimp*hdirty%gil%rmin
      ylimp = ylimp*hdirty%gil%rmax
    endif
  endif
  ! Usefull variables
  nx = hdirty%gil%dim(1)
  ny = hdirty%gil%dim(2)
  np = max(1,hprim%gil%dim(1))
  !
  !
  !
  ! Beam patch according to Method
  if (method%method.eq.'CLARK'.or.   &
     &    method%method.eq.'MRC') then
    if (user_method%patch(1).ne.0) then
      method%patch(1) = min(user_method%patch(1),nx)
    else
      method%patch(1) = min(nx,max(32,nx/4))
    endif
    if (user_method%patch(2).ne.0) then
      method%patch(2) = min(user_method%patch(2),ny)
    else
      method%patch(2) = min(ny,max(32,ny/4))
    endif
  elseif (method%method.eq.'SDI') then
    if (user_method%patch(1).ne.0) then
      method%patch(1) = min(user_method%patch(1),nx/4)
    else
      method%patch(1) = min(nx/2,max(16,nx/8))
    endif
    if (user_method%patch(2).ne.0) then
      method%patch(2) = min(user_method%patch(2),ny/4)
    else
      method%patch(2) = min(ny,max(16,ny/8))
    endif
  endif
  !
  ! Disable Plotting in Parallel mode
  mthread = 1
  !$  mthread = omp_get_max_threads()
  if (mthread.gt.1 .and. method%last.ne.method%first) then
    if (method%pcycle .or. method%pflux) then
      call map_message(seve%w,rname,'Ignoring /PLOT and /FLUX option in Parallel mode')
      method%pcycle = .false.
      method%pflux = .false.
    endif
    plot_case = 1
  else
    plot_case = 0
  endif
  !
  if (method%pflux) call init_flux90(method,hdirty,ylimn,ylimp,ipen)
  !
  ! Delete CCT variable
  call sic_delvariable('CCT',.false.,error)
  !
  ! Avoid array constructors (too touchy about Kind)
  method%bzone(1:2) = 1
  method%bzone(3:4) = hdirty%gil%dim(1:2)
  if (method%method.eq.'MRC') then
    call sub_mrc('MRC',method,hdirty,hresid,hclean,hbeam,hprim,d_mask, &
      &   error, plot_mrc)
  else
    if (plot_case.eq.1) then
      call sub_major(method,hdirty,hresid,hclean,hbeam,hprim,hmask, &
        &   dcct,d_mask,d_list,error, no_major_plot, no_next_flux)
    else
      call sub_major(method,hdirty,hresid,hclean,hbeam,hprim,hmask, &
        &   dcct,d_mask,d_list,error, major_plot90, next_flux90)
    endif
  endif
  !
  if (method%pflux .and. method%method.ne.'MRC') then
    call close_flux90(ipen,error)
  else
    call gr_execl('CHANGE DIRECTORY <GREG')
  endif
  !
  ! Reset extrema
  if (user_method%mosaic) then
    hsky%gil%blan_words = 2
    hsky%gil%eval = 0.0 
  endif
  if (clean_extrema) then
    hresid%loca%addr = locwrd(dresid)
    call gdf_get_extrema (hresid,error)
    hresid%gil%extr_words = def_extr_words
    !
    if (user_method%mosaic) then
      call map_message(seve%i,rname,'Computing extrema of SKY and DIRTY')
      hsky%gil%blan_words = 2
      hsky%gil%eval = 0.0 
      hsky%loca%addr = locwrd(dsky)   
      call gdf_get_extrema (hsky,error)
      hsky%gil%extr_words = def_extr_words
    else
      call map_message(seve%i,rname,'Computing extrema of CLEAN and DIRTY')
      hclean%loca%addr = locwrd(dclean) 
      call gdf_get_extrema (hclean,error)
      hclean%gil%extr_words = def_extr_words
    endif    
  else
    hresid%gil%extr_words = 0
    hclean%gil%extr_words = 0
    hsky%gil%extr_words = 0
  endif
  !
  if (method%method.ne.'MRC') save_data(code_save_cct) = .true.
  !
  ! Save general parameters...
  user_method%ibeam = method%ibeam
  user_method%nlist = method%nlist
  !
  if (user_method%mosaic) then
    ! Specify clean beam parameters
    hsky%gil%reso_words = 3
    hsky%gil%majo = method%major
    hsky%gil%mino = method%minor
    hsky%gil%posa = pi*method%angle/180.0
    hclean%loca%size = 0  ! No Clean data
    last_shown = 'SKY'    ! For SHOW NOISE
    save_data(code_save_sky) = .true.
    !
    hatten%gil%bval = 0.
    where (datten.ne.0.0) datten = 1.0/datten
    if (hatten%gil%dim(3).le.1) then
      hatten%gil%ndim = 2
      hatten%gil%dim(3) = 1
    endif
    hatten%r3d => datten
    call cube_minmax('WEIGHT',hatten,error)
    if (error) return
    !
  else
    ! Specify clean beam parameters
    hclean%gil%reso_words = 3
    hclean%gil%majo = method%major
    hclean%gil%mino = method%minor
    hclean%gil%posa = pi*method%angle/180.0
    hsky%loca%size = 0    ! Reset the Sky (primary beam corrected) image
    last_shown = 'CLEAN'  ! For SHOW NOISE
    save_data(code_save_clean) = .true.
  endif
  !
  call sic_mapgildas ('CCT',hcct,error,dcct)
  last_resid = 'CCT'    ! For UV_RESIDUAL
  !
  ! Signal that these display have been updated
  clist = ['CLEAN ','CCT   ','SKY   ']
  call check_view(3,clist)   ! Force VIEW re-computation for these
  !
end subroutine sub_clean
!
subroutine clean_data(error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>clean_data
  use clean_def
  use clean_arrays
  use gbl_message
  !--------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Prepare Clean parameters
  !   Prepare Clean arrays: CLEAN or SKY, RESIDUAL  
  !--------------------------------------------------------
  logical, intent(out) :: error
  !
  integer nx,ny,nc,nb,m_iter,ier
  logical equal
  character(len=5) :: rname = 'CLEAN'
  !
  error = .false.
  if (hdirty%loca%size.eq.0) then
    call map_message(seve%e,rname,'No dirty image')
    error = .true.
  endif
  if (hbeam%loca%size.eq.0) then
    call map_message(seve%e,rname,'No dirty beam')
    error = .true.
  endif
  if (user_method%mosaic) then
    if (hprim%loca%size.eq.0) then
      call map_message(seve%e,rname,'No primary beam')
      error = .true.
    endif
  endif
  if (error) return
  !
  ! Create clean image if needed
  nx = hdirty%gil%dim(1)
  ny = hdirty%gil%dim(2)
  nc = hdirty%gil%dim(3)
  !
  call gdf_compare_shape(hdirty,hclean,equal)
  if (.not.equal) then
    if (allocated(dclean)) deallocate(dclean,stat=ier)
    call sic_delvariable ('CLEAN',.false.,error)
    if (allocated(dsky)) deallocate(dsky,stat=ier)
    call sic_delvariable ('SKY',.false.,error)
    if (allocated(dresid)) deallocate(dresid,stat=ier)
    call sic_delvariable ('RESIDUAL',.false.,error)
    if (allocated(datten)) deallocate(datten,stat=ier)
    if (allocated(d_mask)) deallocate(d_mask,stat=ier)
    if (allocated(d_list)) deallocate(d_list,stat=ier)
    call sic_delvariable ('THEMASK',.false.,error)
  endif
  !
  call gildas_null(hclean)
  call gdf_copy_header(hdirty,hclean,error)       ! Define header in all cases...
  !
  ! Clean image is either CLEAN or SKY
  if (user_method%mosaic) then
    call gdf_copy_header(hdirty,hsky,error)       ! Define header ?
    if (.not.allocated(dsky)) then
      allocate(dsky(nx,ny,nc),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Sky Memory allocation failure')
        error = .true.
        return
      endif
      call sic_mapgildas ('SKY',hsky,error,dsky)
    endif  
  else
    if (.not.allocated(dclean)) then
      allocate(dclean(nx,ny,nc),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Clean Memory allocation failure')
        error = .true.
        return
      endif
      call sic_mapgildas ('CLEAN',hclean,error,dclean)
    endif
  endif
  !
  if (.not.allocated(dresid)) then
    hresid = hdirty
    allocate(dresid(nx,ny,nc),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Residual Memory allocation failure')
      error = .true.
      return
    endif
    call sic_mapgildas('RESIDUAL',hresid,error,dresid)
  endif
  !
  if (.not.allocated(d_mask)) then
    allocate(d_mask(nx,ny),d_list(nx*ny),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,rname,'Mask & List memory allocation failure')
      error = .true.
      return
    endif
    call sic_def_inte_addr ('THEMASK',d_mask,2,hdirty%gil%dim,   &
     &      .true.,error)
    user_method%do_mask = .true.
  endif
  !
  if (user_method%do_mask) then
    user_method%nlist = 0
  endif
  !
  ! Clean Component Table
  !
  ! Must define M_ITER before allocating space
  m_iter = user_method%m_iter
  if (m_iter.eq.0) then
     call beam_unit_conversion(user_method)
     call copy_method(user_method,method)
     call check_area(method,hdirty,.true.)
     m_iter = method%m_iter
  else
     call copy_method(user_method,method)
  endif
  !
  ! Allocate weight and check beam/image compatibility
  ! Weights are only defined if a Mosaic is treated.
  call gildas_null(hatten)
  call sic_delvariable ('WEIGHT',.false.,error)
  !
  if (user_method%mosaic) then
    !  Mosaic mode check...
    if (hbeam%gil%dim(3).ne.hprim%gil%dim(1)) then
      call map_message(seve%e,rname, &
      & 'MOSAIC mode: Beam and Primary have different pointings')
      error = .true.
    endif
    !
    if (hbeam%gil%dim(4).ne.hprim%gil%dim(4)) then
      call map_message(seve%e,rname, &
      & 'MOSAIC mode: Beam and Primary have different frequencies')
      error = .true.
    endif
    if (error) return
    nb = hbeam%gil%dim(4)
    !
    call gdf_copy_header(hdirty,hatten,error)        ! Define header in all cases...
    hatten%gil%dim(3) = hbeam%gil%dim(4)            ! Number of frequency beams
    hatten%gil%convert(:,3) = hbeam%gil%convert(:,4)
    hatten%char%code(3) = hbeam%char%code(4)
    hatten%gil%ndim = 3          ! No spectral channels, but frequency beams
    hatten%loca%size = nx*ny*nb  ! It differs from that of hdirty !...
    !
    if (.not.allocated(datten)) then
      allocate(datten(nx,ny,nb),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation failure')
        error = .true.
        return
      endif
      user_method%atten => datten
    endif
    ! Define the WEIGHT variable
    call sic_mapgildas('WEIGHT',hatten,error,datten)
    !
  elseif (hbeam%gil%dim(3).ne.1) then
!! Currently, ordering is unclear...
    if (hbeam%gil%dim(3).ne.hdirty%gil%dim(3)) then
      call map_message(seve%w,rname,'Different beam and image spectral resolution, '// &
      'not fully tested yet')
      !! error = .true.
      ! Single field verification
    endif
    !!
    call map_message(seve%e,rname,'More than 1 pointing, and Mosaic mode OFF')
    error = .true.
  endif
  !
  ! Frequency matching case
  if (hbeam%gil%dim(4).le.1) then
    continue
  elseif (hbeam%gil%dim(4).ne.hdirty%gil%dim(3)) then
    call map_message(seve%w,rname,'Different beam and image spectral resolution, '// &
    'not fully tested yet')
    !! error = .true.
  endif
  !
end subroutine clean_data

subroutine uv_shift_mosaic(line,comm,error)
  use clean_def
  use clean_default
  use clean_arrays
  use phys_const
  use gkernel_types
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => uv_shift_mosaic
  !-------------------------------------------------------------------
  ! @ private
  !
  !  IMAGER 
  !   Support routine for command
  !       UV_SHIFT  MAP_CENTER 
  !                 Xpos Ypos UNIT [Angle]
  !
  !   Phase shift a Mosaic or Single Dish UV Table to a new
  !   common phase center and orientation
  !     Offx OffY are offsets in Angle UNIT 
  !               (default 0,0)
  !     Angle     is the final position angle from North in Degree
  !               (default: no change)
  !
  !   Also called implicitely (with no command line arguments, i.e.
  !   no change of Phase Center unless the UV Table is with Phase Offsets)
  !   by command UV_MAP for Mosaics
  !-------------------------------------------------------------------
  character(len=*), intent(in) :: line  ! Command line
  character(len=*), intent(in) :: comm  ! Command name 
  logical error                         ! Logical error flag
  !
  character(len=*), parameter :: rname='UV_SHIFT'
  character(len=80) :: mess
  type(projection_t) :: proj, old_proj, new_proj
  real(8) :: newoff(3), newabs(3), oldabs(3)
  real(4) :: cs(2), angold
  real(8), allocatable :: rpos(:,:)
  real(8) :: freq
  logical :: precise=.true.
  logical :: shift, doit, lshift
  integer :: nc,nu,nv,i,ier,loff,moff,xoff,yoff
  !
  real(8) :: old(2), new(2), tabs(2), off(2)
  integer :: iv,ip
  !
  loff = huv%gil%column_pointer(code_uvt_loff)
  moff = huv%gil%column_pointer(code_uvt_moff)
  xoff = huv%gil%column_pointer(code_uvt_xoff)
  yoff = huv%gil%column_pointer(code_uvt_yoff)
  !
  oldabs = [huv%gil%a0,huv%gil%d0,huv%gil%pang]   !!! Remember map_center
  newabs = oldabs
  newoff = 0.d0
  !
  if (themap%nfields.eq.0) then
    call map_message(seve%i,rname,'UV data is a single field') 
    shift = .false.
  else if (themap%nfields.gt.0) then
    if (xoff.ne.0 .or. yoff.ne.0) then
      call map_message(seve%i,rname,'Mosaic UV data is already in Pointing offsets')
    else
      call map_message(seve%e,rname,'Mosaic UV data is already in Pointing offsets')
      call map_message(seve%e,rname,'Mosaic UV data has no Pointing columns')
      error = .true.
      return
    endif
    shift = .false.
  else
    call map_message(seve%w,rname,'Mosaic UV data is in Phase offsets')
    !
    write(mess,'(A,I0,A)') 'Mosaic UV data has ',abs(themap%nfields),' fields'
    call map_message(seve%i,rname,mess)
    !
    ! Compute the mean offset as phase center position
    newoff(1) = minval(themap%offxy(1,:)) + maxval(themap%offxy(1,:))
    newoff(2) = minval(themap%offxy(2,:)) + maxval(themap%offxy(2,:))
    newoff = newoff*0.5d0
    !
    Print *,'NEWOFF ',newoff
    call gwcs_projec(huv%gil%a0,huv%gil%d0,huv%gil%pang,huv%gil%ptyp,proj,error)
    if (error)  return
    call rel_to_abs(proj,newoff(1),newoff(2),newabs(1),newabs(2),1)
    !
    shift = .true.
    call print_change_header('PHASE_TO_POINT',huv,newabs,shift)
    !
    ! Set the new center so that the Offsets are relative to this one now
    huv%gil%a0 = newabs(1)
    huv%gil%d0 = newabs(2)
  endif                  
  !
  ! Check if command line specifies another center and/or orientation
  call map_center(line,rname,huv,lshift,newabs,error)
  if (error) return
  !
  ! Restore the original Projection 
  huv%gil%a0 = oldabs(1)
  huv%gil%d0 = oldabs(2)
  huv%gil%pang = oldabs(3)
  !
  ! Shifting is the Combination of Phase-->Pointing conversion
  ! and User requested shift through MAP_CENTER or command line arguments
  shift = shift .or. lshift 
  doit = .false.
  !
  if (.not.shift) then
    call map_message(seve%w,rname,'No shift required')
  else
    if (newabs(3).ne.0.0) then
      call map_message(seve%w,rname,'Rotated UV Mosaic cannot be saved -- No convention adopted by IRAM')
    endif      
    !
    doit = .true.   ! Make absolutely sure we do the shift ...
    call uv_shift (newabs,huv%gil%a0,huv%gil%d0,huv%gil%pang,newoff,doit)
    !
    if (.not.doit) then
      call map_message(seve%w,rname,'Shift is below possible precision')
      ! So, no change of Phase Center and Orientation, but the conversion
      ! from Phase to Pointing centers remains to be done.
      !
    else
      !
      ! Compute observing frequency, and new phase center in wavelengths
      !
      if (precise) then
        nc = huv%gil%nchan
        allocate(rpos(2,nc),stat=ier)
        do i=1,huv%gil%nchan
          freq = gdf_uv_frequency(huv,dble(i))
          rpos(1:2,i) = - freq * f_to_k * newoff(1:2)
        enddo
      else
        nc = 1
        allocate(rpos(2,1),stat=ier)
        freq = gdf_uv_frequency(huv)
        rpos(1:2,1) = - freq * f_to_k * newoff(1:2)
      endif
      !
      ! Define the rotation
      cs  = [1.0,0.0]
      angold = huv%gil%pang
      huv%gil%pang = newabs(3)
      cs(1)  =  cos(huv%gil%pang-angold)
      cs(2)  = -sin(huv%gil%pang-angold) !! This sign MAY BE WRONG
      !
      ! Recenter all channels, Loop over line table
      ! We work in place - We do not play with UV buffers
      !
      nu = huv%gil%dim(1)
      nv = huv%gil%nvisi
      !
      ! This rotates the U,V coordinates and Shift the Phases
      call shift_uvdata (huv,nu,nv,duv,cs,nc,rpos)
      !
      ! Set the new Phase center and Orientation
      huv%gil%a0 = newabs(1)
      huv%gil%d0 = newabs(2)  
      huv%gil%pang = newabs(3)
    endif
  endif
  !
  ! Done if Single Field (0) or already Pointing columns (>0)
  if (themap%nfields.eq.0) return ! Single Field
  !
  ! Convert the LOFF - MOFF columns into Pointing columns if needed
  if (themap%nfields.lt.0) then
    ! "Phase" columns
    huv%gil%column_pointer(code_uvt_xoff) = loff
    huv%gil%column_pointer(code_uvt_yoff) = moff
    huv%gil%column_size(code_uvt_xoff) = 1
    huv%gil%column_size(code_uvt_yoff) = 1
    !
    huv%gil%column_pointer(code_uvt_loff) = 0
    huv%gil%column_pointer(code_uvt_moff) = 0
    huv%gil%column_size(code_uvt_loff) = 0
    huv%gil%column_size(code_uvt_moff) = 0
    !
    themap%nfields = abs(themap%nfields)
  endif
  !
  ! And now convert the Offset values to new Coordinate system
  ! 
  ! Before: it was Relative to "OLDABS"
  ! Now it is Relative to "NEWABS"
  !
  if (doit) then
    ! A common, modified, Phase center and "Pointing Offsets"
    !
    ! The whole question is whether the "Pointing Offsets" are
    ! relative to the "Pointing Center" (with no rotation Angle)
    ! or to the "Phase Center" (with a rotation Angle)
    !
    ! The code below assumes everything is relative to the Phase Center.
    !
    xoff = huv%gil%column_pointer(code_uvt_xoff) 
    yoff = huv%gil%column_pointer(code_uvt_yoff)
    !
    old(1) = duv(xoff,1)
    old(2) = duv(yoff,1)
    call gwcs_projec(oldabs(1),oldabs(2),oldabs(3),huv%gil%ptyp,old_proj,error)  ! Previous projection system
    call gwcs_projec(newabs(1),newabs(2),newabs(3),huv%gil%ptyp,new_proj,error)  ! New projection system
    call rel_to_abs(old_proj,old(1),old(2),tabs(1),tabs(2),1)
    call abs_to_rel(new_proj,tabs(1),tabs(2),new(1),new(2),1)
    !
    do iv=1,nv
      off(1) = duv(xoff,iv)
      off(2) = duv(yoff,iv)
      if (any(off.ne.old)) then
        old(1) = duv(xoff,iv)
        old(2) = duv(yoff,iv)
        call rel_to_abs(old_proj,old(1),old(2),tabs(1),tabs(2),1)
        call abs_to_rel(new_proj,tabs(1),tabs(2),new(1),new(2),1)
      endif
      duv(xoff,iv) = new(1)
      duv(yoff,iv) = new(2)
    enddo
    !
    ! And for convenience, to avoid any ambiguity, we set the
    ! Pointing center equal to the Phase center
    !
    huv%gil%ra = huv%gil%a0
    huv%gil%dec = huv%gil%d0 
    !
    ! And we also correct the FIELDS%OFFSET values
    do ip=1,abs(themap%nfields)
      off = themap%offxy(:,ip)
      call rel_to_abs(old_proj,off(1),off(2),tabs(1),tabs(2),1)
      call abs_to_rel(new_proj,tabs(1),tabs(2),off(1),off(2),1)
      themap%offxy(:,ip) = off
    enddo
  endif
  !
end subroutine uv_shift_mosaic
!

module gwcs_interfaces_private
  interface
    subroutine gwcs_message(mkind,procname,message)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ private
      ! Messaging facility for the current library. Calls the low-level
      ! (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine gwcs_message
  end interface
  !
  interface
    subroutine chgref(matrix, oldref, newref)
      !---------------------------------------------------------------------
      ! @ private
      ! Computes the coordinates of the reference direction in the new system
      !---------------------------------------------------------------------
      real(kind=8), intent(in)  :: matrix(3,3)  ! Rotation matrix
      real(kind=8), intent(in)  :: oldref(2)    ! Old coordinates (radians)
      real(kind=8), intent(out) :: newref(2)    ! New coordinates (radians)
    end subroutine chgref
  end interface
  !
  interface
    subroutine chgoff(matrix,oldref,oldoff,newref,newoff)
      !---------------------------------------------------------------------
      ! @ private
      ! Compute offsets in the new system
      !------------------------------------------------------------------------
      real(kind=8), intent(in)  :: matrix(3,3)  ! Rotation matrix
      real(kind=8), intent(in)  :: oldref(2)    ! Old coordinates (radians)
      real(kind=4), intent(in)  :: oldoff(2)    ! Old offsets (radians)
      real(kind=8), intent(in)  :: newref(2)    ! New coordinates (radians)
      real(kind=4), intent(out) :: newoff(2)    ! New offsets (radians)
    end subroutine chgoff
  end interface
  !
  interface
    subroutine full_b1950_to_j2000(obs_epoch,lambda,beta,mu_alph,mu_delt,  &
      parallax,radvel)
      !---------------------------------------------------------------------
      ! @ private
      ! Convert Besselian coordinates to J2000.
      ! Implementation of the general formulas given in Aoki et al AA 128,
      ! 263 (1983), modified (not totally sure the modification is totally
      ! consistent, but the potentially remaining inconsistencies should be
      ! small for practical cases) to handle the case of a non-B1950 observing
      ! epoch.
      !
      ! NOT YET FINISHED, STILL RESTRICTED TO NO PM, NO PARALLAX, NO RV,
      ! BUT WORKS AS BEFORE IN THIS RESTRICTED CASE
      !---------------------------------------------------------------------
      real(kind=8), intent(in)    :: obs_epoch  !
      real(kind=8), intent(inout) :: lambda     !
      real(kind=8), intent(inout) :: beta       !
      real(kind=8), intent(in)    :: mu_alph    !
      real(kind=8), intent(in)    :: mu_delt    !
      real(kind=8), intent(in)    :: parallax   !
      real(kind=8), intent(in)    :: radvel     !
    end subroutine full_b1950_to_j2000
  end interface
  !
  interface
    function arcsin (x)
      use phys_const
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      real(kind=8) :: arcsin         !
      real(kind=8), intent(in) :: x  !
    end function arcsin
  end interface
  !
  interface
    function arccos (x)
      use phys_const
      !---------------------------------------------------------------------
      ! @ private
      !---------------------------------------------------------------------
      real(kind=8) :: arccos         !
      real(kind=8), intent(in) :: x  !
    end function arccos
  end interface
  !
end module gwcs_interfaces_private

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine reassociate_chunk_on_data(dataval,datawei,fchan,nchan,chunk,error)
  use gbl_message
  use mrtcal_interfaces, except_this=>reassociate_chunk_on_data
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-generic reassociate_chunk
  !---------------------------------------------------------------------
  real(kind=4), target, intent(in)    :: dataval(:)  ! DATA target
  real(kind=4), target, intent(in)    :: datawei(:)  ! WEIGHT target
  integer(kind=4),      intent(in)    :: fchan       ! First channel
  integer(kind=4),      intent(in)    :: nchan       ! Number of channels
  type(chunk_t),        intent(inout) :: chunk       !
  logical,              intent(inout) :: error       ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='REASSOCIATE>CHUNK>ON>DATA'
  integer(kind=4) :: lchan
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (chunk%allocated.eq.code_pointer_allocated) then
    call mrtcal_message(seve%e,rname,  &
      'Internal error: attempt to reassociate an allocated pointer (memory leak)')
    error = .true.
    return
  endif
  !
  lchan = fchan + nchan - 1
  chunk%nchan = nchan
  chunk%data1 => dataval(fchan:lchan)
  chunk%dataw => datawei(fchan:lchan)
  chunk%allocated = code_pointer_associated
  !
end subroutine reassociate_chunk_on_data
!
subroutine reassociate_chunk_on_chunk(in,ou,error)
  use gbl_message
  use mrtcal_interfaces, except_this=>reassociate_chunk_on_chunk
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-generic reassociate_chunk
  !---------------------------------------------------------------------
  type(chunk_t), intent(in)    :: in
  type(chunk_t), intent(inout) :: ou
  logical,       intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REASSOCIATE>CHUNK>ON>CHUNK'
  !
  ! Data pointers part
  call reassociate_chunk_on_data(in%data1,in%dataw,1,in%nchan,ou,error)
  if (error)  return
  !
  ! Remaining part: duplicate...
  ! ZZZ use mrtcal_chunk_copy_header?
  ou%id   = in%id
  ou%mjd  = in%mjd
  ou%gen  = in%gen
  ou%pos  = in%pos
  ou%spe  = in%spe
  ou%cal  = in%cal
  ou%swi  = in%swi
  ou%res  = in%res
  ou%user = in%user
  ou%cont1 = in%cont1
  !
end subroutine reassociate_chunk_on_chunk
!
subroutine reassociate_chunkset(in,ou,error,ichunk)
  use gbl_message
  use mrtcal_interfaces, except_this=>reassociate_chunkset
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private
  !  Associate a chunkset onto another one.
  !  If 'ichunk' is present, associate only onto this single element
  ! (pointer to subset).
  !---------------------------------------------------------------------
  type(chunkset_t),          intent(in)    :: in
  type(chunkset_t),          intent(inout) :: ou
  logical,                   intent(inout) :: error
  integer(kind=4), optional, intent(in)    :: ichunk
  ! Local
  character(len=*), parameter :: rname='REASSOCIATE>CHUNKSET'
  integer(kind=4) :: first,last
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (present(ichunk)) then
    if (ichunk.lt.1 .or. ichunk.gt.in%n) then
      call mrtcal_message(seve%e,rname,'Invalid chunk number')
      error = .true.
      return
    endif
    first = ichunk
    last = first
  else
    first = 1
    last = in%n
  endif
  !
  if (ou%allocated.eq.code_pointer_allocated) then
    call free_chunkset(ou,error)
    if (error)  return
  endif
  !
  ou%n = last-first+1
  ou%chunks => in%chunks(first:last)
  ou%allocated = code_pointer_associated
  !
end subroutine reassociate_chunkset
!
subroutine reassociate_chunkset_2d_on_2d(in2d,ou2d,error)
  use gbl_message
  use mrtcal_interfaces, except_this=>reassociate_chunkset_2d_on_2d
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-generic reassociate_chunkset_2d
  !---------------------------------------------------------------------
  type(chunkset_2d_t), intent(in)    :: in2d
  type(chunkset_2d_t), intent(inout) :: ou2d
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REASSOCIATE>CHUNKSET>2DON2D'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (ou2d%allocated.eq.code_pointer_allocated) then
    call free_chunkset_2d(ou2d,error)
    if (error)  return
  endif
  !
  ! ZZZ Partial copy, this is not satisfying, something should be done...
  ou2d%mjd  = in2d%mjd
  ou2d%corr = in2d%corr
  ! ou2d%isub = in2d%isub  NOT THIS ONE! Controled elsewhere...
  ou2d%npix = in2d%npix
  ou2d%nset = in2d%nset
  ou2d%chunkset => in2d%chunkset
  ou2d%allocated = code_pointer_associated
  !
end subroutine reassociate_chunkset_2d_on_2d
!
subroutine reassociate_chunkset_2d_on_3d(itime,in3d,ou2d,error)
  use gbl_message
  use mrtcal_interfaces, except_this=>reassociate_chunkset_2d_on_3d
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-generic reassociate_chunkset_2d
  !---------------------------------------------------------------------
  integer(kind=4),     intent(in)    :: itime  ! Position in in3d
  type(chunkset_3d_t), intent(in)    :: in3d   !
  type(chunkset_2d_t), intent(inout) :: ou2d   !
  logical,             intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='REASSOCIATE>CHUNKSET>2DON3D'
  character(len=message_length) :: mess
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (ou2d%allocated.eq.code_pointer_allocated) then
    call free_chunkset_2d(ou2d,error)
    if (error)  return
  endif
  !
  if (itime.lt.1 .or. itime.gt.in3d%ntime) then
    write(mess,'(A,I0,A,I0,A)')  'Trying to point to time #',itime,  &
        ', i.e., outside the target chunkset_3d (1:',in3d%ntime,')'
    call mrtcal_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  ou2d%nset = in3d%nset
  ou2d%npix = in3d%npix
  ou2d%chunkset => in3d%chunkset(:,:,itime)
  ou2d%allocated = code_pointer_associated
  !
end subroutine reassociate_chunkset_2d_on_3d
!
subroutine reassociate_chunkset_3d_on_2d(itime,in2d,ou3d,error)
  use gbl_message
  use mrtcal_interfaces, except_this=>reassociate_chunkset_3d_on_2d
  use mrtcal_calib_types
  !---------------------------------------------------------------------
  ! @ private-generic reassociate_chunkset_3d
  ! Associate a subset of a chunkset_3d onto a chunkset_2d. Note that
  ! this is kind of reverse operation done by
  ! reassociate_chunkset_2d_on_3d.
  !
  !   Note also that:
  !   - this is a problem of "arrays of pointers", which, in Fortran
  !     is not possible
  !   - chunkset_3d are always allocated, never associated
  ! which means we can not associate a chunkset_3d onto several
  ! chunkset_2d. But this is what we want to do!
  !   Knowing that:
  !   - chunkset are always allocated, never associated
  !   - chunks can be allocated or associated
  ! The solution is to allocate the chunkset_3d, plus its chunksets,
  ! but associate its chunks to the desired target at very low level...
  !---------------------------------------------------------------------
  integer(kind=4),     intent(in)    :: itime   ! Position in ou3d
  type(chunkset_2d_t), intent(in)    :: in2d   !
  type(chunkset_3d_t), intent(inout) :: ou3d   !
  logical,             intent(inout) :: error  !
  ! Local
  character(len=*), parameter :: rname='REASSOCIATE>CHUNKSET>3DON2D'
  character(len=message_length) :: mess
  integer(kind=4) :: iset,ipix
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  ! Sanity check: the output chunkset_3d must have allocated to the correct
  ! size
  if (itime.lt.1 .or. itime.gt.ou3d%ntime) then
    write(mess,'(A,I0,A,I0,A)')  'Trying to point to time #',itime,  &
        ', i.e., outside the chunkset_3d (1:',ou3d%ntime,')'
    call mrtcal_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  if (in2d%nset.ne.ou3d%nset .or. in2d%npix.ne.ou3d%npix) then
    write(mess,'(4(A,I0))')  'Chunksets are inconsistent: nset = ',in2d%nset,  &
      ' vs ',ou3d%nset,', npix = ',in2d%npix,' vs ',ou3d%npix
    call mrtcal_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  do ipix=1,in2d%npix
    do iset=1,in2d%nset
      call reassociate_chunkset(in2d%chunkset(iset,ipix),ou3d%chunkset(iset,ipix,itime),error)
      if (error)  return
    enddo
  enddo
  !
end subroutine reassociate_chunkset_3d_on_2d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine nullify_chunk(chunk,error)
  use gbl_message
  use mrtcal_interfaces, except_this => nullify_chunk
  use mrtcal_calib_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(chunk_t), intent(inout) :: chunk
  logical,       intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='NULLIFY>CHUNK'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (chunk%allocated.eq.code_pointer_associated) then
    chunk%nchan = 0
    chunk%data1 => null()
    chunk%dataw => null()
    chunk%allocated = code_pointer_null
    !
  elseif (chunk%allocated.eq.code_pointer_allocated) then
    call mrtcal_message(seve%e,rname,'Attempt to nullify an allocated pointer')
    error = .true.
    return
  endif
  !
end subroutine nullify_chunk
!
subroutine nullify_chunkset(chunkset,error)
  use gbl_message
  use mrtcal_interfaces, except_this=>nullify_chunkset
  use mrtcal_calib_types
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(chunkset_t), intent(inout) :: chunkset
  logical,          intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='NULLIFY>CHUNKSET'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (chunkset%allocated.eq.code_pointer_associated) then
    chunkset%n = 0
    chunkset%chunks => null()
    chunkset%allocated = code_pointer_null
    !
  elseif (chunkset%allocated.eq.code_pointer_allocated) then
    call mrtcal_message(seve%e,rname,'Attempt to nullify an allocated pointer')
    error = .true.
    return
  endif
  !
end subroutine nullify_chunkset
!
subroutine nullify_chunkset_2d(ck2d,error)
  use gbl_message
  use mrtcal_calib_types
  use mrtcal_interfaces, except_this=>nullify_chunkset_2d
  !---------------------------------------------------------------------
  ! @ private
  !  Nullify a chunkset_2d type.
  !  Nullify only the array. Its components are owned by the target,
  ! this is its responsibility, not ours here.
  !---------------------------------------------------------------------
  type(chunkset_2d_t), intent(inout) :: ck2d
  logical,             intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='NULLIFY>CHUNKSET>2D'
  !
  call mrtcal_message(seve%t,rname,'Welcome')
  !
  if (ck2d%allocated.eq.code_pointer_associated) then
    !
    if (.not.associated(ck2d%chunkset)) then
      ! This is unexpected, since ck2d%allocated tells us the array is in use!
      call mrtcal_message(seve%e,rname,'Chunkset 2D array is not associated!')
      error = .true.
      return
    endif
    !
    ck2d%chunkset => null()
    ck2d%npix = 0
    ck2d%nset = 0
    ck2d%allocated = code_pointer_null
    !
  elseif (ck2d%allocated.eq.code_pointer_allocated) then
    call mrtcal_message(seve%e,rname,'Attempt to nullify an allocated pointer')
    error = .true.
    return
    !
  else  ! ck2d%allocated.eq.code_pointer_null
    if (associated(ck2d%chunkset)) then
      ! This is unexpected, since ck2d%allocated tells us the array is NOT in use!
      call mrtcal_message(seve%e,rname,  &
        'Internal error: unexpected association status')
      error = .true.
      return
    endif
    !
  endif
  !
end subroutine nullify_chunkset_2d
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

subroutine uv_baseline_main(line,error)
  use gbl_message
  use mapping_interfaces, except_this=>uv_baseline_main
  use gildas_def
  !----------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  ! Command line interaction for UV_BASELINE command
  !----------------------------------------------------------
  character(len=*), intent(inout) :: line  ! Command line
  logical, intent(out)            :: error ! Error flag
  !
  character(len=*), parameter :: rname='UV_BASELINE'
  !
  integer                    :: degree           ! degree of the baseline to subtract
  integer, allocatable       :: channellist(:,:) ! list of ranges of channels to exclude
  integer(kind=size_length)  :: nelem            ! Number of excluded ranges
  logical                    :: dozero           ! Just to hold info from uv_filter_parsing, always false
  !
  degree = 0
  call sic_i4(line,0,1,degree,.false.,error)
  if (error) return
  if (degree.ne.0 .and. degree.ne.1) then
     call map_message(seve%e,rname,'Only degree 0 or 1 supported')
     error = .true.
     return
  endif
  !
  ! Call UV Filter to do the filtering.
  call uv_filter_parsing(line,channellist,nelem,dozero,rname,error)
  if (error) return
  !
  ! Now do the work
  call uv_baseline_sub(degree,channellist,nelem,error)
end subroutine uv_baseline_main
!
subroutine uv_baseline_sub(degree,channellist,nelem,error)
  use gildas_def
  use mapping_interfaces, except_this=>uv_baseline_sub
  use clean_arrays
  use gbl_message
  use gkernel_interfaces
  !----------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  ! Coordinates baseline fitting and subtraction
  !----------------------------------------------------------
  integer, intent(in)                   :: degree           ! Polynomial degree of baseline
  integer, allocatable,intent(in)       :: channellist(:,:) ! list of ranges of channels to exclude
  integer(kind=size_length),intent(in)  :: nelem            ! Number of excluded ranges
  logical, intent(out)                  :: error            ! Error flag
  !
  character(len=*), parameter :: rname='UV_BASELINE'
  !
  integer(kind=size_length)              :: nvisi         ! Number of visibilities
  integer(kind=index_length)             :: ivisi         ! visibility index
  integer(kind=index_length)             :: iranges       ! spectral ranges index
  integer(kind=index_length)             :: ichan         ! channel index
  integer(kind=index_length)             :: ivalid        ! valid channel index
  integer(kind=index_length),allocatable :: rindexes(:)   ! indexes for valid real channels
  integer(kind=index_length),allocatable :: iindexes(:)   ! indexes for valid imaginary channels
  integer(kind=index_length),allocatable :: cnumbers(:)   ! valid channels
  real,allocatable                       :: rdata(:)      ! valid real channels
  real,allocatable                       :: idata(:)      ! valid imaginary channels
  integer(kind=4),allocatable            :: notflagged(:)
  integer(kind=size_length)              :: nchan         ! number of channels
  integer                                :: ier
  integer                                :: nvalid        ! NUmber of valid channels
  integer                                :: fchan, lchan  ! First and last channels in a range of channels
  character(len=50)                      :: warning       ! Warning message
  integer(kind=index_length)             :: cols(3)       ! Columns for a specific channel
  integer(kind=1), parameter             :: bit=1         ! 1 in i1
  real                                   :: areal,breal   ! Fit parameters for real part
  real                                   :: aimag,bimag   ! Fit parameters for imaginary part
  !
  !
  nchan = huv%gil%nchan
  nvisi = huv%gil%nvisi
  allocate(notflagged(nchan),stat=ier)
  if (failed_allocate(rname,'Flagged list',ier,error))  return
  notflagged(:) = 1
  !
  ! Getting the flagged ranges
  do iranges=1, nelem
     fchan = channellist(1,iranges)
     lchan = channellist(2,iranges)
     if (lchan.lt.1.or.fchan.gt.huv%gil%nchan) then
        write(warning,1000) iranges,"-th spectral range is outside UV table"
        call map_message(seve%w,rname, trim(warning))
     else
        if (lchan.gt.nchan) lchan = nchan
        if (fchan.lt.1)     fchan = 1
        notflagged(fchan:lchan) = 0
     endif
  enddo
  nvalid = sum(notflagged)
  allocate(rindexes(nvalid),iindexes(nvalid),rdata(nvalid),idata(nvalid),cnumbers(nvalid),stat=ier)
  if (failed_allocate(rname,'Real and imaginary arrays',ier,error))  return
  ivalid=1
  do ichan=1,nchan
     if (notflagged(ichan).eq.bit) then
        call uv_spectral_getcols(ichan,cols)
        rindexes(ivalid) = cols(1)
        iindexes(ivalid) = cols(2)
        cnumbers(ivalid) = ichan
        ivalid = ivalid+1
     endif
  end do
  deallocate(notflagged)
  do ivisi=1, nvisi
     do ivalid=1,nvalid
        rdata(ivalid) = duv(rindexes(ivalid),ivisi)
        idata(ivalid) = duv(iindexes(ivalid),ivisi)
     enddo
     call uv_baseline_baseline(cnumbers,rdata,nvalid,degree,areal,breal,error)
     call uv_baseline_baseline(cnumbers,idata,nvalid,degree,aimag,bimag,error)
     do ichan=1,nchan
        call uv_spectral_getcols(ichan,cols)
        duv(cols(1),ivisi) =  duv(cols(1),ivisi)-(areal*ichan+breal)
        duv(cols(2),ivisi) =  duv(cols(2),ivisi)-(aimag*ichan+bimag)
     enddo
  enddo
1000 format(i4,a38) 
end subroutine uv_baseline_sub
!
subroutine uv_baseline_baseline(xdata,ydata,npoints,degree,acoeff,bcoeff,error)
  use mapping_interfaces, except_this=>uv_baseline_baseline
  use gkernel_interfaces
  use gildas_def
  !----------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  ! Computes baseline from input arrays
  !----------------------------------------------------------
  integer(kind=index_length),allocatable,intent(in) :: xdata(:)
  real,allocatable,intent(in)                       :: ydata(:)
  integer,intent(in)                                :: npoints
  integer,intent(in)                                :: degree
  real,intent(out)                                  :: acoeff
  real,intent(out)                                  :: bcoeff
  logical, intent(out)                              :: error
  !
  character(len=*), parameter :: rname='UV_BASELINE'
  !
  real              :: sumx  ! Sum of xdata
  real              :: sumy  ! Sum of y data
  real              :: sumxy ! Sum of x*y
  real              :: sumxx ! Sum of x^2
  real              :: delta ! midway coefficient
  real, allocatable :: warr(:) ! allocatable workhorse array
  integer           :: ier   ! error flag
  !
  if (degree.eq.0) then
     acoeff = 0.0
     bcoeff = sum(ydata)/npoints
  else if (degree.eq.1)then
     allocate(warr(npoints),stat=ier)
     if (failed_allocate(rname,'Work array',ier,error))  return
     sumx = sum(xdata)
     sumy = sum(ydata)
     warr = xdata**2
     sumxx = sum(warr)
     warr = xdata*ydata
     sumxy = sum(warr)
     delta = (npoints*sumxx-sumx**2)
     bcoeff = (sumxx*sumy-sumx*sumxy)/delta
     acoeff = (npoints*sumxy-sumx*sumy)/delta
     deallocate(warr)
  endif
end subroutine uv_baseline_baseline

subroutine stokes_comm(line,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => stokes_comm
  !---------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER
  !   Support for command
  !
  ! STOKES Value [/FILE FileIn FileOut]
  !
  ! Extract a Polarization state from a UV table
  !
  !---------------------------------------------------------------------
  character(len=*) :: line
  logical error
  !
  integer, parameter :: code_stokes_all=100
  integer, parameter :: code_stokes_any=-100
  character(len=*), parameter :: rname='STOKES'
  integer, parameter :: o_file=1
  !
  character(len=filename_length) :: nami,namo
  character(len=12) :: mystoke
  character(len=message_length) :: mess
  integer :: n, i, istoke
  !
  error = .false.
  call sic_ke(line,0,1,mystoke,n,.true.,error)
  if (error) return
  !
  ! Scan the requested polarization code
  if (mystoke.eq.'NONE') then
    istoke = code_stokes_none
  elseif (mystoke.eq.'ALL') then
    istoke = code_stokes_all
  else
    call stokes_code(mystoke,istoke,error)
    if (error) then
      call map_message(seve%e,rname,'Invalid Stokes '//mystoke)
      return
    endif
  endif
  !
  if (sic_present(o_file,0)) then
    call sic_ch(line,o_file,1,nami,n,.true.,error)
    if (error) return
    call sic_ch(line,o_file,2,namo,n,.true.,error)
    if (error) return
  else
    call sic_ch(line,0,2,nami,n,.true.,error)
    if (error) return
    call sic_ch(line,0,3,namo,n,.true.,error)
    if (error) return
    Print *,'Not yet coded on Buffers, Using File arguments...'
  endif
  call sub_splitpolar (nami,namo,mystoke,error)  
end subroutine stokes_comm
!<FF>
subroutine sub_splitpolar(nami,namo,mystoke,error)
  use image_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => sub_splitpolar
  !
  ! @ private
  !
  character(len=*), intent(inout) :: nami  ! Input file name
  character(len=*), intent(inout) :: namo  ! Output file name
  character(len=*), intent(in) :: mystoke  ! Desired Stoke parameter
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='STOKES'
  type (gildas) :: hin, hou
  real(kind=4), allocatable :: din(:,:), dou(:,:)
  !
  integer, parameter :: code_stokes_all=100
  integer, parameter :: code_stokes_any=-100
  character(len=message_length) :: mess
  !
  integer i, istoke, ivisi, is, ns, iv, jv, ier, ipara
  integer astoke(4)
  integer natom, nlead, nchan, kin, kou, next
  logical extract
  real :: re, im, we
  integer intrail, ontrail, iend, oend
  real :: da, db
  integer :: ip
  integer :: kv, iloop, nblock, nvisi, mblock, multi
  !
  error = .false.
  extract = .false.
  !
  if (mystoke.eq.'NONE') then
    istoke = code_stokes_none
  elseif (mystoke.eq.'ALL') then
    istoke = code_stokes_all
  else
    call stokes_code(mystoke,istoke,error)
    if (error) then
      call map_message(seve%e,rname,'Invalid Stokes '//mystoke)
      return
    endif
  endif
  !
  ! Read Header of a sorted, UV table
  call gildas_null(hin, type= 'UVT')
  call sic_parsef (nami,hin%file,' ','.uvt')
  call gdf_read_header (hin,error)
  if (error) return
  !
  ipara = hin%gil%column_pointer(code_uvt_para)
  !
  !
  call gildas_null(hou, type='UVT')
  call gdf_copy_header (hin, hou, error)
  call sic_parsef (namo,hou%file,'  ','.uvt')
  !
  ! Define the Output Stokes parameter value
  hou%gil%nstokes = 1
  hou%gil%order = istoke           ! Unless it is "ANY" - will be changed later
  !
  call gdf_nitems('SPACE_GILDAS',nblock,hin%gil%dim(1))
  nblock = min(nblock,hin%gil%dim(2))
  !
  ! Check it has more than 1 polarization
  if (hin%gil%nstokes.eq.1) then
    call map_message(seve%i,rname,'Already only 1 polar per visibility ')
    ! Here need to check if a Polar column is present, through the
    ! extra columns (code_uvt_stok)
    !
    is = hin%gil%column_pointer(code_uvt_stok)
    if (is.eq.0) then
      call map_message(seve%i,rname,'Already only 1 polar in total')
      ns = 1
      astoke(ns) = hin%gil%order
      if (istoke.eq.astoke(1) .or. istoke.eq.0) then
        !
        ! OK copy the whole stuff...
        allocate (din(hin%gil%dim(1),nblock),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error ')
          error = .true.
          return
        endif
        !
        hin%blc = 0
        hin%trc = 0
        hou%blc = 0
        hou%trc = 0
        call gdf_create_image(hou,error)
        if (error) return
        !
        call map_message(seve%i,rname,'Replicating UV table ')
        do iloop = 1,hin%gil%dim(2),nblock
          hin%blc(2) = iloop
          hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
          hou%blc(2) = iloop
          hou%trc(2) = hin%trc(2)
          call gdf_read_data (hin,din,error)
          if (error) return
          call gdf_write_data (hou, din, error)
          if (error) return
        enddo
        call gdf_close_image(hou,error)
      else
        call map_message(seve%i,rname,'Polar '//mystoke// &
        ' does not match '//stokes_name(astoke(1)) )
        error = .true.
      endif
      !
      return
    else
      call map_message(seve%i,rname,'Perhaps more than 1 polar, scanning...')
      allocate (din(hin%gil%dim(1),nblock),dou(hou%gil%dim(1),nblock),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%i,rname,'Memory allocation error ')
        error = .true.
        return
      endif
      !
      hin%blc = 0
      hin%trc = 0
      hou%blc = 0
      hou%trc = 0
      hou%blc(2) = 1
      jv = 0
      call gdf_create_image(hou,error)
      if (error) return
      !
      ns = 0
      do iloop = 1,hin%gil%dim(2),nblock
        hin%blc(2) = iloop
        hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
        kv = hin%trc(2)-hin%blc(2)+1
        call gdf_read_data (hin,din,error)
        if (error) return
        !
        jv = 0
        do iv = 1,kv
          if (din(is,iv).ne.istoke) cycle
          jv = jv+1
          dou(:,jv) = din(:,iv)
        enddo
        !
        if (jv.gt.0) then
          hou%trc(2) = hou%blc(2)+jv-1
          call gdf_write_data(hou,dou,error)
          hou%blc(2) = hou%trc(2)+1
        endif
      enddo
      !
      ! Finalize
      hou%gil%nvisi = hou%trc(2)
      hou%gil%dim(2) = hou%trc(2)
      call gdf_update_header(hou,error)
      call gdf_close_image(hou,error)
    endif
    !
  else
    !
    ! This means each Visi has Nstokes x Nchan or Nchan x Nstokes elements
    !
    if (hin%gil%order.eq.code_chan_stok) then
      ! Nchan X Nstokes channels
      !
      call map_message(seve%i,rname,'Input order: Nchan channels X Nstokes stokes')
    else if (hin%gil%order.eq.code_stok_chan) then
      call map_message(seve%i,rname,'Input order: Nstokes stokes X  Nchan channels')
      ! Nstokes x Nchan channels
    else
      call map_message(seve%e,rname,'Inconsistent UV table state for polarization')
      error = .true.
      return
    endif
    ns = hin%gil%nstokes
    mess = 'Input Stokes: '
    next = 20
    do i=1,ns
      mess(next:) = stokes_name(hin%gil%stokes(i))
      next = len_trim(mess)+3
    enddo
    call map_message(seve%i,rname,mess)
    call map_message(seve%i,rname,'Output Stokes:     '//stokes_name(istoke))
    !
    !!print *,'DIN ',(din(1:10,i),i=1,10)
    !
    astoke(1:ns) = hin%gil%stokes(1:ns)
    natom = hin%gil%natom
    nchan = hin%gil%nchan
    nlead = hin%gil%nlead
    intrail = hin%gil%ntrail
    ontrail = intrail
    iend = hin%gil%dim(1)
    !
    ! The useful cases are
    if (ns.eq.2) then
      if (istoke.ge.code_stokes_i .or. istoke.eq.code_stokes_none &
        .or. istoke.eq.code_stokes_all) then
        ! Input: 2 Stokes, HH+VV or RR+LL, Output: I, NONE or ALL
        ! keep everything, make proper weighting
        if ( (astoke(1).eq.code_stokes_hh.and.astoke(2).eq.code_stokes_vv) &
        .or. (astoke(2).eq.code_stokes_hh.and.astoke(1).eq.code_stokes_vv) &
        .or. (astoke(1).eq.code_stokes_ll.and.astoke(2).eq.code_stokes_rr) &
        .or. (astoke(2).eq.code_stokes_ll.and.astoke(1).eq.code_stokes_rr) &
        ) then
          if (istoke.eq.code_stokes_all) then
            hou%gil%nvisi = 2*hin%gil%nvisi
            multi = 2
            ontrail = ontrail+1
          else
            multi = 1
            hou%gil%nvisi = hin%gil%nvisi
          endif
          call map_message(seve%i,rname,'Deriving '//mystoke// &
          ' from '//stokes_name(astoke(1))//' and '//stokes_name(astoke(2)))
          !
          ! Shift the trailing columns
          do i=1,code_uvt_last
            if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
              hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
                & hin%gil%natom * hin%gil%nchan
            endif
          enddo
          !
        else
          call map_message(seve%e,rname,'Cannot derive '//mystoke// &
          ' from '//stokes_name(astoke(1))//' and '//stokes_name(astoke(2)))
          error = .true.
          return
        endif
        !
        hou%gil%dim(2) = hou%gil%nvisi
        hou%gil%dim(1) = hin%gil%dim(1) - hin%gil%nchan*hin%gil%natom &
                       + ontrail-intrail
        oend = hou%gil%dim(1)+intrail-ontrail
        !!Print *,'IN ',hin%gil%natom,  hin%gil%nchan,  hin%gil%nvisi, hin%gil%dim(1)
        !!Print *,'OUT ',hou%gil%natom,  hou%gil%nchan,  hou%gil%nvisi, hou%gil%dim(1)
        !!Print *,'OEND ',oend, intrail, ontrail
        if (istoke.eq.code_stokes_all) then
          hou%gil%column_pointer(code_uvt_stok) = hou%gil%dim(1)
        endif
        !
        ! Here, we make the loop
        ! We make no assumption about the Stokes ordering, so allocate
        ! a block which may handle all input visibilities
        mblock = multi*nblock
        allocate (dou(hou%gil%dim(1),mblock),din(hin%gil%dim(1),nblock),stat=ier)
        if (ier.ne.0) then
          call map_message(seve%e,rname,'Memory allocation error')
          error = .true.
          return
        endif
        !
        hin%blc = 0
        hin%trc = 0
        hou%blc = 0
        hou%trc = 0
        call gdf_create_image(hou,error)
        if (error) return
        !
        hou%blc(2) = 1
        do iloop = 1,hin%gil%dim(2),nblock
          write(mess,*) iloop,' / ',hin%gil%dim(2),nblock
          call map_message(seve%d,rname,mess)
          hin%blc(2) = iloop
          hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
          call gdf_read_data(hin,din,error)
          if (error) return
          nvisi = hin%trc(2)-hin%blc(2)+1
          !
          if (hin%gil%order.eq.code_chan_stok) then
            ! Nchan X Nstokes channels  (ALL)
            !
            if (istoke.eq.code_stokes_all) then
              !
              jv = 0
              do iv = 1,nvisi
                jv = jv+1
                dou(1:nlead,jv) = din(1:nlead,iv)
                dou(nlead+1:nlead+natom*nchan,jv) = din(nlead+1:nlead+natom*nchan,iv)
                if (ontrail.ne.intrail) dou(oend+1,jv) = astoke(1)
                if (intrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
                     din(nlead+1+2*natom*nchan:iend,iv)
                !
                jv = jv+1
                dou(1:nlead,jv) = din(1:nlead,iv)
                dou(nlead+1:nlead+natom*nchan,jv) = din(nlead+1+natom*nchan:nlead+2*natom*nchan,iv)
                if (ontrail.ne.intrail) dou(oend+1,jv) = astoke(2)
                if (intrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
                     din(nlead+1+2*natom*nchan:iend,iv)
              enddo
            else
              call map_message(seve%e,rname, &
              & 'Nchan X Nstokes channel order only supported for code ALL')
              error = .true.
              return
            endif
          else
            !
            ! Nstokes x Nchan channels
            call stokes_derive(din,dou,nvisi,nlead,natom,nchan,ns,intrail,istoke,astoke,ipara)
          endif
          hou%trc(2) = hou%blc(2)+multi*nvisi-1
          call gdf_write_data(hou,dou,error)
          hou%blc(2) = hou%trc(2)+1
          !
        enddo ! By block
      else
        ! Input: 2 Stokes, HH+VV or RR+LL, Output: one among these.
        ! keep only that one...
        if (istoke.eq.astoke(1)) then
          ivisi = 1
        else if (istoke.eq.astoke(2)) then
          ivisi = 2
        else
          call map_message(seve%e,rname,'Cannot extract '//mystoke// &
          ' from '//stokes_name(astoke(1))//' and '//stokes_name(astoke(2)))
          error = .true.
          return
        endif
        call map_message(seve%e,rname,'Extracting '//mystoke// &
        ' from '//stokes_name(astoke(1))//' and '//stokes_name(astoke(2)))
        !
        hou%gil%dim(1) = hin%gil%dim(1)-hin%gil%nchan*hin%gil%natom
        extract = .true.
        !
        ! Shift the trailing columns
        do i=1,code_uvt_last
          if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
            hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
              & hin%gil%natom * hin%gil%nchan
          endif
        enddo
      endif
      !
    else if (ns.eq.4) then
      !
      ! 4 Stokes, extract one of them
      ivisi = 0
      do i=1,ns
        if (istoke.eq.astoke(i)) then
          ivisi = i
          exit
        endif
      enddo
      if (ivisi.eq.0) then
        if ( (istoke.eq.code_stokes_none) .or. & 
          & ((istoke.ge.code_stokes_i).and.(istoke.le.code_stokes_v)) )  then
          if (hin%gil%order.eq.code_chan_stok) then
            call map_message(seve%e,rname, &
              & 'Nchan X Nstokes channel order only supported for code ALL')
            error = .true.
            return
          endif   
          !
          if ( (astoke(1).eq.code_stokes_hh.and.astoke(2).eq.code_stokes_vv) &
          .or. (astoke(2).eq.code_stokes_hh.and.astoke(1).eq.code_stokes_vv) &
          .or. (astoke(1).eq.code_stokes_ll.and.astoke(2).eq.code_stokes_rr) &
          .or. (astoke(2).eq.code_stokes_ll.and.astoke(1).eq.code_stokes_rr) &
          ) then
            continue
          else
            call map_message(seve%e,rname, &
              & 'Unsupported Stokes ordering ')
            error = .true.
            return
          endif   
          !
          multi = 1   ! 1 output visibility per input Visibility      
          ! Shift the trailing columns
          do i=1,code_uvt_last
            if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
              hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
                & 3 * hin%gil%natom * hin%gil%nchan
            endif
          enddo
          !
          ! Figure out which case is to be compressed
          hou%gil%dim(2) = hou%gil%nvisi
          hou%gil%dim(1) = hin%gil%dim(1)-3*hin%gil%nchan*hin%gil%natom &
                &        + ontrail-intrail
          oend = hou%gil%dim(1)+intrail-ontrail
          !!Print *,'IN ',hin%gil%natom,  hin%gil%nchan,  hin%gil%nvisi, hin%gil%dim(1)
          !!Print *,'OUT ',hou%gil%natom,  hou%gil%nchan,  hou%gil%nvisi, hou%gil%dim(1)
          !!Print *,'OEND ',oend, intrail, ontrail
          !
          ! Here, we make the loop
          ! We make no assumption about the Stokes ordering, so allocate
          ! a block which may handle all input visibilities
          mblock = multi*nblock
          allocate (dou(hou%gil%dim(1),mblock),din(hin%gil%dim(1),nblock),stat=ier)
          if (ier.ne.0) then
            call map_message(seve%e,rname,'Memory allocation error')
            error = .true.
            return
          endif
          !
          hin%blc = 0
          hin%trc = 0
          hou%blc = 0
          hou%trc = 0
          call gdf_create_image(hou,error)
          if (error) return
          !
          hou%blc(2) = 1
          do iloop = 1,hin%gil%dim(2),nblock
            write(mess,*) iloop,' / ',hin%gil%dim(2),nblock
            call map_message(seve%i,rname,mess)
            hin%blc(2) = iloop
            hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
            call gdf_read_data(hin,din,error)
            if (error) return
            nvisi = hin%trc(2)-hin%blc(2)+1
            !
            ! Nstokes x Nchan channels
            call stokes_derive(din,dou,nvisi,nlead,natom,nchan,ns,intrail,istoke,astoke,ipara)
            !
            hou%trc(2) = hou%blc(2)+multi*nvisi-1
            call gdf_write_data(hou,dou,error)
            hou%blc(2) = hou%trc(2)+1
            !
          enddo ! Block
          !
        else
          call map_message(seve%e,rname,'Cannot extract '//mystoke// &
          ' from '//stokes_name(astoke(1))//stokes_name(astoke(2))//stokes_name(astoke(3))// &
          ' and '//stokes_name(astoke(4)) )
          error = .true.
          return
        endif
      else
        call map_message(seve%i,rname,'Extracting '//mystoke// &
          ' from '//stokes_name(astoke(1))//stokes_name(astoke(2))//stokes_name(astoke(3))// &
          ' and '//stokes_name(astoke(4)))
        !
        hou%gil%dim(1) = hin%gil%dim(1)-3*hin%gil%nchan*hin%gil%natom
        extract = .true.
        !
        ! Shift the trailing columns
        do i=1,code_uvt_last
          if (hou%gil%column_pointer(i).gt.hin%gil%fcol) then
            hou%gil%column_pointer(i) =  hou%gil%column_pointer(i) - &
              & 3 * hin%gil%natom * hin%gil%nchan
          endif
        enddo
      endif
    endif
    !
    ! The extraction code makes no assumption about the Stokes order at all.
    if (extract) then
      !
      call gdf_create_image(hou,error)
      if (error) return
      !
      allocate (dou(hou%gil%dim(1),nblock),din(hin%gil%dim(1),nblock),stat=ier)
      if (ier.ne.0) then
        call map_message(seve%e,rname,'Memory allocation error ')
        error = .true.
        return
      endif
      hin%blc = 0
      hou%trc = 0
      !
      hou%blc(2) = 1
      do iloop = 1,hin%gil%dim(2),nblock
        hin%blc(2) = iloop
        hin%trc(2) = min(iloop+nblock-1,hin%gil%dim(2))
        kv = hin%trc(2)-hin%blc(2)+1
        call gdf_read_data(hin,din,error)
        if (error) return
        !
        call stokes_extract(hin%gil%order,din,dou,kv,nlead,natom,nchan,ns,intrail,ivisi)
        !
        hou%trc(2) = hou%blc(2)+kv-1
        call gdf_write_data(hou,dou,error)
        hou%blc(2) = hou%trc(2)+1
      enddo
    endif
    call gdf_close_image(hou,error)
  endif
  !
end subroutine sub_splitpolar
!
subroutine stokes_extract(inorder,din,dou,nvisi,nlead,natom,nchan,nstok,ntrail,ivisi)
  use image_def
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !
  ! Support routine for STOKES command: extract the relevant
  ! Stokes parameter from the input visibilities. 
  !---------------------------------------------------------------------  
  real(kind=4), intent(in) :: din(:,:)
  real(kind=4), intent(out) :: dou(:,:)
  integer, intent(in) :: inorder ! Code order
  integer, intent(in) :: nvisi  ! number of visibilities
  integer, intent(in) :: nlead  ! number of leading columns
  integer, intent(in) :: natom  ! Atomic length of a visibility (2 or 3)
  integer, intent(in) :: nchan  ! number of channels
  integer, intent(in) :: nstok  ! number of input Stokes
  integer, intent(in) :: ntrail ! number of trailing columns
  integer, intent(in) :: ivisi  ! Pointer into Stokes parameter
  !
  integer :: iv
  integer :: ic
  integer :: kin, kou
  !
  if (inorder.eq.code_chan_stok) then
    ! Nchan X Nstokes channels
    do iv = 1,nvisi
      dou(1:nlead,iv) = din(1:nlead,iv)
      dou(nlead+1:nlead+natom*nchan,iv) = &
      & din(nlead+1+(ivisi-1)*natom*nchan:nlead+ivisi*natom*nchan,iv)
      if (ntrail.gt.0) dou(1+nlead+natom*nchan:,iv) = din(nlead+1+nstok*natom*nchan:,iv)
    enddo
  else
    ! Nstokes x Nchan channels
    do iv = 1,nvisi 
      dou(1:nlead,iv) = din(1:nlead,iv)
      kin = nlead+(ivisi-1)*natom
      kou = nlead
      do ic=1,nchan
        dou(kou+1:kou+natom,iv) = din(kin+1:kin+natom,iv)
        kou = kou + natom
        kin = kin + nstok*natom
      enddo
      if (ntrail.gt.0) dou(1+nlead+natom*nchan:,iv) = din(nlead+1+nstok*natom*nchan:,iv)
    enddo
  endif
end subroutine stokes_extract
!
subroutine stokes_derive(din,dou,nvisi,nlead,natom,nchan,nstok,ntrail, &
  & istoke,astoke,ipara)
  use image_def
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !
  ! Support routine for STOKES command: Derive the relevant
  ! Stokes parameter from the input visibilities. This routine works
  ! for code_stoke_chan order, and 2 or 4 input Stokes parameters.
  ! Not all combinations are allowed, however.
  !---------------------------------------------------------------------  
  real(kind=4), intent(in) :: din(:,:)
  real(kind=4), intent(out) :: dou(:,:)
  integer, intent(in) :: nvisi  ! Number of visibilities
  integer, intent(in) :: nlead  ! number of leading columns
  integer, intent(in) :: natom  ! Atomic length of a visibility (2 or 3)
  integer, intent(in) :: nchan  ! number of channels
  integer, intent(in) :: nstok  ! number of input Stokes
  integer, intent(in) :: ntrail ! number of trailing columns
  integer, intent(in) :: istoke ! desired Stokes parameter
  integer, intent(in) :: astoke(nstok)   ! Input Stokes parameters
  integer, intent(in) :: ipara ! Parallactic angle column
  !
  integer, parameter :: code_stokes_all=100
  integer, parameter :: code_stokes_any=-100
  !
  integer :: iv, jv
  integer :: kin, kou
  integer :: ic, ip, is
  real :: re, im, we, da, db
  integer :: iend, oend, multi
  real :: hh(2), hv(2), vv(2), vh(2), aa(2), bb(2), xx, yy
  logical :: debug=.false.
  !
  iend = ubound(din,1)
  oend = ubound(dou,1)
  !
  if (debug) then
    Print *, 'NVISI ', nvisi  ! Number of visibilities
    Print *, 'NLEAD ', nlead  ! number of leading columns
    Print *, 'NATOM ', natom  ! Atomic length of a visibility (2 or 3)
    Print *, 'NCHAN ', nchan  ! number of channels
    Print *, 'NSTOK ', nstok  ! number of input Stokes
    Print *, 'NTRAIL ', ntrail ! number of trailing columns
    Print *, 'ISTOKE ', istoke ! desired Stokes parameter
    Print *, 'ASTOKE ', astoke(nstok)   ! Input Stokes parameters
    Print *, 'IPARA ', ipara ! Parallactic angle column
    Print *,'Iend ',iend,' Oend ',oend
  endif
  !
  if (istoke.eq.code_stokes_all) then
    multi = nstok
    oend = oend-1
  else
    multi = 1
  endif
  !
  jv = 0
  select case(istoke)
  !
  case (code_stokes_none)  
    ! Stokes NONE: Unpolarized case - optimize sensitivity
    jv = 0
    do iv = 1,nvisi
      jv = jv+1
      dou(1:nlead,jv) = din(1:nlead,iv)
      kin = nlead
      kou = nlead
      ! 
      do ic=1,nchan
        if (natom.eq.3) then ! Real, Image, Weight
          if (din(kin+3,iv).gt.0) then
            re = din(kin+1,iv) * din(kin+3,iv)
            im = din(kin+2,iv) * din(kin+3,iv)
            we = din(kin+3,iv)
          else
            re = 0
            im = 0
            we = 0
          endif
          kin = kin+natom
          if (din(kin+3,iv).gt.0) then
            re = re + din(kin+1,iv) * din(kin+3,iv)
            im = im + din(kin+2,iv) * din(kin+3,iv)
            we = we + din(kin+3,iv)
          endif
          if (we.ne.0) then
            dou(kou+1:kou+1,jv) = re/we
            dou(kou+2:kou+2,jv) = im/we
            dou(kou+3:kou+3,jv) = we
          else
            dou(kou+1:kou+3,jv) = 0
          endif
          !
        else if (natom.eq.2) then
          ! Only Real Weight
          if (din(kin+2,iv).gt.0) then
            re = din(kin+1,iv) * din(kin+2,iv)
            we = din(kin+2,iv)
          else
            re = 0
            we = 0
          endif
          kin = kin+natom
          if (din(kin+2,iv).gt.0) then
            re = re + din(kin+1,iv) * din(kin+2,iv)
            we = we + din(kin+2,iv)
          endif
          if (we.ne.0) then
            dou(kou+1:kou+1,jv) = re/we
            dou(kou+2:kou+2,jv) = we
          else
            dou(kou+1:kou+2,jv) = 0
          endif
        endif
        ! Skip the HV and VH or LR and RL values
        kin = kin + (nstok-2)*natom
        !
        kou = kou + natom
        kin = kin + natom
      enddo
      !
      ! Fill trailing columns
      if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
           din(nlead+1+nstok*natom*nchan:iend,iv)
    enddo
  case (code_stokes_i)
    ! Stokes I
    ! Stokes I is strictly Stokes I, i.e.   (HH+VV)/2 or (LL+RR)/2, not
    ! an arbitray weighted combination.
    ! For unpolarized signals, to maximize sensitivity, use Stokes NONE
    do iv=1,nvisi
      jv = jv+1
      dou(1:nlead,jv) = din(1:nlead,iv)
      kin = nlead
      kou = nlead
      !
      do ic=1,nchan
        if (din(kin+natom,iv).gt.0)  then
          dou(kou+1:kou+natom,jv) = din(kin+1:kin+natom-1,iv)  ! Visib
          da = 1.0/din(kin+natom,iv) ! Noise**2
          ip = 1
        else
          da = 0.0
          ip = 0
        endif
        kin = kin+natom
        if (din(kin+natom,iv).gt.0)  then
          dou(kou+1:kou+natom-1,jv) = dou(kou+1:kou+natom-1,jv) + &
            din(kin+1:kin+natom-1,iv)
          db = 1.0/din(kin+natom,iv)  ! Noise**2
          ip = ip+1
        else
          db = 0.0
        endif
        if (ip.eq.2) then
          dou(kou+1:kou+natom-1,jv) = dou(kou+1:kou+natom-1,jv) / ip
          dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
        else
          dou(kou+natom,jv) = 0.0
        endif
        ! Skip the HV and VH or LR and RL values
        kin = kin + (nstok-2)*natom
        !
        kou = kou + natom
        kin = kin + natom
      enddo
      !
      ! Fill trailing columns
      if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
           din(nlead+1+nstok*natom*nchan:iend,iv)
    enddo
    !
  case (code_stokes_V)
    ! Stokes V is -j(HV-VH)/2 or (LL-RR)/2
    ! a proper test on ordering would be good.
    !
    ! Natom must be 3 in this case (we need complex numbers)
    if ( (astoke(3).eq.code_stokes_hv).and.(astoke(4).eq.code_stokes_vh) ) then
      ! We only support HH VV HV VH order for the time being
      do iv=1,nvisi
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead
        kou = nlead
        !
        kin = kin+2*natom ! Skipp HH and VV 
        !
        do ic=1,nchan
          if (din(kin+natom,iv).gt.0)  then
            HV(1:2) = din(kin+1:kin+natom-1,iv)  
            da = 1.0/din(kin+natom,iv) ! Noise**2
            ip = 1
          else
            da = 0.0
            ip = 0
          endif
          kin = kin+natom
          if (din(kin+natom,iv).gt.0)  then
            VH(1:2) = din(kin+1:kin+natom-1,iv)
            db = 1.0/din(kin+natom,iv)  ! Noise**2
            ip = ip+1
          else
            db = 0.0
          endif
          if (ip.eq.2) then
            dou(kou+1:kou+1,jv) = -(hv(2)-vh(2))/2          
            dou(kou+2:kou+2,jv) =  (hv(1)-vh(2))/2
            dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
          else
            dou(kou+natom,jv) = 0.0
          endif
          !
          kou = kou + natom
          kin = kin + natom
        enddo
        !
        ! Fill trailing columns
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
      enddo
      !
    else
      Print *,'Ordering ',astoke,' not supported'
    endif    
    !  
  case (code_stokes_Q,code_stokes_U)
    ! Stokes Q and U are more complex
    ! they require the parallactic angle and HH,VV,HV,VH order
    ! a proper test on ordering would be good.
    !
    ! Natom must be 3 in this case (we need complex numbers)
    if ( (astoke(1).eq.code_stokes_hh).and.(astoke(2).eq.code_stokes_vv) .and. & 
      &  (astoke(3).eq.code_stokes_hv).and.(astoke(4).eq.code_stokes_vh) ) then
      !
      ! We only support HH VV HV VH order for the time being
      if (ipara.eq.0) then
        Print *,'No parallactic angle column '
        return
      endif
      !
      ! compute aa = (HH-VV)/2   and bb = (HV+VH)/2
      ! then
      !  Q = aa cos(2.phi) - bb sin(2.phi)
      !  U = aa sin(2.phi) + bb cos(2.phi)
      do iv=1,nvisi
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead
        kou = nlead
        !
        if (istoke.eq.code_stokes_q) then
          xx =  cos(2*din(ipara,iv))
          yy = -sin(2*din(ipara,iv))
        else
          xx = sin(2*din(ipara,iv))
          yy = cos(2*din(ipara,iv))
        endif
        !
        do ic=1,nchan
          if (din(kin+natom,iv).gt.0)  then
            HH(1:2) = din(kin+1:kin+natom-1,iv)  
            da = 1.0/din(kin+natom,iv) ! Noise**2
            ip = 1
          else
            da = 0.0
            ip = 0
          endif
          kin = kin+natom
          if (din(kin+natom,iv).gt.0)  then
            VV(1:2) = din(kin+1:kin+natom-1,iv)
            db = 1.0/din(kin+natom,iv)  ! Noise**2
            ip = ip+1
          endif
          kin = kin+natom
          if (din(kin+natom,iv).gt.0)  then
            HV(1:2) = din(kin+1:kin+natom-1,iv)
            ip = ip+1
          endif
          kin = kin+natom
          if (din(kin+natom,iv).gt.0)  then
            VH(1:2) = din(kin+1:kin+natom-1,iv)
            ip = ip+1
          endif
          !
          aa = (HH-VV)/2
          bb = (HV+VH)/2
          !
          if (ip.eq.4) then
            dou(kou+1:kou+2,jv) = xx*aa + yy*bb
            dou(kou+natom,jv) = 4.0/(da+db)   ! Weight = 1/noise^2
          else
            dou(kou+natom,jv) = 0.0
          endif
          !
          kou = kou + natom
          kin = kin + natom
        enddo
        !
        ! Fill trailing columns
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
      enddo
      !
    elseif ( (astoke(1).eq.code_stokes_rr).and.(astoke(2).eq.code_stokes_ll) .and. & 
      &  (astoke(3).eq.code_stokes_rl).and.(astoke(4).eq.code_stokes_lr) ) then
      Print *,'Ordering ',astoke,' not (yet) supported'
    else
      Print *,'Ordering ',astoke,' not supported'
    endif    
    !  
  case (code_stokes_all)
    ! Stokes ALL : explodes the Stokes / Channel visibilities
    ! into one visibility per Stokes. Add the Stokes column at
    ! end of each Visibility.  
    do iv=1,nvisi
      do is=1,nstok
        jv = jv+1
        dou(1:nlead,jv) = din(1:nlead,iv)
        kin = nlead
        kou = nlead
        do ic=1,nchan
          dou(kou+1:kou+natom,jv) = din(kin+1:kin+natom,iv)
          kou = kou + natom
          kin = kin + 2*natom
        enddo
        if (ntrail.gt.0) dou(1+nlead+natom*nchan:oend,jv) = &
             din(nlead+1+nstok*natom*nchan:iend,iv)
        dou(oend+1,jv) = astoke(is)
      enddo
    enddo
  end select
  !
  ! Sanity check
  if (jv.ne.multi*nvisi) then
    write(*,*) 'E-STOKES, ','Expecting up to ',nvisi,' visibilities, found ',jv
  endif
end subroutine stokes_derive

subroutine alma_clean (line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>alma_clean
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER:  Internal routine
  !     Implementation of a Clean Method for Multi-Array
  !     Mosaic observations
  !----------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  !
  real, allocatable :: tfbeam(:,:,:)
  real, allocatable :: c_tfbeam(:,:,:)
  !
  integer ier, ipen, nx, ny, np, mx, my, mp
  logical limits
  real ylimn,ylimp,fact
  integer iv,na,imethod,nlong
  character(len=8) :: name,argum,voc1(2),voc2(3)
  character(len=4) :: rname = 'ALMA'
  ! Data
  data voc1/'CLEAN','RESIDUAL'/
  data voc2/'CLARK','HOGBOM','SDI'/
  !
  ! Data checkup
  call clean_data (error)
  if (error) return
  call compact_data (error)
  if (error) return
  !
  argum = 'SDI'
  call sic_ke (line,5,1,argum,na,.false.,error)
  if (error) return
  call sic_ambigs (rname,argum,name,imethod,voc2,3,error)
  if (error) return
  !
  ! Get the noise and/or relative weights of the two images
  !
  if (hdirty%gil%rms.ne.0) hdirty%gil%noise = hdirty%gil%rms
  if (c_hdirty%gil%rms.ne.0) c_hdirty%gil%noise =   &
       &    c_hdirty%gil%rms
  if (hdirty%gil%noise.eq.0 .or. c_hdirty%gil%noise.eq.0) then
     if (sic_present(4,0)) then
        call sic_r4(line,4,1,hdirty%gil%noise,.true.,error)
        if (error) return
        call sic_r4(line,4,2,c_hdirty%gil%noise,.true.,error)
        if (error) return
     else
        call map_message(seve%w,rname,'No relative noise information')
        call map_message(seve%w,rname,'Use option /NOISE to indicate it')
        error = .true.
        return
     endif
  else
     if (sic_present(4,0)) then
        call sic_r4(line,4,1,fact,.true.,error)
        if (error) return
        hdirty%gil%noise = fact * hdirty%gil%noise
        call sic_r4(line,4,2,fact,.true.,error)
        if (error) return
        c_hdirty%gil%noise = fact * c_hdirty%gil%noise
     endif
  endif
  !
  ! Parameter Definitions
  user_method%method = 'CLARK'
  c_method%search = cuse_method%search
  c_method%trunca = cuse_method%trunca
  call copy_param(user_method,cuse_method)
  cuse_method%search = c_method%search
  cuse_method%restor = user_method%restor
  cuse_method%trunca = c_method%trunca
  call beam_unit_conversion(cuse_method)
  call copy_method(cuse_method,c_method)
  call beam_unit_conversion(user_method)
  call copy_method(user_method,method)
  ! A voir
  method%pflux = sic_present(1,0)
  method%pcycle = sic_present(2,0)
  method%qcycle = sic_present(3,0)
  if (method%pcycle) then
     argum = 'RESIDUAL'
     call sic_ke (line,2,1,argum,na,.false.,error)
     if (error) return
     call sic_ambigs ('PLOT',argum,name,iv,voc1,2,error)
     if (error) return
     method%pclean = iv.eq.1
  else
     method%pclean = .false.
  endif
  !
  call sic_get_inte('FIRST',method%first,error)
  call sic_get_inte('LAST',method%last,error)
  call sic_i4(line,0,1,method%first,.false.,error)
  call sic_i4(line,0,2,method%last,.false.,error)
  if (method%first.eq.0) method%first = 1
  if (method%last.eq.0) method%last = hdirty%gil%dim(3)
  method%first = max(1,min(method%first,hdirty%gil%dim(3)))
  method%last = max(method%first,min(method%last,hdirty%gil%dim(3)))
  !
  nlong = 0
  call sic_get_inte('NLONG',nlong,error)
  c_method%n_major = nlong
  !
  call check_area(method,hdirty,.false.)
  call check_mask(method,hdirty)
  user_method%do_mask = method%do_mask
  ! Compact array
  c_method%do_mask = .true.
  call check_area(c_method,c_hdirty,.false.)
  call check_mask(c_method,c_hdirty)
  cuse_method%do_mask = c_method%do_mask
  c_method%pflux = sic_present(1,0)
  c_method%pcycle = sic_present(2,0)
  c_method%qcycle = sic_present(3,0)
  !
  ! Set the pointers for use in subroutines
  hdirty%r3d => ddirty
  hclean%r3d => dclean
  hbeam%r4d  => dbeam
  hresid%r3d => dresid
  hprim%r4d  => dprim
  !
  ! Compact Array version
  c_hdirty%r3d => c_ddirty
  c_hclean%r3d => c_dclean
  c_hresid%r3d => c_dresid
  c_hbeam%r3d => c_dbeam
  c_hprim%r3d => c_dprim
  !
  limits = sic_present(1,0)
  if (limits) then
     call sic_r4 (line,1,1,ylimn,.true.,error)
     if (error) return
     call sic_r4 (line,1,2,ylimp,.true.,error)
     if (error) return
  else
     ylimp = sqrt (float(method%m_iter+200) *   &
          &      log(float(method%m_iter+1)) ) * method%gain
     if (-hdirty%gil%rmin.gt.1.3*hdirty%gil%rmax) then
        ! Probably negative
        ylimn = ylimp*hdirty%gil%rmin
        ylimp = 0.0
     elseif (-1.3*hdirty%gil%rmin.gt.hdirty%gil%rmax) then
        ! Probably positive
        ylimn = 0.0
        ylimp = ylimp*hdirty%gil%rmax
     else
        ! Do not know...,
        ylimn = ylimp*hdirty%gil%rmin
        ylimp = ylimp*hdirty%gil%rmax
     endif
  endif
  ! Usefull variables
  nx = hdirty%gil%dim(1)
  ny = hdirty%gil%dim(2)
  np = hprim%gil%dim(1)
  mx = c_hdirty%gil%dim(1)
  my = c_hdirty%gil%dim(2)
  mp = c_hprim%gil%dim(1)
  !
  ! Clean Component Structure
  if (allocated(tcc)) then
     deallocate(tcc)
  endif
  allocate(tcc(method%m_iter),stat=ier)
  !
  ! Beam patch according to Method
  if (user_method%patch(1).ne.0) then
     method%patch(1) = min(user_method%patch(1),nx)
  else
     method%patch(1) = min(nx,max(32,nx/4))
  endif
  if (user_method%patch(2).ne.0) then
     method%patch(2) = min(user_method%patch(2),ny)
  else
     method%patch(2) = min(ny,max(32,ny/4))
  endif
  !
  if (cuse_method%patch(1).ne.0) then
     c_method%patch(1) = min(cuse_method%patch(1),mx)
  else
     c_method%patch(1) = min(mx,max(32,mx/4))
  endif
  if (cuse_method%patch(2).ne.0) then
     c_method%patch(2) = min(cuse_method%patch(2),my)
  else
     c_method%patch(2) = min(my,max(32,my/4))
  endif
  !
  ! Beam Fourier Transform
  allocate(tfbeam(nx,ny,np),c_tfbeam(mx,my,mp),stat=ier)
  !
  ! Number of compact components per cycle
  call sic_get_inte ('C_GOAL',c_method%ngoal,error)
  !
  if (method%pflux)  &
     call init_flux90(method,hdirty,ylimn,ylimp,ipen)
  !
  method%bzone(1:2) = 1
  method%bzone(3:4) = hdirty%gil%dim(1:2)
  c_method%bzone(1:2) = 1
  c_method%bzone(3:4) = c_hdirty%gil%dim(1:2)
  !
  if (imethod.eq.1) then
     call sub_alma (   &
          &      method,hdirty,hresid,hclean,hbeam,   &
          &      hprim,tfbeam,d_list,   &
          &      c_method,c_hdirty,c_hresid,c_hclean,c_hbeam,   &
          &      c_hprim,c_tfbeam,c_list,   &
          &      error,tcc)
  elseif  (imethod.eq.2) then
     call sub_alma_quad (   &
          &      method,hdirty,hresid,hclean,hbeam,   &
          &      hprim,tfbeam,d_list,   &
          &      c_method,c_hdirty,c_hresid,c_hclean,c_hbeam,   &
          &      c_hprim,c_tfbeam,c_list,   &
          &      error,tcc)
  elseif  (imethod.eq.3) then
     call sub_alma_ter (   &
          &      method,hdirty,hresid,hclean,hbeam,   &
          &      hprim,tfbeam,d_list,   &
          &      c_method,c_hdirty,c_hresid,c_hclean,c_hbeam,   &
          &      c_hprim,c_tfbeam,c_list,   &
          &      error,tcc)
  endif
  !
  ! Restore the Compact Beam Pointer
  c_hbeam%r3d => c_dbeam
  !
  if (method%pflux) then
    call close_flux90(ipen,error)
  else
    call gr_execl('CHANGE DIRECTORY <GREG')
  endif
  !
  ! Reset extrema
  hresid%gil%extr_words = 0
  hclean%gil%extr_words = 0
  !
  ! Specify clean beam parameters
  hclean%gil%reso_words = 3
  hclean%gil%majo = method%major
  hclean%gil%mino = method%minor
  hclean%gil%posa = pi*method%angle/180.0
  save_data(code_save_clean) = .true.
  !
  ! Save general parameters...
  user_method%ibeam = method%ibeam
  user_method%nlist = method%nlist
  return
  !
end subroutine alma_clean
!
subroutine compact_data(error)
  use gkernel_interfaces
  use clean_def
  use clean_arrays
  use gbl_message
  logical error
  !
  integer nx,ny,nv,ier
  logical equal
  character(len=5) :: rname = 'CLEAN'
  !
  error = .false.
  if (c_hdirty%loca%size.eq.0) then
    call map_message(seve%e,rname,'No dirty image')
    error = .true.
  endif
  if (c_hbeam%loca%size.eq.0) then
    call map_message(seve%e,rname,'No dirty beam')
    error = .true.
  endif
  if (error) return
  !
  ! Create clean image if needed
  nx = c_hdirty%gil%dim(1)
  ny = c_hdirty%gil%dim(2)
  nv = c_hdirty%gil%dim(3)
  !
  call gdf_compare_shape(c_hdirty,c_hclean,equal)
  if (.not.equal) then
    if (allocated(c_dclean)) deallocate(c_dclean,stat=ier)
    call sic_delvariable ('C_CLEAN',.false.,error)
    if (allocated(c_dresid)) deallocate(c_dresid,stat=ier)
    call sic_delvariable ('C_RESID',.false.,error)
    if (allocated(c_atten)) deallocate(c_atten,stat=ier)
    if (allocated(c_mask)) deallocate(c_mask,stat=ier)
    if (allocated(c_list)) deallocate(c_list,stat=ier)
    call sic_delvariable ('C_MASK',.false.,error)
  endif
  !
  if (.not.allocated(c_dclean)) then
    c_hclean = c_hdirty        ! Define header
    allocate(c_dclean(nx,ny,nv),stat=ier)
    call sic_def_real ('C_CLEAN',c_dclean,c_hclean%gil%ndim,   &
        &      c_hclean%gil%dim,.true.,error)
    c_hresid = c_hdirty
    allocate(c_dresid(nx,ny,nv),stat=ier)
    call sic_def_real ('C_RESID',c_dresid,c_hresid%gil%ndim,   &
        &      c_hresid%gil%dim,.true.,error)
  endif
  !
  if (.not.allocated(c_mask)) then
    allocate(c_mask(nx,ny),c_list(nx*ny),stat=ier)
    call sic_def_inte_addr ('C_MASK',c_mask,2,c_hdirty%gil%dim,   &
        &      .true.,error)
    cuse_method%do_mask = .true.
!    cuse_method%mask => c_mask
!    cuse_method%list => c_list
    cuse_method%nlist = 0
  endif
  !
  ! Allocate weight and check beam/image compatibility
  if (cuse_method%mosaic) then
    if (.not.allocated(c_atten)) then
      allocate(c_atten(nx,ny,1),stat=ier)
      if (ier.ne.0) then
        error = .true.
        return
      endif
      cuse_method%atten => c_atten
    endif
  elseif (c_hbeam%gil%dim(3).le.1) then
    continue
  elseif (c_hbeam%gil%dim(3).ne.c_hdirty%gil%dim(3)) then
    call map_message(seve%e,rname,'Inconsistent beam and image data set '//  &
        & 'or mosaic mode not set')
    error = .true.
  endif
end subroutine compact_data

module gauss_parameter
  integer(kind=4), parameter :: mxline=5
  !
  ! Initial values and Dependency codes
  real(kind=4)    :: spar(4*mxline),deltav  ! 3 for Gauss, 4 for HFS - NH3,
  integer(kind=4) :: kt0,kt(5)              ! 1,kt2,kt3,kt4,kt5
  integer(kind=4) :: kv0,kv(5)              ! 1,kv2,kv3,kv4,kv5
  integer(kind=4) :: kd0,kd(5)              ! 1,kd2,kd3,kd4,kd5
  integer(kind=4) :: ko0,ko(5)              ! 1,ko2,ko3,ko4,ko5
  integer(kind=4) :: kh0,kh(5)              !
  integer(kind=4) :: nline
  !
  ! Weights for minimization
  integer(kind=4) :: mxcan
  integer(kind=4), allocatable :: wfit(:)
  !
  ! Common containing results and errors
  integer(kind=4) :: ngline               ! Number of lines
  real(kind=4)    :: par(4*mxline)   ! Parameters
  real(kind=4)    :: err(4*mxline)   ! Errors
  real(kind=4)    :: sigbas          ! rms on baseline
  real(kind=4)    :: sigrai          ! rms on line
end module gauss_parameter
!
module hyperfine_structure
  ! HFS and NH3 line fitting
  integer(kind=4), parameter    :: mhyp=40
  integer(kind=4)               :: nhyp
  real(kind=4), dimension(mhyp) :: rhfs
  real(kind=4), dimension(mhyp) :: vhfs
  real(kind=4), save            :: hfs_tau_min=0.1
  real(kind=4), save            :: hfs_tau_max=100.0
end module hyperfine_structure
!
module pointing_fit
  real(kind=4) :: width
  real(kind=4) :: aratio
  real(kind=4) :: wratio
end module pointing_fit

!
subroutine uv_residual(line,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>uv_residual
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !------------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER   Support for routine UV_RESIDUAL [FIELDS List]
  !     Remove all Clean Components from a UV Table
  !
  ! Input :
  !     a precessed UV table
  !     a list of Clean Components, in DCCT format
  !      i.e. (x,y,v)(iplane,icomponent)
  !     this organisation is not efficient, and one may need to switch to
  !           (x,y,v,)(icomponent,iplane)
  !     which is more easily transmitted
  ! Output :
  !     a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !
  !------------------------------------------------------------------------
  character(len=*), intent(inout) :: line
  logical, intent(out) :: error
  !
  integer, parameter :: o_field=1
  !
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  character(len=*), parameter :: task='UV_RESIDUAL'
  logical do_weight
  !
  nullify(duv_previous,duv_next)
  !
  ! Do the job. The .false. means do not re-image with Clean 
  ! components added.
  call sub_uv_residual(task,line,duv_previous,duv_next,.false.,error)
  if (error) return
  !
  ! Clean the allocated stuff here to keep only the residual...
  call uv_clean_buffers (duv_previous, duv_next, error)
  if (error) return
  !
  ! Resize UV data and redefine SIC variables 
  huv%gil%nvisi = ubound(duv,2)
  huv%gil%dim(2) = huv%gil%nvisi
  !
  do_weight = sic_present(o_field,0)
  call uv_new_data(weight=do_weight)  ! Re-compute weight if needed
end subroutine uv_residual
!
subroutine sub_uv_residual(task,line,duv_previous,duv_next,do_clean,error)
  use gkernel_interfaces
  use imager_interfaces, except_this=>sub_uv_residual
  use clean_def
  use clean_arrays
  use clean_types
  use clean_default
  use gbl_message
  !$ use omp_lib
  !------------------------------------------------------------------------
  ! @ private
  !
  ! IMAGER   Support for routine UV_RESIDUAL
  !     Remove all Clean Components from a UV Table
  !
  ! Input :
  !     a precessed UV table
  !     a list of Clean Components, in DCCT format
  !      i.e. (x,y,v)(iplane,icomponent)
  !     this organisation is not efficient, and one may need to switch to
  !           (x,y,v,)(icomponent,iplane)
  !     which is more easily transmitted
  ! Output :
  !     a precessed, rotated, shifted UV table, sorted in V,
  !     ordered in (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  !
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: task
  character(len=*), intent(inout) :: line
  real, pointer, intent(out) :: duv_previous(:,:)
  real, pointer, intent(out) :: duv_next(:,:)
  logical, intent(in) :: do_clean
  logical, intent(out) :: error
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: f_to_k = 2.d0*pi/299792458.d-6
  integer, parameter :: o_field=1
  ! Minimum number of Visibilities to activate the FFT mode
  integer, parameter :: fft_mode=20000 
  !
  real(8) :: freq
  character(len=message_length) :: chain
  real :: cpu0, cpu1
  integer :: ier,nu,nv,mv,nchan
  !
  real, pointer :: duv_in(:,:), duv_out(:,:)
  real, allocatable, target :: ccou(:,:,:)
  real, pointer  :: fcou(:,:,:)
  integer, allocatable :: omic(:), nmic(:)
  integer :: maxic, ic,lc, icmax, oic, olc, iv
  integer :: nthread, ithread, np
  logical :: fft, debug
  real(8) :: elapsed_s, elapsed_e, elapsed
  !
  ! For mosaics
  type(projection_t) :: proj
  real(8) :: pos(2)
  real(8), parameter :: sec=3600.d0*180d0/pi
  real(4) :: bsize
  integer :: ifield, jfield, nfields! Field number & Number of fields
  real, allocatable :: doff(:,:)    ! Field offsets
  integer, allocatable :: ivoff(:)  ! Input Visibility pointers
  integer, allocatable :: jvoff(:)  ! Output Visibility pointers
  integer :: ivstart, ivend, kvstart, kvend, it
  logical :: sorted, shift
  real(8) :: new(3)
  real(4) :: uvmin, uvmax
  !
  ! Subtract all Clean Components
  if (.not.associated(duv)) then
    call map_message(seve%e,task,'DUV is NOT allocated')
    error = .true.
    return
  endif
  if (.not.allocated(dcct)) then
    call map_message(seve%e,task,'DCCT is NOT allocated')
    error = .true.
    return
  endif
  !
  if (allocated(doff)) then
    Print *,'DOFF is still allocated '
    deallocate(doff)
  endif
  if (allocated(ivoff)) then
    Print *,'IVOFF is still allocated '
    deallocate(ivoff)
  endif
  !
  ! Basic initializations
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi    ! not %dim(2)
  nchan = huv%gil%nchan !! (nu-7)/3
  !
  ic = 1
  lc = nchan
  ithread = 1
  nthread = 1
  elapsed_e = 0.
  elapsed_s = 0.
  elapsed = 0.
  debug = .false.
  call sic_get_logi('DEBUG',debug,error)
  error = .false.
  !
  ! Verify number of channels match
  if (hcct%gil%dim(2).ne.huv%gil%nchan) then
    write(chain,'(A,I0,A,I0,A)') 'Number of channels in CCT [', &
    & hcct%gil%dim(2),'] and in UV [',huv%gil%nchan,'] do not match'
    call map_message(seve%e,task,chain)
    error = .true.
    return
  endif  
  !
  maxic = hcct%gil%dim(3)
  call sic_i4(line,0,1,maxic,.false.,error)
  if (error) return
  if (maxic.lt.0) maxic = hcct%gil%dim(3)
  maxic = min(hcct%gil%dim(3),maxic)
  if (maxic.eq.0) return ! Nothing to do then...
  !
  allocate (omic(nchan),nmic(nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Compact the Clean components first
  hcct%r3d => dcct
  call uv_clean_sizes(hcct,hcct%r3d,omic,ic,lc)
  icmax = maxval(omic)
  if (debug) Print *,'Max number of clean components ',icmax
  !
  ! Nothing to do if no Clean component
  if (icmax.eq.0) then
    call map_message(seve%w,task,'No valid Clean Component')
    return
  endif  
  !
  call gag_cpu(cpu0)
  !
  if (themap%nfields.ne.0) then
    !
    ! Mosaic case
    nfields = abs(themap%nfields)
    allocate(doff(2,nfields),ivoff(nfields+1),jvoff(nfields+1),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Memory allocation error')
      error = .true.
      return
    endif
    shift = .false.
    sorted = .false.
    error = .false.
    if (debug) Print *,'Sorting Mosaic ',themap%nfields, &
      & huv%gil%column_pointer(code_uvt_xoff), &
      & huv%gil%column_pointer(code_uvt_yoff), &
      & nfields
    !
    new = 0.D0 ! No change of Phase center
    !
    call mosaic_sort (error,sorted,shift,new,uvmax,uvmin, &
      & huv%gil%column_pointer(code_uvt_xoff), &
      & huv%gil%column_pointer(code_uvt_yoff), &
      & nfields,doff,ivoff)
    if (error) return
    if (debug) Print *,'Nfields ',nfields
    !
    ! Shift offset coordinates to Phase center 
    call gwcs_projec(huv%gil%a0,huv%gil%d0,huv%gil%pang,huv%gil%ptyp,proj,error)
    if (debug) Print *,'Posangle ',huv%gil%pang
    ! POS is here the Offset of the Pointing center relative to the Phase center
    call abs_to_rel (proj,huv%gil%ra,huv%gil%dec,pos(1),pos(2),1)
    if (debug) Print *,'POS ',pos
    do ifield=1,nfields
      doff(:,ifield) = doff(:,ifield)+pos
      if (debug) Print *,doff(1,ifield)*sec, doff(2,ifield)*sec
    enddo
    !
    ! Get primary beam size
    call get_bsize(huv,task,' ',bsize,error)
    if (debug) Print *,'Primary beam size ',bsize*sec
    !
    ! For tests per field - not useable in production
    if (task.eq.'UV_RESIDUAL'.and.sic_present(o_field,0)) then
      call select_fields(task,line,o_field,nfields,np,error)
      if (error) return
    endif
    !
    if (selected_fieldsize.ne.0) then
      if (.not.allocated(selected_fields)) then
        call map_message(seve%f,task, &
          & 'Programming error, Selected_Fields not allocated')
        error = .true.
        return
      endif
      if (debug) Print *,'Selected Fields ',selected_fields(1:selected_fieldsize) !!
      nv = 1
      mv = 0
      do jfield=1,selected_fieldsize
        ifield = selected_fields(jfield)
        jvoff(jfield) = nv
        mv = max(ivoff(ifield+1)-ivoff(ifield),mv)
        nv = nv + ivoff(ifield+1)-ivoff(ifield)
        jvoff(jfield+1) = nv
      enddo
      nv = nv-1
      nfields = selected_fieldsize
    else
      jvoff(:) = ivoff
      mv = 0
      do ifield=1,nfields
        mv = max(ivoff(ifield+1)-ivoff(ifield),mv)
      enddo
    endif
  else
    nfields = 1
    mv = nv
    allocate(doff(2,1),ivoff(2),jvoff(2),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Memory allocation error')
      error = .true.
      return
    endif
    doff = 0.0
    bsize = 0.
    ivoff(1) = 1
    ivoff(2) = nv+1
    jvoff(:) = ivoff
    !
    if (debug) Print *,'Single Field case'
  endif 
  !
  ! Select the FFT or DIRECT mode by default, according to the
  ! problem size. This may need to be tested in more details
  if (mv.lt.fft_mode) then
    fft = .false.
  else
    fft = .true.
  endif
  !! Print *,'Default FFT ',fft, mv
  call sic_get_logi('FAST',fft,error)
  !! Print *,'User set FFT ',fft, error
  error = .false.
  !
  ! Prepare appropriate array...
  nullify (duv_previous, duv_next)
  call uv_find_buffers (task,nu,nv,duv_previous, duv_next,error)
  if (error) then
    call map_message(seve%e,task,'Cannot set buffer pointers')
    return
  endif
  !!Print *,'Found buffers',nu,nv
  !
  ! Redo that by block - At this stage NFIELDS is the actual number
  ! of selected fields.
  !
  oic = ic    ! This must be 1
  olc = lc    ! This must be nchan
  !
  ! Spatially compress the Clean Component List
  allocate(ccou(3,icmax,nchan),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,task,'Memory allocation error')
    error = .true.
    return
  endif
  if (debug) Print *,'uv_squeeze_clean ',nchan,omic,ic,lc
  call uv_squeeze_clean(nchan,hcct%r3d,ccou, omic,ic,lc)
  ! 
  ! Remember the Full Clean Component List size
  nmic(:) = omic
  !
  if (bsize.ne.0) then
    maxic = maxval(omic)
    write(chain,'(A,I0,A,I0,A)') 'Compressing CCT from ',icmax,' to ',maxic,' components'
    call map_message(seve%i,task,chain)
    allocate(fcou(3,maxic,nchan),stat=ier)
    if (ier.ne.0) then
      call map_message(seve%e,task,'Memory allocation error')
      error = .true.
      return
    endif
  else
    fcou => ccou
  endif
  freq = gdf_uv_frequency(huv,0.5d0*(ic+lc))
  !
  if (debug) Print *,'LCOL ',huv%gil%lcol,' and DIM ',huv%gil%dim(1)
  !
  ! Simple sequential stuff - parallelism is inside the
  !   uv_remove_...  subroutines to avoid memory issues
  ! Unfortunately, this parallelism is only efficient if
  ! the number of visibilities is sufficient.
  !
  ! So a mode with per-field parallelism would be good.
  ! But one has to be careful about IC and LC
  !
  if (debug) Print *,'IC LC ',ic,lc,' OIC OLC ',oic,olc
  !
  do jfield=1,nfields
    if (sic_ctrlc()) then
      call map_message(seve%w,task,'Aborted by user ^C')
      error = .true.
      return
    endif
    !
    ifield = jfield
    if (selected_fieldsize.ne.0) ifield = selected_fields(jfield)
    if (debug) Print *,'Field ',ifield,jfield
    !
    ! This looks tricky, but is working.
    ! It used to extract an arbitrary subset of all fields
    ! In input Ifield
    ivstart = ivoff(ifield)      ! Starting Visibility of field
    ivend   = ivoff(ifield+1)-1  ! Ending Visibility of field
    ! In output Jfield
    kvstart = jvoff(jfield)      ! Starting Visibility of field
    kvend   = jvoff(jfield+1)-1  ! Ending Visibility of field
    write(chain,'(A,I0,4(1X,I0),2F10.2)') 'Processing field # ',ifield, &
      & ivstart,ivend, kvstart, kvend, doff(1,ifield)*sec, doff(2,ifield)*sec
    call map_message(seve%i,task,chain)
    !
    nv = ivend-ivstart+1
    if (ivend.gt.ubound(duv,2)) then
      Print *,'Programming error IVEND',kvend,' > Bound ',ubound(duv,2)
    endif
    duv_in => duv(:,ivstart:ivend)
    if (kvend.gt.ubound(duv_next,2)) then
      Print *,'Programming error KVEND',kvend,' > Bound ',ubound(duv_next,2)
    endif
    duv_out => duv_next(:,kvstart:kvend)
    !
    if (bsize.ne.0) then
      omic(:) = nmic(:)   ! Restart from un-attenuate Clean Component List size
      call attenuate_clean(nchan,ccou,doff(:,ifield),bsize,fcou,omic)
      if (debug) then
        do it=1,min(10,omic(1))
          Print *,it,ccou(1:3,it,1),fcou(1:3,it,1),omic(1),nmic(1)
        enddo
      endif
    endif
    !
    if (.not.fft) then
      if (debug) Print *,'Slow case IC ',ic,' LC ',lc,' OMIC ',omic
      call uv_removes_clean(nv,duv_in,duv_out,lc-ic+1,omic, &
        & fcou,freq,ic,lc)
      if (debug) Print *,'Done Slow ',ifield  
    else
      if (debug) Print *,'Fast case '
      call uv_removef_clean(hcct,duv_in,duv_out,lc-ic+1,omic, &
        & fcou,freq,ic,lc)
      if (debug) Print *,'Done Fast ',ifield  
    endif
    !
    ! Add leading and trailing data if any
    if (debug) Print *,'NV ',nv,' Bounds ',ubound(duv_in,2),ubound(duv_out,2)
    if (huv%gil%lcol.lt.huv%gil%dim(1)) then
      do iv=1,nv
        duv_out(1:7,iv) = duv_in(1:7,iv)
        duv_out(huv%gil%lcol+1:huv%gil%dim(1),iv) = &
          & duv_in(huv%gil%lcol+1:huv%gil%dim(1),iv)  
      enddo
    else
      if (debug) Print *,'WARNING no trailing column'
      do iv=1,nv
        duv_out(1:7,iv) = duv_in(1:7,iv)
      enddo
    endif
  enddo
  !
  ! Compute the CLEAN image
  if (do_clean) then
    ! Use the Full Clean Component list size
    call generate_clean(hsky,ic,lc,ccou,nmic)
  endif
  !
  call gag_cpu(cpu1)
  if (elapsed.eq.0) then
    write(chain,102) 'Finished Residual CPU ',cpu1-cpu0
  else
    write(chain,102) 'Finished Residual Elapsed ',elapsed,'; CPU ',cpu1-cpu0
  endif
  call map_message(seve%i,task,chain)
  !
  if (associated(fcou)) then
    if (.not.associated(fcou,ccou)) deallocate(fcou)
  endif
  if (allocated(ccou)) deallocate(ccou)
  !
102 format(a,f9.2,a,f9.2)
end subroutine sub_uv_residual
!
subroutine uv_clean_size(hcct,ccin, mic)
  use image_def
  !-----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Support for UV_RESTORE
  !   Compute the actual number of components
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct  ! header of CCT data set
  real, intent(in) :: ccin(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))
  integer, intent(out) :: mic
  integer :: nc
  integer :: ni, ki, mi
  integer :: i,ic
  !
  nc = hcct%gil%dim(2)
  ni = hcct%gil%dim(3)
  !
  mi = 0
  do ic=1,nc
    ki = 0
    do i=1,ni
      if (ccin(3,ic,i).eq.0) then
        ki = i-1
        exit
      endif
    enddo
    !!!!Print *,'Channel ',ic,ki
    if (ki.ne.0) then
      mi = max(mi,ki)
    endif
  enddo
  if (mi.eq.0) mi = ni
  mic = mi
  !!!!Print *,'MIC ',mic
end subroutine uv_clean_size
!
subroutine uv_compact_clean(hcct,ccin,occt,ccou, mic)
  use image_def
  !-----------------------------------------------------------------
  ! @ private
  !
  ! MAPPING   Support for UV_RESTORE
  !   Compact the component list by summing up all values at the
  !   same position
  !-----------------------------------------------------------------
  type(gildas), intent(in) :: hcct  ! header of CCT data set
  type(gildas), intent(in) :: occt  ! header of CCT data set
  real, intent(in) :: ccin(hcct%gil%dim(1),hcct%gil%dim(2),hcct%gil%dim(3))
  real, intent(out) :: ccou(occt%gil%dim(1),occt%gil%dim(2),occt%gil%dim(3))
  integer, intent(inout) :: mic
  !
  integer nc
  integer ni
  integer :: ii,jj,ic
  integer :: ki, mi ! Number of different components per channel
  logical doit
  !
  nc = hcct%gil%dim(2)
  ni = mic ! no longer !!! hcct%gil%dim(3)
  !
  mi = 0
  ccou = 0
  !
  do ic=1,nc
    ki = 0
    do ii=1,ni
      if (ccin(3,ic,ii).eq.0) then
        exit
      else
        doit = .true.
        do jj=1,ki
          if (ccou(1,ic,jj).eq.ccin(1,ic,ii)) then
            if (ccou(2,ic,jj).eq.ccin(2,ic,ii)) then
              doit = .false.
              !!!!Print *,'Component ',ii,' relocated at ',jj
              ccou(3,ic,jj) = ccou(3,ic,jj) + ccin(3,ic,ii)
              exit
            endif
          endif
        enddo
        if (doit) then
          ki = ki+1
          !!!!Print *,'Component ',ii,' new at ',ki
          ccou(1:3,ic,ki) = ccin(1:3,ic,ii)
        endif
      endif
    enddo
    if (ki.ne.0) mi = max(mi,ki)
  enddo
  !
  mic = mi
end subroutine uv_compact_clean
!
subroutine generate_clean(hmap,first,last,ccou,mic)
  use clean_arrays
  use imager_interfaces, except_this => generate_clean
  !
  ! @ private-mandatory
  !
  type(gildas), intent(inout) :: hmap
  integer, intent(in) :: first
  integer, intent(in) :: last
  real, intent(in) :: ccou(:,:,:)  !  (x,y,Value),Component,Plane
  integer, intent(in) :: mic(:)    ! Niter per plane
  !
  type (cct_par), allocatable :: p_cct(:)
  real, pointer :: p_clean(:,:)
  integer :: iplane, jplane, niter, miter, i, ier
  !
  miter = max(1,maxval(mic))
  allocate (p_cct(miter),stat=ier)
  !
  do iplane = first, last
    method%iplane = iplane
    p_clean =>  hmap%r3d(:,:,iplane)
    !
    ! Recover the component list in pixels
    jplane = iplane-first+1
    niter = mic(jplane) 
    do i=1,niter
      if (ccou(3,i,jplane).eq.0) then
        p_cct(i)%value = 0 ! Required
        niter = i-1
        exit
      else
        !
        ! The NINT is required because of rounding errors
        p_cct(i)%ix = nint( (ccou(1,i,jplane)-hmap%gil%convert(2,1)) /  &
            &        hmap%gil%convert(3,1) + hmap%gil%convert(1,1))
        p_cct(i)%iy = nint( (ccou(2,i,jplane)-hmap%gil%convert(2,2)) /  &
            &        hmap%gil%convert(3,2) + hmap%gil%convert(1,2))
        p_cct(i)%value = ccou(3,i,jplane)
      endif
    enddo
    ! Stupid test
    if (niter.gt.0) then
      method%n_iter = niter
      call clean_make90(method,hmap,p_clean,p_cct)
    else
      p_clean = 0
    endif
  enddo
  deallocate(p_cct)
!!  hmap%file = 'toto.lmv-clean'
!!  call gdf_write_image(hmap,hmap%r3d,error)
end subroutine generate_clean
!
subroutine attenuate_clean(nchan,ccou,doff,bsize,fcou,mic)
  !---------------------------------------------------------------------
  ! @ private-mandatory
  !
  ! IMAGER
  !   Apply primary beam attenuation to Clean Components
  ! at specified offset
  !   Input   CCOU(3,Nclean,Nchan)
  !   Output  FCOU(3,Ncomp,Nchan)
  ! Ncomp is lower than Nclean: Clean components at same position
  !   have been averaged first
  ! MIC(nchan) contains the number of effective Clean Components
  ! for this channel (after attenuation).
  !---------------------------------------------------------------------
  integer, intent(in) :: nchan      ! Number of channels
  real, intent(in) :: ccou(:,:,:)   ! Shape (3,Ncomp,Nplane)
  real, intent(out) :: fcou(:,:,:)  ! Same shape, but different sizes 
  real, intent(in) :: doff(2)       ! Offset value
  real, intent(in) :: bsize         ! Beam size
  integer, intent(inout) :: mic(nchan)  ! Effective number of Clean components
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real(8), parameter :: sec=3600.d0*180d0/pi
  real :: beam_e, b2, fact
  integer :: ic,jc,kc
  !
  !!Print *,'Into ATTENUATE ',maxval(mic)
  !!Print *,'CCOU shape ',ubound(ccou)
  !!Print *,'FCOU shape ',ubound(fcou)
  !!Print *,'Doff ',doff(1)*sec,doff(2)*sec
  beam_e = bsize/(2.*sqrt(log(2.0)))
  b2 = (1.0/beam_e)**2
  !
  do ic=1,nchan
    kc = 0
    do jc=1,mic(ic)
      fact = ((ccou(1,jc,ic)-doff(1))**2+(ccou(2,jc,ic)-doff(2))**2)*b2
      if (fact.lt.32) then
        kc = kc+1
        fcou(3,kc,ic) = ccou(3,jc,ic)*exp(-fact)
        fcou(1:2,kc,ic) = ccou(1:2,jc,ic)
      endif
    enddo
    mic(ic) = kc
  enddo
  !
end subroutine attenuate_clean

!
subroutine getuv_conversion(uvout,nc,convert)
  use gildas_def
  use image_def
  use phys_const
  !---------------------------------------------------------------------
  ! MAPPING
  !   @ public
  !   Derive the frequency axis corresponding to a specified
  !   Velocity sampling.
  !---------------------------------------------------------------------
  type (gildas), intent(inout) :: uvout   ! Output UV table header
  integer, intent(in) :: nc               ! Number of desired channels
  real(8), intent(inout) :: convert(3)    ! Velocity conversion formula
  !
  real(8) :: n_iref
  !
  ! Convert(3) is initially on a Velocity Scale.
  !
  ! Compute the Reference pixel at which VOFF will occur
  ! in this new sampling, to preserve the VOFF / FREQ / IREF 
  ! correspondance
  !! voff = (n_iref - convert(1))*convert(3) + convert(2)
  n_iref = (uvout%gil%voff - convert(2)) / convert(3) + convert(1)
  !
  convert(1) = n_iref
  convert(2) = uvout%gil%voff
  uvout%gil%vres = convert(3)
  uvout%gil%fres = - uvout%gil%vres * 1d3 / clight * uvout%gil%freq
  uvout%gil%ref(1) = convert(1)
  uvout%gil%val(1) = uvout%gil%freq  ! This is already the case
  uvout%gil%inc(1) = uvout%gil%fres  
  uvout%gil%nchan = nc
  !
  uvout%gil%nchan = nc
  uvout%gil%dim(1) = uvout%gil%nlead+uvout%gil%ntrail + uvout%gil%natom*nc
end subroutine getuv_conversion
!
subroutine resample_uv (uvint,uvout,uvint_data,uvout_data,nt)
  use image_def
  use mapping_interfaces, only : interpolate_uv
  !------------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !   Support for command UV_RESAMPLE
  !   Resample (in memory) a UV data set
  !------------------------------------------------------------------------
  type (gildas), intent(in) :: uvint  ! Input UV header
  type (gildas), intent(in) :: uvout  ! Output UV header
  real(4), intent(in) :: uvint_data(uvint%gil%dim(1),uvint%gil%dim(2))
  real(4), intent(out) :: uvout_data(uvout%gil%dim(1),uvout%gil%dim(2))
  integer, intent(in) :: nt         ! Number of trailing informations
  !
  integer(kind=index_length) :: iv, nv
  integer :: nin, nou
  real(8) :: xref,xval,xinc
  real(8) :: yref,yval,yinc
  !
  nv = uvint%gil%nvisi 
  xref = uvout%gil%ref(1)
  yref = uvint%gil%ref(1)
  xval =   uvout%gil%voff
  xinc =   uvout%gil%vres
  yval =   uvint%gil%voff
  yinc =   uvint%gil%vres
  !
  nou = uvout%gil%dim(1)
  nin = uvint%gil%dim(1)
  !
  ! Add test here
  call uv_resample_test_overlap(uvout%gil%nchan,xinc,xref,xval,uvint%gil%nchan,yinc,yref,yval)
  !
  !$OMP PARALLEL &
  !$OMP    & SHARED(uvout_data,uvint_data, uvout, uvint) &
  !$OMP    & SHARED(xinc,xref,xval, yinc,yref,yval, nv,nt,nou,nin) & 
  !$OMP    & PRIVATE(iv)
  !$OMP DO SCHEDULE(STATIC)
  do iv = 1,nv  						  
     uvout_data(1:7,iv) = uvint_data(1:7,iv)
     call interpolate_uv (uvout_data(8,iv), uvout%gil%nchan, xinc,xref,xval, &
          uvint_data(8,iv),uvint%gil%nchan,yinc,yref,yval)
     if (nt.ne.0) then
        uvout_data(nou-nt+1:nou,iv) = uvint_data(nin-nt+1:nin,iv)
     endif
  enddo
  !$OMP END DO
  !$OMP END PARALLEL
end subroutine resample_uv
!
subroutine interpolate_uv(x,xdim,xinc,xref,xval, y,ydim,yinc,yref,yval)
  !-----------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING   Support for UV_RESAMPLE
  ! Performs the linear interpolation/integration for visibilities
  !
  ! 1) if actual interpolation (XINC <= YINC)
  !     this is a 2-point linear interpolation formula.
  !     the data is untouched if the resolution is unchanged and the shift
  !     is an integer number of channels.
  !
  ! 2) if not (XINC > YINC)
  !     boxcar convolution (width xinc-yinc) followed by linear interpolation
  !
  !-----------------------------------------------------------------------------
  integer, intent(in) :: ydim             ! Input axis size
  integer, intent(in) :: xdim             ! Output axis size
  real(8), intent(in) :: yref,yval,yinc   ! Input conversion formula
  real(8), intent(in) :: xref,xval,xinc   ! Output conversion formula
  real(4), intent(in) :: y(3,xdim)        ! Input values
  real(4), intent(out) :: x(3,ydim)       ! Output values
  ! Local:
  integer i,imax,imin, j
  real(8) :: pix, val, expand
  real scale, ww
  !-----------------------------------------------------------------------
  !
  expand = abs(xinc/yinc)
  do i = 1, xdim
     !
     ! Compute interval
     val = xval + (i-xref)*xinc
     pix = (val-yval)/yinc + yref
     if (expand.gt.1.) then
        imin = int(pix-expand/2d0+0.5d0)
        imax = int(pix+expand/2d0+0.5d0)
        if (imin.gt.ydim .or. imax.lt.1) then
           cycle
        endif
        if (imin.lt.1) then
           imin = 1
           ww = 1.0  ! the whole channel is in...
        else
           ww = imin-(pix-expand/2d0-0.5d0)
        endif
        x(1:3,i) = y(1:3,imin)*ww
        scale = ww
        !
        if (imax.gt.ydim) then
           imax = ydim
           ww = 1.0
        else
           ww = pix+expand/2d0+0.5d0-imax
        endif
        x(1:3,i) = x(1:3,i) + y(1:3,imax)*ww
        scale = scale + ww
        !
        do j=imin+1, imax-1
           x(1:3,i) = x(1:3,i) + y(1:3,j)
           scale = scale+1.
        enddo
        ! Normalize
        !!            w(i) = scale/expand  ! This is the fraction of channel covered
        x(1:2,i) = x(1:2,i)/scale
     else      
        imin = int(pix)
        imax = imin+1
        if ((imin.lt.1).or.(imax.gt.ydim)) then
           x(1:3,i) = 0.
        else
           x(1:3,i) = y(1:3,imin)*(imin+1-pix) + y(1:3,imin+1)*(pix-imin)
        endif
        ! Re-scale the weight
        x(3,i) = x(3,i)*expand
     endif
  enddo
end subroutine interpolate_uv
!
subroutine average_uv (out,nx,nv,inp,ny,nc,num,nt)
  !------------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !   Support for command UV_AVERAGE
  !   Average (in memory) a series of channels of a UV data set
  !------------------------------------------------------------------------
  integer, intent(in) :: num        ! Number of selected channels
  integer, intent(in) :: nx         ! Output Visibility size
  integer, intent(in) :: nv         ! Number of visibilities
  real, intent(out) :: out(nx,nv)   ! Output Visibilities
  integer, intent(in) :: ny         ! Input visibility size
  real, intent(in) :: inp(ny,nv)    ! Input visibilities
  integer, intent(in) :: nc(num)    ! Selected Channels, first & last pairs
  integer, intent(in) :: nt         ! Number of trailing informations
  ! Local
  integer :: j,k,kk,l
  real :: a,b,c
  !
  do j=1,nv
    out(1:7,j) = inp(1:7,j)
    a = 0.0
    b = 0.0
    c = 0.0
    do l=2,num,2
      do k=nc(l-1),nc(l)
        kk = 7+3*k
        if (inp(kk,j).gt.0) then
          a = a+inp(kk-2,j)*inp(kk,j)
          b = b+inp(kk-1,j)*inp(kk,j)
          c = c+inp(kk  ,j)
        endif
      enddo
    enddo
    if (c.ne.0.0) then
      out(8,j) =a/c
      out(9,j) =b/c
      out(10,j)=c              ! time*band
    else
      out(8,j) =0.0
      out(9,j) =0.0
      out(10,j)=0.0
    endif
    !
    if (nt.ne.0) then
      out(nx-nt+1:nx,j) = inp(ny-nt+1:ny,j)
    endif
  enddo
end subroutine average_uv
!
subroutine compress_uv(out,nx,nv,mx,inp,ny,nc,nt)
  !------------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !   Support for command UV_COMPRESS
  !   Compress (in memory) by NC channels a UV data set
  !------------------------------------------------------------------------
  integer, intent(in) :: nx         ! Output Visibility size
  integer, intent(in) :: nv         ! Number of visibilities
  integer, intent(in) :: mx         ! Number of Output Channels
  real, intent(out) :: out(nx,nv)   ! Output Visibilities
  integer, intent(in) :: ny         ! Input visibility size
  real, intent(in) :: inp(ny,nv)    ! Input visibilities
  integer, intent(in) :: nc         ! Number of Channels to average
  integer, intent(in) :: nt         ! Number of trailing informations
  ! Local
  integer :: i,j,k,n,kk,ifi
  real :: a,b,c
  !
  do j=1,nv
    out(1:7,j) = inp(1:7,j)
    ifi = 1
    do i=1,mx
      a = 0.
      b = 0.
      c = 0.
      do k=ifi,ifi+nc-1
        kk = 7+3*k
        if (inp(kk,j).gt.0) then
          a = a+inp(kk-2,j)*inp(kk,j)
          b = b+inp(kk-1,j)*inp(kk,j)
          c = c+inp(kk  ,j)
        endif
      enddo
      ifi = ifi+nc
      kk = 7+3*i
      if (c.ne.0) then
        out(kk-2,j) = a/c
        out(kk-1,j) = b/c
        out(kk  ,j) = c         ! time*band
      else
        out(kk-2,j) = 0.
        out(kk-1,j) = 0.
        out(kk  ,j) = 0.
      endif
    enddo
    !
    if (nt.ne.0) then
      out(nx-nt+1:nx,j) = inp(ny-nt+1:ny,j)
    endif
  enddo
end subroutine compress_uv
!
subroutine uv_resample_test_overlap(nchanout,incout,refout,valout,nchanin,incin,refin,valin)
  use gbl_message
  !---------------------------------------------------------------------
  ! MAPPING
  !   @ private
  !   Tests if a resampled UV table is going to be empty
  !---------------------------------------------------------------------
  integer, intent(in)      :: nchanin              ! Input number of channels
  integer, intent(in)      :: nchanout             ! Output number of channels
  real(kind=8), intent(in) :: refin,valin,incin    ! Input conversion formula
  real(kind=8), intent(in) :: refout,valout,incout ! Output conversion formula
  ! Locals
  integer(kind=4)          :: nzerochans ! Number of zeroed channels on output
  integer(kind=4)          :: ichan ! index for channel iterations
  real(kind=8)             :: velout ! velocity for chan in output
  real(kind=8)             :: channelin ! channel in input
  !
  ! Code
  nzerochans = 0
  do ichan = 1, nchanout
     ! Compute interval
     velout = valout + (ichan-refout)*incout ! velocity on output
     channelin = (velout-valin)/incin + refin ! channel on input
     if (channelin.gt.nchanin.or.channelin.lt.1) then
        nzerochans = nzerochans+1
     endif
  enddo
  if (nzerochans.eq.nchanout) then
     call map_message(seve%w,'UV_RESAMPLE',"Requested velocity range does not intersect the input velocity range")
     call map_message(seve%w,'UV_RESAMPLE',"Output UV table will be zero valued")
  else if (nzerochans.lt.nchanout.and.nzerochans.gt.0) then
      call map_message(seve%w,'UV_RESAMPLE',"Requested velocity range partially intersect the input velocity range")
     call map_message(seve%w,'UV_RESAMPLE',"Output UV table will contain zero valued channels")
  end if
end subroutine uv_resample_test_overlap

subroutine mrtcal_list_comm(line,error)
  use gbl_message
  use mrtcal_dependencies_interfaces
  use mrtcal_interfaces, except_this=>mrtcal_list_comm
  use mrtcal_index_vars
  !---------------------------------------------------------------------
  ! @ private
  ! Support routine for command
  !   LIST [IN|CURRENT]
  !   1    [/TOC]
  !   2    [/PAGE]
  !   3    [/COLUMNS List]
  !   4    [/FILE OutputFile]
  !   5    [/VARIABLE VarName]
  !---------------------------------------------------------------------
  character(len=*), intent(in)    :: line   ! Input command line
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='MLIST'
  integer(kind=4), parameter :: nwhat=2
  character(len=7), parameter :: what(nwhat) = (/ 'IN     ','CURRENT' /)
  character(len=7) :: argum,key,optname
  integer(kind=4) :: nchar,ikey,ier,olun
  type(mrtindex_optimize_t), pointer :: optx
  integer(kind=4) :: custom(20)  ! Up to 20 custom columns
  character(len=filename_length) :: file
  integer(kind=4), parameter :: optpage=2
  !
  argum = 'CURRENT'
  call sic_ke(line,0,1,argum,nchar,.false.,error)
  if (error)  return
  call sic_ambigs(rname,argum,key,ikey,what,nwhat,error)
  if (error)  return
  !
  if (ikey.eq.1) then
    optx => ix
    optname = 'In'
  else
    optx => cx
    optname = 'Current'
  endif
  !
  ! Output to STDOUT or file?
  if (sic_present(4,0)) then  ! /FILE
    call sic_ch(line,4,1,file,nchar,.true.,error)
    if (error)  return
    !
    ier = sic_getlun(olun)
    if (ier.ne.1) then
      call mrtcal_message(seve%e,rname,'No logical unit left')
      error = .true.
      return
    endif
    ier = sic_open(olun,file,'NEW',.false.)
    if (ier.ne.0) then
      call mrtcal_message(seve%e,rname,'Cannot open file '//file)
      error = .true.
      call sic_frelun(olun)
      return
    endif
  else
    olun = 6  ! STDOUT
  endif
  !
  if (sic_present(1,0)) then  ! /TOC
    call mrtindex_list_toc_comm(optx,line,olun,error)
    if (error)  goto 10
  else
    call mrtindex_list_columns(line,custom,error)
    if (error)  goto 10
    call mrtindex_list(optx,optname,custom,olun,sic_present(optpage,0),error)
    if (error)  goto 10
  endif
  !
10 continue
  if (olun.ne.6) then
    ier = sic_close(olun)
    call sic_frelun(olun)
  endif
  !
end subroutine mrtcal_list_comm

subroutine pdbi_narrow(line,error)
  use gkernel_interfaces
  use gbl_message
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! PDBI internal routine, support for command
  !	NARROW_INPUT 1|2 Q1|Q2|Q3|Q4 [HOR|VER]
  !---------------------------------------------------------------------
  character(len=*):: line           !
  logical :: error                  !
  ! Local
  integer(kind=4) :: i,n,nkey,nc
  character(len=2) :: qq
  character(len=6) :: entry(2)
  character(len=6) :: input1(4), input2(4)
  data input1/'Q1 HOR','Q2 HOR','Q3 VER','Q4 VER'/
  data input2/'Q1 VER','Q2 VER','Q3 HOR','Q4 HOR'/
  character(len=11) :: rname
  data rname /'PDBI_NARROW'/
  ! ---------------------------------------------------------------------------
  !
  ! LINE command must have been run (find a better test?)
  !
  if (flo1.eq.0) then
     call astro_message(seve%e,rname,'LINE command not yet executed')
     error = .true.
     return
  endif
  !
  narrow_def = .false.
  do i=1,nunit
    unit_def(i) = .false.
  enddo
  !
  n = sic_narg(0)
  if (n.ne.2) then
    call astro_message(seve%e,rname,'Command needs two arguments')
    error = .true.
    return
  endif
  !
  do i = 1,2
    call sic_ch(line,0,i,qq,nc,.false.,error)
    if (error) return
    call sic_upper(qq)
    if (i.eq.1) then
      call sic_ambigs( 'PDBI_NARROW',qq,entry(1),nkey,input1,4,error)
    elseif (i.eq.2) then
      call sic_ambigs( 'PDBI_NARROW',qq,entry(2),nkey,input2,4,error)
    endif
    if (error) then
      call astro_message(seve%e,rname,'Wrong syntax')
      return
    endif
    narrow_input(i) = nkey
  enddo
  !
  ! Now do the plot
  !
  narrow_def = .true.
  plot_mode = 2
  call pdbi_plot_def(error)
  if (error) return
  call pdbi_plot_line(error)
  !
end subroutine pdbi_narrow
!
subroutine pdbi_widex(line,error)
  use gbl_message
  use ast_line
  !---------------------------------------------------------------------
  ! @ private
  ! PDBI internal routine, support for command WIDEX
  ! (only producing a plot)
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  logical :: error                  !
  !
  plot_mode = 3
  call pdbi_plot_def(error)
  if (error) return
  call pdbi_plot_line(error)
  !
end subroutine pdbi_widex

module imager_interfaces_public
  interface
    subroutine dispatch_clean(line,error)
      use gbl_message
      use clean_arrays
      !----------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER   Main CLEAN routine
      !   Call appropriate subroutine according to METHOD%METHOD
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line  ! Command line
      logical,          intent(out)   :: error ! Logical error flag
    end subroutine dispatch_clean
  end interface
  !
  interface
    subroutine uv_fibeam (name,freq,uv,nu,nvis,wcol,majo,mino,pa,error)
      use gildas_def
      use mod_fitbeam
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Find beam parameters for deconvolution
      !   Fit an elliptical gaussian clean beam to UV data weight
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: name          ! Caller name
      real(8), intent(in) :: freq                   ! Observation frequency
      integer, intent(in) :: nu                     ! Visibility size 
      integer, intent(in) :: nvis                   ! Number of visibilities
      integer, intent(in) :: wcol                   ! Weight column  
      real, intent(in) :: uv(nu,nvis)               ! Visibilities
      real, intent(inout) :: majo                   ! Major axis
      real, intent(inout) :: mino                   ! Minor axis
      real, intent(inout) :: pa                     ! Position Angle
      logical, intent(inout) :: error               ! Error flag
    end subroutine uv_fibeam
  end interface
  !
  interface
    subroutine sub_uvcal(ncol,nvis,data,ndc,cal, &
         &    index,times,do_flag,flagged,nvg,gain,indg,timesg,   &
         &    ampli_gain,phase_gain,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      ! Mapping Task
      !
      !   Apply phase and/or amplitude calibration to
      !   the "raw" UV data.   Phase and Amplitudes are stored in
      !   the "gain" UV table, and usually come from a previous
      !   use of Task uv_gain.    This subroutine allows to apply the
      !   corrections to a spectral line table, whatever the way the gains
      !   were computed before.
      !---------------------------------------------------------------------
      integer, intent(in) :: ncol            ! Visibility size
      integer, intent(in) :: nvis            ! Number of visibilities
      real, intent(in) :: data(ncol,nvis)    ! Visibility array
      integer, intent(in) :: ndc             ! Number of channels
      real, intent(out) :: cal(ncol,nvis)    ! Calibrated visibilities
      integer, intent(in) :: index(nvis)     ! Visibility Index
      real(8), intent(inout) :: times(nvis)  ! Visibility Time stamp
      logical, intent(in) :: do_flag           ! Flag data with no solution
      integer, intent(inout) :: flagged(nvis)  ! Flag work array
      integer, intent(in) :: nvg             ! Number of gains
      real, intent(in) :: gain(10,nvg)       ! Gain array
      integer, intent(out) :: indg(nvg)      ! Index in gains
      real(8), intent(out) :: timesg(nvg)    ! Gain time stamp
      real(8), intent(in) :: ampli_gain      ! Amplitude gain
      real(8), intent(in) :: phase_gain      ! Phase gain
      logical, intent(out) :: error          ! Error flag
    end subroutine sub_uvcal
  end interface
  !
  interface
    subroutine message_colour(colour)
      use gbl_ansicodes
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !   Change the colour
      !---------------------------------------------------------------------
      integer, intent(in) :: colour   !
    end subroutine message_colour
  end interface
  !
  interface
    subroutine rmask_to_list(rmask,m,list,n)
      !---------------------------------------------------------------------
      ! @ public
      ! 
      !   IMAGER public routine
      !   Get list of positions from a Real mask (1-D index)
      !---------------------------------------------------------------------
      integer, intent(in) :: m         ! Number of entries
      real, intent(in) :: rmask(m)     ! Mask values
      integer, intent(out) :: n        ! Number of TRUE values
      integer, intent(out) :: list(m)  ! Position of entries 
    end subroutine rmask_to_list
  end interface
  !
  interface
    subroutine lmask_to_list(lmask,m,list,n)
      !---------------------------------------------------------------------
      ! @ public
      ! 
      !   IMAGER public routine
      !   Get list of positions from a Logical mask (1-D index)
      !---------------------------------------------------------------------
      integer, intent(in) :: m         ! Size of mask 
      logical, intent(in) :: lmask(m)  ! Mask values
      integer, intent(out) :: n        ! Number of TRUE values
      integer, intent(out) :: list(m)  ! Position of entries 
    end subroutine lmask_to_list
  end interface
  !
  interface
    subroutine get_listsize (mask,m,n)
      !---------------------------------------------------------------------
      ! @ public
      ! 
      !   IMAGER public routine
      !   Count number of TRUE values (Rank 1 arrays)
      !---------------------------------------------------------------------
      integer, intent(in) :: m        ! Number of entries
      integer, intent(out) :: n       ! Number of TRUE values
      logical, intent(in) :: mask(m)  ! Mask values
    end subroutine get_listsize
  end interface
  !
  interface
    subroutine compute_atten (nx,ny,np,atten,primary,mask,   &
         &    wsear,wrest,wmin)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! 
      !   IMAGER public routine
      !   Set the mosaic weights
      !---------------------------------------------------------------------
      integer, intent(in) :: nx               ! X size
      integer, intent(in) :: ny               ! Y size 
      integer, intent(in) :: np               ! Number of pointings
      real, intent(out) ::  atten(nx,ny)      ! Weight map
      real, intent(in) ::  primary(np,nx,ny)  ! Primary beams
      real, intent(in) ::  wsear              ! Search threshold
      real, intent(in) ::  wrest              ! Restore threshold   
      real, intent(in) ::  wmin               ! Minimum beal value  
      logical, intent(inout) ::  mask(nx,ny)  ! Search mask
    end subroutine compute_atten
  end interface
  !
  interface
    subroutine check_box(nx,ny,blc,trc)
      !---------------------------------------------------------------------
      ! @ public
      ! 
      !   IMAGER public routine
      !   Define the search box corners 
      !   The default is the inner quarter of the image
      !---------------------------------------------------------------------
      integer, intent(in) :: nx,ny         ! Size of image
      integer, intent(inout) :: blc(2)     ! Bottom left corner
      integer, intent(inout) :: trc(2)     ! Top right corner
    end subroutine check_box
  end interface
  !
  interface
    subroutine major_multi90 (rname,method,head,   &
         &    dirty,resid,beam,mask,clean,nx,ny,   &
         &    tcc,miter,limit,niter, &
         &    smask, sresid, trans, cdata, sbeam, &
         &    tfbeam, wfft, mcct, nker, kernel)
    ! Need to add
    !    &    nf, primary, weight)
      use image_def
      use gbl_message
      use clean_def
      !$  use omp_lib
      !-----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !     Multi-Resolution CLEAN - with NS (parameter) scales
      !
      !     Algorithm
      !     For each iteration, search at which scale the signal to noise
      !     is largest. Use the strongest S/N to determine the "component"
      !     intensity and shape at this iteration.
      !
      !     Restore the ("infinite" resolution) image from the list of location
      !     types, and intensities of the "components"
      !
      !     The noise level at each scale is computed from the Fourier transform
      !     of the smoothed dirty beams, since the FT is the weight distribution
      !     and the noise level is the inverse square root of the sum of the
      !     weights.
      !-----------------------------------------------------------------------
      character(len=*), intent(in) :: rname
      type (clean_par), intent(inout) :: method
      type (gildas), intent(inout) :: head         ! Unused, but here for consistency...
      integer, intent(in)  :: nx,ny                ! Image size
      integer, intent(in)  :: miter                ! Maximum number of clean components
      integer, intent(out) :: niter                ! Number of found components
      real, intent(in)  :: dirty(nx,ny)            ! Dirty image
      real, intent(inout) :: resid(nx,ny)          ! Residual image (initialized to Dirty image)
      real, intent(in)  :: beam(nx,ny)             ! Dirty beam
      real, intent(inout) :: clean(nx,ny)          ! "CLEAN" image (not convolved yet)
      logical, intent(in)  :: mask(nx,ny)          ! Search area
      real, intent(in)  :: limit                   ! Maximum residual
      real, intent(in)  :: tfbeam(nx,ny)           ! Real Beam TF
      real, intent(inout) :: wfft(*)
      type (cct_par), intent(out) :: tcc(miter)
      integer, intent(out) :: nker(:)              ! Kernel sizes
      real, intent(out) :: kernel(:,:,:)           ! Smoothing kernel values
      !
      integer, intent(out) :: mcct                 ! Number of separate Clean components
      !
      ! In call sequence
      real, intent(inout) ::  sbeam(nx,ny,*)          ! Smoothed beams
      real, intent(inout) ::  sresid(nx,ny)           ! Smoothed residuals
      real, intent(inout) ::  trans(nx,ny)            ! Translated beam
      complex, intent(inout) ::  cdata(nx,ny)         ! Work array
      logical, intent(inout) ::  smask(nx,ny)         ! Smoothed mask
    end subroutine major_multi90
  end interface
  !
  interface
    subroutine expand_multi_cct(head,nker,kernel,nx,ny,ip,miter,flux,niter,tcc,dcct)
      ! @ public-mandatory
      !
      ! IMAGER  Expand the MultiScale Clean Component List
      !
      use image_def
      use clean_def
      !
      type (gildas), intent(inout) :: head         ! Clean header
      integer, intent(in) :: nker(:)               ! Kernel sizes
      real, intent(in) :: kernel(:,:,:)            ! Smoothing kernel values
      integer, intent(in)  :: nx,ny                ! Image size
      integer, intent(in)  :: ip                   ! Plane number 
      integer, intent(in)  :: miter                ! Maximum number of clean components
      real, intent(out) :: flux
      integer, intent(in)  :: niter                ! Number of found components
      type (cct_par), intent(in) :: tcc(niter)
      real, intent(inout) :: dcct(:,:,:)           ! Clean component values
    end subroutine expand_multi_cct
  end interface
  !
  interface
    subroutine map_message(mkind,procname,message)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Messaging facility for the current library. Calls the low-level
      !   (internal) messaging routine with its own identifier.
      !---------------------------------------------------------------------
      integer,          intent(in) :: mkind     ! Message kind
      character(len=*), intent(in) :: procname  ! Name of calling procedure
      character(len=*), intent(in) :: message   ! Message string
    end subroutine map_message
  end interface
  !
  interface
    subroutine get_i4list_fromsic(rname,line,opt,nf,list,error)
      use gkernel_types
      use gbl_message
      use gbl_format
      !
      ! @ public-mandatory
      !
      ! Return in the allocatable array the content of the 1-D
      ! SIC variable given as argument of Option # opt.
      ! Return the size of the array in NF
      ! If NF is non zero on entry, the size must match and the
      ! array is pre-allocated.
      !
      character(len=*), intent(in) :: rname
      character(len=*), intent(in) :: line
      integer, intent(in) :: opt
      integer, intent(inout) :: nf
      integer, allocatable, intent(inout) :: list(:)
      logical, intent(out) :: error
    end subroutine get_i4list_fromsic
  end interface
  !
  interface
    subroutine get_r4list_fromsic(rname,line,opt,nf,list,error)
      use gkernel_types
      use gbl_message
      use gbl_format
      !
      ! @ public-mandatory
      !
      ! Return in the allocatable array the content of the 1-D
      ! SIC variable given as argument of Option # opt.
      ! Return the size of the array in NF
      ! If NF is non zero on entry, the size must match and the
      ! array is pre-allocated.
      !
      character(len=*), intent(in) :: rname
      character(len=*), intent(in) :: line
      integer, intent(in) :: opt
      integer, intent(inout) :: nf
      real, allocatable, intent(inout) :: list(:)
      logical, intent(out) :: error
    end subroutine get_r4list_fromsic
  end interface
  !
  interface
    subroutine maxcct (x,n,nomin,rmin,nomax,rmax)
      use clean_def
      !----------------------------------------------------------------------
      ! @ public
      !
      ! Mapping:	Utility routine
      ! 	Compute position and values of Min and Max of Clean Component Array X
      !----------------------------------------------------------------------
      integer, intent(in) :: n              ! taille du vecteur
      type(cct_par), intent(in) :: x(n)     ! Clean components 
      integer, intent(out) :: nomin,nomax   ! Resultat de la recherche:indices
      real, intent(out) :: rmin,rmax        ! et valeurs
    end subroutine maxcct
  end interface
  !
  interface
    subroutine maxvec (x,n,nomin,rmin,nomax,rmax)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! GILDAS:	Utility routine
      ! 	Compute position and values of Min and Max of array X
      !----------------------------------------------------------------------
      integer, intent(in) :: n             ! taille du vecteur
      real, intent(in) :: x(n)             ! Vecteur donne
      integer, intent(out) :: nomin,nomax   ! Resultat de la recherche:indices
      real, intent(out) :: rmin,rmax        ! et valeurs
    end subroutine maxvec
  end interface
  !
  interface
    subroutine maxmap(ary,nx,ny,box,amax,imax,jmax,amin,imin,jmin)
      !--------------------------------------------------------------------
      ! @ public
      !
      ! GILDAS:	Utility routine
      !	Find max and min in specified region of real array
      !--------------------------------------------------------------------
      integer, intent(in) :: nx, ny         ! X,Y size
      real, intent(in) :: ary(nx,ny)        ! Array of values
      integer, intent(in) :: box(4)         ! Search box
      integer, intent(out) :: imax, jmax    ! Position of Max
      integer, intent(out) :: imin, jmin    ! Position of Min
      real, intent(out) :: amax, amin       ! Max and Min
    end subroutine maxmap
  end interface
  !
  interface
    subroutine maxmsk(ary,nx,ny,msk,box,   &
         &    amax,imax,jmax,amin,imin,jmin)
      !--------------------------------------------------------------------
      ! @ public
      !
      ! GILDAS:	Utility routine
      !	  Find max and min in specified region of real array
      !   Version with mask
      !--------------------------------------------------------------------
      integer, intent(in) :: nx, ny         ! X,Y size
      real, intent(in) :: ary(nx,ny)        ! Array of values
      logical, intent(in) ::  msk(nx,ny)    ! Search mask
      integer, intent(in) :: box(4)         ! Search box
      integer, intent(out) :: imax, jmax    ! Position of Max
      integer, intent(out) :: imin, jmin    ! Position of Min
      real, intent(out) :: amax, amin       ! Max and Min
    end subroutine maxmsk
  end interface
  !
  interface
    subroutine maxlst(ary,nx,ny,list,nl,   &
         &    amax,imax,jmax,amin,imin,jmin)
      !--------------------------------------------------------------------
      ! @ public
      !
      ! GILDAS:	Utility routine
      !	  Find max and min in specified region of real array
      !   using a list of valid pixels
      !--------------------------------------------------------------------
      integer, intent(in) :: nx, ny         ! X,Y size
      real, intent(in) :: ary(nx*ny)        ! Array of values
      integer, intent(in) :: nl             ! List size
      integer, intent(in) :: list(nl)       ! Search list 
      integer, intent(out) :: imax, jmax    ! Position of Max
      integer, intent(out) :: imin, jmin    ! Position of Min
      real, intent(out) :: amax, amin       ! Max and Min
    end subroutine maxlst
  end interface
  !
  interface
    subroutine mosaic_sortuv (np,nv,ntrail,vin,vout,xy,cs,uvmax,uvmin, &
      & error,ixoff,iyoff,nf,doff,voff)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! IMAGER
      !     Sort a UV table by fields
      !     Rotate, Shift and Sort a UV table for map making
      !     Differential precession should have been applied before.
      !---------------------------------------------------------------------
      integer, intent(in) :: np        ! Size of a visibility
      integer, intent(in) :: nv        ! Number of visibilities
      integer, intent(in) :: ntrail    ! Number of trailing daps
      real, intent(in) :: vin(np,nv)   ! Input visibilities
      real, intent(out) :: vout(np,nv) ! Output visibilities
      real, intent(in) :: xy(2)        ! Phase shift
      real, intent(in) :: cs(2)        ! Frame Rotation
      real, intent(out) :: uvmax       ! Max UV value
      real, intent(out) :: uvmin       ! Min UV value
      integer, intent(in) :: ixoff, iyoff
      integer, intent(out) :: nf
      real, intent(out) :: doff(:,:)
      integer, intent(out) :: voff(:)
      logical, intent(out) :: error    !
    end subroutine mosaic_sortuv
  end interface
  !
  interface
    subroutine loadfiuv (visi,np,nv,dtr,it,sorted,ixoff,iyoff,rpv,nf,doff)
      !---------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! IMAGER    UVSORT routines
      !     Load field numbers into work arrays for sorting.
      !---------------------------------------------------------------------
      integer, intent(in)  :: np                   ! Size of a visibility
      integer, intent(in)  :: nv                   ! Number of visibilities
      real, intent(in) :: visi(np,nv)              ! Input visibilities
      real(8), intent(out) :: dtr(nv)              ! Output field number
      integer, intent(out) :: it(nv)               ! Indexes
      logical, intent(out) :: sorted               !
      integer, intent(in)  :: ixoff                ! X pointer
      integer, intent(in)  :: iyoff                ! Y pointer
      real(4), intent(in)  :: rpv(nv)              ! V Values
      integer, intent(inout) :: nf                 ! Number of fields
      real(kind=4), intent(out) :: doff(:,:)       ! Fields offsets
    end subroutine loadfiuv
  end interface
  !
  interface
    subroutine mulgau(data,nx,ny,bmaj,bmin,pa,scale,xinc,yinc,isign)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      ! 	Multiply of Divide (according to isign) the TF of an image by the 
      ! TF of a convolving gaussian function. BMAJ and BMIN are the
      !	widths of the original gaussian. PA is the position angle of major
      !	axis (from north towards east), in Degrees
      !----------------------------------------------------------------------
      integer, intent(in) :: nx,ny    ! X,Y size
      real, intent(in) :: bmaj        ! Major axis in Radian
      real, intent(in) :: bmin        ! Minor axis in Radian 
      real, intent(in) :: pa          ! Position Angle in Degree
      real, intent(in) :: scale       ! Flux scale factor
      real, intent(in) :: xinc        ! X pixel size
      real, intent(in) :: yinc        ! Y pixel size
      complex, intent(inout) :: data(nx,ny)  ! TF of Data to be smoothed
      integer, intent(in) :: isign
    end subroutine mulgau
  end interface
  !
  interface
    subroutine check_view(n,argu)
      ! @ public-mandatory
      integer, intent(in) :: n
      character(len=*), intent(in) :: argu(n)
    end subroutine check_view
  end interface
  !
  interface
    subroutine convolve (image,dirty,nx,ny,fbeam,fcomp,wfft)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !	  Convolve an image by a beam through Fourier Transform
      !----------------------------------------------------------------------
      integer, intent(in) :: nx,ny          ! Problem size
      complex, intent(in) :: fbeam(nx,ny)    ! Beam TF
      complex, intent(inout) :: fcomp(nx,ny) ! TF workspace
      real, intent(in) :: image(nx,ny)      ! Input image
      real, intent(out) :: dirty(nx,ny)     ! Convolved image
      real, intent(inout) :: wfft(*)        ! Work area
    end subroutine convolve
  end interface
  !
  interface
    subroutine compress(nx,ny,large,wl,mx,my,small,ws,wfft)
      !----------------------------------------------------------------------
      !	@ public
      ! 
      ! MAPPING
      !   Compress an image through FT truncation
      !----------------------------------------------------------------------
      integer, intent(in) :: nx,ny,mx,my
      real, intent(in) :: large(nx,ny)
      complex, intent(inout) :: wl(nx,ny)
      real, intent(out) :: small(mx,my)
      complex, intent(inout) :: ws(mx,my)
      real, intent(inout) :: wfft(*)
    end subroutine compress
  end interface
  !
  interface
    subroutine expand (nx,ny,large,wl,mx,my,small,ws,wfft)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !	  Expand an image through FT zero extension
      !----------------------------------------------------------------------
      integer, intent(in) :: nx,ny,mx,my
      real, intent(out) :: large(nx,ny)
      complex, intent(inout) :: wl(nx,ny)
      real, intent(in) :: small(mx,my)
      complex, intent(inout) :: ws(mx,my)
      real, intent(inout) :: wfft(*)
    end subroutine expand
  end interface
  !
  interface
    function beam_for_channel(iplane,hdirty,hbeam)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !   Find out the appropriate beam channel for an image channel
      !---------------------------------------------------------------------  
      integer :: beam_for_channel !! intent(out)  ! Beam channel
      type(gildas), intent(in) :: hdirty          ! Dirty header
      type(gildas), intent(in) :: hbeam           ! Beam header
      integer, intent(in) :: iplane               ! Dirty channel
    end function beam_for_channel
  end interface
  !
  interface
    subroutine histos (r,nx,ny, list, nl, hx,nh,hmin,hstep)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! GDF	Internal routine
      !
      !	Computes the histogram of part of an image
      !----------------------------------------------------------------------
      integer, intent(in) :: nx        ! X size
      integer, intent(in) :: ny        ! Y size
      real, intent(in)  :: r(nx*ny)    ! Input array 
      integer, intent(in) :: nl        ! List size
      integer, intent(in) :: list(nl)  ! List of values
      integer, intent(in) :: nh        ! Histogram size
      integer, intent(out) :: hx(nh)   ! Histogram
      real, intent(in) :: hmin         ! Min bin
      real, intent(in) :: hstep        ! Bin size
    end subroutine histos
  end interface
  !
  interface
    subroutine choice (r,nx,ny,list,nl,limite,   &
         &    mcl,wcl,ncl,rmax,ngoal)
      use clean_def
      !----------------------------------------------------------------------
      ! @ public
      !
      !  GILDAS:	CLEAN 	Internal routine
      !	Select possible clean components in residual map.
      !	Components are returned ordered in increasing I and J.
      ! 
      ! Search list is built if ngoal>0, re-used otherwise.
      !----------------------------------------------------------------------
      integer, intent(in) :: nx          ! X size
      integer, intent(in) :: ny          ! Y size
      integer, intent(in) :: nl          ! List size
      integer, intent(in) :: mcl         ! Maximum number of components
      integer, intent(out) :: ncl        ! Number of components found
      real, intent(in) :: r(nx*ny)       ! Input array
      type(cct_par), intent(out) :: wcl(mcl)      ! Components
      integer, intent(in) :: list(nl)    ! List of pixels 
      real, intent(inout) ::  limite     ! selection threshold
      real, intent(in) :: rmax           ! Maximum value
      integer, intent(in) :: ngoal       ! Intended number   
    end subroutine choice
  end interface
  !
  interface
    subroutine find_sidelobe (beam,nx,ny,i0,j0,nxp,nyp,bgain)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! GILDAS:	CLEAN	Internal routine
      !	Find the maximum sidelobe outside the beam patch defined
      !	by the beam center (I0,J0) and patch size (NXP,NYP)
      !----------------------------------------------------------------------
      integer, intent(in) :: nx       ! X size
      integer, intent(in) :: ny       ! Y size
      real, intent(in) :: beam(nx,ny) ! Input beam
      integer, intent(in) :: i0       ! X beam center
      integer, intent(in) :: j0       ! Y beam center
      integer, intent(in) :: nxp      ! X beam patch
      integer, intent(in) :: nyp      ! Y beam patch
      real, intent(out) :: bgain      ! Maximum sidelobe
    end subroutine find_sidelobe
  end interface
  !
  interface
    subroutine mos_sidelobe (beam,nx,ny,i0,j0,nxp,nyp,bgain,nf)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! GILDAS:	CLEAN	Internal routine
      !	Find the maximum sidelobe outside the beam patch defined
      !	by the beam center (I0,J0) and patch size (NXP,NYP)
      ! Adapted for Mosaic
      !----------------------------------------------------------------------
      integer nx,ny,i0,j0,nxp,nyp,nf
      real beam(nx,ny,nf),bgain
    end subroutine mos_sidelobe
  end interface
  !
  interface
    subroutine t_setextrema(h,rmi,jmi,rma,jma)
      use gildas_def
      use image_def
      !------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Put extrema into the specified header
      !------------------------------------------------
      type (gildas), intent(inout), target :: h
      real(kind=4), intent(in) :: rmi     ! Value of minimum
      integer(kind=size_length), intent(in) :: jmi  ! Position of minimum
      real(kind=4), intent(in) :: rma     ! Value of maximum
      integer(kind=size_length), intent(in) :: jma  ! Position of maximum
    end subroutine t_setextrema
  end interface
  !
  interface
    subroutine fibeam (name,dirty,nx,ny,nbx,nby,thre,majo,mino,pa,convert,error)
      use gildas_def
      use mod_fitbeam
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Find beam parameters for deconvolution
      !   Fit an elliptical gaussian clean beam to main beam
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: name          ! Caller name
      integer, intent(in) :: nx                     ! X size
      integer, intent(in) :: ny                     ! Y size
      real, intent(in) :: dirty(nx,ny)              ! Dirty beam
      integer, intent(in) :: nbx                    ! X patch
      integer, intent(in) :: nby                    ! Y patch
      real, intent(inout) :: thre                   ! Threshold
      real, intent(inout) :: majo                   ! Major axis
      real, intent(inout) :: mino                   ! Minor axis
      real, intent(inout) :: pa                     ! Position Angle
      real(8), intent(in) :: convert(3,2)           ! Conversion formula
      logical, intent(inout) :: error               ! Error flag
    end subroutine fibeam
  end interface
  !
  interface
    subroutine dofft (np,nv,visi,jx,jy,jo   &
         &    ,nc,nx,ny,map,mapx,mapy,sup,cell,taper,we,vv   &
         &    ,ubias,vbias,ubuff,vbuff,ctype)
      use gildas_def
      use clean_default
      !----------------------------------------------------------------------
      ! @ public
      !
      ! GILDAS  UV_MAP
      !   Compute FFT of image by gridding UV data
      !   Operational version using the fastest method.
      !----------------------------------------------------------------------
      integer, intent(in) :: nv                   ! number of values
      integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
      real, intent(in) :: visi(np,nv)             ! values
      integer, intent(in) :: nc                   ! number of channels
      integer, intent(in) :: jx                   ! X coord location in VISI
      integer, intent(in) :: jy                   ! Y coord location in VISI
      integer, intent(in) :: jo                   ! first channel to map
      integer, intent(in) :: nx                   ! X map size
      integer, intent(in) :: ny                   ! Y map size
      complex, intent(out) :: map(nc+1,nx,ny)     ! gridded visibilities
      real, intent(in) :: mapx(nx)                ! X Coordinates of grid
      real, intent(in) :: mapy(ny)                ! Y Coordinates of grid
      real, intent(in) :: sup(2)                  ! Support of convolving function in Meters
      real, intent(in) :: cell(2)                 ! cell size in Meters
      real, intent(in) :: taper(4)                ! 1/e taper in Meters + Angle in Radians
      real, intent(in) :: we(nv)                  ! Weight array
      real, intent(in) :: vv(nv)                  ! V Values
      real, intent(in) :: ubias                   ! U gridding offset
      real, intent(in) :: vbias                   ! V gridding offset
      real, intent(in) :: ubuff(4096)             ! U gridding buffer
      real, intent(in) :: vbuff(4096)             ! V gridding buffer
      integer, intent(in) :: ctype                ! type of gridding
    end subroutine dofft
  end interface
  !
  interface
    subroutine remisajour (nxy,clean,resid,tfbeam,fcomp,   &
         &    wcl,ncl,nx,ny,wfft,   &
         &    np,primary,weight,wtrun)
      use clean_def
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   CLEAN   Internal routine
      !   Subtract last major cycle components from residual map.
      !----------------------------------------------------------------------
      integer, intent(in) :: nxy      ! Problem size
      integer, intent(in) :: nx,ny    ! Problem size
      integer, intent(in) :: ncl      ! Number of clean components
      integer, intent(in) :: np       ! Number of primary beams
      type(cct_par), intent(in) :: wcl(ncl)   ! Clean component list
      real, intent(in) :: tfbeam(nx,ny,np)    ! TF of dirty beams
      complex, intent(inout) :: fcomp(nx,ny)  ! Work area
      real, intent(inout) :: clean(nx,ny)     ! Clean map
      real, intent(inout) :: resid(nx,ny)     ! Residual map
      real, intent(in) :: primary(np,nx,ny)   ! Primary beams
      real, intent(in) :: weight(nx,ny)       ! Flat field weights
      real, intent(in) :: wtrun               ! Truncation of mosaic
      real, intent(in) :: wfft(*)             ! work fft area
    end subroutine remisajour
  end interface
  !
  interface
    subroutine soustraire (wcl,ncl,        &
         &    dirty,nx,ny,ixbeam,iybeam,   &
         &    ixpatch,iypatch,kcl,gain,    &
         &    nf, primary, weight, wtrun)
      use clean_def
      !$ use omp_lib
      !----------------------------------------------------------------------
      ! @ public
      !
      ! GILDAS: CLEAN   Internal routine
      ! Subtract the clean component, convolved with dirty beam
      ! restricted to beam patch, from the list of selected points.
      ! Caution : points must be ordered according I and J
      !----------------------------------------------------------------------
      integer, intent(in) :: nf                   ! Number of fields
      integer, intent(in) :: ncl                  ! nombre de points retenus
      integer, intent(in) :: nx,ny,ixbeam,iybeam  ! dimension et centre du beam
      real, intent(in) :: dirty(nx,ny,nf)         ! Dirty Beam
      integer, intent(in) :: ixpatch,iypatch      ! taille du centre BEAM retenu
      type(cct_par), intent(inout) :: wcl(ncl)
      integer, intent(in) :: kcl                  ! No de la composante introduite
      real, intent(in) :: gain                    ! gain de clean
      real, intent(in) :: primary (nf,nx,ny)      ! Primary beams
      real, intent(in) :: weight (nx,ny)          ! Effective weights on sky
      real, intent(in) :: wtrun
    end subroutine soustraire
  end interface
  !
  interface
    subroutine domima(a,rmi,rma,imi,ima,n)
      !----------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Compute minmax and location
      !----------------------------------------------------------
      integer, intent(in) :: n
      integer, intent(out) :: ima,imi
      real, intent(in) ::  a(n)
      real, intent(inout) :: rmi,rma
    end subroutine domima
  end interface
  !
  interface
    subroutine mosaic_loadfield (visi,np,nv,ixoff,iyoff,nf,doff,voff,uvmax,uvmin)
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! IMAGER    MOSAIC routines
      !     Load field coordinates into work arrays after sorting.
      !----------------------------------------------------------------------
      integer, intent(in)  :: np                   ! Size of a visibility
      integer, intent(in)  :: nv                   ! Number of visibilities
      real, intent(in) :: visi(np,nv)              ! Input visibilities
      integer, intent(in)  :: ixoff                ! X pointer
      integer, intent(in)  :: iyoff                ! Y pointer
      integer, intent(out) :: nf                   ! Number of fields
      real(kind=4), intent(out) :: doff(:,:)  ! Fields offsets
      integer, intent(out) :: voff(:)  ! Fields visibility offsets
      real, intent(inout) :: uvmax    ! Maximum length
      real, intent(inout) :: uvmin    ! Minimum baseline
    end subroutine mosaic_loadfield
  end interface
  !
  interface
    subroutine mosaic_getfields (visi,np,nv,ixoff,iyoff,nf,doff)
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! IMAGER    MOSAIC routines
      !     Count number of fields and Get their coordinates
      !----------------------------------------------------------------------
      integer, intent(in)  :: np                   ! Size of a visibility
      integer, intent(in)  :: nv                   ! Number of visibilities
      real, intent(inout)  :: visi(np,nv)              ! Input visibilities
      integer, intent(in)  :: ixoff                ! X pointer
      integer, intent(in)  :: iyoff                ! Y pointer
      integer, intent(out) :: nf                   ! Number of fields
      real, intent(out), allocatable :: doff(:,:)  ! Field offsets
    end subroutine mosaic_getfields
  end interface
  !
  interface
    subroutine init_kernel(ker,mk,nk,smooth)
      !-----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Support for MULTISCALE clean
      !   Initialize a smoothing Kernel by a Gaussian shape
      !-----------------------------------------------------------------------
      integer, intent(in) :: mk            ! Kernel size
      integer, intent(in) :: nk            ! Kernel size
      real(4), intent(inout) :: ker(mk,mk) ! Kernel, centered on (NK+1)/2
      real(4), intent(in) :: smooth
    end subroutine init_kernel
  end interface
  !
  interface
    subroutine smooth_mask (mask,smask,nx,ny,nk)
      !-----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Support for MULTISCALE clean
      !   Enlarge a mask using a kernel
      !   Only based on kernel size
      !-----------------------------------------------------------------------
      integer, intent(in) :: nx             !
      integer, intent(in) :: ny             !
      logical, intent(in) :: mask(nx,ny)    ! Input array
      logical, intent(out) :: smask(nx,ny)  ! Smoothed array
      integer, intent(in) :: nk             !
    end subroutine smooth_mask
  end interface
  !
  interface
    subroutine smooth_kernel (beam,sbeam,nx,ny,mk,nk,ker)
      !-----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Support for MULTISCALE clean
      !   Smooth an array using a kernel
      !-----------------------------------------------------------------------
      integer, intent(in) :: nx             !
      integer, intent(in) :: ny             !
      real, intent(in) :: beam(nx,ny)       ! Input array
      real, intent(out) :: sbeam(nx,ny)     ! Smoothed array
      integer, intent(in) :: nk             !
      integer, intent(in) :: mk             !
      real, intent(in) :: ker(mk,mk)        ! Smoothing kernel, centered on (nk+1)/2
    end subroutine smooth_kernel
  end interface
  !
  interface
    subroutine smooth_masked (nx,ny,sbeam,beam,mask,mk,nk,ker)
      !-----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Support for MULTISCALE
      !   Smooth an array using a kernel, but only in a mask
      !-----------------------------------------------------------------------
      integer, intent(in) :: nx             !
      integer, intent(in) :: ny             !
      real, intent(in) :: beam(nx,ny)       ! Input array
      real, intent(out) :: sbeam(nx,ny)     ! Smoothed array
      logical, intent(in) :: mask(nx,ny)    ! Valid area
      integer, intent(in) :: mk             !
      integer, intent(in) :: nk             !
      real, intent(in) :: ker(mk,mk)        ! Smoothing kernel, centered on (nk+1)/2
    end subroutine smooth_masked
  end interface
  !
  interface
    subroutine add_kernel (clean,nx,ny,value,kx,ky,mk,nk,ker)
      !-----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Support for MULTISCALE Clean
      !   Spread a value using a Kernel and add it to result
      !-----------------------------------------------------------------------
      integer, intent(in) :: nx           ! X Image size
      integer, intent(in) :: ny           ! Y Image size
      real, intent(inout) :: clean(nx,ny) ! Summed output array
      real, intent(in) :: value           ! Input value
      integer, intent(in) :: kx           ! X Center of value
      integer, intent(in) :: ky           ! Y Center of value
      integer, intent(in) :: mk           ! Kernel size
      integer, intent(in) :: nk           ! Kernel size
      real, intent(in) :: ker(mk,mk)      ! Smoothing kernel, centered on (nk+1)/2
    end subroutine add_kernel
  end interface
  !
  interface
    subroutine amaxmask (a,mask,nx,ny,ix,iy)
      !-----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !     Support for deconvolution
      !     Search the absolute maximum, in a masked region
      !-----------------------------------------------------------------------
      integer, intent(in) :: nx           ! X size
      integer, intent(in) :: ny           ! Y size
      real, intent(in) :: a(nx,ny)        ! Values
      logical, intent(in) :: mask(nx,ny)  ! Mask
      integer, intent(out) :: ix          ! X position of max
      integer, intent(out) :: iy          ! Y position of max
    end subroutine amaxmask
  end interface
  !
  interface
    subroutine spread_kernel (nx,ny,ip,nc,dcct,value,kx,ky,nk,ker)
      !-----------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! IMAGER
      !   Support for MULTISCALE Clean
      !   Spread a value using a Kernel and add it to result
      !-----------------------------------------------------------------------
      integer, intent(in) :: nx           ! X Image size
      integer, intent(in) :: ny           ! Y Image size
      integer, intent(in) :: ip           ! Plane number 
      integer, intent(inout) :: nc        ! Number of clean components
      real, intent(out) :: dcct(:,:,:)    ! Expanded Clean Components 
      real, intent(in) :: value           ! Input value
      integer, intent(in) :: kx           ! X Center of value
      integer, intent(in) :: ky           ! Y Center of value
      integer, intent(in) :: nk           ! Actual Kernel size
      real, intent(in) :: ker(:,:)        ! Smoothing kernel, centered on (nk+1)/2
    end subroutine spread_kernel
  end interface
  !
  interface
    real function telescope_beam(rname,head)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !   Get telescope beamsize for the frequency of a GILDAS data set
      !---------------------------------------------------------------------  
      character(len=*) :: rname
      type(gildas), intent(in) :: head
    end function telescope_beam
  end interface
  !
  interface
    subroutine no_major_plot (method,head   &
         &    ,conv,niter,nx,ny,np,tcc  &
         &    ,clean,resid,poids)
      use clean_def
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER 
      !   Support for Clean -- Dummy replacement of "major_plot"
      !   Do not Plot result of Major Cycle
      !---------------------------------------------------------------------
      type (clean_par), intent(inout) :: method
      type (gildas), intent(in) :: head
      !
      logical, intent(in) ::  conv          ! Convergence status
      integer, intent(in) ::  niter         ! Number of iterations
      integer, intent(in) ::  nx            ! X size
      integer, intent(in) ::  ny            ! Y size
      integer, intent(in) ::  np            ! Number of planes
      real, intent(in) :: clean(nx,ny)      ! Clean image
      real, intent(in) :: resid(nx,ny)      ! Residuals
      real, intent(in) :: poids(nx,ny)      ! Weight image
      type (cct_par), intent(in) :: tcc(niter)
    end subroutine no_major_plot
  end interface
  !
  interface
    subroutine no_next_flux(niter,cum)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !   Support for Clean -- Dummy replacement of "next_flux"
      !   Do not draw in the <FLUX window
      !---------------------------------------------------------------------
      integer, intent(in) :: niter
      real, intent(in) :: cum
    end subroutine no_next_flux
  end interface
  !
  interface
    subroutine no_remask(method,head,nl,error)
      use clean_def
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !   Support for Clean -- Dummy replacement of "remask"
      !---------------------------------------------------------------------
      type (clean_par), intent(in) :: method
      type (gildas), intent(in) :: head
      integer, intent(in) :: nl
      logical, intent(in) :: error
    end subroutine no_remask
  end interface
  !
  interface
    subroutine get_rlist (rmsk,nx,ny,box,list,nl)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !     Return a LOGICAL mask from the a (0 - non zero) mask, and also
      !       computes its boundaries
      !---------------------------------------------------------------------
      integer, intent(in) :: nx                     ! X size
      integer, intent(in) :: ny                     ! Y size
      real(kind=4), intent(in) :: rmsk(nx,ny)       ! Real mask
      integer, intent(out) :: box(4)                ! Mask Boundary
      integer, intent(out) :: list(nx*ny)           ! List of pixels in mask
      integer, intent(out) :: nl
    end subroutine get_rlist
  end interface
  !
  interface
    subroutine gr4_slmsk (rmsk,lmsk,nx,ny,box)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !     Return a LOGICAL mask from the a (0 - non zero) mask, and also
      !       computes its boundaries
      !---------------------------------------------------------------------
      integer, intent(in) :: nx                ! X size
      integer, intent(in) :: ny                ! Y size
      real(kind=4), intent(in) :: rmsk(nx,ny)  ! Real mask
      logical, intent(out) :: lmsk(nx,ny)      ! Logical mask
      integer, intent(out) :: box(4)           ! Mask boundary (xblc,yblc,xtrc,ytrc)
    end subroutine gr4_slmsk
  end interface
  !
  interface
    subroutine get_lmask(hmask,rmask,hmap,lmask,box)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !     Return a LOGICAL mask from the a (0 - non zero) mask, and also
      !       computes its boundaries
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: hmask        ! Mask header
      type(gildas), intent(in) :: hmap         ! Map header  
      real(kind=4), intent(in) :: rmask(:,:)   ! Real mask
      logical, intent(out) :: lmask(:,:)       ! Logical mask
      integer, intent(out) :: box(4)           ! Mask boundary (xblc,yblc,xtrc,ytrc)
    end subroutine get_lmask
  end interface
  !
  interface
    subroutine getuv_conversion(uvout,nc,convert)
      use gildas_def
      use image_def
      use phys_const
      !---------------------------------------------------------------------
      ! MAPPING
      !   @ public
      !   Derive the frequency axis corresponding to a specified
      !   Velocity sampling.
      !---------------------------------------------------------------------
      type (gildas), intent(inout) :: uvout   ! Output UV table header
      integer, intent(in) :: nc               ! Number of desired channels
      real(8), intent(inout) :: convert(3)    ! Velocity conversion formula
    end subroutine getuv_conversion
  end interface
  !
  interface
    subroutine resample_uv (uvint,uvout,uvint_data,uvout_data,nt)
      use image_def
      !------------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Support for command UV_RESAMPLE
      !   Resample (in memory) a UV data set
      !------------------------------------------------------------------------
      type (gildas), intent(in) :: uvint  ! Input UV header
      type (gildas), intent(in) :: uvout  ! Output UV header
      real(4), intent(in) :: uvint_data(uvint%gil%dim(1),uvint%gil%dim(2))
      real(4), intent(out) :: uvout_data(uvout%gil%dim(1),uvout%gil%dim(2))
      integer, intent(in) :: nt         ! Number of trailing informations
    end subroutine resample_uv
  end interface
  !
  interface
    subroutine interpolate_uv(x,xdim,xinc,xref,xval, y,ydim,yinc,yref,yval)
      !-----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   Support for UV_RESAMPLE
      ! Performs the linear interpolation/integration for visibilities
      !
      ! 1) if actual interpolation (XINC <= YINC)
      !     this is a 2-point linear interpolation formula.
      !     the data is untouched if the resolution is unchanged and the shift
      !     is an integer number of channels.
      !
      ! 2) if not (XINC > YINC)
      !     boxcar convolution (width xinc-yinc) followed by linear interpolation
      !
      !-----------------------------------------------------------------------------
      integer, intent(in) :: ydim             ! Input axis size
      integer, intent(in) :: xdim             ! Output axis size
      real(8), intent(in) :: yref,yval,yinc   ! Input conversion formula
      real(8), intent(in) :: xref,xval,xinc   ! Output conversion formula
      real(4), intent(in) :: y(3,xdim)        ! Input values
      real(4), intent(out) :: x(3,ydim)       ! Output values
    end subroutine interpolate_uv
  end interface
  !
  interface
    subroutine average_uv (out,nx,nv,inp,ny,nc,num,nt)
      !------------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Support for command UV_AVERAGE
      !   Average (in memory) a series of channels of a UV data set
      !------------------------------------------------------------------------
      integer, intent(in) :: num        ! Number of selected channels
      integer, intent(in) :: nx         ! Output Visibility size
      integer, intent(in) :: nv         ! Number of visibilities
      real, intent(out) :: out(nx,nv)   ! Output Visibilities
      integer, intent(in) :: ny         ! Input visibility size
      real, intent(in) :: inp(ny,nv)    ! Input visibilities
      integer, intent(in) :: nc(num)    ! Selected Channels, first & last pairs
      integer, intent(in) :: nt         ! Number of trailing informations
    end subroutine average_uv
  end interface
  !
  interface
    subroutine compress_uv(out,nx,nv,mx,inp,ny,nc,nt)
      !------------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Support for command UV_COMPRESS
      !   Compress (in memory) by NC channels a UV data set
      !------------------------------------------------------------------------
      integer, intent(in) :: nx         ! Output Visibility size
      integer, intent(in) :: nv         ! Number of visibilities
      integer, intent(in) :: mx         ! Number of Output Channels
      real, intent(out) :: out(nx,nv)   ! Output Visibilities
      integer, intent(in) :: ny         ! Input visibility size
      real, intent(in) :: inp(ny,nv)    ! Input visibilities
      integer, intent(in) :: nc         ! Number of Channels to average
      integer, intent(in) :: nt         ! Number of trailing informations
    end subroutine compress_uv
  end interface
  !
  interface
    subroutine doself (model,resul,itype,self,weight)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !   Compute self calibraton factor
      !---------------------------------------------------------------------
      complex, intent(in) :: model   ! Model visibility
      complex, intent(in) :: resul   ! Actual observation
      integer, intent(in) :: itype   ! Type of self calibration
      complex, intent(out) :: self   ! Self calibration factor
      real, intent(out) :: weight    ! Weight scaling factor
    end subroutine doself
  end interface
  !
  interface
    subroutine doscal (nc,visi,cosi,sinu,sreel,simag,weight)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !	  Apply the self-calibration factor to the current visibility
      !	  Set weight to zero if no self-cal factor
      !---------------------------------------------------------------------
      integer, intent(in) :: nc           !  Number of channels
      real, intent(inout) :: visi(*)      !  Visibility
      real, intent(in) :: sreel           !  Real part to subtract
      real, intent(in) :: simag           !  Imaginary part to subtract
      real, intent(in) :: cosi            !  Phase rotation cos
      real, intent(in) :: sinu            !  Phase rotation sin
      real, intent(in) :: weight          !  Scaling factor of weight
    end subroutine doscal
  end interface
  !
  interface
    subroutine dosubt (nc,visi,sreel,simag)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !   Subtract a continuum value from a line visibility
      !---------------------------------------------------------------------
      integer, intent(in) :: nc           !  Number of channels
      real, intent(inout) :: visi(*)      !  Visibility
      real, intent(in) :: sreel           !  Real part
      real, intent(in) :: simag           !  Imaginary part
    end subroutine dosubt
  end interface
  !
  interface
    subroutine doflag (nc,visi)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !   Flag (by zero) a line visibility
      !---------------------------------------------------------------------
      integer, intent(in) :: nc           !  Number of channels
      real, intent(inout) :: visi(*)      !  Visibility
    end subroutine doflag
  end interface
  !
  interface
    subroutine getiba (visi,stime,time,base,uv)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !   Get baseline and time information
      !---------------------------------------------------------------------
      real, intent(in)  :: visi(*)                   ! Visibility
      real(8), intent(in) :: stime                   ! Reference time
      real(8), intent(out) :: time                   ! Time offset
      real, intent(out)  :: base(2)                  ! First and Last antenna
      real, intent(out)  :: uv(2)                    ! U and V
    end subroutine getiba
  end interface
  !
  interface
    subroutine dotime (mv,nv,visi,wtime,it,stime)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !	  Compute the observing times of the data, 
      !	  sort it and return sorting index
      !---------------------------------------------------------------------
      integer, intent(in) :: mv           ! Size of visibility
      integer, intent(in) :: nv           ! Number of visibilities
      real, intent(in) :: visi(mv,nv)     ! Visibilities
      real(8), intent(out) :: wtime(nv)   ! Sorted times
      integer, intent(inout) :: it(nv)    ! Sorting index
      real(8), intent(out) :: stime       ! Reference time
    end subroutine dotime
  end interface
  !
  interface
    subroutine geself (mv,nv,iw,visi,time,ftime,wtime,it,   &
         &    rbase,complx,uv)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !	  Compute the Observed Visibility of the "model source"
      !---------------------------------------------------------------------
      integer, intent(in) :: mv           ! Size of visibility
      integer, intent(in) :: nv           ! Number of visibilities
      real, intent(in) :: visi(mv,nv)     ! Visibilities
      real(8), intent(out) :: wtime(nv)   ! Sorted times
      integer, intent(in) :: iw(2)        ! First and Last channel
      real(8), intent(in) :: time         ! Time of observation
      real(8), intent(in) :: ftime        ! Tolerance on time +/-
      integer, intent(in) :: it(nv)       ! Ordering of visibilities
      real, intent(in) :: rbase(2)        ! Antennas
      real, intent(in) :: uv(2)           ! U and V
      complex, intent(out) :: complx      ! Result
    end subroutine geself
  end interface
  !
  interface
    subroutine findr (np,x,xlim,nlim)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   UV Tools
      !	  Find NLIM such as
      !	 	    X(NLIM-1) < XLIM <= X(NLIM)
      !	  for input data ordered.
      !	  Use a dichotomic search for that
      !---------------------------------------------------------------------
      integer, intent(in) :: np          ! Number of data points
      real(8), intent(in) :: x(np)       ! Data values
      real(8), intent(in) :: xlim        ! Value to be localized
      integer, intent(out) :: nlim       ! Found position
    end subroutine findr
  end interface
  !
  interface
    subroutine uvsort_uv (np,nv,ntrail,vin,vout,xy,cs,uvmax,uvmin,error)
      use gildas_def
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !     Rotate, Shift and Sort a UV table for map making
      !     Differential precession should have been applied before.
      !---------------------------------------------------------------------
      integer, intent(in) :: np        ! Size of a visibility
      integer, intent(in) :: nv        ! Number of visibilities
      integer, intent(in) :: ntrail    ! Number of trailing daps
      real, intent(in) :: vin(np,nv)   ! Input visibilities
      real, intent(out) :: vout(np,nv) ! Output visibilities
      real, intent(in) :: xy(2)        ! Phase shift
      real, intent(in) :: cs(2)        ! Frame Rotation
      real, intent(out) :: uvmax       ! Max UV value
      real, intent(out) :: uvmin       ! Min UV value
      logical, intent(out) :: error    !
    end subroutine uvsort_uv
  end interface
  !
  interface
    subroutine loaduv (visi,np,nv,cs,u,v,s,uvmax,uvmin)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER    UVSORT routines
      !     Load new U,V coordinates and sign indicator into work arrays
      !     for sorting.
      !---------------------------------------------------------------------
      integer, intent(in) :: np       ! Size of a visibility
      integer, intent(in) :: nv       ! Number of visibilities
      real, intent(in) :: visi(np,nv) ! Input visibilities
      real, intent(in) :: cs(2)       ! Rotation parameter
      real, intent(out) :: u(nv)      ! Output U and V coordinates
      real, intent(out) :: v(nv)      ! Output U and V coordinates
      logical, intent(out) :: s(nv)   ! V Sign indicator
      real, intent(inout) :: uvmax    ! Maximum length
      real, intent(inout) :: uvmin    ! Minimum baseline
    end subroutine loaduv
  end interface
  !
  interface
    subroutine chksuv (nv,v,it,sorted)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING    UVSORT routines
      !   Check if visibilities are sorted
      !---------------------------------------------------------------------
      integer, intent(in) :: nv      ! Number of visibilities
      real, intent(in) :: v(nv)      ! Visibilities
      integer, intent(out) :: it(nv) ! Sorting pointer
      logical, intent(out) :: sorted ! short cut
    end subroutine chksuv
  end interface
  !
  interface
    subroutine sortuv (vin,vout,np,nv,ntrail,xy,u,v,s,it)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING    UVSORT routines
      !     Sort an input UV table into an output one.
      !     The output UV table is a rotated, phase shifted copy of
      !     the input one, with all V negative and increasing
      !---------------------------------------------------------------------
      integer, intent(in) :: np         ! Size of a visibility
      integer, intent(in) :: nv         ! Number of visibilities
      integer, intent(in) :: ntrail     ! Number of trailing daps
      real, intent(in) :: vin(np,nv)    ! Input visibilities
      real, intent(out) :: vout(np,nv)  ! Output visibilities
      real, intent(in) :: xy(2)         ! Phase shifting factors
      real, intent(in) :: u(nv)         ! New U coordinates
      real, intent(in) :: v(nv)         ! New V coordinates
      logical, intent(in) :: s(nv)      ! Sign of new visibility
      integer, intent(in) :: it(nv)     ! Pointer to old visibility
    end subroutine sortuv
  end interface
  !
  interface
    subroutine uniform_beam (map_name,uv_taper,map_size,map_cell,   &
            &    uniform,wcol,mcol,work,error,mode,                 &
            &    beams,mbeam,start,step,uvmax,result,huv,duv)
      use gildas_def
      use image_def
      use gbl_message
      !------------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   UV_STAT Compute a map from a CLIC UV Sorted Table
      !   by Gridding and Fast Fourier Transform, with
      !   one single beam for all channels.
      !
      ! Input :
      ! a precessed UV table, sorted in V, ordered in
      ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
      ! Output :
      ! a beam image
      ! a VLM cube
      ! Work space :
      ! a  VLM complex Fourier cube (first V value is for beam)
      !------------------------------------------------------------------------
      type(gildas), intent(in) :: huv               ! UV Table Header
      real, intent(inout) :: duv(:,:)               ! Visibility Array
      character(len=*), intent(in) :: map_name      ! Name of image (void)
      character(len=*), intent(in) :: mode          ! Mode of statistics
      real, intent(in) :: uv_taper(3)               ! UV Taper
      integer, intent(in) :: map_size(2)            ! Number of pixels
      real, intent(in) :: map_cell(2)               ! Pixel size
      real, intent(in) :: uniform(2)                ! Robust parameter
      integer, intent(inout) :: wcol                ! Weight column
      integer, intent(inout) :: mcol(2)             ! Channel range
      integer, intent(in) :: mbeam      ! Number of beams
      real :: work(*)                   ! Work array
      logical :: error                  ! Error flag
      real, intent(out) :: beams(map_size(1),map_size(2),mbeam)
      real, intent(inout) :: start      ! Starting value for range
      real, intent(inout) :: step       ! Step for range
      real, intent(in) :: uvmax         ! Max UV distance
      real, intent(out) :: result(10,8) ! Resulting beam characteristics
    end subroutine uniform_beam
  end interface
  !
  interface
    subroutine extracs (np,nx,ny,ip,in,out,lx,ly)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !     Extract a Fourier plane from the FFT cube
      !     Plane and Cube may have different X,Y dimensions
      !----------------------------------------------------------------------
      integer,intent(in) :: np  ! Number of planes
      integer,intent(in) :: nx  ! output FFT X plane size
      integer,intent(in) :: ny  ! output FFT Y plane size
      integer,intent(in) :: ip  ! Plane to be extracted
      integer,intent(in) :: lx  ! input FFT cube X plane size
      integer,intent(in) :: ly  ! input FFT cube Y plane size
      complex,intent(in) :: in(np,lx,ly) ! Input FFT cube
      complex,intent(out) :: out(nx,ny)  ! Output 2-D FFT
    end subroutine extracs
  end interface
  !
  interface
    subroutine extrac (np,nx,ny,ip,in,out)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !     Extract a Fourier plane from an FFT cube
      !     Plane and Cube must have same X,Y dimensions
      !----------------------------------------------------------------------
      integer,intent(in) :: np  ! Number of planes
      integer,intent(in) :: nx  ! FFT X plane size
      integer,intent(in) :: ny  ! FFT Y plane size
      integer,intent(in) :: ip  ! Plane to be extracted
      complex,intent(in) :: in(np,nx,ny) ! Input FFT cube
      complex,intent(out) :: out(nx,ny)  ! Output 2-D FFT
    end subroutine extrac
  end interface
  !
  interface
    subroutine dovisi (np,nv,visi,vv,ww,jw)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Extract V coordinate and Weight value
      !----------------------------------------------------------------------
      integer, intent(in) :: np        ! Size of visibilities
      integer, intent(in) :: nv        ! Number of visibilities
      real, intent(in) :: visi(np,nv)  ! Visibilities
      real, intent(out) :: vv(nv)      ! V values
      real, intent(out) :: ww(nv)      ! Weight values
      integer, intent(in) :: jw        ! Weight column
    end subroutine dovisi
  end interface
  !
  interface
    subroutine dogrid (corr,corx,cory,nx,ny,beam)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Compute grid correction array, with normalisation
      !   of beam to 1.0 at maximum pixel
      !----------------------------------------------------------------------
      integer, intent(in) :: nx     ! X size
      integer, intent(in) :: ny     ! Y size
      real, intent(in) :: beam(nx,ny) ! Denormalized beam
      real, intent(in) :: corx(nx)    ! X grid correction
      real, intent(in) :: cory(ny)    ! Y Grid correction
      real, intent(out) :: corr(nx,ny) ! Final grid correction and beam normalization
    end subroutine dogrid
  end interface
  !
  interface
    subroutine docorr (map,corr,nd)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Apply grid correction to map
      !----------------------------------------------------------------------
      integer, intent(in) :: nd
      real, intent(inout) :: map(nd)
      real, intent(in) :: corr(nd)
    end subroutine docorr
  end interface
  !
  interface
    subroutine docoor (n,xinc,x)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Compute FFT grid coordinates in U or V
      !----------------------------------------------------------------------
      integer,intent(in) :: n
      real, intent(out) :: x(n)
      real, intent(in) :: xinc
    end subroutine docoor
  end interface
  !
  interface
    subroutine findp (nv,xx,xlim,nlim)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING  Utility
      !   Find NLIM such as
      !   XX(NLIM-1) < XLIM < XX(NLIM)
      !   for input data ordered, retrieved from memory
      !   Assumes NLIM already preset so that XX(NLIM-1) < XLIM
      !----------------------------------------------------------------------
      integer, intent(in) :: nv       ! Number of values
      integer, intent(inout) :: nlim  ! Preset Position
      real, intent(in) :: xx(nv)  ! Input order value
      real, intent(in) :: xlim    ! Value to be located
    end subroutine findp
  end interface
  !
  interface
    subroutine findm (nv,xx,xlim,nlim)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING  Utility
      !   Find NLIM such as
      !     XX(NLIM-1) < XLIM < XX(NLIM)
      !   for input data ordered, retrieved from memory
      !   Assumes NLIM already preset so that XLIM < XX(NLIM)
      !----------------------------------------------------------------------
      integer, intent(in) :: nv       ! Number of values
      integer, intent(inout) :: nlim  ! Preset Position
      real, intent(in) :: xx(nv)  ! Input order value
      real, intent(in) :: xlim    ! Value to be located
    end subroutine findm
  end interface
  !
  interface
    subroutine grdtab (n, buff, bias, corr)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING  Utility
      !   Compute fourier transform of gridding function
      !----------------------------------------------------------------------
      integer, intent(in) :: n     ! Number of pixels, assuming center on N/2+1
      real, intent(in) :: buff(*)  ! Gridding function, tabulated every 1/100 cell
      real, intent(in) :: bias     ! Center of gridding function
      real, intent(out) :: corr(n) ! Gridding correction FT
    end subroutine grdtab
  end interface
  !
  interface
    subroutine retocm(r,z,nx,ny)
      !------------------------------------------------------------------------
      ! @  public
      ! MAPPING
      !   Convert real to complex, with Shifting in corners for FFT
      !------------------------------------------------------------------------
      integer, intent(in) :: nx, ny         ! Problem size
      real, intent(in) :: r(nx,ny)          ! Real values
      complex, intent(out) :: z(nx, ny)     ! Complex shifted values
    end subroutine retocm
  end interface
  !
  interface
    subroutine cmtore (in,out,nx,ny)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING Utility
      !   Extract Real image from Fourier Transform of its complex FFT
      !   with appropriate recentering
      !----------------------------------------------------------------------
      integer, intent(in) :: nx         ! Size of map
      integer, intent(in) :: ny         ! Size of map
      complex, intent(in) :: in(nx,ny)  ! Complex FFT
      real, intent(out) :: out(nx,ny)   ! Extracted real image
    end subroutine cmtore
  end interface
  !
  interface
    subroutine convfn (ctype, parm, buffer, bias)
      use gildas_def
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! MAPPING
      !   CONVFN computes the convolving functions and stores them in
      !   the supplied buffer. Values are tabulated every 1/100 cell.
      !----------------------------------------------------------------------
      integer, intent(inout) :: ctype
      real(4), intent(inout) :: parm(10)
      real(4), intent(out)   :: buffer(:)
      real(4), intent(out)   :: bias
    end subroutine convfn
  end interface
  !
  interface
    subroutine grdflt (ctypx, ctypy, xparm, yparm)
      !----------------------------------------------------------------------
      ! @ public
      !
      !     GRDFLT determines default parameters for the convolution functions
      !     If no convolving type is chosen, an Spheroidal is picked.
      !     Otherwise any unspecified values ( = 0.0) will be set to some
      !     value.
      ! Arguments:
      !     CTYPX,CTYPY           I  Convolution types for X and Y direction
      !                                1 = pill box
      !                                2 = exponential
      !                                3 = sinc
      !                                4 = expontntial * sinc
      !                                5 = spheroidal function
      !     XPARM(10),YPARM(10)   R*4  Parameters for the convolution fns.
      !                                (1) = support radius (cells)
      !
      !----------------------------------------------------------------------
      integer, intent(inout) :: ctypx,ctypy
      real(4), intent(inout) :: xparm(10), yparm(10)
    end subroutine grdflt
  end interface
  !
  interface
    subroutine uvgmax(huv,visi,uvmax,uvmin)
      use image_def
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING Support for UV_MAP
      !       Get the Min Max of UV distances
      !----------------------------------------------------------------------
      type (gildas), intent(inout) :: huv
      real, intent(in) ::  visi(:,:) ! Visibilities
      real, intent(out) :: uvmax ! Max baseline
      real, intent(out) :: uvmin ! Min baseline
    end subroutine uvgmax
  end interface
  !
  interface
    function sump(n,a)
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   Support for UV_MAP
      !       Return the sum of positive values in array
      !----------------------------------------------------------------------
      real :: sump    ! Return value, intent(out)
      integer, intent(in) :: n   ! Number of values
      real, intent(in) :: a(n)   ! Values
    end function sump
  end interface
  !
  interface
    subroutine dotape (jc,nv,visi,jx,jy,taper,we)
      use gildas_def
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING  Support for UV_MAP
      !     Apply taper to the weights of the visibility points.
      !----------------------------------------------------------------------
      integer, intent(in) :: nv          ! number of values
      integer, intent(in) :: jc          ! Size of a visibility
      integer, intent(in) :: jx          ! X coord location in VISI
      integer, intent(in) :: jy          ! Y coord location in VISI
      real, intent(in) :: visi(jc,nv)    ! Visibilities
      real, intent(in) :: taper(4)       ! Taper definition
      real, intent(inout) :: we(nv)      ! Weights
    end subroutine dotape
  end interface
  !
  interface
    subroutine doweig (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,error,code)
      use gildas_def
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public-mandatory
      !
      ! MAPPING   Support for UV_MAP
      !     Compute weights of the visibility points.
      !----------------------------------------------------------------------
      integer, intent(in) ::  nv          ! number of values
      integer, intent(in) ::  jc          ! Number of "visibilities"
      integer, intent(in) ::  jx          ! X coord location in VISI
      integer, intent(in) ::  jy          ! Y coord location in VISI
      integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
      real, intent(in) ::  visi(jc,nv)    ! Visibilities
      real, intent(in) ::  unif           ! uniform cell size in Meters
      real, intent(inout) ::  we(nv)      ! Weight array
      real, intent(in) ::  wm             ! on input: % of uniformity
      real, intent(in) ::  vv(nv)         ! V values, pre-sorted
      logical, intent(inout) :: error
      integer, intent(in), optional :: code
    end subroutine doweig
  end interface
  !
  interface
    subroutine doweig_sph (jc,nv,visi,jx,jy,jw,unif,we,wm,vv,error,code)
      use gildas_def
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING   Support for UV_MAP
      !     Compute weights of the visibility points.
      !----------------------------------------------------------------------
      integer, intent(in) ::  nv          ! number of values
      integer, intent(in) ::  jc          ! Number of "visibilities"
      integer, intent(in) ::  jx          ! X coord location in VISI
      integer, intent(in) ::  jy          ! Y coord location in VISI
      integer, intent(in) ::  jw          ! Location of weights. If .LE.0, uniform weight
      real, intent(in) ::  visi(jc,nv)    ! Visibilities
      real, intent(in) ::  unif           ! uniform cell size in Meters
      real, intent(inout) ::  we(nv)      ! Weight array
      real, intent(in) ::  wm             ! on input: % of uniformity
      real, intent(in) ::  vv(nv)         ! V values, pre-sorted
      logical, intent(inout) :: error
      integer, intent(in), optional :: code  ! Number of sub-cells per UV uniform cell size
    end subroutine doweig_sph
  end interface
  !
  interface
    subroutine scawei (nv,uni,ori,wall)
      !---------------------------------------------------------
      ! @ public
      !
      ! MAPPING
      !   Scale the weights
      !---------------------------------------------------------
      integer, intent(in) :: nv     ! Number of visibilities
      real, intent(out) :: uni(nv)  ! Re-weighted weights
      real, intent(in)  :: ori(nv)  ! Original weights
      real, intent(out) :: wall     ! Sum of weights
    end subroutine scawei
  end interface
  !
  interface
    subroutine howmany_beams(uvin, nvisi, din, cases, ncase, error)
      use image_def
      !----------------------------------------------------------------------
      ! @ public
      !
      ! MAPPING support routine for command
      !     UV_CHECK
      !----------------------------------------------------------------------
      type(gildas), intent(in) :: uvin                  ! UV table header
      integer, intent(in) :: nvisi                      ! Number of visibilities
      real, intent(in), target :: din(uvin%gil%dim(1),nvisi)    ! UV data
      integer, intent(inout) :: cases(uvin%gil%nchan)   ! Possible cases for beams
      integer, intent(inout) :: ncase                   ! Number of cases
      logical, intent(out) :: error                     ! flag
    end subroutine howmany_beams
  end interface
  !
  interface
    subroutine t_channel_sampling(rname,huv,nident,msize)
      use image_def
      use clean_default
      use gbl_message
      !----------------------------------------------------------
      ! @ public-mandatory
      !
      ! MAPPING
      !   Check how many channels can have the same beam
      !----------------------------------------------------------
      character(len=*), intent(in) :: rname      ! Caller name
      type(gildas), intent(in) :: huv            ! UV data header
      integer, intent(out) :: nident             ! returned step
      integer, intent(in) :: msize               ! Current map_size
    end subroutine t_channel_sampling
  end interface
  !
  interface
    subroutine t_continuum(hluv,hcuv,channels,uvcode,error,alpha)
      use gildas_def
      use image_def
      use uvmap_def
      use gbl_message
      !$ use omp_lib
      !----------------------------------------------------------
      ! @ public-mandatory
      !
      ! IMAGER
      !   Support routine for UV_CONTINUUM 
      !   create a continuum UV table from a Line one
      !----------------------------------------------------------
      !
      type (gildas), intent(in) :: hluv       ! Line UV header
      type (gildas), intent(inout) :: hcuv    ! Continuum UV header
      integer, intent(in) :: channels(3)      ! Channel selection
      integer, intent(in) :: uvcode           ! Type of UV data
      logical, intent(out) :: error
      real, intent(in), optional :: alpha     ! Spectral index
    end subroutine t_continuum
  end interface
  !
  interface
    subroutine my_compress_uv(out,nx,nv,mx,inp,ny,nc,nt, print)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !   Support for command UV_COMPRESS
      !   Compress (in memory) by NC channels a UV data set
      !---------------------------------------------------------------------
      integer, intent(in) :: nx         ! Output Visibility size
      integer, intent(in) :: nv         ! Number of visibilities
      integer, intent(in) :: mx         ! Number of Output Channels
      real, intent(out) :: out(nx,nv)   ! Output Visibilities
      integer, intent(in) :: ny         ! Input visibility size
      real, intent(in) :: inp(ny,nv)    ! Input visibilities
      integer, intent(in) :: nc         ! Number of Channels to average
      integer, intent(in) :: nt         ! Number of trailing informations
      logical, intent(in) :: print
    end subroutine my_compress_uv
  end interface
  !
  interface
    function imager_nitems(head,last)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !
      ! Returns the number of blocks in the last dimension
      !--------------------------------------------------------------------- 
      integer :: imager_nitems         ! intent(out) function value
      type(gildas), intent(in) :: head ! Input Gildas header
      integer, intent(in) :: last      ! Last blocked dimension
    end function imager_nitems
  end interface
  !
  interface
    subroutine map_beamsize(map,huv,duv,uvmax,error)
      use image_def
      use clean_def
      use gbl_message
      !
      ! @ public
      !     Get the natural synthesized beam size
      !
      type(uvmap_par), intent(in) :: map  ! MAP parameters
      type(gildas), intent(in) :: huv   ! UV Header
      real, intent(in) :: duv(:,:)      ! UV data
      real, intent(in) :: uvmax         ! Maximum UV value
      logical, intent(out) :: error     ! Error flag
    end subroutine map_beamsize
  end interface
  !
  interface
    subroutine time_compress(invisi,nd,first,last,wcol, out, ovisi, jv, &
      & mvisi, error)
      use gildas_def
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !   Time compress a UV table
      !   Compute visibilities for a single output time
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: out
      integer, intent(in) :: nd                     ! Visibility size
      real, intent(in) :: invisi(:,:)               ! Input visibilities
      integer, intent(in) :: wcol                   ! Weight column
      real, intent(inout) :: ovisi(:,:)             ! Output visibilities
      integer, intent(in) :: first, last            ! First and last input visibilities
      integer, intent(inout) :: jv                  ! Current output visibility number
      integer, intent(in) :: mvisi
      logical, intent(out) :: error
    end subroutine time_compress
  end interface
  !
  interface
    subroutine add_visiw(out,ovisi,aw,avisi,sw)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !   Add a visibility to current output one
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: out   ! Input image header
      real, intent(inout) :: ovisi(:)   ! Output visibilities
      real, intent(in) :: aw            ! Input weight
      real, intent(inout) :: avisi(:)   ! Input visibilities
      real, intent(inout) :: sw         ! Output weight
    end subroutine add_visiw
  end interface
  !
  interface
    subroutine mean_visiw(out,ovisi,sw)
      use image_def
      !---------------------------------------------------------------------
      ! @ public
      !   Normalize the final visibility
      !---------------------------------------------------------------------
      type(gildas), intent(in) :: out   ! Input image header
      real, intent(inout) :: ovisi(:)   ! Output visibilities
      real, intent(inout) :: sw         ! Output weight
    end subroutine mean_visiw
  end interface
  !
  interface
    subroutine time_integrate(rname,huv,mytime,wcol,nu,nv,vin,vout,nvout,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! Time-Average a UV data set
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: rname  ! Calling routine
      type(gildas), intent(in) :: huv        ! UV Header
      real(4), intent(in) :: mytime          ! Integration time
      integer, intent(in) :: wcol            ! Weight column
      integer, intent(in) :: nu              ! Size of a visibility
      integer, intent(in) :: nv              ! Number of input visibilities
      real, intent(in) :: vin(:,:)           ! input visibilities
      real, intent(inout) :: vout(:,:)       ! output visibilities
      integer, intent(out) :: nvout          ! Number of output visibilities
      logical, intent(out) :: error          ! Error flag
    end subroutine time_integrate
  end interface
  !
  interface
    subroutine fit_parabola(n,x,y,a,b,c,d)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! Find the characteristics of a parabola
      ! Parabola definition a + b.x + c.x^2
      !---------------------------------------------------------------------
      integer, intent(in) :: n  ! Number of values
      real, intent(in) :: x(n)  ! X coordinates
      real, intent(in) :: y(n)  ! Y values
      real, intent(inout) :: a    ! Constant term
      real, intent(inout) :: b    ! Linear term
      real, intent(inout) :: c    ! Second order term
      real, intent(inout) :: d    ! rms of fit
    end subroutine fit_parabola
  end interface
  !
  interface
    subroutine clip_lineregions(rname,data,nchan,nhist,bval,eval,clip,debug,rms, &
      & noise_ratio)
      use gildas_def
      use gbl_message
      !
      ! @ public
      !
      character(len=*), intent(in) :: rname
      integer(kind=index_length), intent(in) :: nchan   ! Data size
      integer(kind=index_length), intent(in) :: nhist   ! Histogram size
      real, intent(inout) :: data(nchan)                ! Data to be clipped
      real, intent(in) :: bval, eval                    ! Blanking values to be used
      real, intent(in) :: clip                          ! Clipping level in Sigma
      logical, intent(in) :: debug                      ! Debug printout
      real, intent(in) :: rms                           ! Expected rms noise
      real, intent(in) :: noise_ratio                   ! Noise scaling factor
    end subroutine clip_lineregions
  end interface
  !
  interface
    subroutine guess_lineregions(data,nchan,bval,eval,mylines,nb)
      use gildas_def
      ! @ public
      integer(kind=index_length), intent(in) :: nchan   ! Data size
      real, intent(inout) :: data(nchan)                ! Blanked data 
      real, intent(in) :: bval, eval                    ! Blanking values to be used
      integer, intent(inout) :: mylines(nchan)          ! Line channel list
      integer, intent(inout) :: nb                      ! Number of line channels
    end subroutine guess_lineregions
  end interface
  !
  interface
    subroutine median_filter(temp,nchan,bval,eval,amed,amin,amax)
      use gildas_def
      ! @ public
      integer(kind=index_length), intent(in) :: nchan
      real, intent(inout) :: temp(nchan)
      real, intent(in) :: bval
      real, intent(in) :: eval
      real, intent(out) :: amed
      real, intent(out) :: amin
      real, intent(out) :: amax
    end subroutine median_filter
  end interface
  !
  interface
    subroutine compute_continuum(hmap,hcont,spectrum,nhist,clip_value,error,box,mask)
      use image_def
      use gbl_message
      !
      ! @ public-mandatory
      !
      type(gildas), intent(in) :: hmap
      type(gildas), intent(inout) :: hcont
      real, intent(out) :: spectrum(:,:)
      integer(kind=index_length), intent(in) :: nhist
      real, intent(in) :: clip_value
      logical, intent(out) :: error
      integer(kind=4), intent(in) :: box(4)
      logical, intent(in), optional :: mask(:,:)
    end subroutine compute_continuum
  end interface
  !
  interface
    subroutine uv_steps(visx, n1, nvx, q, nq, eff_dim,   &
         &    array,meter,flag,nsize)
      !------------------------------------------------------------------
      ! IMAGER
      !   @ public 
      !
      !------------------------------------------------------------------
      integer, intent(in) :: n1              ! Size of a visibility
      integer, intent(in) :: nvx             ! Number of a visibilities
      real, intent(in) :: visx(n1,nvx)       ! Visibilities
      integer, intent(in) :: nq              ! Number of radii
      real, intent(in) :: q(nq+1)            ! Radii
      integer, intent(out) :: eff_dim        ! Actual size of radial array
      integer, intent(in) :: nsize           ! Size of radial array
      integer, intent(out) :: array(nsize)   ! Cell value
      real, intent(inout) :: meter(nsize)    ! Cell position
      integer, intent(out) :: flag(nsize)    ! Is there any data ?
    end subroutine uv_steps
  end interface
  !
  interface
    subroutine uv_circle_average(n1, nvx, visx, nq, visy, q, eff_dim,   &
         &    array, meter, nsize)
      !------------------------------------------------------------------
      ! IMAGER
      !   @ public 
      !
      !------------------------------------------------------------------
      integer, intent(in) :: n1              ! Size of a visibility
      integer, intent(in) :: nvx             ! Number of a visibilities
      real, intent(in) :: visx(n1,nvx)       ! Visibilities
      integer, intent(in) :: nq              ! Number of radii
      real, intent(in) :: q(nq+1)            ! Radii
      integer, intent(in) :: eff_dim         ! Actual size of radial array
      real, intent(out) :: visy(n1, eff_dim) ! Output visibilities        !
      integer, intent(in) :: nsize           ! Size of radial array
      integer, intent(in) :: array(nsize)    ! Cell value
      real, intent(inout) :: meter(nsize)       ! Cell position
    end subroutine uv_circle_average
  end interface
  !
  interface
    subroutine shift_and_squeeze_uv(hin,hou,nvisi,xy,cs,cosi)
      use image_def
      !------------------------------------------------------------------
      ! IMAGER
      !   @ public 
      !
      ! Apply a Phase shift to the data (in the previous frame)
      ! then rotate the frame (u,v) coordinates.
      !------------------------------------------------------------------
      type(gildas), intent(in)  :: hin    ! Input UV data 
      type(gildas), intent(inout) :: hou  ! Output UV data
      integer, intent(in) :: nvisi        ! Number of visibilities
      real, intent(in) :: xy(2)  ! Phase Shift
      real, intent(in) :: cs(2)  ! Cos/Sin of Rotation
      real, intent(in) :: cosi   ! Cos of inclination
    end subroutine shift_and_squeeze_uv
  end interface
  !
  interface
    subroutine do_apply_cal(ncol,nch,nvis,data,cal,gain,flag,index)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER command SOLVE
      ! Task UV_GAIN
      !
      !     Apply Gain Table to input UV data set
      !
      ! Index is the ordering of the gain. Gain(i) applies to Visi(Index(i))
      !---------------------------------------------------------------------
      integer, intent(in) :: ncol                   ! Number of column in visi
      integer, intent(in) :: nvis                   ! Number of visibilities
      integer, intent(in) :: nch                    ! Number of channels
      real, intent(in) :: data(ncol,nvis)           ! Raw data
      real, intent(out) :: cal(ncol,nvis)           ! Calibrated data
      real, intent(in) :: gain(10,nvis)             ! Gain array
      logical, intent(in) :: flag                   ! Flag data with no solution
      integer, intent(in) :: index(nvis)            ! Visibility order
    end subroutine do_apply_cal
  end interface
  !
  interface
    subroutine do_ante_gain(do_amp,do_pha,nvis,times,tinteg,snr, &
      & basegain,antegain,refant,ntimes,nantes,smin,scal,flag,error)
      use gildas_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER command SOLVE
      ! Task UV_GAIN
      !
      !     S.Guilloteau & V.Pietu, derived from R.Lucas CLIC code
      !
      !   Compute complex gains (antenna-based solution) from a set
      !   of initial Antenna gains, smoothing in time as needed.
      !
      !   The initial Antenna gains must be sorted by increasing time
      !---------------------------------------------------------------------
      logical, intent(in)  :: do_amp                 ! Calibrate amplitude ?
      logical, intent(in)  :: do_pha                 ! Compute phase ?
      integer, intent(in)  :: nvis                   ! Number of visibilities
      real(8), intent(in)  :: times(nvis)            ! Times of visibilities
      real, intent(in)  :: tinteg                    ! Integration time
      real, intent(in)  :: snr                       ! requested Signal to Noise 
      real, intent(in)  :: basegain(10,nvis)         ! Input baseline gain array
      real, intent(inout)  :: antegain(10,nvis)      ! Output antenna gain array
      integer, intent(in) :: refant                  ! Reference antenna
      integer, intent(out) :: ntimes                 ! Number of time steps
      integer, intent(out) :: nantes                 ! Number of antennas
      real, intent(in) :: smin  ! Min SNR for de-biasing
      real, intent(in) :: scal  ! Scale factor for SNR de-biasing 
      logical, intent(in) :: flag                    ! Flag wrong solutions ?
      logical, intent(out) :: error                  ! In case nothing left ...
    end subroutine do_ante_gain
  end interface
  !
  interface
    subroutine do_base_gain(do_amp,do_pha,nvis,ncol,icol,times,index,   &
         &    data,model,gain)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER command SOLVE
      !   developped from Task UV_GAIN
      !
      !     S.Guilloteau & V.Pietu, from R.Lucas CLIC code
      !
      !   Compute the Baseline-Based Gain by comparing the Data
      !   to the Model, retaining either Amplitude or Phase
      !   (or both, but this is not used by the calling routines so far)
      ! 
      !   We use channel Icol from Data table for the Data.
      !   Model and Gain are assumed to be continuum (i.e. single-channel)
      !   tables.
      !   Gain will contain the observed baseline gains, in an increasing 
      !   time order.
      !   Times is a Real(8) array to sort out date/time 
      !   Index is an integer array yielding the ordering
      !     gain(i) = data/model (Index(i))
      !---------------------------------------------------------------------
      logical, intent(in) :: do_amp                 ! Calibrate amplitude
      logical, intent(in) :: do_pha                 ! Calibrate phase
      integer, intent(in) :: nvis                   ! Number of visibilities
      integer, intent(in) :: ncol                   ! Size of a visibility
      integer, intent(in) :: icol                   ! Reference column
      real(8), intent(out) :: times(nvis)           ! Time stamps of visibilities
      integer, intent(out) :: index(nvis)           ! Index of visibilities
      real, intent(in) :: data(ncol,nvis)           ! Raw visibilities
      real, intent(in) :: model(10,nvis)            ! Modeled visibilities
      real, intent(out) :: gain(10,nvis)            ! Gain solution
    end subroutine do_base_gain
  end interface
  !
  interface
    subroutine gain_ant(iy,nbas,iant,jant,iref,nant,y,w,wk2,wk3,ss,c,wc,error)
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER command SOLVE
      ! Task UV_GAIN
      !
      !     S.Guilloteau & V.Pietu, from R.Lucas CLIC code
      !
      ! gain_ant 
      !     computes a weighted least-squares approximation
      !     to the antenna amplitudes or phases
      !     for an arbitrary set of baseline data points.
      !---------------------------------------------------------------------
      integer, intent(in) :: iy                ! 1 for log(amplitude), 2 for phase
      integer, intent(in) :: nbas              ! the number of baselines
      integer, intent(in) :: iant(nbas)        ! start antenna for each baseline
      integer, intent(in) :: jant(nbas)        ! end  antenna for each baseline
      integer, intent(in) :: iref              ! Reference antenna for phases
      integer, intent(in) :: nant              ! the number of antennas
      real(8), intent(in) :: y(nbas)           ! the data values
      real(8), intent(in) :: w(nbas)           ! weights
      real(8), intent(inout) :: wk2(nant,nant) ! work space
      real(8), intent(inout) :: wk3(nant)      ! work space
      real(8), intent(out) :: ss(nbas)         ! rms of fit for each baseline
      real(8), intent(out) :: c(nant)          ! the gains
      real(8), intent(out) :: wc(nant)         ! the weights
      logical, intent(out) :: error            !
    end subroutine gain_ant
  end interface
  !
  interface
    subroutine do_get_cgain(ntimes,nantes,hsol,again,refant,scale_gain,error)
      use gildas_def
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public-mandatory
      ! 
      ! IMAGER Command SOLVE
      ! Task UV_GAIN
      !
      ! Prepare the Solution Table: Amplitude & Phase correction per antenna.
      !
      ! Convert the formatted temporary files to a Gildas Table
      !---------------------------------------------------------------------
      integer, intent(in) :: ntimes   ! Number of times
      integer, intent(in) :: nantes   ! Maximum number of antennas
      integer, intent(in) :: refant   ! Reference antenna
      type(gildas), intent(inout) :: hsol  ! Antenna Solution table
      real, allocatable, intent(out) :: again(:,:)  ! Antenna Solution array
      real, intent(out) :: scale_gain ! Scaling Amplitude factor
      logical, intent(inout) :: error ! Error flag
    end subroutine do_get_cgain
  end interface
  !
  interface
    subroutine do_uvmodel (visi,nc,nv,a,nx,ny,nf,   &
         &    freq,xinc,yinc,factor)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !
      ! Compute the MODEL UV data set from the current CCT table
      !
      !     Uses an intermediate FFT with further interpolation for
      !     better speed than UV_CCT
      ! CAUTION
      !     Frequency (and hence Lambda/D) is assumed constant 
      !---------------------------------------------------------------------
      !
      integer, intent(in) :: nc                     ! Size of visibility
      integer, intent(in) :: nv                     ! Number of visibilities
      real, intent(inout) :: visi(nc,nv)            ! Visibilities
      integer, intent(in) :: nx                     ! X Size of image
      integer, intent(in) :: ny                     ! Y Size of image
      integer, intent(in) :: nf                     ! Number of frequencies
      complex, intent(in) :: a(nx,ny,nf)            ! Clean Component Image
      real(8), intent(in) :: freq                   ! Reference frequency
      real(8), intent(in) :: xinc                   ! X Pixel increment
      real(8), intent(in) :: yinc                   ! Y Pixel increment
      real, intent(in) :: factor                    ! Flux scale factor
    end subroutine do_uvmodel
  end interface
  !
  interface
    subroutine copyuv (nco,nv,out,nci,in)
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !
      ! Copy structure of UV data, but not the (Real,Imag) columns
      !---------------------------------------------------------------------
      integer, intent(in)  :: nco                    ! Size of output visi.
      integer, intent(in)  :: nv                     ! Number of visibilities
      real, intent(out)  :: out(nco,nv)              ! Output Visibilities
      integer, intent(in) :: nci                     ! Size of input visi.
      real, intent(in)  :: in(nci,nv)                ! Input visibilities
    end subroutine copyuv
  end interface
  !
  interface
    subroutine uvshort_trim_short(rname,huv,duv,change)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! IMAGER
      !     Remove all short spacing visibilities
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: rname
      type(gildas), intent(inout) :: huv
      real, intent(inout) :: duv(:,:)
      logical, intent(out) :: change
    end subroutine uvshort_trim_short
  end interface
  !
  interface
    subroutine get_gildas(rname,cinp,desc,hin,error)
      use gkernel_types
      use gbl_message
      !---------------------------------------------------------------------
      ! IMAGER
      ! @ public
      !   General tool to incarnate the SIC variable into a Gildas 
      !   derived type Fortran variable
      ! 
      !---------------------------------------------------------------------
      character(len=*), intent(in) :: rname         ! Input caller name
      character(len=*), intent(in) :: cinp          ! Input variable name
      type(sic_descriptor_t), intent(out) :: desc   ! Descriptor
      type(gildas), intent(inout) :: hin            ! Gildas header 
      logical, intent(inout) :: error               ! Error flag 
    end subroutine get_gildas
  end interface
  !
  interface
    subroutine resize_real_array(array,osize,nsize)
      ! @ public-mandatory
      real, allocatable, intent(inout) :: array(:)
      integer, intent(in) :: osize
      integer, intent(in) :: nsize
    end subroutine resize_real_array
  end interface
  !
  interface
    subroutine resize_inte_array(array,osize,nsize)
      ! @ public-mandatory
      integer, allocatable, intent(inout) :: array(:)
      integer, intent(in) :: osize
      integer, intent(in) :: nsize
    end subroutine resize_inte_array
  end interface
  !
  interface
    subroutine resize_dble_array(array,osize,nsize)
      ! @ public-mandatory
      real(kind=8), allocatable, intent(inout) :: array(:)
      integer, intent(in) :: osize
      integer, intent(in) :: nsize
    end subroutine resize_dble_array
  end interface
  !
  interface
    subroutine s_uv_consistency(high,low,error,ier)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      ! 
      ! IMAGER
      !   Support routine for command FEATHER
      !
      ! Verify data cube consistencies
      !---------------------------------------------------------------------
      type (gildas), intent(in) :: high        ! High resolution image
      type (gildas), intent(in) :: low         ! Low resolution image
      logical, intent(out) :: error            ! Error flag
      integer, intent(out) :: ier
    end subroutine s_uv_consistency
  end interface
  !
  interface
    subroutine s_uv_hybrid(high,low,all,uvradius,ratio,exponent,range,error)
      use image_def
      use gbl_message
      !---------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !   Support for command FEATHER
      !
      !   Take HIGH map (high resolution map) 
      !   Take LOW  map (map with shortest spacings)
      !
      !   Make oversampled Fourier Transform of boths
      !   Compute the truncation function f(r)
      !   Make the Truncated compact Fourier Transform, f(r) x T(LOW)
      !   Make the complement long baseline Fourier Transform, (1-f(r)) x T(HIGH)
      !   Sum them T(ALL) = f(r) x T(LOW) + (1-f(r)) x T(HIGH)
      !   Make the inverse Fourier Transform
      !   Truncate the resulting image to original size and Mask
      !---------------------------------------------------------------------
      type (gildas), intent(in) :: high        ! High resolution image
      type (gildas), intent(in) :: low         ! Low resolution image
      type (gildas), intent(inout) :: all      ! Combined image
      real, intent(in) ::  uvradius            ! Transition radius
      real, intent(in) ::  ratio               ! Scale factor LOW / HIGH
      real, intent(in) ::  exponent            ! Sharpness of transition                
      real, intent(in) ::  range(2)            ! Range of overlap (m) 
      logical, intent(out) :: error            ! Error flag
    end subroutine s_uv_hybrid
  end interface
  !
  interface
    subroutine init_clean
      !----------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER
      !   Initialize Mapping Languages
      !----------------------------------------------------------------------
      use clean_def
      use clean_arrays
      use clean_default
      use clean_types
      !
      ! vocabulaire de CLEAN
    end subroutine init_clean
  end interface
  !
  interface
    subroutine run_self (line,comm,error)
      use clean_arrays
      use clean_default
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER   Main routine
      !   Call appropriate subroutine according to COMM
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line  ! Command line
      character(len=*), intent(in)    :: comm  ! Command name
      logical,          intent(out)   :: error ! Logical error flag
    end subroutine run_self
  end interface
  !
  interface
    subroutine run_clean (line,comm,error)
      use clean_arrays
      use clean_default
      use gbl_message
      use gkernel_types
      !----------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER   Main routine
      !   Call appropriate subroutine according to COMM
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line  ! Command line
      character(len=*), intent(in)    :: comm  ! Command name
      logical,          intent(out)   :: error ! Logical error flag
    end subroutine run_clean
  end interface
  !
  interface
    subroutine run_advanced(line,comm,error)
      use clean_arrays
      use clean_default
      use gbl_message
      !----------------------------------------------------------------------
      ! @ public
      !
      ! IMAGER   Main routine
      !   Call appropriate subroutine according to COMM
      !----------------------------------------------------------------------
      character(len=*), intent(inout) :: line  ! Command line
      character(len=*), intent(in)    :: comm  ! Command name
      logical,          intent(out)   :: error ! Logical error flag
    end subroutine run_advanced
  end interface
  !
end module imager_interfaces_public

!-----------------------------------------------------------------------
! Set of utilities to access some GDF properties, most often derived
! from header itself.
!-----------------------------------------------------------------------
function gag_sizeof(form)
  use gbl_format
  !---------------------------------------------------------------------
  ! @ public
  ! Return data word length in Bytes
  ! This function is generic for GDF, SIC variables, etc as they share
  ! the same codes. Hence the prefix gag_
  !---------------------------------------------------------------------
  integer(kind=4) :: gag_sizeof     ! Function value on return
  integer(kind=4), intent(in) :: form ! Data format
  !
  gag_sizeof=4
  if (form.eq.fmt_r8)then
    gag_sizeof=8
  elseif (form.eq.fmt_i8)then
    gag_sizeof=8
  elseif (form.eq.fmt_c4)then
    gag_sizeof=8
  elseif (form.eq.fmt_c8)then
    gag_sizeof=16
  elseif (form.eq.fmt_by)then
    gag_sizeof=1
  elseif (form.gt.0)then
    gag_sizeof=form
  endif
end function gag_sizeof
!
function gdf_nelem(h)
  use image_def
  !---------------------------------------------------------------------
  ! @ public
  ! Return the number of elements from the input GDF header
  !---------------------------------------------------------------------
  integer(kind=size_length) :: gdf_nelem
  type(gildas), intent(in) :: h
  ! Local
  integer(kind=4) :: jdim
  !
  gdf_nelem = 1
  do jdim=1,h%gil%ndim
    gdf_nelem = gdf_nelem * max(1,h%gil%dim(jdim))
  enddo
  !
end function gdf_nelem
!
function gdf_size(h)
  use image_def
  use gio_interfaces, except_this=>gdf_size
  !---------------------------------------------------------------------
  ! @ public
  ! Return the whole data size in bytes
  !---------------------------------------------------------------------
  integer(kind=size_length) :: gdf_size
  type(gildas), intent(in) :: h
  !
  gdf_size = gdf_nelem(h) * gag_sizeof(h%gil%form)
  !
end function gdf_size
!
function gdf_2gelems(h)
  use image_def
  use gio_interfaces, except_this=>gdf_2gelems
  !---------------------------------------------------------------------
  ! @ private
  ! Return .true. if the data has more than 2 giga-elements
  !---------------------------------------------------------------------
  logical :: gdf_2gelems  ! Function value on return
  type(gildas), intent(in) :: h
  ! Local
  integer(kind=8), parameter :: maxi4=2147483647_8 ! 2**31-1
  !
  gdf_2gelems = gdf_nelem(h).gt.maxi4
end function gdf_2gelems
!
function gdf_2gbytes(h)
  use image_def
  use gio_interfaces, except_this=>gdf_2gbytes
  !---------------------------------------------------------------------
  ! @ private
  ! Return .true. if the data is larger than 2 GB (bytes, not 4-bytes
  ! words)
  !---------------------------------------------------------------------
  logical :: gdf_2gbytes  ! Function value on return
  type(gildas), intent(in) :: h
  ! Local
  integer(kind=8), parameter :: size4max=2147483647  ! 2**31-1
  !
  gdf_2gbytes = gdf_size(h).gt.size4max
end function gdf_2gbytes
!
subroutine gdf_toobig(h,error)
  use image_def
  use gbl_message
  use gio_interfaces, except_this=>gdf_toobig
  !---------------------------------------------------------------------
  ! @ public
  ! Return an error if the image is too large to be opened on the
  ! current system
  !---------------------------------------------------------------------
  type(gildas), intent(in)    :: h
  logical,      intent(inout) :: error       !
  ! Local
  character(len=*), parameter :: rname='GDF'
  !
#if defined(BITS64)
  ! There maybe limits on the number of elements
  if (gdf_2gelems(h)) then
    if (index_length.eq.8) then
      ! Ok
      continue
    else
      call gio_message(seve%e,rname,  &
      'Images or UV tables of more than 2**31-1 elements not supported')
      error = .true.
      return
    endif
  endif
#else
  if (gdf_2gbytes(h)) then
    ! File is larger than 2 GB. We can think to use the blc and trc,
    ! but there are offsets in bytes which are computed by the
    ! file access layer (even if the underlying operating system is
    ! purely 64 bits) that overflow.
    !
    ! So even having moffs being of kind=size_length set to 64 bits
    ! does not help
    error = .true.
    call gio_message(seve%e,rname,  &
      'Files larger than 2 GB are not supported under 32 bits architecture')
  endif
#endif
  !
end subroutine gdf_toobig

program uv_resample
  !------------------------------------------------------------------------
  ! TASK  Resample in velocity an input UV Table
  !
  ! input :
  !	a uv table
  ! output :
  !	a uv table
  !------------------------------------------------------------------------
  use gbl_format
  use gkernel_interfaces
  !
  character(len=filename_length) :: input,output
  character(len=*), parameter :: rname = 'UV_RESAMPLE'
  real(8) :: convert(3)
  integer nc
  logical error
  !
  ! Input parameters
  call gildas_open
  call gildas_char('UV_INPUT$',input)
  call gildas_char('UV_OUTPUT$', output)
  call gildas_inte('NC$',nc,1)
  call gildas_dble('CONVERT$',convert,3)
  call gildas_close
  !
  call sub_uv_resample(input, output, nc, convert, error)
  if (error) call sysexi(fatale)
  call gagout('I-UV_RESAMPLE,  Successful completion')
  !
end program uv_resample  
!  
subroutine sub_uv_resample(input, output, nc, convert, error)
  !
  use image_def
  use gbl_format
  use gkernel_interfaces
  use mapping_interfaces
  use gbl_message
  !
  character(len=*), intent(in) :: input
  character(len=*), intent(in) :: output
  integer, intent(in) :: nc
  real(8), intent(inout) :: convert(3)
  logical, intent(out) :: error
  !
  type (gildas) :: uvint, uvout
  character(len=*), parameter :: rname = 'UV_RESAMPLE'
  integer :: i, n, ier
  integer :: iv, kv, nblock
  real(8) :: xref,xval,xinc,yref,yval,yinc
  character(len=80) :: mess
  !
  call map_message(seve%w,rname,'Task still experimental')
  call map_message(seve%w,rname,'Results NOT proven yet...')
  !
  error = .true.
  n = len_trim(input)
  if (n.le.0) then
    call map_message(seve%e,rname,'Input table name empty')
    return
  endif
  n = len_trim(output)
  if (n.le.0) then
    call map_message(seve%e,rname,'Output table name empty')
    return
  endif
  !
  ! Read input UV table
  call gildas_null(uvint, type = 'UVT')
  call gdf_read_gildas (uvint, input, '.uvt', error, data=.false.)
  if (gildas_error(uvint,rname,error)) then
    call map_message(seve%e,rname,'Cannot read Input UV table')
    return
  endif
  !
  ! Define output UV table
  call gildas_null(uvout, type = 'UVT')
  call gdf_copy_header(uvint,uvout,error)
  ! Compute the Frequency Conversion from the Velocity Conversion
  call getuv_conversion (uvout,nc,convert)
  call gdf_uv_shift_columns(uvint,uvout)
  call gdf_setuv(uvout,error)
  if (error) return
  !
  ! Define blocking factor
  call gdf_nitems('SPACE_GILDAS',nblock,uvint%gil%dim(1)) ! Visibilities at once
  nblock = min(nblock,uvint%gil%dim(2))
  allocate (uvint%r2d(uvint%gil%dim(1),nblock), uvout%r2d(uvout%gil%dim(1),nblock), stat=ier)
  if (ier.ne.0) then
    write(mess,*) 'Memory allocation error ',uvint%gil%dim(1), nblock
    call map_message(seve%e,rname,mess)
    error = .true.
    return
  endif
  !
  call sic_parse_file(output,' ','.uvt',uvout%file)
  call map_message(seve%i,rname,'Creating UV table '//trim(uvout%file))
  call gdf_create_image(uvout,error)
  !
  ! Loop over line table
  !
  uvint%blc = 0
  uvint%trc = 0
  uvout%blc = 0
  uvout%trc = 0
  !
  xref = uvout%gil%ref(1)
  yref = uvint%gil%ref(1)
  xval =   uvout%gil%voff
  xinc =   uvout%gil%vres 
  yval =   uvint%gil%voff
  yinc =   uvint%gil%vres 
  !
  do i=1,uvout%gil%dim(2),nblock
    write(mess,*) i,' / ',uvout%gil%dim(2),nblock
    call map_message(seve%i,rname,mess) 
    uvint%blc(2) = i
    uvint%trc(2) = min(uvint%gil%dim(2),i-1+nblock)
    uvout%blc(2) = i
    uvout%trc(2) = min(uvout%gil%dim(2),i-1+nblock) 
    call gdf_read_data(uvint,uvint%r2d,error)
    if (error) return
    !
    kv = uvint%trc(2)-uvint%blc(2)+1
    do iv=1,kv
      uvout%r2d(1:uvout%gil%nlead,iv) = uvint%r2d(1:uvint%gil%nlead,iv)
      call interpolate_uv (                                 & 
        &  uvout%r2d(uvout%gil%fcol:uvout%gil%lcol,iv),uvout%gil%nchan,&
        &   xinc,xref,xval,       &    
        &  uvint%r2d(uvint%gil%fcol:uvint%gil%lcol,iv),uvint%gil%nchan,& 
        &   yinc,yref,yval )
      if (uvout%gil%ntrail.gt.0) uvout%r2d(uvout%gil%lcol+1:uvout%gil%dim(1),iv) &
          = uvint%r2d(uvint%gil%lcol+1:uvint%gil%dim(1),iv)
    enddo
    call gdf_write_data (uvout,uvout%r2d,error)
    if (error) return
  enddo
  !
  ! Finalize UV data
  call gdf_close_image(uvint,error)
  call gdf_close_image(uvout,error)
  if (error) then
    call map_message(seve%e,rname,'Error writing UV table')
  endif
  !
end subroutine sub_uv_resample

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!
subroutine telcal_reallocate_chopper(n,chopper,error)
  use gbl_message
  use gkernel_interfaces
  use telcal_interfaces, except_this=>telcal_reallocate_chopper
  use chopper_definitions
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  integer(kind=4), intent(in)    :: n
  type(chopper_t), intent(inout) :: chopper
  logical,         intent(inout) :: error
  ! Local
  character(len=*), parameter :: rname='REALLOCATE>CHOPPER'
  character(len=message_length) :: mess
  logical :: alloc
  integer(kind=4) :: ier
  real(kind=8), parameter :: telcal_null=-1000.d0
  !
  call telcal_message(seve%t,rname,'Welcome')
  !
  if (n.le.0) then
     write(mess,'(a,i0)') 'Input array size is <= 0: ',n
     call telcal_message(seve%t,rname,mess)
     error = .true.
     return
  endif
  if (chopper%n.eq.n) then
     write(mess,'(a,i0)') 'Chopper arrays already associated at the right size: ',n
     call telcal_message(seve%d,rname,mess)
     alloc = .false.
  else
     call telcal_free_chopper(chopper,error)
     if (error)  return
     alloc = .true.
  endif
  if (alloc) then
     allocate( &
          chopper%freqs(n),chopper%loads(n),chopper%recs(n), &
          chopper%atms(n),chopper%tcals(n),chopper%atsyss(n), &
          chopper%tsyss(n),chopper%errors(n),&
          stat=ier)
     if (failed_allocate(rname,"chopper",ier,error)) then
        call telcal_free_chopper(chopper,error)
        return
     endif
     write(mess,'(a,i0)') 'Allocated chopper arrays of size: ',n
     call telcal_message(seve%d,rname,mess)
  endif
  !
  ! Allocation success => Initialize
  chopper%n = n
  chopper%bad = telcal_null
  !
end subroutine telcal_reallocate_chopper
!
subroutine telcal_free_chopper(chopper,error)
  use gbl_message
  use telcal_interfaces, except_this => telcal_free_chopper
  use chopper_definitions
  !-------------------------------------------------------------------
  ! @ private
  !-------------------------------------------------------------------
  type(chopper_t), intent(inout) :: chopper
  logical,         intent(inout) :: error
  !
  character(len=*), parameter :: rname='TELCAL>FREE>CHOPPER'
  !
  call telcal_message(seve%t,rname,'Welcome')
  !
  chopper%n = 0
  if (associated(chopper%freqs))  deallocate(chopper%freqs)
  if (associated(chopper%loads))  deallocate(chopper%loads)
  if (associated(chopper%recs))   deallocate(chopper%recs)
  if (associated(chopper%atms))   deallocate(chopper%atms)
  if (associated(chopper%tcals))  deallocate(chopper%tcals)
  if (associated(chopper%atsyss)) deallocate(chopper%atsyss)
  if (associated(chopper%tsyss))  deallocate(chopper%tsyss)
  if (associated(chopper%errors)) deallocate(chopper%errors)
  ! Nullification is implicit with deallocate
  !
end subroutine telcal_free_chopper
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!       PROGRAM TEST
!       CHARACTER CHAIN*80,NAME*80,DEF*40,EXT*20,ANAME*80
!       LOGICAL FOUND, SIC_FINDFILE
!
!       DEF = ' ' ! 'GAG_DEMO:'
!       write(6,*) "Path ?",def
!       read(5,'(a)') def
!       EXT = '.PRO'
! 1     WRITE(6,*) 'name?'
!       READ(5,'(a)',END=100) ANAME
!       NAME = ANAME
!       CALL SIC_PARSEF(NAME,CHAIN,DEF,EXT)
!       Print *,'File '//TRIM(CHAIN)
!       Print *,'Short name '//TRIM(NAME)
!       NAME = ANAME
!       FOUND = SIC_FINDFILE (NAME,CHAIN,DEF,EXT)
!       Print *,'Found ',found
!       Print *,'File '//TRIM(CHAIN)
!       Print *,'Short name '//TRIM(NAME)
!       GOTO 1
! 100   CONTINUE
!       END
!
subroutine sic_resolve_log(chain)
  use gsys_interfaces, except_this=>sic_resolve_log
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  ! Resolve logical variables recursively
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: chain  !
  ! Local
  character(len=path_length) :: file
  character(len=filename_length) :: direct
  logical :: ok
  integer(kind=4) :: i1,ier
  !
  ok = .true.
  do while(ok)
    ier = sic_getlog(chain)
    !
    ! Translate logical names
    i1 = index(chain,':')
    !
    ! Now we have only "logical names" and slashes.
    if (i1.ne.0) then
      direct = chain(1:i1)
      i1 = i1+1
      file = direct
      ier = sic_getlog(direct)
      if (direct.eq.file) exit
      file = trim(direct)//chain(i1:)
    else
      file = chain
      ok = .false.
    endif
    chain=file
  enddo
end subroutine sic_resolve_log
!
subroutine sic_parse_file(name,dir,ext,file)
  use gsys_interfaces, except_this=>sic_parse_file
  use gildas_def
  !---------------------------------------------------------------------
  ! @ public
  ! Adds the directory DIR and extension EXT if necessary to the file
  ! name NAME to form FILE. In addition, logical name are translated to
  ! obtain the intrinsic "physical" names.
  !
  ! For UNIX purposes: (a logical name is somestring finished with ":")
  !      a) converts "\" to "/"
  !      b) converts ~ to $HOME
  !
  ! if first character is "!" or "/"
  !     1) TRANSLATES LOGICAL NAMES
  !     2) Does not add extension
  !     3) is respectful of upper/lowercases
  ! if not :
  !     1) converts to lowercase
  !     2) TRANSLATES LOGICAL NAMES
  !     3) Does add extension, in lowercase
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: name  ! File name
  character(len=*), intent(in)  :: dir   ! Default directory
  character(len=*), intent(in)  :: ext   ! Default extension
  character(len=*), intent(out) :: file  ! Fully extended file name
  ! Local
  integer(kind=4) :: lon,i,i1,i2,l
  character(len=filename_length) :: chain, direct
  character(len=1) :: ousep, insep, disep
  character(len=1), parameter :: notrans='!'
  logical :: ok
  data direct/' '/
  !
  call gag_separ(insep,ousep,disep)
  !
  if (name(1:1).eq.notrans) then
    chain = name(2:)
  else
    chain = name
  endif
  !
  call sic_resolve_log(chain)
  !
  ! get full directory part
  ok = .true.
  i1 = len_trim(chain)
  do while (ok .and. i1.gt.0)
    if (chain(i1:i1).eq.ousep .or. chain(i1:i1).eq.insep) then
      ok = .false.
    else
      i1 = i1-1
    endif
  enddo
  if (i1.eq.0) then
    direct = dir
    call sic_resolve_log(direct)
    l = len_trim(direct)
    file = trim(direct)//chain
  else
    file = chain
    l = i1
  endif
  !
  ! Convert directory separators
  lon = len_trim(file)
  do i=1,lon
    if (file(i:i).eq.insep) file(i:i)=ousep
  enddo
  !
  ! Extension?
  lon = len_trim(file(l+1:))+l
  i2 = index(file(l+1:lon),'.')
  if (i2.eq.0) then
    ! Insert default extension
    file(lon+1:) = ext
    i2 = lon+1
    lon = len_trim(file)
    call sic_lower(file(i2:lon))   ! To debug tasks...
  endif
  !
end subroutine sic_parse_file
!
subroutine sic_parsef(name,file,dir,ext)
  use gbl_message
  use gsys_interfaces, except_this=>sic_parsef
  !---------------------------------------------------------------------
  ! @ public
  !  Same as SIC_PARSE_FILE +
  !  at return, NAME is the file named stripped from directory and
  !  extension
  ! ---
  !  Obsolete: use SIC_PARSE_FILE and/or SIC_PARSE_NAME instead
  !---------------------------------------------------------------------
  character(len=*), intent(inout) :: name  ! File name
  character(len=*), intent(out)   :: file  ! Fully extended file name
  character(len=*), intent(in)    :: dir   ! Default directory
  character(len=*), intent(in)    :: ext   ! Default extension
  ! Local
  character(len=filename_length) :: tmp
  !
  ! Compute DIR+NAME+EXT into FILE
  call sic_parse_file(name,dir,ext,file)
  !
  ! Strip NAME from its directory and extension
  tmp = name
  call sic_parse_name(tmp,name)
  !
end subroutine sic_parsef
!
function sic_query_file (name,path,ext,file)
  use gildas_def
  use gsys_interfaces, except_this=>sic_query_file
  !---------------------------------------------------------------------
  ! @ public
  ! Same as sic_findfile but avoid modifying input 'name'
  !---------------------------------------------------------------------
  logical :: sic_query_file              ! Function value on return
  character(len=*), intent(in)  :: name  ! File name
  character(len=*), intent(in)  :: path  ! Search path
  character(len=*), intent(in)  :: ext   ! Default extension
  character(len=*), intent(out) :: file  ! Fully extended file name
  ! Local
  character(len=filename_length) :: temp
  !
  temp = name
  sic_query_file = sic_findfile(temp,file,path,ext)
end function sic_query_file
!
function sic_findfile(name,file,path,ext)
  use gsys_interfaces, except_this=>sic_findfile
  !---------------------------------------------------------------------
  ! @ public
  !  Search on the path PATH and with extension EXT if necessary the
  ! file name NAME to find FILE. At return, NAME is the file named
  ! stripped from these extensions. In addition, logical name are
  ! translated to obtain the intrinsic "physical" names.
  !---------------------------------------------------------------------
  logical :: sic_findfile                  ! Function value on return
  character(len=*), intent(inout) :: name  ! File name
  character(len=*), intent(out)   :: file  ! Fully extended file name
  character(len=*), intent(in)    :: path  ! Search Path
  character(len=*), intent(in)    :: ext   ! Default extension
  ! Local
  integer(kind=4) :: lon,i,lpath,iext,ipath,isep1,isep2,ier
  character(len=path_length) :: apath
  character(len=512) :: chain, direct
  character(len=512) :: etype
  character(len=1) :: ousep, insep, disep
  character(len=1), parameter :: notrans='!'
  logical :: ok
  data direct/' '/
  !
  call gag_separ(insep,ousep,disep)
  sic_findfile = .false.
  !
  ! Convert directory separators
  if (name(1:1).eq.notrans) then
    chain = name(2:)
  else
    chain = name
  endif
  !
  lon = len_trim(chain)
  !
  if (lon.le.0) then
    ! Stupid protection, but seems to happen
    file = ''
    return
  endif
  !
  do i=1,lon
    if (chain(i:i).eq.insep) chain(i:i)=ousep
  enddo
  ier = sic_getlog(chain)
  lon = len_trim(chain)
  !
  ! Get extension
  iext = lon
  ipath = 0
  ok = .true.
  do while(ok)
    if (chain(iext:iext).eq.'.') then
      etype = chain(iext:lon)
      iext = iext-1
      ok = .false.
    elseif  (chain(iext:iext).eq.ousep) then
      etype = ext
      call sic_lower(etype)    ! To debug tasks
      iext = lon
      ok = .false.
    else
      if (chain(iext:iext).eq.':') ipath = iext
      iext = iext-1
      if (iext.eq.0) then
        iext = lon
        etype = ext
        call sic_lower(etype)  ! To debug tasks
        ok = .false.
      endif
    endif
  enddo
  !
  ! Insert default path if needed, or used built-in directory
  if (ipath.eq.0) ipath = index(chain,':')
  if (ipath.eq.0) then
    apath = path
  else
    apath = chain(1:ipath)
  endif
  name = chain(ipath+1:iext)
  call sic_resolve_log(apath)
  lpath = len_trim(apath)
  !
  ! Translate path name
  isep1 = 1
  do while (isep1.lt.lpath)
    isep2 = index(apath(isep1:lpath),';')
    if (isep2.eq.0) isep2 = lpath-isep1+2
    direct = apath(isep1:isep2-2+isep1)
    call sic_resolve_log(direct)
    file = trim(direct)//chain(ipath+1:iext)//etype
    if (gag_inquire(file,len_trim(file)).ne.0) then
      sic_findfile = .false.
    else
      sic_findfile = .true.
      return
    endif
    isep1 = isep1+isep2
  enddo
  !
  ! If no search path or directory was specified, search
  ! for current directory, OR if an absolute path was
  ! specified, use it "as is"
  if (lpath.ne.0.and.chain(1:1).ne.ousep) return
  file = chain(ipath+1:iext)//etype
  sic_findfile = (gag_inquire(file,len_trim(file)).eq.0)
end function sic_findfile
!
subroutine sic_parse_name(iname,ofile,oext,odir)
  use gildas_def
  use gsys_interfaces, except_this=>sic_parse_name
  !---------------------------------------------------------------------
  ! @ public
  !  Split an input file name as:
  !  - its basename (no extension),
  !  - its extension,
  !  - its dirname.
  ! Sic logicals are resolved in the the input file name before parsing
  !---------------------------------------------------------------------
  character(len=*), intent(in)            :: iname
  character(len=*), intent(out)           :: ofile
  character(len=*), intent(out), optional :: oext
  character(len=*), intent(out), optional :: odir
  ! Local
  character(len=1) :: insep,ousep,disep
  character(len=1), parameter :: notrans='!'
  logical :: ok
  character(len=filename_length) :: oname
  integer(kind=4) :: lf,i,isep,idot
  !
  call gag_separ(insep,ousep,disep)
  !
  if (iname(1:1).eq.notrans) then
    oname = iname(2:)
  else
    oname = iname
  endif
  call sic_resolve_log(oname)
  lf = len_trim(oname)
  !
  ! Search for last directory separator
  ok = .true.
  isep = lf
  do while (ok .and. isep.gt.0)
    if (oname(isep:isep).eq.ousep .or. oname(isep:isep).eq.insep) then
      ok = .false.
    else
      isep = isep-1
    endif
  enddo
  ! NB: isep can be 0 on return
  !
  ! Set output directory name
  if (present(odir)) then
    odir = oname(1:isep)
    ! Convert directory separators
    do i=1,isep
      if (odir(i:i).eq.insep)  odir(i:i) = ousep
    enddo
  endif
  !
  ! Set output name and extension
  idot = index(oname(isep+1:lf),'.')
  if (idot.eq.0) then
    ofile = oname(isep+1:lf)
    if (present(oext))  oext = ''
  else
    ofile = oname(isep+1:isep+idot-1)
    if (present(oext))  oext = oname(isep+idot+1:lf)
  endif
  !
end subroutine sic_parse_name

!      PROGRAM TEST
!      INCLUDE 'astro.inc'
!*
!      REAL*8 JDATE,RRA,DDEC
!      REAL*4 EQUINOX
!      REAL PIFX,PIFY
!      LOGICAL ERROR
!*
!
!      RRA  = 0.0
!      DDEC = 0.0
!      EQUINOX=2000.0
!      EQUINOX=2002.0
!      JDATE =  52275.500        ! 01-JAN-2002 00:00 UT
!      CALL PARALLAX_FACTORS(JDATE,RRA,DDEC,EQUINOX,PIFX,PIFY,ERROR)
!      STOP 
! 99   STOP 'ERROR'
!      END


*
      SUBROUTINE PARALLAX_FACTORS(MJDATE,RRA,DDEC,EQUINOX,
     +     PIFX,PIFY,ERROR)
      REAL*8 MJDATE,RRA,DDEC
      REAL*4 EQUINOX
      REAL*8 PIFX,PIFY
      LOGICAL ERROR
*
      INCLUDE 'physical_constants.inc'
      REAL*8 J2000
      PARAMETER (J2000 = 2451545.0D0)
*
      REAL*8 CRA,CDEC,SRA,SDEC ! Trigonometric functions of RA+Dec
*
      REAL*8 JULDAY
      REAL*8 JNOW_TDT                    ! date julienne TDT
      REAL*8 D_TDT                       ! TDT - UTC (seconds)
      REAL*8 XG_0(3), XG_1(3)
      REAL*8 ANGLES(6), PSI, THE, PHI, JFIX, EPSM
      REAL*8 MAT1(9), MAT2(9) !, MAT3(9)
      REAL*8 TRFM_01(9), TRFM_10(9)
      INTEGER I
*
      REAL PREV_EQU
      LOGICAL INITIALISED
      DATA INITIALISED /.FALSE./, PREV_EQU /-1E35/
      SAVE INITIALISED, PREV_EQU, TRFM_01, TRFM_10
*
      REAL*8 OBLIMO   ! Function
*  
* Initialize the VSOP87 ephemerids   
      IF (.NOT.INITIALISED) THEN
         CALL EPHINI(ERROR)
         IF (ERROR) THEN
            CALL GAGOUT('F-ASTRO_INIT,  Error in EPHINI')
            GOTO 99
         ENDIF
         INITIALISED = .TRUE.
      ENDIF
*
*  Compute transformation matrix from equatorial (Equinox) to 
*  ecliptic (J2000.0), in which the VSOP87 ephemerids are stored. 
      IF (EQUINOX.NE.PREV_EQU) THEN
         JFIX=J2000+(EQUINOX-2000.0D0)*365.25D0 ! fixed equinox (julian days)
         EPSM=OBLIMO (JFIX)     ! mean obliquity at fixed equinox
         PSI=0.D0               ! Euler angles of transformation
         THE=EPSM
         PHI=0.D0
         CALL EULMAT (PSI,THE,PHI,MAT1) ! compute matrix from R1(EQ) to ecl (JFIX)
         CALL QPREC (JFIX,J2000,ANGLES) ! compute precession angles
         PSI=ANGLES(5)          ! Euler angles of transformation
         THE=ANGLES(4)
         PHI=-ANGLES(6)-ANGLES(5)
         CALL EULMAT (PSI,THE,PHI,MAT2) ! compute matrix from ecl (JFIX) to (R0)
         CALL MULMAT (MAT1,MAT2,TRFM_01) ! product TRFM01 = MAT2 x MAT1
         CALL TRANSP (TRFM_01, TRFM_10) ! We need the inverse/transpose
         PREV_EQU = EQUINOX
      ENDIF
*
* Transform time to standard julian day zero point
      JULDAY = MJDATE+2400000.
      D_TDT = 56.184D0
      JNOW_TDT = JULDAY+ D_TDT/86400.D0
*
* Get Earth motion (/ Sol Sys Barycenter)
      CALL EPHSTA (0, 0, ERROR)
      IF (ERROR) THEN
         CALL GAGOUT('F-PARALLAX,  Error in EPHSTA')
         RETURN
      ENDIF
      CALL EPHVEC (JNOW_TDT, 0, XG_0, ERROR)
      IF (ERROR) THEN
         CALL GAGOUT('E-PARALLAX, Error in solar system ephemeris')
      ENDIF
      DO I=1,3
         XG_0(I)=-XG_0(I)  ! We want G-->Earth, not Earth-->G
      ENDDO
*
* Rotate the position vector of the earth from Ecliptic-J2000 to the requested 
* equatorial frame.
      CALL MATVEC(XG_0, TRFM_10, XG_1)
      CRA  = COS(RRA)
      SRA  = SIN(RRA)
      CDEC = COS(DDEC)
      SDEC = SIN(DDEC)
!      PIFX = XG_1(1)*SRA-XG_1(2)*CRA
!      PIFY = XG_1(1)*CRA*SDEC+XG_1(2)*SRA*SDEC-XG_1(3)*CDEC
* X is along positive Declination, Y along positive RA, not xi-eta.
      PIFY = XG_1(1)*SRA-XG_1(2)*CRA
      PIFX = XG_1(1)*CRA*SDEC+XG_1(2)*SRA*SDEC-XG_1(3)*CDEC
      PIFX = PIFX/(au/km)
      PIFY = PIFY/(au/km)
      RETURN
*
 99   ERROR = .TRUE.
      RETURN
      END

subroutine write_sdm_Processor(holodata, error)
  !---------------------------------------------------------------------
  ! Write the AlmaCorrelatorMode SDM table.
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_Processor
  use sdm_enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical :: holodata, error
  ! Local
  type (ProcessorRow) :: pRow
  type (ProcessorKey) :: pKey
  character sdmTable*12
  parameter (sdmTable='Processor')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  ! very much TBD at this stage.
  !
  ! the Transmitter holography
  !
  if (holodata) then
    pRow%processorType = ProcessorType_Radiometer
    !! pRow%processorSubType = ProcessorSubType_HOLOGRAPHY
    pRow%processorSubType = ProcessorSubType_SQUARE_LAW_DETECTOR
    pRow%modeId = squareLawDetector_Id
    call addProcessorRow(pKey, pRow, error)
    if (error) return
    TotPowprocessor_Id = pKey%processorId
  !
  ! normal case
  !
  else
    pRow%processorType = ProcessorType_CORRELATOR
    pRow%processorSubType = ProcessorSubType_ALMA_CORRELATOR_MODE
    pRow%modeId = correlatorMode_Id
    call addProcessorRow(pKey, pRow, error)
    if (error) return
    processor_Id = pKey%processorId
    !
    pRow%processorType = ProcessorType_RADIOMETER
    pRow%ProcessorSubType = ProcessorSubType_SQUARE_LAW_DETECTOR
    pRow%modeId = squareLawDetector_id
    call addProcessorRow(pKey, pRow, error)
    if (error) return
    TotPowprocessor_Id = pKey%processorId
    !
    pRow%processorType = ProcessorType_RADIOMETER
    ! ProcessorSubType_ALMA_RADIOMETER is missing
    pRow%ProcessorSubType = ProcessorSubType_ALMA_RADIOMETER
    !pRow%ProcessorSubType = ProcessorSubType_SQUARE_LAW_DETECTOR
    pRow%modeId = squareLawDetector_id
    call addProcessorRow(pKey, pRow, error)
    if (error) return
    RadiometerProcessor_Id = pKey%processorId
  endif
  !
  call sdmMessage(1,1,sdmTable ,'Written.')
  return
  !
99 error = .true.
end subroutine write_sdm_Processor
!---------------------------------------------------------------------
subroutine get_sdm_Processor(AlmaCorr, error)
  !---------------------------------------------------------------------
  ! Get  the AlmaCorrelatorMode SDM table row for an integration
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_processor
  use sdm_Enumerations
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  ! Dummy
  logical error, AlmaCorr
  ! Local
  type (ProcessorRow) :: pRow
  type (ProcessorKey) :: pKey
  character sdmTable*12
  parameter (sdmTable='Processor')
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  ! very much TBD at this stage.
  pKey%processorId = processor_Id
  !      print *, 'processor_Id ',processor_Id
  call getProcessorRow(pKey, pRow, error)
  if (error) return
!!!   correlatorMode_Id = pRow%almaCorrelatorModeId
  correlatorMode_Id = pRow%modeId
  !      l = lenc(pRow%type)
  ! This means we will get Correlator binary data...
  !
  !     make it simple for the time being...
  AlmaCorr = pRow%ProcessorType .eq. ProcessorType_CORRELATOR
  !$$$      AlmaCorr = pRow%type .eq. ProcessorType_CORRELATOR .and.
  !     &     pRow%subtype .eq. 'ALMA_CORRELATOR_MODE'
  !cc Should we test this one??
  !cc OPTIONAL in SS2      if (pRow%flagRow) then
  !cc OPTIONAL in SS2         call sdmMessage(4,2,sdmTable ,'ProcessorRow is flagged')
  !cc OPTIONAL in SS2      endif
  call sdmMessage(1,1,sdmTable ,'Read.')
  return
  !
99 error = .true.
end subroutine get_sdm_Processor

subroutine uv_reweight_comm(line,error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_reweight_comm
  use clean_def
  use clean_arrays
  use gbl_message
  use phys_const
  !------------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Reweight the data
  !------------------------------------------------------------------------
  character(len=*), intent(in) :: line  ! Command line
  logical, intent(out) :: error         ! Error flag
  !
  character(len=*), parameter :: rname = 'UV_REWEIGHT'
  integer(kind=index_length) :: iv
  integer :: ic
  real(4) :: scale
  !
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,rname,'No UV data loaded')
    error = .true.
    return
  endif
  !
  error = .false.
  call sic_r4(line,0,1,scale,.true.,error)
  if (error) return
  !
  do iv=1,huv%gil%nvisi
    do ic=1,huv%gil%nchan
      duv(3*ic+huv%gil%fcol-1,iv) = scale * duv(3*ic+huv%gil%fcol-1,iv)
    enddo
  enddo
  do_weig = .true.
end subroutine uv_reweight_comm
!
subroutine uv_resample_comm(line,comm,error)
  use gkernel_interfaces
  use mapping_interfaces, except_this=>uv_resample_comm
  use clean_def
  use clean_arrays
  use clean_types
  use gbl_message
  use phys_const
  !---------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Resample in velocity the UV Table or compress it
  !   Support for commands
  !     UV_RESAMPLE NC [Ref Val Inc]
  !     UV_COMPRESS NC
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: line  ! Command line
  character(len=*), intent(in) :: comm  ! Calling command
  logical, intent(out) :: error         ! Error flag
  !
  character(len=11) :: rname = 'UV_RESAMPLE'
  real, pointer :: duv_previous(:,:), duv_next(:,:)
  character(len=80) :: chain
  character(len=4) :: arg(4)
  real(8) :: convert(3), velo
  integer :: nt, nc, nchan, na
  type (gildas) :: uvout
  integer :: nu, nv, ni, i
  !
  if (huv%loca%size.eq.0) then
    call map_message(seve%e,'UV_MAP','No UV data loaded')
    error = .true.
    return
  endif
  !
  error = .false.
  ! No argument: get back to the original UV data
  if (sic_narg(0).eq.0) then
    call uv_reset_buffer(rname)
    do_weig = .true.
    return
  endif
  !
  ! Compute the Frequency Conversion from the Velocity Conversion
  call gildas_null(uvout, type = 'UVT')
  call gdf_copy_header(huv,uvout,error)
  !
  if (comm.eq.'UV_RESAMPLE') then
    nc = 0
    !    SIC__CH would complain if argument is too long, SIC_KE is silent
    call sic_ke(line,0,1,arg(1),na,.true.,error)
    error = .false.
    if (arg(1).ne.'*') call sic_i4(line,0,1,nc,.true.,error)
    if (error) return
    !
    ! Set default resampling in Velocity
    convert(1) = huv%gil%ref(1)
    convert(2) = huv%gil%voff
    convert(3) = huv%gil%vres
    ! Get new one
    do i=2,sic_narg(0)
      call sic_ke(line,0,i,arg(i),na,.false.,error)
      error = .false.
      if (arg(i).ne.'*') call sic_r8(line,0,i,convert(i-1),.false.,error)
      if (error) return
    enddo
    !
    ! Fill missing arguments
    if (nc.eq.0) then
      nc = nint(abs(huv%gil%nchan*huv%gil%vres/convert(3)))
      if (arg(2).eq.'*') then
        ! Keep the middle channel in the middle
        velo = (0.5d0*huv%gil%nchan-huv%gil%ref(1))*huv%gil%vres + huv%gil%voff
        convert(1) = 0.5d0*nc - (velo-convert(2))/convert(3)
      endif
    endif
    !
    call getuv_conversion(uvout,nc,convert)
    !
  else if (comm.eq.'UV_COMPRESS') then
    call sic_i4(line,0,1,nc,.true.,error)
    if (error) return
    if (nc.gt.huv%gil%nchan) nc = huv%gil%nchan
    write(chain,'(A,I6,A)') 'Averaging by chunks of ',nc,' channels'
    call map_message(seve%i,comm,chain)
    uvout%gil%inc(1) = uvout%gil%inc(1)*nc
    uvout%gil%ref(1) = (2.0d0*uvout%gil%ref(1)+nc-1.0)/(2*nc)
    uvout%gil%vres = nc*uvout%gil%vres
    uvout%gil%fres = nc*uvout%gil%fres
    ! Change the number of channels
    uvout%gil%nchan = uvout%gil%nchan/nc
  else
    call map_message(seve%e,rname,'Unrecognized choice '//comm)
    error = .true.
    return
  endif
  !
  ! Work with complete structure
  uvout%gil%dim(1) = 3*uvout%gil%nchan + 7 + uvout%gil%ntrail ! and nothing more ?...
  if (uvout%gil%ntrail.ne.0) then
    do i=1,code_uvt_last
      if (uvout%gil%column_pointer(i).gt.uvout%gil%lcol) uvout%gil%column_pointer(i) =  &
        & uvout%gil%column_pointer(i) + uvout%gil%dim(1) - huv%gil%dim(1)
    enddo
  endif
  !
  ni = huv%gil%dim(1)
  nu = uvout%gil%dim(1)
  nv = uvout%gil%dim(2)
  nt = uvout%gil%ntrail
  nchan = uvout%gil%nchan
  !
  ! Prepare appropriate array...
  ! Prepare appropriate array...
  nullify (duv_previous, duv_next)
  call uv_find_buffers (comm,nu,nv,duv_previous, duv_next,error)
  if (error) then
    call map_message(seve%e,comm,'Cannot set buffer pointers')
    return
  endif
  !
  ! Now resample
  if (comm.eq.'UV_RESAMPLE') then
    call resample_uv (huv,uvout,duv_previous,duv_next,nt)
  else if (comm.eq.'UV_COMPRESS') then
    call compress_uv (duv_next,nu,nv,nchan,duv_previous,ni,nc,nt)
  endif
  !
  ! Set header
  call gdf_copy_header(uvout,huv,error)
  !
  ! Reset proper pointers
  call uv_clean_buffers (duv_previous, duv_next,error)
  if (error) return
  !
  if (allocated(duvt)) deallocate (duvt)            ! UV data not plotted
  uv_plotted = .false.
  !
  ! Indicate optimization and save status
  optimize(code_save_uv)%change = optimize(code_save_uv)%change + 1
  save_data(code_save_uv) = .true.
  do_weig = .true.  ! Recompute weight
  !
  ! Redefine SIC variables 
  call sic_delvariable ('UV',.false.,error)
  call sic_mapgildas ('UV',huv,error,duv) 
end subroutine uv_resample_comm
!

subroutine putios (name,ier)
  use gsys_interfaces, except_this=>putios
  !---------------------------------------------------------------------
  ! @ public
  ! Print system message corresponding to IO error code IER
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name  ! Facility name
  integer(kind=4),  intent(in) :: ier   ! 32-bit system message code
  ! Local
  character(len=256) :: msg
  !
  call gag_iostat(msg,ier)
  write(6,'(A,A)') name,trim(msg)
end subroutine putios
!
subroutine putmsg (name,ier)
  !---------------------------------------------------------------------
  ! @ private
  ! UTIL  Internal routine
  !       Print system message corresponding to code IER on SYS$OUTPUT.
  !---------------------------------------------------------------------
  character(len=*), intent(in) :: name  ! Facility name
  integer(kind=4),  intent(in) :: ier   ! 32-bit system message code
  !
  write(6,'(A,A,I6)') name,'System Error number ',ier
end subroutine putmsg
!
subroutine gag_iostat (msg,ier)
  use gsys_interfaces, except_this=>gag_iostat
  !---------------------------------------------------------------------
  ! @ public
  ! Return system message corresponding to IO error code IER
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: msg  ! Returned message
  integer(kind=4),  intent(in)  :: ier  ! 32-bit system message code
  !
#if defined(GFORTRAN)
  call gfc_iostat(msg,ier)
#elif defined(WIN32)
  call win32_iostat(msg,ier)
#elif defined(IFORT)
  call ifort_iostat(msg,ier)
#else
  write(msg,'(A,I6)') 'I/O error number ',ier
#endif
end subroutine gag_iostat
!
subroutine win32_iostat (msg,ier)
  !---------------------------------------------------------------------
  ! @ private
  ! Get system message corresponding to IO error code IER
  !     Version for WIN32 Dec/Compaq compiler
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: msg  ! Returned message
  integer(kind=4),  intent(in)  :: ier  ! 32-bit system message code
  ! Local
  character(len=48) :: io00(22:68)
  !
  data io00                                          &
    /'Input record too long '                        &  ! 22
    ,'Backspace error'                               &  ! 23
    ,'End-of-file during read'                       &  ! 24
    ,'Record number out of range '                   &  ! 25
    ,'OPEN required '                                &  ! 26
    ,'Too many record in I/O statement'              &  ! 27
    ,'CLOSE error'                                   &  ! 28
    ,'File not found'                                &  ! 29
    ,'Open failure'                                  &  ! 30
    ,'Mixed file access modes'                       &  ! 31
    ,'Invalid logical unit number'                   &  ! 32
    ,'ENDFILE error'                                 &  ! 33
    ,'Unit already opened'                           &  ! 34
    ,'Segmented record format error'                 &  ! 35
    ,'Attempt to access non-existent record'         &  ! 36
    ,'Inconsistent record length'                    &  ! 37
    ,'Error during write'                            &  ! 38
    ,'Error during read'                             &  ! 39
    ,'Recursive I/O operation'                       &  ! 40
    ,'Insufficient virtual memory'                   &  ! 41
    ,'No such device'                                &  ! 42
    ,'File name specification error'                 &  ! 43
    ,'Inconsistent record type'                      &  ! 44
    ,'Keyword value error in OPEN statement'         &  ! 45
    ,'Inconsistent OPEN/CLOSE parameters'            &  ! 46
    ,'Write to READONLY file'                        &  ! 47
    ,'Invalid argument to Fortran Run-Time Library'  &  ! 48
    ,' '                                             &
    ,' '                                             &
    ,'Inconsistent file organization',' '            &  ! 51
    ,'No current record',' '                         &  ! 53
    ,'DELETE error',' '                              &  ! 55
    ,'FIND error'                                    &  ! 57
    ,'Format syntax error at or near XX'             &  ! 58
    ,'List directed I/O syntax error'                &  ! 59
    ,'Infinite format loop'                          &  ! 60
    ,'Format/variable-type mismatch'                 &  ! 61
    ,'Syntax error in format'                        &  ! 62
    ,'Output conversion error'                       &  ! 63
    ,'Input conversion error'                        &  ! 64
    ,'Floating invalid'                              &  ! 65
    ,'Output statement overflows record'             &  ! 66
    ,'Input statement requires too much data'        &  ! 67
    ,'Variable format expression value error'/          ! 68
  ! ,' '
  ! ,'Integer overflow'                                 ! 70
  ! ,'Integer divide by zero'
  ! ,'
  !
  if (ier.lt.22 .or. ier.gt.68) then
    write(msg,'(A,I6)') 'I/O error number ',ier
  else
    msg = io00(ier)
  endif
  !
end subroutine win32_iostat
!
subroutine g95_iostat (msg,ier)
  !---------------------------------------------------------------------
  ! @ private
  ! Get system message corresponding to IO error code IER
  !     Version for G95 Gnu compiler.
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: msg  ! Returned message
  integer(kind=4),  intent(in)  :: ier  ! 32-bit system message code
  ! Local
  character(len=40) :: errmsg
  character(len=40) :: io200(15)
  data io200/                               &
    'Conflicting statement options',        &
    'Bad statement option',                 &
    'Missing statement option',             &
    'File already opened in another unit',  &
    'Unattached unit',                      &
    'FORMAT error',                         &
    'Incorrect ACTION specified',           &
    'Read past ENDFILE record',             &
    'Corrupt unformatted sequential file',  &
    'Bad value during read',                &
    'Numeric overflow on read',             &
    'Out of memory',                        &
    'Array already allocated',              &
    'Deallocated a bad pointer',            &
    'Bad record read on input'/
  !
  if (ier.eq.-2) then
    msg = 'End of record'
  elseif  (ier.eq.-1) then
    msg = 'End of file'
  elseif  (ier.lt.200) then
    call gag_errno(ier,errmsg)
    write(msg,'(A,I4,A)')  trim(errmsg)//' (O/S errno # ',ier,')'
  elseif  (ier.le.214) then
    msg = io200(ier-200+1)
  else
    write(msg,'(A,I5)')  'Unknown error code ',ier
  endif
  !
end subroutine g95_iostat
!
subroutine gfc_iostat (msg,ier)
  !---------------------------------------------------------------------
  ! @ private
  ! Get system message corresponding to IO error code IER
  !     Version for GFortran Gnu compiler.
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: msg  ! Returned message
  integer(kind=4),  intent(in)  :: ier  ! 32-bit system message code
  ! Local
  character(len=48) :: errmsg,io5000(17)
  data io5000/                                       &
    'Conflicting statement options',                 &  ! 5001
    'Bad statement option',                          &  ! 5002
    'Missing statement option',                      &  ! 5003
    'File already opened in another unit',           &  ! 5004
    'Unattached unit',                               &  ! 5005
    'FORMAT error',                                  &  ! 5006
    'Incorrect ACTION specified',                    &  ! 5007
    'Read past ENDFILE record',                      &  ! 5008
    'Corrupt unformatted sequential file',           &  ! 5009
    'Bad value during read',                         &  ! 5010
    'Numeric overflow on read',                      &  ! 5011
    'Internal error in run-time library',            &  ! 5012
    'Internal unit I/O error',                       &  ! 5013
    '? (LIBERROR_ALLOCATION)',                       &  ! 5014 ?
    'Write exceeds length of DIRECT access record',  &  ! 5015
    'I/O past end of record on unformatted file',    &  ! 5016
    'Unformatted file structure has been corrupted' /   ! 5017
  !
  select case (ier)
  case(-2)
    msg = 'End of record'
    !
  case(-1)
    msg = 'End of file'
    !
  case(5001:5017)
    msg = io5000(ier-5000)
    !
  case default
    call gag_errno(ier,errmsg)
    write(msg,'(A,I4,A)')  trim(errmsg)//' (O/S errno # ',ier,')'
    !
  end select
  !
end subroutine gfc_iostat
!
subroutine ifort_iostat(msg,ier)
  !---------------------------------------------------------------------
  ! @ private
  ! Get system message corresponding to IO error code IER
  !     Version for Intel Fortran compiler.
  !---------------------------------------------------------------------
  character(len=*), intent(out) :: msg  ! Returned message
  integer(kind=4),  intent(in)  :: ier  ! 32-bit system message code
  !
  select case (ier)
  case(-2)
    msg = 'End of record'
  case(-1)
    msg = 'End of file'
  case(1)
    msg = 'Not a Fortran-specific error'
  case(8)
    msg = 'Internal consistency check failure'
  case(9)
    msg = 'Permission to access file denied'
  case(10)
    msg = 'Cannot overwrite existing file'
  case(11)
    msg = 'Unit not connected'
  case(17)
    msg = 'Syntax error in NAMELIST input'
  case(18)
    msg = 'Too many values for NAMELIST variable'
  case(19)
    msg = 'Invalid reference to variable in NAMELIST input'
  case(20)
    msg = 'REWIND error'
  case(21)
    msg = 'Duplicate file specifications'
  case(22)
    msg = 'Input record too long'
  case(23)
    msg = 'BACKSPACE error'
  case(24)
    msg = 'End-of-file during read'
  case(25)
    msg = 'Record number outside range'
  case(26)
    msg = 'OPEN or DEFINE FILE required'
  case(27)
    msg = 'Too many records in I/O statement'
  case(28)
    msg = 'CLOSE error'
  case(29)
    msg = 'File not found'
  case(30)
    msg = 'Open failure'
  case(31)
    msg = 'Mixed file access modes'
  case(32)
    msg = 'Invalid logical unit number'
  case(33)
    msg = 'ENDFILE error'
  case(34)
    msg = 'Unit already open'
  case(35)
    msg = 'Segmented record format error'
  case(36)
    msg = 'Attempt to access non-existent record'
  case(37)
    msg = 'Inconsistent record length'
  case(38)
    msg = 'Error during write'
  case(39)
    msg = 'Error during read'
  case(40)
    msg = 'Recursive I/O operation'
  case(41)
    msg = 'Insufficient virtual memory'
  case(42)
    msg = 'No such device'
  case(43)
    msg = 'File name specification error'
  case(44)
    msg = 'Inconsistent record type'
  case(45)
    msg = 'Keyword value error in OPEN statement'
  case(46)
    msg = 'Inconsistent OPEN/CLOSE parameters'
  case(47)
    msg = 'Write to READONLY file'
  case(48)
    msg = 'Invalid argument to Fortran Run-Time Library'
  case(51)
    msg = 'Inconsistent file organization'
  case(53)
    msg = 'No current record'
  case(55)
    msg = 'DELETE error'
  case(57)
    msg = 'FIND error'
  case(58)
    msg = 'Format syntax error at or near xx'
  case(59)
    msg = 'List-directed I/O syntax error'
  case(60)
    msg = 'Infinite format loop'
  case(61)
    msg = 'Format/variable-type mismatch'
  case(62)
    msg = 'Syntax error in format'
  case(63)
    msg = 'Output conversion error'
  case(64)
    msg = 'Input conversion error'
  case(65)
    msg = 'Floating invalid'
  case(66)
    msg = 'Output statement overflows record'
  case(67)
    msg = 'Input statement requires too much data'
  case(68)
    msg = 'Variable format expression value error'
  case(70)
    msg = 'Integer overflow'
  case(71)
    msg = 'Integer divide by zero'
  case(72)
    msg = 'Floating overflow'
  case(73)
    msg = 'Floating divide by zero'
  case(74)
    msg = 'Floating underflow'
  case(75)
    msg = 'Floating point exception'
  case(77)
    msg = 'Subscript out of range'
  case(78)
    msg = 'Process killed'
  case(79)
    msg = 'Process quit'
  case(90)
    msg = 'INQUIRE of internal unit-number is always an error (unit identifies a file)'
  case(91)
    msg = 'INQUIRE of internal unit-number is always an error (unit does not identify a file)'
  case(95)
    msg = 'Floating-point conversion failed'
  case(96)
    msg = 'F_UFMTENDIAN environment variable was ignored: erroneous syntax'
  case(98)
    msg = 'Cannot allocate memory for the file buffer - out of memory'
  case(104)
    msg = 'Incorrect "XXXXX=" specifier value for connected file'
  case(106)
    msg = 'FORT_BLOCKSIZE environment variable has erroneous syntax'
  case(107)
    msg = 'FORT_BUFFERCOUNT environment variable has erroneous syntax'
  case(108)
    msg = 'Cannot stat file'
  case(109)
    msg = 'Stream data transfer statement is not allowed to an unopened unit'
  case(118)
    msg = 'The RECL= value in an OPEN statement exceeds the maximum allowed for the file''s record type'
  case(119)
    msg = 'The FORT_BUFFERING_THRESHOLD environment variable has erroneous syntax'
  case(120)
    msg = 'Operation requires seek ability'
  case(121)
    msg = 'Cannot access current working directory'
  case default
    write(msg,'(A,I5)')  'Unknown error code ',ier
  end select
  !
end subroutine ifort_iostat
!
function failed_allocate(rname,array,ier,error)
  use gbl_message
  use gsys_interfaces, except_this=>failed_allocate
  !-------------------------------------------------------------------
  ! @ public
  ! Check allocation status and display a message if error
  !-------------------------------------------------------------------
  logical :: failed_allocate  ! Function value on return
  character(len=*), intent(in)    :: rname  ! Calling routine name
  character(len=*), intent(in)    :: array  ! Name of allocated array
  integer(kind=4),  intent(in)    :: ier    ! Allocation status
  logical,          intent(inout) :: error  ! Logical error flag
  ! Local
  character(len=160) :: mess
  !
  if (ier.ne.0) then
    write(mess,'(a,i0,a)') 'Could not allocate memory for '//array//' (IER = ',ier,')'
    call gsys_message(seve%e,rname,mess)
    error = .true.
  endif
  failed_allocate = error
end function failed_allocate

subroutine uv_listheader(huv,visi,mt,tf,nt,freq)
  use gkernel_interfaces
  use image_def
  use gbl_message
  use imager_interfaces, except_this => uv_listheader
  !-----------------------------------------------------
  ! @ private
  ! MAPPING
  !
  ! Give a brief summary of the content of an UV Table
  !-----------------------------------------------------
  type(gildas), intent(in) :: huv
  integer, intent(in) :: mt         ! Maximum number of dates
  integer, intent(out) :: nt        ! Number of dates
  integer, intent(out) :: tf(mt)    ! Dates (in Gildas code)
  real(4), intent(in) :: visi(huv%gil%dim(1),huv%gil%dim(2)) ! Visbilities
  real(8), intent(in) :: freq       ! Observing frequency
  !
  character(len=14) :: ch
  logical error
  integer jt,ti,co,i,j,k
  integer(kind=index_length) :: iv
  integer count(mt)
  real bmin(mt), bmax(mt), bm, bp, base, scale
  character(len=message_length) :: chain
  real(8) :: rti
  integer(4) :: iant, jant, ia, ja, nant
  integer(4) :: ka(-1:256),la(-1:256)
  !
  call map_message(seve%r,'HEADER','Summary of observations')
  scale = freq/299792458.d-6*1e-3
  write(chain,'(I6,A,I2,A,A,F13.3,A)') huv%gil%nchan,' Channels, ', &
    &   huv%gil%nstokes,' Stokes, ','  Rest Frequency ',freq,' MHz'
  call map_message(seve%r,'HEADER',chain)
  !
  nt = 0
  tf(:) = 0
  bmin(:) = 1E20
  bmax(:) = 0
  iant = 257
  jant = 0
  nant = 0
  ka = 0
  la = 0
  !
  do iv=1,huv%gil%nvisi
    rti = dble(visi(4,iv))+dble(visi(5,iv))/86400.0d0
    if (rti.ge.0) then
      ti = int(rti)
    else
      ti = int(rti)-1
    endif
    !
    jt = 0
    do j=1,nt
      if (ti.eq.tf(j)) then
        jt = j
        exit
      endif
    enddo
    if (jt.eq.0) then
      if (nt.gt.mt) return
      nt = nt+1
      tf(nt) = ti
      count(nt) = 1
      jt = nt
    else
      count(jt) = count(jt)+1
    endif
    !
    ! Build the antenna pointer list
    ia = nint(visi(6,iv))
    if (ia.ne.0) then
      if (la(ia).eq.0) then
      nant = nant+1
      la(ia) = nant
      ka(nant) = ia
      endif
    endif
    ja = nint(visi(7,iv))
    if (ja.ne.0) then
      if (la(ja).eq.0) then
        nant = nant+1
        la(ja) = nant
        ka(nant) = ja
      endif
    endif
    if (ia.ne.0 .and. ja.ne.0) then
      iant = min(iant,ia,ja)
      jant = max(jant,ia,ja)
      !
      ! Valid antenna : compute baseline length
      base = visi(1,iv)**2+visi(2,iv)**2
      bmin(jt) = min(base,bmin(jt))
      bmax(jt) = max(base,bmax(jt))
    endif
  enddo
  !
  ! Go to baseline
  bmin = sqrt(bmin)
  bmax = sqrt(bmax)
  !
  !
  ! A simple sort
  if (.false.) then
    do j = nt-1,1,-1
      k = j
      do i = j+1,nt
        if (tf(j).le.tf(i)) exit
        k = i
      enddo
      if (k.ne.j) then
        ti = tf(j)
        co = count(j)
        bp = bmax(j)
        bm = bmin(j)
        do i = j+1,k
          tf(i-1) = tf(i)
          count(i-1) = count(i)
          bmax(i-1) = bmax(i)
          bmin(i-1) = bmin(i)
        enddo
        tf(k) = ti
        count(k) = co
        bmax(k) = bp
        bmin(k) = bm
      endif
    enddo
  endif
  !
  if (huv%gil%version_uv .ge. code_version_uvt_syst) then
    call map_message(seve%r,'HEADER','Has fine Doppler correction')
  else if (huv%gil%version_uv .eq. code_version_uvt_freq) then
    call map_message(seve%r,'HEADER','Has no Doppler information')
  else if (huv%gil%version_uv .eq. code_version_uvt_dopp) then
    call map_message(seve%r,'HEADER','Has coarse Doppler information')
  endif
  call map_message(seve%r,'HEADER', &
       & '   Dates      Visibilities     Minimun    & Maximum Baselines')
  call map_message(seve%r,'HEADER', &
       & '                              (m)  (kWave)    (m)    (kWave)')
  do i=1,nt
    call gag_todate(tf(i),ch,error)
    write(chain,100) ch,count(i),bmin(i),bmin(i)*scale,bmax(i),bmax(i)*scale
    call map_message(seve%r,'HEADER',chain)
  enddo
  write(chain,'(I4,A,I4,I4)') nant, ' Antennas,  in range ',iant,jant
  call map_message(seve%r,'HEADER',chain)
  write(*,'(20I4)') ka(1:nant)
100 format (1X,A,I8,3X,F7.1,1x,F7.1,2X,F8.1,1X,F7.1)
end subroutine uv_listheader
!
subroutine uniform_beam (map_name,uv_taper,map_size,map_cell,   &
        &    uniform,wcol,mcol,work,error,mode,                 &
        &    beams,mbeam,start,step,uvmax,result,huv,duv)
  use imager_interfaces, except_this=>uniform_beam
  use gildas_def
  use image_def
  use gbl_message
  use gkernel_interfaces
  !------------------------------------------------------------------------
  ! @ public
  !
  ! MAPPING
  !   UV_STAT Compute a map from a CLIC UV Sorted Table
  !   by Gridding and Fast Fourier Transform, with
  !   one single beam for all channels.
  !
  ! Input :
  ! a precessed UV table, sorted in V, ordered in
  ! (U,V,W,D,T,iant,jant,nchan(real,imag,weig))
  ! Output :
  ! a beam image
  ! a VLM cube
  ! Work space :
  ! a  VLM complex Fourier cube (first V value is for beam)
  !------------------------------------------------------------------------
  type(gildas), intent(in) :: huv               ! UV Table Header
  real, intent(inout) :: duv(:,:)               ! Visibility Array
  character(len=*), intent(in) :: map_name      ! Name of image (void)
  character(len=*), intent(in) :: mode          ! Mode of statistics
  real, intent(in) :: uv_taper(3)               ! UV Taper
  integer, intent(in) :: map_size(2)            ! Number of pixels
  real, intent(in) :: map_cell(2)               ! Pixel size
  real, intent(in) :: uniform(2)                ! Robust parameter
  integer, intent(inout) :: wcol                ! Weight column
  integer, intent(inout) :: mcol(2)             ! Channel range

  integer, intent(in) :: mbeam      ! Number of beams
  real :: work(*)                   ! Work array
  logical :: error                  ! Error flag
  real, intent(out) :: beams(map_size(1),map_size(2),mbeam)
  real, intent(inout) :: start      ! Starting value for range
  real, intent(inout) :: step       ! Step for range
  real, intent(in) :: uvmax         ! Max UV distance
  real, intent(out) :: result(10,8) ! Resulting beam characteristics
  !
  ! Global variables:
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real ubias,vbias,ubuff(4096),vbuff(4096)
  common /conv/ ubias,vbias,ubuff,vbuff
  !
  real(8), parameter :: clight=299792458d-6  ! Frequency in MHz
  !
  integer ctype               ! Convolution mode, local value
  real(8) freq,rcol,convert(6)
  integer nx,ny,nc,nv,nd,lx,ly,nu
  integer ctypx,ctypy,lcol,fcol
  real uv_cell(2)
  real xparm(10),yparm(10),support(2)
  real vref,voff,vinc,lambda
  integer ndim, nn(2), i
  real, allocatable :: ipxc(:), ipyc(:)
  real, allocatable :: ipw(:,:), ipv(:), ipg(:)
  complex, allocatable :: ipf(:)
  complex, allocatable :: ipft(:)
  integer :: ier
  !
  integer, parameter :: nuni=10
  real wnat, noise, mn
  integer ix_patch, iy_patch, icol, ib
  real(4) major_axis(nuni), minor_axis(nuni), pos_angle(nuni),knoise(nuni)
  real(4) sidelobe(2,nuni),utaper(nuni), unif(nuni),wuni(nuni)
  real(4) sec,zero(3),thre,rms,rmk,vmax
  character(len=8) chain(nuni)
  character(len=32) unit
  character(len=10) jyunit
  character(len=16) kunit
  character(len=message_length) string
  character(len=7) :: rname = 'UV_STAT'
  !
  real cpu0,cpu1,pixel_per_beam,bmax
  !
  data zero/3*0/
  data pixel_per_beam /2.0/
  !------------------------------------------------------------------------
  call gag_cpu(cpu0)
  xparm(1:10) = 0
  yparm(1:10) = 0
  !
  if (mode.eq.'TAPER') then
    if (step.eq.0.0) step = sqrt(2.0)
    if (start.eq.0.0) start = 50.0
  elseif (mode.eq.'WEIGHT') then
    if (step.eq.0.0) step = 10.0**0.25
    if (start.eq.0.0) start = 1.0/step**4
  elseif (mode.eq.'CELL' ) then
    if (step.eq.0.0) step = sqrt(2.0)
    if (start.eq.0.0) start = uniform(1)/step**4
    if (start.eq.0.0) start = 7.5/step**4 ! NOEMA default    
  elseif (mode.eq.'BRIGGS') then
    continue
  else
    string = 'Unsupported mode '//mode
    call map_message(seve%e,rname,string)
    error = .true.
    return
  endif
  !
  ! Code:
  nx = map_size(1)
  ny = map_size(2)
  nd = nx*ny
  nu = huv%gil%dim(1)
  nv = huv%gil%nvisi   !! NOT huv%gil%dim(2)
  !
  ! This must be a patch for some old stuff
  if (huv%gil%dim(1).ne.3) then
    ! nc = (huv%gil%dim(1)-7)/3
    nc = huv%gil%nchan
  else
    nc = 1
  endif
  write(string,100) 'Found ',nv,' visibilities, ',nc,' channels'
  call map_message(seve%i,rname,string)
  if (nv.eq.0) return ! Just in case
  !
  ! Get work space at once, for memory contiguity reasons.
  !
  allocate (ipxc(nx),ipyc(ny),ipw(nv,nuni),ipv(nv),ipg(nd),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation failure')
    error = .true.
    return
  endif
  !
  vref = huv%gil%convert(1,1)
  voff = huv%gil%voff
  vinc = huv%gil%vres
  if (mcol(1).eq.0) then
    mcol(1) = 1
  else
    mcol(1) = max(1,min(mcol(1),nc))
  endif
  if (mcol(2).eq.0) then
    mcol(2) = nc
  else
    mcol(2) = max(1,min(mcol(2),nc))
  endif
  fcol = min(mcol(1),mcol(2))
  lcol = max(mcol(1),mcol(2))
  !
  ! Compute observing sky frequency for U,V cell size
  rcol = 0.5*(fcol+lcol)
  freq = gdf_uv_frequency(huv,rcol)
  !
  if (wcol.lt.0) then
    ! WCOL negative is used to avoid examining the Dates 
    fcol = -wcol
  else if (wcol.eq.0) then
    icol = min(max(1,mcol(1)),nc)  ! First channel
    fcol = min(mcol(2),nc)
    if (fcol.eq.0) fcol = nc
    fcol = (icol+fcol)/3           ! Avoid middle channel
  else
    fcol = wcol
  endif
  fcol = min(fcol,nc)
  fcol = max(1,fcol)
  icol = fcol*3+7
  !
  ! Compute gridding function
  ctype = 1                    ! Force it for the FAST gridding.
  ctypx = ctype
  ctypy = ctype
  call grdflt (ctypx, ctypy, xparm, yparm)
  call convfn (ctypx, xparm, ubuff, ubias)
  call convfn (ctypy, yparm, vbuff, vbias)
  uv_cell(1) = clight/freq/(map_cell(1)*map_size(1))
  uv_cell(2) = clight/freq/(map_cell(2)*map_size(2))
  support(1) = xparm(1)*uv_cell(1) ! In meters
  support(2) = yparm(1)*uv_cell(2)
  !
  lx = (uvmax+support(1))/uv_cell(1) + 2
  ly = (uvmax+support(2))/uv_cell(2) + 2
  lx = 2*lx
  ly = 2*ly
  call docoor (lx,-uv_cell(1),ipxc) 
  call docoor (ly,uv_cell(2),ipyc) 
  !
  if (wcol.ge.0) call dodate (nu,nv,duv,4,5)
  if ( (mode.ne.'TAPER') .or.   &
     &    (uniform(2).gt.0.and.uniform(1).gt.0) ) then
    !
    ! Safety belt & Airbag...
    vmax = duv(2,1)
    do i=1,nv
      if (duv(2,i).lt.vmax) then
        call map_message(seve%f,rname,'Programming error, UV data not sorted')
        error = .true.
        return
      endif
      vmax = duv(2,i)
    enddo
  endif
  !
  ! Load V values
  ! Here, we will ignore the output in IPW,
  ! so we can use ICOL even if wrong, but ICOL is used later
  call dovisi (nu,nv,duv,ipv,ipw, icol)
  call gag_cpu(cpu1)
  write(string,102) 'Start Weighting ',cpu1-cpu0
  call map_message(seve%i,rname,string)
  !
  ! Compute weights
  if (mode.eq.'TAPER') then
    wuni(1) = uniform(2)
    utaper(1) = start
    do i=2,nuni-1
      utaper(i) = utaper(i-1)*step
    enddo
    utaper(nuni) = 0.0
    call do3weig (nu,nv,  &
     &      duv,          &    ! Visibilities
     &      1,2,          &    ! U, V pointers
     &      icol,         &    ! Weight channel
     &      uniform(1),   &    ! Uniform UV cell size
     &      ipw,          &    ! Weight array
     &      wuni,nuni,    &    ! Fraction of weight
     &      utaper,wnat,  &
     &      ipv)
  elseif (mode.eq.'WEIGHT') then
    unif(1) = start
    unif(nuni) = 0.0
    do i = 2,nuni-1
      unif(i) = unif(i-1)*step
    enddo
    wuni(1:nuni) = unif(1:nuni)
    utaper(1:3) = uv_taper(1:3)
    call do2weig (nu,nv,  &
     &      duv,          &    ! Visibilities
     &      1,2,          &    ! U, V pointers
     &      icol,         &    ! Weight channel
     &      uniform(1),   &    ! Uniform UV cell size
     &      ipw,          &    ! Weight array
     &      wuni,nuni,    &    ! Fraction of weight
     &      utaper,wnat,  &
     &      ipv)
  elseif (mode.eq.'BRIGGS') then
    do i = 1,nuni
      unif(i) = -4.0+(i-1)*0.50 !! nuni)/(nuni-1)
    enddo
    unif(nuni) = 0.0
    wuni(1:nuni) = unif(1:nuni)
    utaper(1:3) = uv_taper(1:3)
    call do2weig (nu,nv,  &
     &      duv,          &    ! Visibilities
     &      1,2,          &    ! U, V pointers
     &      icol,         &    ! Weight channel
     &      uniform(1),   &    ! Uniform UV cell size
     &      ipw,          &    ! Weight array
     &      wuni,nuni,    &    ! Fraction of weight
     &      utaper,wnat,  &
     &      ipv)
  elseif (mode.eq.'CELL') then
    unif(1) = start
    do i = 2,nuni
      unif(i) = unif(i-1)*step
    enddo
    wuni(1) = uniform(2)
    wuni(2:nuni) = unif(2:nuni)
    utaper(1:3) = uv_taper(1:3)
    call do4weig (nu,nv,  &
     &      duv,          &    ! Visibilities
     &      1,2,          &    ! U, V pointers
     &      icol,         &    ! Weight channel
     &      unif,         &    ! Uniform UV cell size
     &      ipw,          &    ! Weight array
     &      wuni,nuni,    &    ! Fraction of weight
     &      utaper,wnat,  &
     &      ipv)
  endif
  call gag_cpu(cpu1)
  write(string,102) 'Finished Weighting ',cpu1-cpu0
  call map_message(seve%i,rname,string)
  if (wnat.eq.0.0) then
    write(string,101) 'Plane ',fcol,' has Zero weight'
    call map_message(seve%e,rname,string)
    deallocate (ipxc,ipyc,ipw,ipv,ipg,stat=ier)
    error = .true.
  return
  endif
  !
  noise = 1e-3/sqrt(wnat)
  call prnoise(rname,'Natural',noise,rms)
  !
  ! Get FFTs work space
  allocate (ipf(nd),ipft(lx*ly*nuni),stat=ier)
  if (ier.ne.0) then
    call map_message(seve%e,rname,'Memory allocation failure')
    deallocate (ipxc,ipyc,ipw,ipv,ipg,stat=ier)
    error = .true.
  return
  endif
  !
  ! Compute FFTs
  call do2fft (nu,nv,   &      ! Size of visibility array
     &    duv,          &      ! Visibilities
     &    1,2,          &      ! U, V pointers
     &    lx,ly,nuni,   &      ! Cube size
     &    ipft,         &      ! FFT cube
     &    ipxc, ipyc,   &      ! U and V grid coordinates
     &    ipw)                 ! Weight array 
  call gag_cpu(cpu1)
  write(string,102) 'Finished Weighting ',cpu1-cpu0
  call map_message(seve%i,rname,string)
  !
  ! Make beam, not normalized
  ndim = 2
  nn(1) = nx
  nn(2) = ny
  call fourt_plan(ipf,nn,ndim,-1,1)
  !
  convert = (/dble(nx/2+1),0.d0,-dble(map_cell(1)),   &
     &    dble(ny/2+1),0.d0,dble(map_cell(2))/)
  !
  ! Compute grid correction,
  ! Normalization factor is applied to grid correction, for further
  ! use on channel maps. Use IPF and IPF+NX for work space.
  !
!  call grdtab (ny, vbuff, vbias, ipxc)
!  call grdtab (nx, ubuff, ubias, ipyc)
  !
  ! Loop on Uniform parameters
  ipw(:,:) = max(0.0,ipw) ! Flagged data have negative weights
  !
  do i = 1,nuni
    ib = min(i,mbeam)
    call extracs(nuni,nx,ny,i,ipft,ipf,lx,ly)
    call fourt  (ipf,nn,ndim,-1,1,work)
    call cmtore (ipf,beams(1,1,ib),nx,ny)
!    call dogrid (ipg,ipxc,ipyc,nx,ny,beams(1,1,ib))
    !
    ! Normalize and Free beam
!    call docorr (beams(1,1,ib),ipg,nd)
    bmax = beams(nx/2+1,ny/2+1,ib)
    beams(:,:,ib) = beams(:,:,ib)/bmax
    !
    ! Get noise & Sidelobes
    wuni(i) = sum(ipw(1:nv,i))
    sidelobe(1,i) = minval(beams(:,:,ib)) !! minimum(nd,beams(1,1,ib))
    thre = max(min(abs(-1.5*sidelobe(1,i)),0.7),0.3)
    !
    ! Fit beam
    ix_patch = nx/2
    iy_patch = ny/2
    major_axis(i) = 0.
    minor_axis(i) = 0.
    pos_angle(i) = 0.
    call fibeam (' ',beams(1,1,ib),nx,ny,   &
     &      ix_patch,iy_patch,thre,   &
     &      major_axis(i),minor_axis(i),pos_angle(i),   &
     &      convert,error)
    !
    ! Subtract main beam
    call sidelo (beams(1,1,ib),nx,ny,sidelobe(1,i),   &
     &      major_axis(i),minor_axis(i),pos_angle(i),   &
     &      convert)
    !
  enddo
  call gag_cpu(cpu1)
  write(string,102) 'Finished FFTs ',cpu1-cpu0
  call map_message(seve%i,rname,string)
  !
  ! Delete scratch space
  deallocate (ipxc,ipyc,ipw,ipv,ipg,stat=ier)
  deallocate (ipf,ipft,stat=ier)
  !
  ! Printout results
  sec = 180.*3600./pi
  lambda =  clight/freq
  call gagout(' ')
  ! Define the unit for Flux dsensitivity
  if (rms.le.2.0) then
    jyunit = '(Jy)      '
  else if (rms.le.2e3) then
    jyunit = '(mJy)     '
  else
    jyunit = '(microJy) '
  endif
  rms = rms*1e-3 ! As frequencies are in MHz
  !
  ! Define the scale factor for
  !
  knoise = sqrt(1.0/wuni)*lambda**2*4*log(2.0)*1e-3/ &
     &      (2.0*1.38e3*major_axis*minor_axis*pi)
  rmk = sqrt(minval(knoise)*maxval(knoise))
  !
  if (rmk.gt.0.05) then
    rmk = 1
    kunit = ' (K)       % '
  elseif (rmk.gt.0.1e-3) then
    rmk = 1e3
    kunit = '(mK)       % '
  else
    rmk = 1e6
    kunit = '(microK)   % '
  endif
  unit = jyunit//kunit
  !
  if (mode.eq.'TAPER') then
    call gagout('Taper       Major    Minor     PA            Noise      Sidelobe')
    call gagout(' (m)          (")      (")     (deg)    '//unit)
    do i=1,nuni-1
      write(chain(i),106) utaper(i)
    enddo
    chain(nuni) = '  None'
  elseif  (mode.eq.'CELL') then
    call gagout('Cell        Major    Minor     PA            Noise      Sidelobe')
    call gagout(' (m)          (")      (")     (deg)    '//unit)
    chain(1) = '  None'
    do i=2,nuni
      write(chain(i),106) unif(i)
    enddo
  elseif  (mode.eq.'WEIGHT') then
    call gagout('Robust      Major    Minor     PA            Noise      Sidelobe')
    call gagout('              (")      (")     (deg)    '//unit)
    do i=1,nuni-1
      write(chain(i),106) unif(i)
    enddo
    chain(nuni) = '  None'
  elseif  (mode.eq.'BRIGGS') then
    call gagout('Briggs      Major    Minor     PA            Noise      Sidelobe')
    call gagout('              (")      (")     (deg)    '//unit)
    do i=1,nuni-1
      write(chain(i),106) unif(i)
    enddo
    chain(nuni) = '  None'
  endif
  !
  do i=1,nuni
    write(string,105) chain(i),major_axis(i)*sec,minor_axis(i)*sec   &
     &      ,pos_angle(i),sqrt(1.0/wuni(i))*rms,knoise(i)*rmk &
     &      ,sidelobe(1,i)*100.0,sidelobe(2,i)*100.0
    call gagout(string)
    result(i,1) = unif(i)
    result(i,2) = major_axis(i)*sec
    result(i,3) = minor_axis(i)*sec
    result(i,4) = pos_angle(i)
    result(i,5) = sqrt(1.0/wuni(i))*1e-3
    result(i,6) = knoise(i)
    result(i,7) = sidelobe(1,i)*100.0
    result(i,8) = sidelobe(2,i)*100.0
  enddo
  call gagout(' ')
  !
  ! Recommend pixel size
  mn = minor_axis(1)
  do i=2,nuni
    mn = min(mn,minor_axis(i))
  enddo
  if (mn.ge.0.1*sec) then
    mn = 0.02*nint(50.0*mn*sec/pixel_per_beam)
  else
    mn = 0.002*nint(500.0*mn*sec/pixel_per_beam)
  endif
  write(string,107) map_cell(1)*sec, mn
  call map_message(seve%i,rname,string)
  error = .false.
  return
  !
  100   format(a,i10,a,i5,a)
  101   format(a,i6,a)
  102   format(a,f9.3,a)
  105   format(a,1x,f9.3,f9.3,f9.1,1x,f9.2,f9.2,1x,f6.1,f6.1)
  106   format(f7.2)
  107   format('Recommended pixel size is ',f6.3,' - ',f6.3,'"')
end subroutine uniform_beam
!
subroutine do2weig (jc,nv,visi,jx,jy,iw,unif,we,wm,nw,taper,s,vv)
  use gildas_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => do2weig
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Compute weights of the visibility points.
  !   Explore here the robust parameters.
  !----------------------------------------------------------------------
  integer, intent(in) :: nv  ! Size of a visibility
  integer, intent(in) :: jc  ! Number of visibilities
  integer, intent(in) :: jx  ! X coordinate pointer
  integer, intent(in) :: jy  ! Y coordinate pointer
  integer, intent(in) :: iw  ! Weight pointer
  integer, intent(in) :: nw  ! Number of weighting schemes
  real, intent(in) :: visi(jc,nv)  ! Visibilities
  real, intent(in) :: unif         ! Cell size in meters
  real, intent(out) :: we(nv,nw)   ! Weight arrays
  real, intent(inout) :: wm(nw)    ! on input: robust factors
  real, intent(in) :: taper(3)     ! Taper
  real, intent(out) :: s           ! Sum of weights (natural noise)
  real, intent(in) :: vv(nv)       ! V values
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='DO2WEIG'
  !
  integer i,kw
  real u,v,weight,wmax,wmin
  real cx,sx,cy,sy,staper
  real ss(10),s2(10),ww,st,u2
  logical do_taper, briggs
  real umin,umax,vmin,vmax
  real wfact
  integer nbcv,  nbv
  !
  ! GILDAS robust parameter ranges from [0,infty] (in practice 10)
  briggs = wm(1).lt.0   ! Briggs parameters range from [-4,0] 
  ! re-mapped to true Briggs by shifting in the [-2,2] range
  !
  ! Natural weights
  s = 0.
  do i=1,nv
    if (visi(iw,i).gt.0.0) then
      we(i,nw) = visi(iw,i)
      s = s+we(i,nw)
    else
      we(i,nw) = 0.0
    endif
  enddo
  if (s.eq.0) return
  !
  ! Define taper
  staper = taper(3)*pi/180.0
  do_taper = .false.
  if (taper(1).ne.0) then
    cx = cos(staper)/taper(1)
    sy = sin(staper)/taper(1)
    do_taper = .true.
  else
    cx = 0.0
    sy = 0.0
  endif
  if (taper(2).ne.0) then
    cy = cos(staper)/taper(2)
    sx = sin(staper)/taper(2)
    do_taper = .true.
  else
    cy = 0.0
    sx = 0.0
  endif
  !
  ! 1) Compute VMIN, VMAX, UMIN, UMAX
  vmin = visi(jy,1)
  vmax = visi(jy,nv)
  umin = 0.0
  umax = 0.0
  do i=1,nv
    if (visi(jx,i).lt.umin) then
      umin = visi(jx,i)
    elseif  (visi(jx,i).gt.umax) then
      umax = visi(jx,i)
    endif
  enddo
  !
  call do0weig (jc,nv,visi,jx,jy,iw,unif,we(1,nw),vv,nbv, &
      &   umin,umax,vmin,vmax,nbcv)
  !
  ! Define robustness - generic
  weight = 0.0
  wmax = 0.0
  wmin = 1.e36  
  do i=1,nv
    if (we(i,nw).gt.0.0) then
      wmin = min(we(i,nw),wmin)
      wmax = max(we(i,nw),wmax)
      weight = weight+we(i,nw)
    endif
  enddo
  weight = weight/nv
  wfact = sqrt(wmin*wmax)
  do kw = 1,nw-1
    !    wm(kw) = wm(kw)*sqrt(wmin*wmax)
  enddo
  !
  ! Apply robustness
  do kw=1,nw-1
    ss(kw) = 0.0
    s2(kw) = 0.0
  enddo
  ss(nw) = 1.0
  s2(nw) = 1.0
  !
  do i=1,nv
    ww = we(i,nw)
    if (do_taper) then
      v = visi(jy,i)
      u = visi(jx,i)
      staper = (u*cx + v*sy)**2 + (-u*sx + v*cy)**2
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
    else
      staper = 1.0
    endif
    !
    ! Get the natural weighting correct now
    if (ww.le.0.0) then
      we(i,nw) = 0.0
    else
      we(i,nw) = staper*visi(iw,i)
    endif
    !
    ! Compute the new weights 
    if (briggs) then
      ! Briggs way
      do kw=1,nw-1
        ! s = 5*10^(-Briggs)  with (typically) -2 < Briggs < 2
        ! Here we use an input range [-4,0] so shift by 2
        u2  = 5*10**(-(2+wm(kw)))    ! s
        u2 = u2*u2                   ! s^2
        !
        if (ww.gt.0) then
          st = staper/(u2*ww/wfact+1.0)
          we(i,kw) = visi(iw,i)*st
          ss(kw) = ss(kw) + we(i,kw)
          s2(kw) = s2(kw) + we(i,kw)*st
        else
          we(i,kw) = 0.0
        endif
      enddo
    else
      ! GILDAS way
      do kw=1,nw-1
        !! if (ww.gt.wm(kw)) then
        if (ww.gt.wm(kw)*wfact) then
          st = staper/ww*wm(kw)*wfact
          we(i,kw) = visi(iw,i)*st
          ss(kw) = ss(kw) + we(i,kw)
          s2(kw) = s2(kw) + we(i,kw)*st
        elseif (ww.gt.0.0) then
          we(i,kw) = visi(iw,i)*staper
          ss(kw) = ss(kw) + we(i,kw)
          s2(kw) = s2(kw) + we(i,kw)*staper
        else
          we(i,kw) = 0.0
        endif
      enddo
    endif
  enddo
  !
  ! Renormalize weights to get proper noise
  do kw=1,nw
    st = ss(kw)/s2(kw)
    do i=1,nv
      we(i,kw) = st*we(i,kw)
    enddo
  enddo
end subroutine do2weig
!
function minimum(n,a)
  integer n,i
  real a(*)
  real minimum
  !
  minimum = a(1)
  do i=2,n
    minimum = min(minimum,a(i))
  enddo
end function minimum
!
subroutine do3weig (jc,nv,visi,jx,jy,iw,cunif,we,cwm,nw,taper,s,vv)
  use gildas_def
  use gkernel_interfaces
  use gbl_message
  use imager_interfaces, except_this => do3weig
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Compute weights of the visibility points.
  !   TAPER mode
  !----------------------------------------------------------------------
  integer, intent(in) :: nv  ! Size of a visibility
  integer, intent(in) :: jc  ! Number of visibilities
  integer, intent(in) :: jx  ! X coordinate pointer
  integer, intent(in) :: jy  ! Y coordinate pointer
  integer, intent(in) :: iw  ! Weight pointer
  integer, intent(in) :: nw  ! Number of weighting schemes
  real, intent(in) :: visi(jc,nv)  ! Visibilities
  real, intent(in) :: cunif(1)     ! Cell size in meters
  real, intent(out) :: we(nv,nw)   ! Weight arrays
  real, intent(in) :: cwm(1)       ! on input: robust factors
  real, intent(in) :: taper(nw)    ! Tapers
  real, intent(out) :: s           ! Sum of weights (natural noise)
  real, intent(in) :: vv(nv)       ! V values
  !
  character(len=*), parameter :: rname='DO3WEIG'
  integer i,kw
  real u,v,weight,wmax,wmin
  real staper
  real ss(10),s2(10),ww,st
  !
  real umin,umax,vmin,vmax,vstep,vimin,vimax
  real vcmin, vcmax,unif,wm
  integer nbcv, ivmin, ivmax, icv, nbv, new
  character(len=message_length) :: chain
  !
  ! Natural weights
  unif = cunif(1)
  wm = cwm(1)
  !
  s = 0.
  do i=1,nv
    if (visi(iw,i).gt.0.0) then
      we(i,nw) = visi(iw,i)
      s = s+we(i,nw)
    else
      we(i,nw) = 0.0
    endif
  enddo
  if (s.eq.0) return
  !
  if (unif*wm.ne.0.0) then
    !
    ! 1) Compute VMIN, VMAX, UMIN, UMAX
    vmin = visi(jy,1)
    vmax = visi(jy,nv)
    umin = 0.0
    umax = 0.0
    do i=1,nv
      if (visi(jx,i).lt.umin) then
        umin = visi(jx,i)
      elseif  (visi(jx,i).gt.umax) then
        umax = visi(jx,i)
      endif
    enddo
    !
    ! Symmetry ?...
    if (-umin.gt.umax) then
      umax = -umin
    else
      umin = -umax
    endif
    vmin = 1.001*vmin          ! Allow small margin
    umax = 1.001*umax
    umin = 1.001*umin
    !
    ! Some speed up factor
    nbcv = 8
    vstep = -vmin/nbcv
    !
    ! Adjust the number of cells. A cell must be > 2*UNIF, and > 4*UNIF is more
    ! than sufficient to get speed up.
    !
    if (vstep.lt.4*unif) then
      nbcv = -vmin/(4*unif)
      if (mod(nbcv,2).ne.0) nbcv = nbcv-1
      if (nbcv.eq.0) nbcv = 1
      vstep = -vmin/nbcv
    endif
    write(chain,'(A,I2,A)') 'Using ',nbcv,' sub-grids'
    call map_message(seve%i,rname,chain)
    !
    ! Loop on U,V cells
    nbv = 0
    ivmin = 1
    do icv = 1,nbcv
      vcmin = (icv-1)*vstep+vmin
      vimin = vcmin-unif
      vcmax = icv*vstep+vmin
      vimax = vcmax+unif
      call findp (nv,vv,vimin,ivmin)
      ivmax = ivmin
      call findp (nv,vv,vimax,ivmax)
      ivmax = min(nv,ivmax+1)
      new = ivmax-ivmin+1
      if (icv.eq.nbcv) then
        vimin = -unif
        call findp (nv,vv,vimin,ivmin)
        new = new + (nv-ivmin+1)
      endif
      nbv = max(new,nbv)
    enddo
    !
    call do0weig (jc,nv,visi,jx,jy,iw,unif,we(1,nw),vv,nbv,   &
      &      umin,umax,vmin,vmax,nbcv)
    !
    ! Define robustness
    weight = 0.0
    wmax = 0.0
    wmin = 1.e36
    do i=1,nv
      if (we(i,nw).gt.0.0) then
        wmin = min(we(i,nw),wmin)
        wmax = max(we(i,nw),wmax)
        weight = weight+we(i,nw)
      endif
    enddo
    weight = weight/nv
    weight = wm*sqrt(wmin*wmax)
  else
    do i=1,nv
      weight = max(weight,we(i,nw))
    enddo
  endif
  !
  ! Apply robustness
  do kw=1,nw
    ss(kw) = 0.0
    s2(kw) = 0.0
  enddo
  !
  do i=1,nv
    v = visi(jy,i)
    u = visi(jx,i)
    do kw=1,nw
      if (kw.eq.nw) then
        staper = 1.0
      else
        staper = (u**2+v**2)/taper(kw)**2
        if (staper.gt.64.0) then
          staper = 0.0
        else
          staper = exp(-staper)
        endif
      endif
      ww = we(i,nw)
      if (ww.gt.weight) then
        st = staper/ww*weight
        we(i,kw) = visi(iw,i)*st
        ss(kw) = ss(kw) + we(i,kw)
        s2(kw) = s2(kw) + we(i,kw)*st
      elseif (ww.gt.0.0) then
        we(i,kw) = visi(iw,i)*staper
        ss(kw) = ss(kw) + we(i,kw)
        s2(kw) = s2(kw) + we(i,kw)*staper
      else
        we(i,kw) = 0.0
      endif
    enddo
  enddo
  !
  ! Renormalize weights to get proper noise
  do kw=1,nw
    st = ss(kw)/s2(kw)
    do i=1,nv
      we(i,kw) = st * we(i,kw)
    enddo
  enddo
end subroutine do3weig
!
subroutine dodate(nc,nv,visi,id,it)
  use gkernel_interfaces
  use gbl_message
  !-----------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   List the dates
  !-----------------------------------------------------
  integer, intent(in) :: id  ! Date pointer
  integer, intent(in) :: it  ! Time pointer
  integer, intent(in) :: nc  ! Size of a visibility
  integer, intent(in) :: nv  ! Number of visibilities
  real, intent(in) :: visi(nc,nv)
  !
  character(len=*), parameter :: rname='DODATE'
  character(len=78) ch
  logical error
  integer maxt,nt
  parameter (maxt=100)
  integer ti,tf(maxt),i,j,k,jt
  real(8) :: rti
  !
  nt = 0
  do i=1,nv
    rti = dble(visi(id,i))+dble(visi(it,i))/86400.0d0
    if (rti.ge.0) then
      ti = int(rti)
    else
      ti = int(rti)-1
    endif
    !
    jt = 0
    do j=1,nt
      if (ti.eq.tf(j)) then
        jt = j
        exit
      endif
    enddo
    if (jt.eq.0) then
      if (nt.gt.maxt) return
      nt = nt+1
      tf(nt) = ti
      jt = nt
    endif
  enddo
  !
  ! Simple sort
  do j = nt-1,1,-1
    k = j
    do i = j+1,nt
      if (tf(j).le.tf(i)) exit
      k = i
    enddo
    if (k.ne.j) then
      ti = tf(j)
      do i = j+1,k
        tf(i-1) = tf(i)
      enddo
      tf(k) = ti
    endif
  enddo
  !
  call map_message(seve%i,rname,'Observing dates are:')
  k = 5
  ch = ' '
  do i=1,nt
    call gag_todate(tf(i),ch(k:),error)
    k = k+20
    if (k.gt.80) then
      call gagout(ch)
      k = 5
    endif
  enddo
  if (k.gt.5) call gagout(ch)
end subroutine dodate
!
subroutine do4weig (jc,nv,visi,jx,jy,iw,unif,we,wm,nw,taper,s,vv)
  use gkernel_interfaces
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for UV_STAT
  !   Compute weights of the visibility points.
  !   CELL mode
  !----------------------------------------------------------------------
  integer, intent(in) :: nv  ! Size of a visibility
  integer, intent(in) :: jc  ! Number of visibilities
  integer, intent(in) :: jx  ! X coordinate pointer
  integer, intent(in) :: jy  ! Y coordinate pointer
  integer, intent(in) :: iw  ! Weight pointer
  integer, intent(in) :: nw  ! Number of weighting schemes
  real, intent(in) :: visi(jc,nv)  ! Visibilities
  real, intent(in) :: unif(nw)     ! Cell size in meters
  real, intent(out) :: we(nv,nw)   ! Weight arrays
  real, intent(inout) :: wm(nw)    ! on input: robust factors
  real, intent(in) :: taper(3)     ! Tapers
  real, intent(out) :: s           ! Sum of weights (natural noise)
  real, intent(in) :: vv(nv)       ! Sorted V<0 values
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  character(len=*), parameter :: rname='DO4WEIG'
  integer i,kw,jold
  real u,v,wmax,wmin
  real cx,sx,cy,sy,staper
  real ss(10),s2(10),ww,st
  real :: cpu1,cpu0,dcpu,cpul
  !
  real, allocatable :: suu(:), svv(:), sww(:), swe(:), wt(:)
  real :: umin, umax, vmin, vmax
  real :: sizecell
  integer :: ier, mv, nbv, ivmin, icode
  integer :: kcode(10)
  logical :: error
  character(len=64) :: string
  !
  ! Natural weights & Compute VMIN, VMAX, UMIN, UMAX
  vmin = visi(jy,1)
  vmax = visi(jy,nv)
  umin = 0.0
  umax = 0.0
  !
  call gag_cpu(cpu0)
  s = 0.
  do i=1,nv
    if (visi(iw,i).gt.0.0) then
      we(i,1) = visi(iw,i)
      if (visi(jx,i).lt.umin) then
        umin = visi(jx,i)
      elseif  (visi(jx,i).gt.umax) then
        umax = visi(jx,i)
      endif
    else
      we(i,1) = 0.0
    endif
    s = s+we(i,1)
  enddo
  if (s.eq.0) return
  !
  ! Define taper
  staper = taper(3)*pi/180.0
  if (taper(1).ne.0) then
    cx = cos(staper)/taper(1)
    sy = sin(staper)/taper(1)
  else
    cx = 0.0
    sy = 0.0
  endif
  if (taper(2).ne.0) then
    cy = cos(staper)/taper(2)
    sx = sin(staper)/taper(2)
  else
    cy = 0.0
    sx = 0.0
  endif
  !
  ! Uniform weights next
  jold = 0
  !
  ! First compute the taper
  allocate(wt(nv),stat=ier)
  do i=1,nv
    if (visi(iw,i).le.0.0) then
      wt(i) = 0.0
    else
      v = visi(jy,i)
      u = visi(jx,i)
      staper = (u*cx + v*sy)**2 +(-u*sx + v*cy)**2
      if (staper.gt.64.0) then
        staper = 0.0
      else
        staper = exp(-staper)
      endif
      wt(i) = staper
    endif
  enddo
  !
  ! Then apply robustness
  !
  ! Find the location of -unif
  ivmin = 1
  call findp (nv,vv,-unif,ivmin)
  !
  mv = 2*nv-ivmin+1
  allocate(suu(mv),svv(mv),sww(mv),swe(mv),stat=ier)
  !
  suu(1:nv) = visi(jx,:)
  svv(1:nv) = visi(jy,:)
  sww(1:nv) = max(0.0,visi(iw,:))
  !
  ! Apply symmetry
  nbv = nv
  do i=ivmin,nv
    if (visi(iw,i).gt.0) then
      nbv = nbv+1
      suu(nbv) = -visi(jx,i)
      svv(nbv) = -visi(jy,i)
      sww(nbv) = visi(iw,i)
    endif
  enddo
  !
  we(:,1) = sww(1:nv) * wt(1:nv)
  !
  kcode    = 15  ! A reasonable value in most cases, except the large cells
  kcode(8) = 22
  kcode(9) = 30
  kcode(10)= 40
  !
  cpul = cpu0
  do kw=nw,2,-1
    call dowei_icode(umax,umin,vmax,vmin,unif(kw),mv,icode)
    sizecell = unif(kw)/icode
    call gridless_density(nbv,sizecell,unif(kw),suu,svv,sww,swe, &
    &  umin,umax,vmin,unif(kw),error)
    if (error) return
    !
    we(:,kw) = swe(1:nv) * wt(1:nv)  ! Apply taper
    call gag_cpu(cpu1)
    dcpu = cpu1-cpul
    if (dcpu.gt.2) then
      write(string,'(A,I2,F9.3,A)') 'Finished weighting # ',kw,cpu1-cpu0
      call map_message(seve%i,rname,string)
      cpul = cpu1
    endif
  enddo
  !
  ! Define Robust parameter & Apply Robustness
  ss(2:nw) = 0.0
  s2(2:nw) = 0.0
  ss(1) = 1.0
  s2(1) = 1.0
  !
  do kw = 2,nw
    wmax = 0.0
    wmin = 1.e36
    do i=1,nv
      if (we(i,kw).ne.0.0) then
        wmin = min(we(i,kw),wmin)
        wmax = max(we(i,kw),wmax)
      endif
    enddo
    wm(kw) = wm(1)*sqrt(wmin*wmax)
    !
    do i=1,nv
      staper = wt(i)
      ww = we(i,kw)
      if (ww.gt.wm(kw)) then
        st = staper/ww*wm(kw)
        we(i,kw) = visi(iw,i)*st ! On peut optimiser en utilisant sww(i)
        ss(kw) = ss(kw) + we(i,kw)
        s2(kw) = s2(kw) + we(i,kw)*st
      elseif (we(i,kw).gt.0.0) then
        we(i,kw) = visi(iw,i)*staper
        ss(kw) = ss(kw) + we(i,kw)
        s2(kw) = s2(kw) + we(i,kw)*staper
      else
        we(i,kw) = 0.0
      endif
    enddo
    !
    ! Re-normalize weight to compute noise
    st = ss(kw)/s2(kw)
    do i=1,nv
      we(i,kw) = st * we(i,kw)
    enddo
  enddo
end subroutine do4weig
!
subroutine sidelo (map,nx,ny,thre,majo,mino,pa,convert)
  !------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Compute sidelobes
  !------------------------------------------------------------
  integer, intent(in) :: nx,ny        ! X,Y sizes
  real, intent(in) :: map(nx,ny)      ! Beam map
  real, intent(in) :: majo            ! Major axis
  real, intent(in) :: mino            ! Minor axis
  real, intent(in) :: pa              ! PA
  real, intent(out) :: thre(2)        ! Pos and Neg sidelobe
  real(8), intent(in) :: convert(3,2) ! Conversion formula
  !
  real(8), parameter :: pi=3.14159265358979323846d0
  real pang,oang,ca,sa,ma,mi,xs,ys,d,g,sln2
  integer i,j
  !
  sln2 = 2.0*sqrt(log(2.0))
  pang = pa-90.0
  oang = pi*pang/180.0
  ca = cos(oang)
  sa = sin(oang)
  ma = majo/convert(3,1)/sln2
  mi = mino/convert(3,2)/sln2
  !
  thre(1) = 0.0
  thre(2) = 0.0
  !
  do j=ny/4+1,3*ny/4
    ys = j-convert(1,2)
    do i=nx/4+1,3*nx/4
      xs = i-convert(1,1)
      g = ((ca*xs + sa*ys)/ma)**2 + ((-sa*xs+ca*ys)/mi)**2
      d = map(i,j)
      thre(1) = min(thre(1),d)
      if (g.le.40.) then
        d = map(i,j)-exp(-g)
      endif
      thre(2) = max(thre(2),d)
    enddo
  enddo
end subroutine sidelo
!
subroutine do0weig (jc,nv,visi,jx,jy,jw,unif,we,vv,   &
     &    lv,umin,umax,vmin,vmax,nbcv)
  use gkernel_interfaces
  use gildas_def
  use gbl_message
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for UV_STAT
  !   Compute weights of the visibility points.
  !----------------------------------------------------------------------
  integer, intent(in) :: nv  ! Size of a visibility
  integer, intent(in) :: jc  ! Number of visibilities
  integer, intent(in) :: jx  ! X coordinate pointer
  integer, intent(in) :: jy  ! Y coordinate pointer
  integer, intent(in) :: jw  ! Weight pointer
  real, intent(in) :: visi(jc,nv)  ! Visibilities
  real, intent(in) :: unif         ! Cell size in meters
  real, intent(out) :: we(nv)      ! Weight arrays
  real, intent(in) :: vv(nv)       ! V values
  !
  integer, intent(in) :: lv        ! Unused
  real, intent(in) ::  umin,umax,vmin,vmax
  integer, intent(in) :: nbcv       ! Unused here
  !
  real, allocatable :: suu(:), svv(:), sww(:), swe(:)
  real :: sizecell
  integer :: ier, mv, nbv, i, ivmin, icode
  character(len=*), parameter :: rname='DO0WEIG'
  !
  logical :: error
  !
  ! Find the location of -unif
  ivmin = 1
  call findp (nv,vv,-unif,ivmin)
  !
  mv = 2*nv-ivmin+1
  allocate(suu(mv),svv(mv),sww(mv),swe(mv),stat=ier)
  !
  suu(1:nv) = visi(jx,:)
  svv(1:nv) = visi(jy,:)
  sww(1:nv) = visi(jw,:)
  !
  ! Apply symmetry
  nbv = nv
  do i=ivmin,nv
    nbv = nbv+1
    suu(nbv) = -visi(jx,i)
    svv(nbv) = -visi(jy,i)
    sww(nbv) = visi(jw,i)
  enddo
  !
  call dowei_icode(umax,umin,vmax,vmin,unif,mv,icode)
  sizecell = unif/icode
  call gridless_density(mv,sizecell,unif,suu,svv,sww,swe, &
    umin,umax,vmin,unif,error)
  if (error) return
  !
  we(:) = swe(1:nv)
end subroutine do0weig
!
subroutine do2fft (np,nv,visi,jx,jy   &
     &    ,nx,ny,nw,map,mapx,mapy,we) 
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for UV_STAT
  !   Compute FFT of image by gridding UV data for several weights
  !   at once. Uses simple in-cell gridding
  !
  ! Input UV data must be sorted by increasing V < 0
  !----------------------------------------------------------------------
  ! Call
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  integer, intent(in) :: nw                   ! number of weight schemes
  integer, intent(in) :: nx,ny                ! map size
  integer, intent(in) :: jx,jy                ! X coord, Y coord location in VISI
  real, intent(in) :: visi(np,nv)             ! values
  complex, intent(out) :: map(nw,nx,ny)       ! gridded visibilities
  real, intent(in) :: mapx(nx),mapy(ny)       ! Coordinates of grid
  real, intent(in) :: we(nv,nw)               ! Weight array
  !
  ! Local
  integer :: ix,iy,iw,i,my,ky,kx
  real :: u,v
  real(8) :: xinc,xref,yinc,yref
  !
  ! Initialize
  map = 0.0
  xinc = mapx(2)-mapx(1)
  xref = nx/2+1
  yinc = mapy(2)-mapy(1)
  yref = ny/2+1
  my = ny/2+1
  !
  ! the UV data is such that all V are negative...
  !
  ! Start with loop on observed visibilities
  do i=1,nv
    u = visi(jx,i)
    v = visi(jy,i)
    !
    ! Define map cell
    ix = nint(u/xinc+xref)
    iy = nint(v/yinc+yref)
    do iw=1,nw
      map (iw,ix,iy) = map (iw,ix,iy) + we(i,iw)
    enddo
    !
    ix = nint(-u/xinc+xref)
    iy = nint(-v/yinc+yref)
    if (iy.eq.my) then
      do iw=1,nw
        map (iw,ix,iy) = map (iw,ix,iy) + we(i,iw)
      enddo
    endif
  enddo
  !
  ! Apply symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      do iw=1,nw
        map(iw,ix,iy) = map(iw,kx,ky)
      enddo
    enddo
  enddo
end subroutine do2fft
!
subroutine prnoise(prog,which,noise,rms)
  use gbl_message
  use imager_interfaces, only : map_message
  !--------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Printout the noise value
  !--------------------------------------------------
  character(len=*), intent(in) :: prog  ! Caller name
  character(len=*), intent(in) :: which ! Type of image
  real, intent(in) :: noise             ! Noise value
  real, intent(out) :: rms              ! Unit of noise
  !
  character(len=message_length) string
  character(len=16) unit
  !
  ! It comes in Jy/beam
  if (noise.gt.0.05) then
    rms = 1
    unit = ' Jy/beam'
  elseif (noise.gt.0.1e-3) then
    rms = 1e3
    unit = ' mJy/beam'
  else
    rms = 1e6
    unit = ' microJy/beam'
  endif
  write(string,'(a,a,f9.3,a)')  which,' rms noise is ', rms*noise, unit
  call map_message(seve%i,prog,string)
end subroutine prnoise
!
subroutine doqfft (np,nv,visi,jx,jy,jw   &
     &    ,nx,ny,map,weight,uvcell)
  !----------------------------------------------------------------------
  ! @ private
  !
  ! MAPPING
  !   Support for UV_STAT    (Quick Gridding)
  !   Compute FFT of beam by gridding UV data for Natural
  !   weighting only. Uses simple in-cell gridding for speed
  !----------------------------------------------------------------------
  ! Call
  integer, intent(in) :: nv                   ! number of values
  integer, intent(in) :: np                   ! Number of "visibilities", normally 7+3*nc
  integer, intent(in) :: nx,ny                ! map size
  integer, intent(in) :: jx,jy,jw             ! X coord, Y coord & Weight location in VISI
  real, intent(in) :: visi(np,nv)             ! values
  complex, intent(out) :: map(nx,ny)          ! gridded visibilities
  real, intent(in) :: weight(nv)              ! Weights
  real, intent(in) :: uvcell                  ! UV cell size 
  !
  ! Local
  integer :: ix,iy,iv,my,ky,kx
  real :: u,v
  real(8) :: xinc,xref,yinc,yref
  !
  ! Initialize
  map = 0.0
  xinc = -uvcell 
  xref = nx/2+1
  yinc =  uvcell 
  yref = ny/2+1
  my = ny/2+1
  !
  ! Start with loop on observed visibilities
  do iv=1,nv
    u = visi(jx,iv)
    v = visi(jy,iv)
    ! Make sure V is < 0
    if (v.gt.0) then
      u = -u
      v = -v
    endif
    !
    ! Define map cell
    ix = nint(u/xinc+xref)
    iy = nint(v/yinc+yref)
    map (ix,iy) = map (ix,iy) + weight(iv) 
    !
    iy = nint(-v/yinc+yref)
    if (iy.eq.my) then
      ix = nint(-u/xinc+xref)
      map (ix,iy) = map (ix,iy) + weight(iv) 
    endif
  enddo
  !
  ! Apply symmetry
  do iy=my+1,ny
    ky = ny+2-iy
    do ix=2,nx
      kx = nx+2-ix
      map(ix,iy) = map(kx,ky)
    enddo
  enddo
end subroutine doqfft

function err_vector (dummy)
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  logical :: err_vector             !
  logical :: dummy                  !
  err_vector = .false.
end function err_vector
!
subroutine load_vector
  use sic_dependencies_interfaces
  use sic_interactions
  use sic_interfaces, except_this=>load_vector
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  ! Local
  character(len=*), parameter :: rname='VECTOR'
  integer(kind=4) :: ier
  integer(kind=4), parameter :: mcom=21
  character(len=12) :: vocab(mcom)
  character(len=32) :: name
  logical :: error
  ! Data
  data vocab /                                                               &
    ' FITS',   '/BITS','/STYLE','/HDU','/CHECK','/BLC','/TRC','/OVERWRITE',  &
    ' HEADER', '/EXTREMA','/TELESCOPE',                                      &
    '$RUN',    '/EDIT','/WINDOW','/NOWINDOW',                                &
    '$SUBMIT', '/EDIT','/WINDOW','/NOWINDOW',                                &
    ' SPY',                                                                  &
    ' TRANSPOSE' /
  !
  ! Set Up Language and Prompt
  call sic_begin ('VECTOR','GAG_HELP_VECTOR',mcom,vocab,'4.0    20-Jul-2011',  &
  run_vector,err_vector)
  !
  ! Define TASK executor
  task_node = 'LOCAL'  ! Default
  ier = sic_getlog('GILDAS_NODE',task_node)
  !
  error = .false.
  call sic_def_char('GILDAS_NODE',task_node,.false.,error)
  if (error) call sic_message(seve%e,rname,'Error defining GILDAS_NODE')
  !
  ! Window mode
  call sic_get_logi('SIC%WINDOW',run_window,error)
  call sic_def_logi('RUN_WINDOW',run_window,.false.,error)
  tee = .false.  ! WARNING: if 'tee' is .true., any runtime error when
                 ! the task is executed. is not trapped (because of the
                 ! pipe construct)
  call sic_def_logi('SIC%TEE',tee,.false.,error)
  ier = sic_getlog('GILDAS_PIPE_ERROR',name)
  if (ier.eq.0) then
    piperr = 1
  else
    piperr = 0
  endif
  !
  ! Load the tasks
  call load_task
  !
end subroutine load_vector
!
subroutine run_vector (line,comm,error)
  use sic_interfaces, except_this=>run_vector
  use gbl_message
  !---------------------------------------------------------------------
  ! @ public-mandatory (but should be private in the context of new
  ! language initialization) (mandatory because symbol is used elsewhere)
  !---------------------------------------------------------------------
  character(len=*) :: line          !
  character(len=*) :: comm          !
  logical :: error                  !
  !
  call sic_message(seve%c,'VECTOR',line)
  !
  error = .false.
  select case (comm)
  case('TRANSPOSE')
    call sic_transpose (line,error)
  case('HEADER')
    call vector_header(line,error)
  case('FITS')
    call fits_gildas(line,error)
  !
  ! Task related commands
  case('RUN')
    call parameter(comm,line,error)
  case('SUBMIT')
    call parameter(comm,line,error)
  case('SPY')
    call spy (line,error)
  case default
    call sic_message(seve%e,'VECTOR','Unsupported command '//comm)
    error = .true.
  end select
end subroutine run_vector
!
subroutine detach(area,name,file,nowait,error)
  use gildas_def
  use gbl_message
  use gsys_types
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>detach
  use sic_interactions
  !---------------------------------------------------------------------
  ! @ private
  !  GILDAS Support routine for command
  !     RUN
  !  Creates a detached job to run the command
  !---------------------------------------------------------------------
  character(len=*), intent(in)  :: area    !
  character(len=*), intent(in)  :: name    ! Program name
  character(len=*), intent(in)  :: file    ! Parameter file name
  logical,          intent(in)  :: nowait  !
  logical,          intent(out) :: error   ! Logical error flag
  ! Local
  character(len=*), parameter :: rname='DETACH'
  character(len=filename_length) :: input,output,tempo
  integer :: ni,no,ier,jer
  logical :: exist
  character(len=message_length) :: mess
  type(cputime_t) :: time
  !
  ! Remove old .gildas file if necessary
  tempo = name
  call sic_parsef(tempo,output,'GAG_LOG:','.gildas')
  no = len_trim(output)
  inquire(file=output,exist=exist)
  if (exist) then
    tempo = trim(output)//'~'
    ier = gag_filrename(output,tempo)
  endif
  !
  ! Check that output file can be created
  ier = sic_open(tlun,output,'NEW',.false.)
  if (ier.ne.0) then
    call putios('E-DETACH,  ',ier)
    call sic_message(seve%e,rname,'Error opening '//output)
    error = .true.
    return
  endif
  close(tlun)
  !
  ! Prepare command line
  !    AREA:taskname.exe < 'input'  >output 2>&1
  ! OR
  !    AREA:taskname.exe < 'input' 2>&1 | tee output
  !
  tempo = name
  !    CALL SIC_PARSEF(TEMPO,INPUT,AREA,TASKEXT)
  exist = sic_findfile(tempo,input,area,taskext)
  ! The following line doesn't work with GAG_SYSTEM
  !      INPUT = '"'//trim(INPUT)//'"'
  input = trim(input)//' < "'//trim(file)//'"'
  ni = len_trim(input)
  !
  ! The following code is to obtain a copy on the screen through a "tee"
  ! pipe
  if (tee) then
    if (piperr.eq.0) then
      input(ni+1:) = ' 2>&1'
      ni = ni+5
    endif
    input(ni+1:) = ' | tee '
    ni = ni+7
    input(ni+1:) = '"'//trim(output)//'"'
    ni = ni+no+2
    !
    ! Simple log file, but no copy on screen
  else
    input(ni+1:) = ' > '
    ni = ni+3
    input(ni+1:) = '"'//trim(output)//'"'
    ni = ni+no+2
    if (piperr.eq.0) then
      input(ni+1:) = ' 2>&1'
      ni = ni+5
    endif
  endif
  !
  if (nowait) then
    input(ni+1:) = '&'
    ni = ni+1
  endif
  !
  call sic_message(seve%i,'RUN','Task '//trim(name)//' running, logfile is')
  call sic_message(seve%i,'RUN',output)
  tempo = input(1:ni)
  !
  call gag_cputime_init(time)
  call sic_message(seve%d,'RUN','Running command: '//tempo)
  ier = gag_system(tempo)
  ! Display messages (hereafter) in any case (error or not) and then exit
  !
  if ((.not.tee).and.(.not.nowait)) then
#if defined(WIN32)
    tempo = 'type "'//trim(output)//'"'
#else
    tempo = 'cat "'//trim(output)//'"'
#endif
    write (*,'(1X)')
    jer = gag_system(tempo)
    if (jer.ne.0) then
      call sic_message(seve%e,rname,'Error showing '//output)
      error = .true.
    endif
    write (*,'(1X)')
  endif
  call gag_cputime_get(time)
  write(mess,'(3(A,F0.1))') 'Elapsed ',time%diff%elapsed,  &
                            ', User ',time%diff%user,      &
                            ', System ',time%diff%system
  call sic_message(seve%i,'RUN',mess)
  !
  last_task = name
  if (ier.ne.0) then
    write (mess,102) 'Task ',trim(name),' crashed with status ',ier
    call sic_message(seve%i,'RUN',mess)
    error = .true.
  else
    if (nowait) then
      call sic_wait(3.0)
      call sic_message(seve%i,'RUN','Task '//trim(name)//' activated ...')
    else
      call sic_message(seve%i,'RUN','Task '//trim(name)//' completed '//  &
      'successfully')
    endif
    error = .false.
  endif
  !
102 format(a,a,a,i0)
end subroutine detach
!
subroutine spy (line,error)
  use gildas_def
  use gbl_message
  use sic_dependencies_interfaces
  use sic_interactions
  use sic_interfaces, except_this=>spy
  !---------------------------------------------------------------------
  ! @ private
  !	Support routine for command SPY
  !	List all active Tasks of current session.
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  logical,          intent(inout) :: error  !
  ! Local
  integer :: i,ier
  character(len=filename_length) :: name,file,para
  !
  if (sic_present(0,1)) then
    call sic_ch (line,0,1,name,i,.true.,error)
    if (error) return
  else
    name = last_task
  endif
  !
  call sic_parsef (name,para,'GAG_SCRATCH:','.par')
  call sic_parsef (name,file,'GAG_LOG:','.gildas')
#if defined(WIN32)
  name = 'type '//trim(file)//'|more'
#else
  name = 'more '//trim(para)//' '//file
#endif
  ier = gag_system(name)
  if (ier.ne.0) then
    call sic_message(seve%e,'SPY','Error spying file '//file)
    error = .true.
    return
  endif
end subroutine spy
!
! Remote.f ---
subroutine remote (name,lun,file,error,inter,node)
  use sic_interfaces, except_this=>remote
  use sic_interactions
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GILDAS	Internal routine
  !	Submit a program to run in batch queue GILDAS_BATCH
  ! Arguments:
  !	NAME	C*(*)	Program Name
  !	LUN	I	Logical unit where file is opened
  !       FILE    C*(*)   Input file name
  !	ERROR	L	Logical error flag
  !       INTER   L       RUN or SUBMIT command ?
  !       NODE    C*(*)   Remote Node
  !---------------------------------------------------------------------
  character(len=*) :: name          !
  integer :: lun                    !
  character(len=*) :: file          !
  logical :: error                  !
  logical :: inter                  !
  character(len=*) :: node          !
  ! Local
  character(len=255) :: input,output,chain
  character(len=128) :: pwd
  character(len=10) :: word
  integer :: lpa
  integer :: nl,ni,no,nf,ier
  character(len=message_length) :: mess
  !
  close (unit=lun)
  !
  ! Remote Node Name
  call sic_lower(node)
  !
  ! Log File: should it go in current directory ?
  nl = len_trim(name)
  call local_to_remote('gag_log:',output,node)
  no = len_trim(output)
  output(no+1:) = trim(name)//'.gildas'
  no = len_trim(output)
  !
  ! Prepare command line
  !	GILDAS_RUN:taskname.exe < input  > output 2>&1
  !
  ! Command line should actually depend on remote system type. The above syntax
  ! is for instance invalid if the remote system is a SUN.
  call local_to_remote('GILDAS_RUN:',input,node)
  ni = len_trim(input)
  input(ni+1:) = name
  ni  = ni+nl
  nf = len_trim(file)
  input(ni+1:) = '.exe < '''//trim(file)//''' >'
  ni = ni+nf+11
  input(ni+1:ni+no) = output(1:no)
  ni = ni+no
  !
  if (piperr.eq.0) then
    input(ni+1:) = ' 2>&1'
    ni = ni+5
  endif
  !
  ier = sic_open (lun,'task_submit.tmp','NEW',.false.)
  if (ier.ne.0) then
    call sic_message(seve%i,'SUBMIT','Open error file "task_submit.tmp"')
    call putios('I-SUBMIT, ',ier)
    error = .true.
    return
  endif
  !
  ! Add equivalent working directory in remote tasks
  pwd = ' '
  lpa = 0
  call sic_setdir(pwd,lpa,error)
  !
  write (lun,'(A)') 'cd '//pwd(1:lpa)
  write (lun,'(A)') input(1:ni)
  write (lun,'(A,A)') 'rm ',trim(file)
  write (lun,'(A)') 'rm task_submit.tmp'
  close (unit=lun)
  !
  ! OK, send the remote command
  if (inter) then
    chain = 'ssh '//trim(node)//' < task_submit.tmp'
    word  = 'executed,'
  else
    chain = 'ssh '//trim(node)//'  "batch < task_submit.tmp'
    word  = 'submitted,'
  endif
  ier = gag_system (chain)
  error = ier.ne.0
  !
  if (error) then
    write (mess,102) 'Task ',trim(name),' not '//word//' status ',ier
    call sic_message(seve%e,'REMOTE',mess)
  else
    call sic_message(seve%i,'REMOTE','Task '//trim(name)//' remotely '//  &
    word//' logfile is')
    call sic_message(seve%i,'REMOTE',output(1:no))
  endif
  !
102 format(a,a,a,i13)
end subroutine remote
!
subroutine local_to_remote (name,file,node)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>local_to_remote
  !---------------------------------------------------------------------
  ! @ private
  !  VECTOR
  !     Find the equivalent remote path of a local path
  ! Arguments:
  ! 	NAME	C*(*)	File name			Input
  !	FILE	C*(*)	Fully extended file name	Output
  !	NODE    C*(*)	Remote NODE                     Input
  !---------------------------------------------------------------------
  character(len=*) :: name          !
  character(len=*) :: file          !
  character(len=*) :: node          !
  call sic_parse_file(name,'','',file)
end subroutine local_to_remote
!
! Submit.f ---
subroutine submit(area,name,lun,file,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>submit
  use sic_interactions
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GILDAS	Internal routine
  !	Submit a program to run in batch queue GILDAS_BATCH
  ! Arguments:
  !	NAME	C*(*)	Program Name
  !	LUN	I	Logical unit where file is opened
  !	ERROR	L	Logical error flag
  !---------------------------------------------------------------------
  character(len=*) :: area          !
  character(len=*) :: name          !
  integer :: lun                    !
  character(len=*) :: file          !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='SUBMIT'
  character(len=256) :: input,output,tempo,fich
  character(len=24) :: nom,time
  character(len=256) :: chain
  integer :: ni,no,ier,nff
  character(len=message_length) :: mess
  !
  close (unit=lun)
  tempo = name
  call sic_parsef(tempo,output,'GAG_LOG:','.gildas')
  no = len_trim(output)
  !
  ! Prepare command line
  !	AREA:taskname.exe < input  >output 2>&1
  !
  ! Get unambigous file name based on time
  call sic_date(fich)
  time = fich(13:14)//fich(16:17)//fich(19:20)//fich(22:23)
  nom = 'par-'//time
  call sic_parsef(nom,fich,'GAG_TMP:','.par')
  nff = len_trim(fich)
  ! Copy parameter file
  tempo = 'cp '//trim(file)//' '//fich
  ier = gag_system(tempo)
  call sic_wait(1.0)
  !
  tempo = name
  call sic_parsef(tempo,input,area,taskext)
  ni = len_trim(input)
  input(ni+1:) = ' < '''//trim(fich)//''' >'
  ni = ni+nff+7
  input(ni+1:ni+no) = output(1:no)
  ni = ni+no
  input(ni+1:) = ' 2>&1'
  ni = ni+5
  !
  nom = 'par-'//time
  call sic_parsef(nom,fich,'GAG_TMP:','.submit')
  open (unit=lun,file=fich,status='UNKNOWN',iostat=ier)
  if (ier.ne.0) then
    call sic_message(seve%i,rname,'Open error file "task.submit"')
    call putios('I-SUBMIT,  ',ier)
    error = .true.
    call sic_frelun(lun)
    return
  endif
  !
  write (lun,'(A)') input(1:ni)
  close (unit=lun)
  !
  chain = 'batch < '//fich
  ier = gag_system (chain)
  if (ier.ne.0) then
    write (mess,102) 'Task ',trim(name),' not submitted, status ',ier
    call sic_message(seve%i,rname,mess)
    error = .true.
  else
    call sic_message(seve%i,rname,'Task '//trim(name)//' submitted, '//  &
    'logfile is')
    call sic_message(seve%i,rname,output(1:no))
    error = .false.
  endif
102 format(a,a,a,i13)
end subroutine submit
!
! Parameter.f
subroutine parameter(comm,line,error)
  use sic_dependencies_interfaces
  use sic_interactions
  use sic_interfaces, except_this=>parameter
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  ! GILDAS	Support routine for commands
  !	RUN 	Program [Parameter_File] [/EDIT] [/NOWINDOW] [/WINDOW]
  !	SUBMIT	Program [Parameter_File] [/EDIT] [/NOWINDOW] [/WINDOW]
  ! Arguments
  !	COMM	C*(*)	Command (RUN or SUBMIT)
  !	LINE	C*(*)	Command line
  !	ERROR	L	Logical error flag
  !---------------------------------------------------------------------
  character(len=*) :: comm          !
  character(len=*) :: line          !
  logical :: error                  !
  ! Local
  character(len=1), parameter :: backslash=char(92)
  integer :: nc,lun,iopt,ntas,nini,narea,lno,nf
  character(len=128) :: taskname
  character(len=filename_length) :: program,initfile,checkfile,helpfile
  character(len=20) :: area,node,help
  character(len=256) :: chain,command,sline
  integer :: lire,status
  logical :: edit,exist,run,remo,xwnd,nowait,ok
  !
  sline = line
  error = .false.
  !
  ! Get GILDAS Node Name
  call sic_get_char('GILDAS_NODE',node,lno,error)
  remo = node(1:lno) .ne. 'LOCAL'
  !
  ! Get procedure name and verify that it exists
  edit = sic_present(1,0)
  xwnd = sic_present(2,0)
  if (sic_present(3,0)) then
    if (xwnd) then
      call sic_message(seve%e,'RUN','Conflicting options')
      error = .true.
      return
    endif
    x_window = .false.
  else
    x_window = run_window .or. xwnd
  endif
  !
  ! Slightly tricky code to support RUN /EDIT /WINDOW and RUN /WINDOW /EDIT
  ! and "RUN /EDIT toto tutu /WINDOW" and "RUN /WINDOW toto tutu /EDIT",
  ! etc...
  iopt = sic_narg(0)
  if (iopt.eq.0) then
    if (edit.and.xwnd) then
      if (sic_narg(1).eq.1) then
        iopt = 1
      elseif (sic_narg(2).eq.1) then
        iopt = 2
      endif
    elseif (edit) then
      iopt = 1
    elseif (xwnd) then
      iopt = 2
    endif
  else
    iopt = 0
  endif
  !
  call sic_ch (line,iopt,1,taskname,nc,.true.,error)
  if (error) return
  call sic_parsef(taskname,program,'GILDAS_LOCAL:',taskext)
  ntas = len_trim(taskname)
  inquire (file=program,exist=exist)
  if (.not.exist) then
    exist = sic_findfile(taskname,program,'TASK#DIR:',taskext)
    if (.not.exist) then
      call sic_message(seve%e,comm,'Program '//trim(taskname)//' does not '//  &
      'exist')
      call sic_parse_file('gag_help_run_deleted',' ','.hlp',helpfile)
      ok = sichelp(puthelp,taskname,'',helpfile,.true.,.true.)
      error = .true.
      return
    endif
    area = 'TASK#DIR:'
    help = area
  else
    area = 'GILDAS_LOCAL:'
    help = 'GILDAS_LOCAL:'
  endif
  status = parse_file(program,-1)
  narea = len_trim(area)
  !
  ! No /EDIT option :
  if (.not.edit) then
    if (sic_present(iopt,2)) then
      call sic_ch (line,iopt,2,checkfile,nc,.false.,error)
      if (error) return
      if (checkfile.eq.'*') checkfile = trim(taskname)//'.init'
      call sic_parsef(checkfile,initfile,' ','.init')
    else
      exist = sic_findfile(taskname,initfile,area,'.init')
    endif
    !
    ! Check if parameter file already exist
    nini = len_trim(initfile)
    inquire (file=initfile,exist=exist)
    if (.not.exist) then
      call sic_message(seve%e,comm,'Parameter file does not exist')
      error = .true.
      return
    endif
    !
    ! /EDIT option : take parameter file in current directory if it exits,
    ! else take default parameter file
    !
  else
    call edtask (line,comm,iopt,taskname,ntas,initfile,nini,area,narea,error)
    if (error) return
  endif
  !
  ! Checker file
  error = .not.sic_findfile(taskname,checkfile,area,'.check')
  if (error) then
    call sic_parsef(taskname,checkfile,'gag_scratch:','.check')
    error = .false.
  endif
  call sic_ch(line,iopt,3,checkfile,nc,.false.,error)
  if (error) return
  !
  ! Window mode
  if (x_window) then
    call copy_parfile (line,comm,iopt,taskname,ntas,initfile,nini,area,narea,  &
    error)
    if (error) return
    error = .not.sic_findfile(taskname,helpfile,help,'.hlp')
    if (error) then
      call sic_message(seve%e,comm,trim(taskname)//'.hlp file not found')
      return
    endif
    !
    ! Transmit Help File name for further use
    help_text_file = trim(helpfile)//char(0)
    !
    chain = 'GUI'//backslash//'PANEL '//trim(taskname)//' "'//trim(helpfile)//  &
    '" /LOG task'
    nf = len_trim(chain)
    call sic_blanc(chain,nf)
    call sic_analyse(command,chain,nf,error)
    call xgag_input(chain,error)
  endif
  !
  ! Prepare data file
  call prepare(comm,taskname,program,initfile,checkfile,lun,remo,error)
  if (error) then
    close(unit=lun,status='DELETE')
    return
  endif
  !
  ! Submit (or run) the job
  if (.not.remo) then
    if (comm.eq.'SUBMIT') then
      call submit(area,taskname,lun,initfile,error)
    elseif (comm.eq.'RUN') then
      close (unit=lun)
      ! If GO has an argument, assume we should not wait...
      nowait = sic_present(0,1)  ! Invalid: command line pointers have been
                                 ! overwritten when parsing the init file!
      call detach(area,taskname,initfile,nowait,error)
    endif
  else
    run = comm.eq.'RUN'
    call remote(taskname,lun,initfile,error,run,node)
  endif
  lire = sic_lire()
  if (lire.eq.0) call sic_insert(sline)
end subroutine parameter
!
! edtask.f
subroutine edtask (line,comm,iopt,task,ntas,init,nini,area,narea,error)
  use sic_interfaces, except_this=>edtask
  use gbl_message
  !---------------------------------------------------------------------
  ! @ private
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  character(len=*)                :: comm   !
  integer                         :: iopt   !
  character(len=*)                :: task   !
  integer                         :: ntas   !
  character(len=*)                :: init   !
  integer                         :: nini   !
  character(len=*)                :: area   !
  integer                         :: narea  !
  logical,          intent(inout) :: error  !
  ! Local
  integer :: nc
  !
  character(len=132) :: fich
  !
  ! Prepare parameter file
  call copy_parfile (line,comm,iopt,task,ntas,init,nini,area,narea,error)
  !
  ! Edit the file
  call editor(init(1:nini),error)
  if (error) return
  !
  fich = ' '
  call sic_wprn('I-EDIT,  Press <CR> to run task, Q to QUIT ',fich,nc)
  if (len_trim(fich).ne.0) then
    call sic_message(seve%e,comm,'Aborted by QUIT command')
    error = .true.
  endif
end subroutine edtask
!
subroutine copy_parfile (line,comm,iopt,task,ntas,init,nini,area,narea,error)
  use sic_dependencies_interfaces
  use sic_interfaces, except_this=>copy_parfile
  !---------------------------------------------------------------------
  ! @ private
  ! Copy Parameter File
  !---------------------------------------------------------------------
  character(len=*)                :: line   !
  character(len=*)                :: comm   !
  integer                         :: iopt   !
  character(len=*)                :: task   !
  integer                         :: ntas   !
  character(len=*)                :: init   !
  integer                         :: nini   !
  character(len=*)                :: area   !
  integer                         :: narea  !
  logical,          intent(inout) :: error  !
  ! Local
  logical :: exist
  character(len=256) :: comlin,comlin2
  character(len=132) :: fich
  integer(kind=4) :: ier
  !
  if (sic_present(iopt,2)) then
    call sic_ch (line,iopt,2,fich,nini,.false.,error)
    if (error) return
    if (fich.eq.'*') fich = task(1:ntas)
    call sic_parsef(fich,init,' ','.init')
    nini = len_trim(init)
  else
    fich = task(1:ntas)
    call sic_parsef(fich,init,' ','.init')
    nini = len_trim(init)
    inquire (file=init,exist=exist)
    if (.not.exist) then
      fich = task(1:ntas)
      exist = sic_findfile(fich,comlin,area,'.init')
      comlin2= init(1:nini)
      ier = gag_filcopy(comlin,comlin2)
    endif
  endif
end subroutine copy_parfile
!
! Prepare.f
subroutine prepare(comm,task,exec,file,check_file,lun,rem,error)
  use sic_interfaces, except_this=>prepare
  use gildas_def
  use sic_interactions
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! GILDAS	Internal routine
  !	Execute the two procedures necessary to setup
  !	task parameters before running or submitting the task
  !
  ! Arguments :
  !	TASK		Task name
  !	EXEC		Program to be executed
  !	FILE		User edited procedure (input)
  !			    command file to execute (output)
  !	CHECK_FILE	Checking procedure
  !	LUN		  Logical unit number where procedure is editted
  !       REM     Remote Flag
  !     ERROR		Logical error flag
  !---------------------------------------------------------------------
  character(len=*) :: comm          !
  character(len=*) :: task          !
  character(len=*) :: exec          !
  character(len=*) :: file          !
  character(len=*) :: check_file    !
  integer :: lun                    !
  logical :: rem                    !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='TASK'
  integer :: nt,ier,i,status
  character(len=filename_length) :: fich,proced
  logical :: found
  !
  tprog = task
  nt = len_trim(task)
  !
  ! Open parameter / command file
  if (rem) then
    task(nt+1:)='_PAR'
    nt=nt+4
    call sic_parsef (task,fich,' ','.tmp')
    nt = nt-4
    task(nt+1:) = ' '
  else
    call sic_parsef (task,fich,'GAG_SCRATCH:','.par')
  endif
  ier = sic_open(tlun,fich,'NEW',.false.)
  if (ier.ne.0) then
    call putios('E-TASK, ',ier)
    call sic_message(seve%e,rname,'Error opening '//fich)
    error = .true.
    return
  endif
  !
  tabort = .true.
  nreal = 0
  ninte = 0
  nlogi = 0
  nchar = 0
  npar = 0
  !
  ! Make file name non-translatable.
  proced = '@ "!'//trim(file)//'"'
  !
  ! Duplicate init file if X_Window mode.
  if (x_window) then
    call sic_if (.true.)
    call exec_task(proced)
    call xgag_finish
    call sic_if (.false.)
    x_window = .false.
    call task_out(file,task,error)
  else
    call exec_task(proced)
    if (tabort) call sic_message(seve%e,rname,'Missing GO command in INIT file')
  endif
  !
  ! Now execute the file
  if (tabort) then
    continue
    !         CALL GAGOUT('E-TASK,  Missing GO command in INIT file')
  else
    tabort = .true.
    file = fich
    status = parse_file(file,-1)
    !
    ! Create .check file if it does not exist
    inquire(file=check_file,exist=found)
    if (.not.found) then
      call write_check (check_file,error)
      if (error) return
    endif
    ! Make file name non-translatable.
    proced = '@ "!'//trim(check_file)//'"'
    call exec_task(proced)
    !
    ! Remove .check file if it was created here
    if (.not.found) then
      call gag_filrm(check_file)
    endif
  endif
  do i=1,npar
    call sic_delvariable(tname(i),.false.,error)
  enddo
  lun = tlun
  error = tabort
end subroutine prepare
!
function parse_file(chain,stat)
  use sic_dependencies_interfaces
  use gildas_def
  !---------------------------------------------------------------------
  ! @ private
  ! VECTOR
  !	Support routine for commands FILE [/OLD] [/NEW]
  !	CHAIN	C*(*)	File name
  !	STAT	I	Status of file (0 Unknown, -1 Old, 1 New)
  !---------------------------------------------------------------------
  integer :: parse_file             !
  character(len=*) :: chain         !
  integer :: stat                   !
  ! Local
  character(len=filename_length) :: name,tempo
  integer :: i,lnode,ldisk,lname,ier
  !
  parse_file = 0
  !
  ! One logical name translation, just in case of logname
  call sic_parse_file(chain,'','',chain)
  !
  ! Check for node
  lnode = index(chain,'::')
  if (lnode.ne.0) return
  !
  ! Find "OLD" files
  parse_file = 1
  !
  ! Check for disk for "UNKNOWN" or "NEW" files
  ldisk = index(chain,':')
  if (ldisk.eq.0) return
  lname = ldisk-1
  name = chain(1:lname)
  tempo = chain(ldisk+1:)
  !
  ! Translate all possible logical names
  do i=1,10
    ier = sic_getlog(name)
    lname = len_trim(name)
    ldisk = index(name(1:lname),':')
    if (ldisk.ne.0) then
      if (name(ldisk:ldisk+1).eq.'::') ldisk = 0
    endif
    if (ldisk.ne.lname) then
      if (name(lname-1:lname).eq.'.]') then
        chain = name(ldisk+1:lname-1)//tempo(2:)
      elseif (name(lname:lname).eq.']') then
        chain = name(ldisk+1:lname)//tempo
      elseif (tempo(1:1).ne.':') then
        chain = name(ldisk+1:lname)//':'//tempo
      else
        chain = name(ldisk+1:lname)//tempo
      endif
      tempo=chain
    endif
    if (ldisk.eq.0) return
    name(ldisk:) = ' '
  enddo
end function parse_file
!
subroutine task_out(file,task,error)
  use sic_interfaces, except_this=>task_out
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! TASK
  !     Copy the .INIT file after X-Window input
  !---------------------------------------------------------------------
  character(len=*) :: file          !
  character(len=*) :: task          !
  logical :: error                  !
  ! Local
  character(len=1), parameter :: backslash=char(92)
  character(len=256) :: line
  character(len=filename_length) :: argu  ! Any kind of argument (numeric, file name,...)
  character(len=256) :: fich1,fich2
  character(len=5) :: tache
  integer :: ilin,iopt,idol,ibra,iquo,icom
  integer :: ilun,slun,dlun,nf,ier
  !
  integer :: icont
  !
  ier = sic_getlun(ilun)
  ier = sic_getlun(dlun)
  ier = sic_getlun(slun)
  !
  ! Scan .init file & .save file as input
  ! Open .last file as output
  tache = 'TASK'//backslash
  nf = len_trim(file)
  ier=sic_open (ilun,file,'OLD',.true.)
  ier=sic_open (slun,'task.save','OLD',.true.)
  call sic_parsef (task,fich2,' ','.last')
  ier=sic_open (dlun,fich2(1:nf),'UNKNOWN',.false.)
  do while (.true.)
    read(ilun,'(A)',end=10) line
    ilin = len_trim(line)
    icom = index(line,'!')
    icont = index(line(ilin:),'-')
    do while (icont.gt.0)
      line(ilin:ilin) = ' '
      read (ilun,'(A)',end=11) line(ilin+1:)
      ilin = len_trim(line)
      icont = index(line(ilin:),'-')
    enddo
11  continue
    if (index(line,tache).eq.0) then
      write(dlun,'(A)') line(1:ilin)
    elseif (icom.gt.0.and.index(line,tache).gt.icom) then
      write(dlun,'(A)') line(1:ilin)
    elseif (index(line,'MORE').ne.0) then
      write(dlun,'(A)') line(1:ilin)
    else
      read(slun,'(A)',iostat=ier) argu
      if (ier.ne.0) then
        write(dlun,'(A)') line(1:ilin)
      else
        idol = index(line,'$')
        if (line(idol+1:idol+1).eq.'[') then
          ibra = index(line(idol:),']')
          idol = idol+ibra
        endif
        !
        ! Check if an option precedes the argument.
        iquo = index(line(idol:),'"')
        !
        ! Quoted text
        if (iquo.ne.0) then
          iquo = iquo+idol
          iopt = index(line(iquo:),'"')
          iquo = iopt+iquo
          ! followed by options or not
          iopt = index(line(iquo:),'/')
          if (iopt.eq.0) then
            write(dlun,'(A,1X,A)') line(1:idol),trim(argu)
          else
            iopt = iopt+iquo-1
            write(dlun,'(A,1X,A,1X,A)') line(1:idol),trim(argu),line(iopt:ilin)
          endif
        else
          !
          ! No quoted text
          iopt = index(line(idol:),'/')
          if (iopt.eq.0) then
            write(dlun,'(A,1X,A)') line(1:idol),trim(argu)
          else
            iopt = iopt+idol-1
            write(dlun,'(A,1X,A,1X,A)') line(1:idol),trim(argu),line(iopt:ilin)
          endif
        endif
      endif
    endif
  enddo
  !
10 close(unit=ilun)
  close(unit=slun)
  close(unit=dlun)
  call sic_frelun(ilun)
  call sic_frelun(slun)
  call sic_frelun(dlun)
  !
  fich1 = fich2(1:nf)
  fich2 = file(1:nf)
  ier = gag_filrename(fich1,fich2)
  call gag_filrm('task.save')
end subroutine task_out
!
subroutine write_check(chkfil,error)
  use sic_interfaces, except_this=>write_check
  use sic_interactions
  use gbl_message
  use sic_dependencies_interfaces
  !---------------------------------------------------------------------
  ! @ private
  ! Automatically creat the .check file if it is not already
  ! existing.
  !---------------------------------------------------------------------
  character(len=*) :: chkfil        !
  logical :: error                  !
  ! Local
  character(len=*), parameter :: rname='TASK'
  integer :: i,ier,ilun
  !
  ier = sic_getlun(ilun)
  if (ier.ne.1) then
    error = .true.
    return
  endif
  ier = sic_open(ilun,chkfil,'NEW',.false.)
  if (ier.ne.0) then
    call sic_message(seve%e,rname,'Cannot create .check file')
    call putios('E-TASK, ',ier)
    error = .true.
    return
  endif
  !
  do i=1,npar
    write(ilun,100) tname(i)
  enddo
  write(ilun,101)
  close (unit=ilun)
  call sic_frelun(ilun)
  !
  call sic_message(seve%i,rname,'Created .check File '//chkfil)
  !
100 format ('TASK\WRITE ',a)
101 format ('TASK\GO')
end subroutine write_check

! (Copyright IRAM, the GILDAS team)
!
! Author: Stephane Guilloteau, Laboratoire d'Astrophysique de Bordeaux
!   June 2015
!
! Task to "refine" the imaging process.
!   The zeroth order in imaging is to compute a single gridding
! and beam for all channels, at the center frequency: this is
! the standard way of making imaging. Strictly speaking, it produces
! an angular scale inversely proportional to frequency.
!   The infinite order is to compute one beam per channel, but it
! is a costly process.
!
!   This task is here for the first order correction, of the angular
! scale varying with frequency, just making a linear interpolation
! between images computed with two different gridding because of
! the angular scale.
!   This task interpolates
! the dirty images for each channel based on dirty images computed
! for 2 different angular scales (corresponding to the frequencies
! of the 2 extreme channels).
!
program map_refine
  use gkernel_interfaces
  use gildas_def
  !
  character(len=filename_length) :: namea, nameb, nameo
  character(len=12) :: ctype
  logical :: error
  !
  call gildas_open
  call gildas_char('FILE_A$',namea)
  call gildas_char('FILE_B$',nameb)
  call gildas_char('OUTPUT$',nameo)
  call gildas_char('TYPE$',ctype)
  call gildas_close
  !
  call sic_lower (ctype)
  if (ctype(1:1).ne.'.') ctype = '.'//ctype
  call sub_map_refine(namea,nameb,nameo,ctype,error)
  if (error) call sysexi(fatale)
  !
contains
!<FF>
subroutine sub_map_refine(namea,nameb,nameo,ctype,error)
  use gkernel_interfaces
  use gbl_message
  use image_def
  !
  character(len=*), intent(in) :: namea    ! First file name
  character(len=*), intent(in) :: nameb    ! Second file name
  character(len=*), intent(in) :: nameo    ! Output file name
  character(len=*), intent(in) :: ctype    ! Type of file name
  logical, intent(out) :: error
  !
  character(len=*), parameter :: rname='MAP_REFINE'
  !
  type(gildas) :: ha,hb,hout
  real, allocatable :: da(:,:,:)
  real, allocatable :: db(:,:,:)
  real, allocatable :: dout(:,:,:)
  !
  integer :: nx,ny,nv,nb,sblock,space_gildas,first,last
  integer :: iblock,iv,kv,ier
  real :: ra,rb
  real(8) :: fa,fb
  logical :: equal
  character(len=64) :: chain
  !
  call gildas_null (ha)
  call gildas_null (hb)
  call gildas_null (hout)
  !
  ! Read Headers
  call sic_parse_file(namea,' ',ctype,ha%file)
  call gdf_read_header (ha,error)
  if (error) return
  if (ctype.ne.'.beam') then
    if (ha%gil%dim(3).le.2) then
      call gag_message(seve%e,rname, &
        & 'no refinement needed for less than 3 channels')
      error = .true.
      return
    endif
  endif
  !
  call sic_parse_file(nameb,' ',ctype,hb%file)
  call gdf_read_header (hb,error)
  if (error) return
  !
  ! Compare shapes and axes (TBD)
  call gdf_compare_shape(ha,hb,equal)
  if (.not.equal) then
    call gag_message(seve%e,rname,'Images do not match')
    error = .true.
    return
  endif
  !
  ! Create output image
  nx = ha%gil%dim(1)
  ny = ha%gil%dim(2)
  if (ctype.eq.'.lmv') then
    nv = ha%gil%dim(3)
    nb = nv
  else if (ctype.eq.'.beam') then
    fa = (1-ha%gil%ref(3))*ha%gil%inc(3)+ha%gil%val(3)
    fb = (1-hb%gil%ref(3))*hb%gil%inc(3)+hb%gil%val(3)
    nv = nint (abs(fa-fb)/abs(hb%gil%inc(3)))+1
    nb = 1
    write (chain,'(a,i0,a)') 'Beam differ by ',nv,'channels'
    call gag_message(seve%i,rname,chain)
  else
    call gag_message(seve%e,rname,'Invalid image type '//ctype)
    error = .true.
    return
  endif
  !
  call gdf_copy_header(ha,hout,error)
  hout%gil%dim(3) = nv
  call sic_parse_file(nameo,' ',ctype,hout%file)
  call gdf_create_image(hout,error)
  if (error) return
  !
  ! Work by blocks
  space_gildas = 128
  ier = sic_getlog('SPACE_GILDAS',space_gildas)            ! Mega Bytes
  ! Number of channels per block
  sblock = max(int(256.0*space_gildas*1024.0)/(nx*ny),1)
  nb = min(sblock,nb)
  allocate(da(nx,ny,nb),db(nx,ny,nb),dout(nx,ny,sblock), &
      & stat=ier)
  if (ier.ne.0) then
    call gag_message(seve%e,rname,'Memory allocation error')
    error = .true.
    return
  endif
  !
  ! Read beams only once
  if (ctype.eq.'.beam') then
    call gdf_read_data(ha,da,error)
    if (error) return
    call gdf_read_data(hb,db,error)
    if (error) return
  endif
  !
  ! Loop on blocks for images
  first = 0
  do iblock = 1, nv, sblock
    last = min(first+sblock,nv)
    first = first+1
    !
    if (ctype.eq.'.lmv') then
      ha%blc(3) = first
      ha%trc(3) = last
      hb%blc(3) = first
      hb%trc(3) = last
      !
      call gdf_read_data(ha,da,error)
      if (error) return
      call gdf_read_data(hb,db,error)
      if (error) return
      !
      kv = 0
      do iv = first, last
        ra = real(nv-iv)/real(nv-1)
        rb = real(iv-1)/real(nv-1)
        !
        kv = kv+1
        dout(:,:,kv) = ra*da(:,:,kv) + rb*db(:,:,kv)
      enddo
    else
      kv = 0
      do iv = first, last
        ra = real(nv-iv)/real(nv-1)
        rb = real(iv-1)/real(nv-1)
        !
        kv = kv+1
        dout(:,:,kv) = ra*da(:,:,1) + rb*db(:,:,1)
      enddo
    endif
    !
    hout%blc(3) = first
    hout%trc(3) = last
    call gdf_write_data(hout,dout,error)
  enddo
  !
  call gdf_close_image(ha,error)
  call gdf_close_image(hb,error)
  call gdf_close_image(hout,error)
  !
end subroutine sub_map_refine
!
end program map_refine

subroutine write_sdm_calAtmosphere(error)
  !---------------------------------------------------------------------
  ! Write the calAtmosphere SDM table.
  !
  !
  !---------------------------------------------------------------------
  use gildas_def
  use gkernel_interfaces
  use sdm_CalAtmosphere
  use sdm_CalData
  use sdm_CalReduction
  use sdm_Antenna
  use sdm_SpectralWindow
  use sdm_Enumerations
  ! Dummy
  logical error
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  character*20 version
  ! Local
  type(CalAtmosphereRow) :: caRow
  type(CalAtmosphereKey) :: caKey
  type(CalAtmosphereOpt) :: caOpt
  type(CalDataRow) :: cdRow
  type(CalDataKey) :: cdKey
  type(CalReductionRow) :: crRow
  type(CalReductionKey) :: crKey
  type(AntennaKey) :: aKey
  type(AntennaRow) :: aRow
  type(SpectralWindowRow) :: swRow
  type(SpectralWindowKey) :: swKey
  type(SpectralWindowOpt) :: swOpt
  integer  :: sig, ima, nfreq, ia, isb, ier, numChan,   &
    numReceptor, ip, l, lAmbient, lCold
  integer  :: ireturn, sdm_addCalDataRow, sdm_addCalReductionRow,   &
    sdm_addCalAtmosphereRow
  logical  :: present
  character  :: sdmTable*16, bureRecName(4)*5
  parameter (sdmTable = 'calAtmosphere')
  data bureRecName /'3mm','2mm','1.3mm','0.8mm'/
  !---------------------------------------------------------------------
  include 'clic_version.inc'
  call sdmMessage(1,1,sdmTable ,'starting...')
  !
  ! for the time being ...
  !
  ! cal data table:
  cdRow%numScan = 1
  call allocCalDataRow(cdRow, error)
  if (error) return
  !
  cdRow%scanSet(1) = r_scan
  cdRow%calType = CalType_CAL_ATMOSPHERE
  cdRow%calDataType = CalDataOrigin_TOTAL_POWER
  !     this is not stricly true, but we lost track of the time of actual
  !     load observations...
  cdRow%startTimeObserved = time_interval(1)
  cdRow%endTimeObserved = time_interval(1)+time_interval(2)
  l = lenc(execBlock_uid)
  cdRow%execBlockUID = '<EntityRef entityId="' //   &
    execBlock_uid(1:l)//   &
    '" partId="X00000000" entityTypeName="ExecBlock" '//   &
    'documentVersion="1"/>'//char(0)
  !print *, 'call addCalDataRow(cdKey, cdRow, error)'
  call addCalDataRow(cdKey, cdRow, error)
  if (error) goto 99
  !
  caKey%CalDataId = cdKey%CalDataId
  !
  ! cal reduction table:
  !
  crRow%numApplied = 1
  crRow%numParam = 2
!!!   call allocCalReductionRow(crRow, crRow%numApplied, crRow%numParam,   &
!!!     1, error)
  crRow%numInvalidConditions = 1
  call allocCalReductionRow(crRow, error)
  if (error) goto 99
  !!crRow%calAppliedArray(1) = 'None'
  crRow%appliedCalibrations(1) = 'None'
  crRow%timeReduced = time_Interval(1) + time_Interval(2)
  crRow%messages = 'None'
  crRow%software = 'CLIC'
  crRow%softwareVersion = version
  ! Nothing better ? should be none...
  crRow%invalidConditions(1) =   &
    InvalidatingCondition_ANTENNA_DISCONNECT
  do isb = 1, r_lnsb
    crRow%appliedCalibrations(1) = 'None'
    !! crRow%calAppliedArray(1) = 'None'
    if (isb.eq.1) then
      crRow%paramSet(1) = 'USB'
    elseif (isb.eq.2) then
      crRow%paramSet(1) = 'LSB'
    endif
    crRow%paramSet(2)='???'
    if ((r_nrec.gt.0).and.(r_nrec.le.4)) then
      crRow%paramSet(2)=bureRecName(r_nrec)
    endif
    !print *, 'call addCalReductionRow(crKey, crRow, error)'
    call addCalReductionRow(crKey, crRow, error)
    if (error) goto 99
    !
    caKey%CalReductionId = crKey%CalReductionId
    ! these are ordered properly...
    caKey%receiverBand = ReceiverBand_BURE_01 + (r_nrec-1)
    !
    ! cal atmosphere  table:
    !
    carow%startValidTime = cdRow%startTimeObserved
    ! assumed valid one hour
    carow%endValidTime = cdRow%endTimeObserved + 3600d9
    carow%syscalType = SyscalMethod_TEMPERATURE_SCALE
    carow%groundPressure = r_pamb*1d5  ! convert in Pascals
    carow%groundTemperature = r_tamb
    carow%groundRelHumidity = r_humid
    !
    ! the spectra here refer to the continuum detector since it is used for derivation.
    ! so for each antenna we have two results, one for LSB and one for USB.
    ! the number of frequencies each time is 1.
    numChan = 1
    if (r_isb.eq.1) then
      sig = 1
      ima = 2
    else
      sig = 2
      ima = 1
    endif
    !
    caRow%numFreq = 1
    caRow%numReceptor = r_npol_rec
    caRow%numLoad = 2
    lAmbient=2
    lCold=1
    !print *, 'call allocCalAtmosphereRow(caRow, error)'
    call allocCalAtmosphereRow(caRow, error)
    if (error) return
    call allocCalAtmosphereOpt(caRow, caOpt, error)
    if (error) return
    !
    do ia=1, r_nant
      !
      ! Get the ANtenna Name in Antenna Table:
      aKey%antennaId = Antenna_id(ia)
      !print *, 'call allocAntennaRow( aRow, error)'
      call allocAntennaRow( aRow, error)
      if (error) return
      call getAntennaRow(aKey, aRow, error) 
      if (error) return
      caKey%antennaName = aRow%name
      !
      !
      !     Get frequency range from SpectralWindow Table;
      !     totPowSpectralWindow must point to a single channel spectral
      !     window.
      do ip=1, r_npol_rec
        if (ip.eq.1) then
          caRow%polarizationTypes(ip) = PolarizationType_X
        else
          caRow%polarizationTypes(ip) = PolarizationType_Y
        endif
      enddo
      !     might be just as well b ethe reverse...
      !
      ! Remember all this is single-polarization !!!
      !
      ! not quite now ...
      swKey%spectralWindowId =  totPowSpectralWindow_Id(isb)
      !print *, 'call getSpectralWindowRow(swKey, swRow, error)'
      call getSpectralWindowRow(swKey, swRow, error)
      if (error) goto 99
!!!       caRow%frequencyRange(1) = swRow%chanFreq(1) -   &
!!!         swRow%chanWidth(1)/2
!!!       caRow%frequencyRange(2) = swRow%chanFreq(1) +   &
!!!         swRow%chanWidth(1)/2
!!!       caRow%frequencySpectrum(1) = swRow%chanFreq(1)
      !print *, 'call getSpectralWindowChanFreqStart(swKey, swOpt, error)'
      call getSpectralWindowChanFreqStart(swKey, swOpt, present, error)
      !print *, 'call getSpectralWindowChanWidth(swKey, swOpt, error)'
      call getSpectralWindowChanWidth(swKey, swOpt, present, error)
      if (error) goto 99
! these are 0?
      caRow%frequencyRange(1) = swOpt%chanFreqStart - swOpt%chanWidth/2
      caRow%frequencyRange(2) = swOpt%chanFreqStart + swOpt%chanWidth/2
      caRow%frequencySpectrum(1) = swOpt%chanFreqStart
!!!
      do ip=1, r_npol_rec
        carow%tRecSpectrum(1,ip) = r_trec(ip,ia)
        carow%tRec(ip) = r_trec(ip,ia)
        carow%water(ip) = r_h2omm(ip,ia)
        carow%waterError(ip) = 0.0 ! not in Bure data
        carow%powerSkySpectrum(1,ip) = r_csky(ip, ia)
        carow%powerLoadSpectrum(1,ip,lambient) = r_cchop(ip, ia)
        carow%powerLoadSpectrum(1,ip,lcold) = r_ccold(ip, ia)
       
        if (isb.eq.sig) then
          carow%tSysSpectrum(1,ip) = r_tsyss(ip,ia)
          carow%tSys(ip) = r_tsyss(ip,ia)
          carow%tAtmSpectrum(1,ip) = r_tatms(ip,ia)
          carow%tAtm(ip) = r_tatms(ip,ia)
          caopt%sbGainSpectrum(1,ip) = 1./(1.+r_gim(ip,ia))
          caopt%sbGain(ip) = 1./(1.+r_gim(ip,ia))
          carow%tauSpectrum(1,ip) = r_taus(ip,ia)
          carow%tau(ip) = r_taus(ip,ia)
        elseif (isb.eq.ima) then
          carow%tSysSpectrum(1,ip) = r_tsysi(ip,ia)
          carow%tSys(ip) = r_tsysi(ip,ia)
          carow%tAtmSpectrum(1,ip) = r_tatmi(ip,ia)
          carow%tAtm(ip) = r_tatmi(ip,ia)
          caopt%sbGainSpectrum(ip,1) = r_gim(ip,ia)/(1.+r_gim(ip,ia))
          caopt%sbGain(ip) = r_gim(ip,ia)/(1.+r_gim(ip,ia))
          carow%tauSpectrum(1,ip) = r_taui(ip,ia)
          carow%tau(ip) = r_taui(ip,ia)
        endif
        caopt%forwardEfficiency(ip) = r_feff(ip,ia)
        carow%forwardEffSpectrum(1,ip) = r_feff(ip,ia)
      enddo
      !print *, 'call addCalAtmosphereRow(cakey, carow, error)'
      call addCalAtmosphereRow(cakey, carow, error)
      if (error) goto 99
      call addCalAtmosphereForwardEfficiency(cakey, caopt, error)
      if (error) goto 99
      !print *, 'call addCalAtmosphereSbGain(cakey, carow, error)'
      call addCalAtmosphereSbGain(cakey, caopt, error)
      if (error) goto 99
      !print *, 'call addCalAtmosphereSbGainSpectrum(cakey, caopt, error)'
      call addCalAtmosphereSbGainSpectrum(cakey, caopt, error)
      if (error) goto 99
    enddo ! antenna
  enddo   ! side band
  call sdmMessage(1,1,sdmTable ,'Written.')
99 return
end subroutine write_sdm_calAtmosphere
!---------------------------------------------------------------------
subroutine get_sdm_calAtmosphere(error)
  use gkernel_interfaces
  !---------------------------------------------------------------------
  !     Read the calAtmosphere SDM table, and associated cal_data and
  !     cal_reduction tables...
  !
  !
  !---------------------------------------------------------------------
  use gildas_def
  use sdm_CalAtmosphere
  !      use sdm_SpectralWindow
  use sdm_Antenna
  ! Dummy
  logical error
  ! Global variables:
  include 'clic_parameter.inc'
  include 'clic_par.inc'
  include 'clic_dheader.inc'
  include 'clic_clic.inc'
  include 'clic_constant.inc'
  include 'gbl_memory.inc'
  include 'sdm_identifiers.inc'
  character*20 version
  ! Local
  type(CalAtmosphereRow) :: caRow
  type(CalAtmosphereOpt) :: caOpt
  type(CalAtmosphereKey), allocatable  :: caKeyList(:)
  !$$$      type(SpectralWindowKey) :: swKey
  !$$$      type(SpectralWindowRow) :: swRow
  type(AntennaKey) :: aKey
  type(AntennaRow) :: aRow
  integer mscan, mcalApp, mfreq, mparam, mreceptors
  parameter (mscan=10, mcalApp=10, mparam=10, mfreq = 1, mreceptors   &
    =2)
  integer sig, ima, nreceptors, nfreq,   &
    ia, isb, ier , numChan, numReceptor
  character sdmTable*16
  logical  :: present
  real*8 fmin, fmax, freq
  !
  parameter (sdmTable = 'calAtmosphere')
  integer atmSize, lenz, i, l, l1, ip
  integer imax, eps(2)
  integer*8 tmin, tmax
  data eps /1, -1/
  !---------------------------------------------------------------------
  call sdmMessage(1,1,sdmTable ,'starting...')
  !
  !$$$      call allocSpectralWindowRow(swRow, mch, error)
  !$$$      if (error) goto 99
  !
  !     cal data table is ignored...
  !
  !     read the calAtmosphere
  call getCalAtmosphereTableSize(atmSize, error)
  if (error) goto 99
  if (atmSize.le.0) then
    call sdmmessage(2,2,sdmTable,'No table present')
    goto 90
  endif
  allocate(caKeyList(atmSize), stat=ier)
  if (ier.ne.0) then
    call sdmmessageI(8,4,sdmTable,'Memory allocation error: ier '   &
      ,ier)
    error = .true.
    goto 99
  endif
  call getCalAtmosphereKeys(atmSize, caKeyList, error)
  if (error) goto 99
  !
  !     set dimension parameters
  numChan = 1
  numReceptor = r_npol_rec
  !!call allocCalAtmosphereRow(caRow, numChan, numReceptor, error)
  call allocCalAtmosphereRow(caRow, error)
  if (error) goto 99
  !
  !     find the latest one one that applies:
  !
  !     Loop on antennas and side bands.
  do ia = 1, r_nant
    ! get antenna name in antenna table (in aRow%name)
    aKey%antennaId = Antenna_id(ia)
    call getAntennaRow(aKey, aRow, error)
    if (error) return
    l1 = lenc(aRow%name)
    aRow%name = aRow%name(1:l1)
    !
    do isb = 1, 2
      !c            if (new_receivers) then
      !     this actually depends on the frequency setup. We should do better.
      !               fmin = 1d6*min(r_flo1+eps(isb)*4200.,r_flo1+eps(isb)*7800
      !     &              .)
      !               fmax = 1d6*max(r_flo1+eps(isb)*4200.,r_flo1+eps(isb)*7800
      !     &              .)
      !            else
      !     at this point we have a single tsys for each side band in CLIC. We
      !     estimate it applies to the interval of 100-800 MHz IF2.
      fmin = 1d6*min(r_flo1+eps(isb)*(r_flo2(1)-100.),r_flo1   &
        +eps(isb)*(r_flo2(1)-800.))
      fmax = 1d6*max(r_flo1+eps(isb)*(r_flo2(1)-100.),r_flo1   &
        +eps(isb)*(r_flo2(1)-800.))
      !            endif
      tmin = time_Interval(1)
      tmax = time_Interval(1)
      imax = -1
      do i = 1, atmSize
        l = lenc(caKeyList(i)%antennaName)
        if (caKeyList(i)%antennaName(1:l) .eq. aRow%name(1:l1))   &
          then
          call GetCalAtmosphereRow(caKeyList(i), caRow, error)
          if (error) goto 99
          !
          ! at this point we need to read the sp window to get the frequency
          ! SS2: no,  we have it here now.
          ! use the mid-range point. We could be more strict and check the limits.
          freq = (caRow%frequencyRange(1) +   &
            caRow%frequencyRange(2)) /2.
          if ((caRow%startValidTime.le.tmin .and.   &
            caRow%endValidTime.ge.tmax) .and. (freq .gt. fmin   &
            ) .and. (freq .le. fmax)) then
            tmax = caRow%endValidTime
            imax = i
          endif
        endif
      enddo
      if (imax.lt.0) then
        call sdmMessage(8,2,sdmTable   &
          ,'No valid atmosphere calibration!')
        imax = 1
      endif
      call GetCalAtmosphereRow(caKeyList(imax), caRow, error)
      if (error) return
      r_pamb = caRow%groundPressure/1d5
      r_tamb = caRow%groundTemperature
      r_humid = caRow%groundRelHumidity
      call GetCalAtmosphereSbGainSpectrum(caKeyList(imax), caOpt, present, error)
      if (error) return
      !
      !     signal band:
      !
      do ip = 1, r_npol_rec
        !     note we use 1 receptor in CLIC - no check...
        if (r_isb.eq.eps(isb)) then
          r_trec(ip,ia) = caRow%tRecSpectrum(ip,1)
          r_tsyss(ip,ia) = caRow%tSysSpectrum(ip,1)
          r_tatms(ip,ia) = caRow%tAtmSpectrum(ip,1)
          r_taus(ip,ia) = caRow%tauSpectrum(ip,1)
          !!r_gim(ip,ia) = 1./caRow%sbGainSpectrum(ip,1) - 1
          r_gim(ip,ia) = 1./caOpt%sbGainSpectrum(ip,1) - 1
          r_feff(ip,ia) =    caRow%forwardEffSpectrum(ip,1)
          r_totscale(ip,ia) =  1.0
        !
        !     image band:
        else
          r_tsysi(ip,ia) = caRow%tSysSpectrum(ip,1)
          r_tatmi(ip,ia) = caRow%tAtmSpectrum(ip,1)
          r_taui(ip,ia) = caRow%tauSpectrum(ip,1)
        endif
      enddo
    enddo
  enddo
90 call sdmMessage(1,1,sdmTable ,'Read.')
  !
99 if (allocated(caKeyList)) then
    deallocate(caKeyList, stat=ier)
    if (ier.ne.0) then
      call sdmmessageI(8,4,sdmTable   &
        ,'Memory deallocation error 1 ier ',ier)
      error = .true.
    endif
  endif
  return
end subroutine get_sdm_calAtmosphere
!---------------------------------------------------------------------
!!! subroutine allocCalAtmosphereRow(row, numChan, numReceptor, error   &
!!!     )
!!!   use sdm_CalAtmosphere
!!!   type(CalAtmosphereRow) :: row
!!!   integer :: numChan, numReceptor, ier
!!!   logical :: error
!!!   character, parameter :: sdmTable*16 = 'calAtmosphere'
!!!   ! frequencyRange
!!!   if (allocated(row%frequencyRange)) then
!!!     deallocate(row%frequencyRange, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%frequencyRange(2), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! frequencySpectrum
!!!   if (allocated(row%frequencySpectrum)) then
!!!     deallocate(row%frequencySpectrum, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%frequencySpectrum(numChan), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! tRecSpectrum
!!!   if (allocated(row%tRecSpectrum)) then
!!!     deallocate(row%tRecSpectrum, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%tRecSpectrum(numReceptor, numChan), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! tSysSpectrum
!!!   if (allocated(row%tSysSpectrum)) then
!!!     deallocate(row%tSysSpectrum, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%tSysSpectrum(numReceptor, numChan), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! tAtmSpectrum
!!!   if (allocated(row%tAtmSpectrum)) then
!!!     deallocate(row%tAtmSpectrum, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%tAtmSpectrum(numReceptor, numChan), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! tauSpectrum
!!!   if (allocated(row%tauSpectrum)) then
!!!     deallocate(row%tauSpectrum, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%tauSpectrum(numReceptor, numChan), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! sbGainSpectrum
!!!   if (allocated(row%sbGainSpectrum)) then
!!!     deallocate(row%sbGainSpectrum, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%sbGainSpectrum(numReceptor, numChan), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! forwardEffSpectrum
!!!   if (allocated(row%forwardEffSpectrum)) then
!!!     deallocate(row%forwardEffSpectrum, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%forwardEffSpectrum(numReceptor, numChan), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! polarizationTypes
!!!   if (allocated(row%polarizationTypes)) then
!!!     deallocate(row%polarizationTypes, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%polarizationTypes(numReceptor), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! sbGain
!!!   !$$$      if (allocated(row%sbGain)) then
!!!   !$$$         deallocate(row%sbGain, stat=ier)
!!!   !$$$         if (ier.ne.0) goto 98
!!!   !$$$      endif
!!!   !$$$      allocate(row%sbGain(numReceptor), stat=ier)
!!!   !$$$      if (ier.ne.0) goto 99
!!!   ! forwardEfficiency
!!!   !$$$      if (allocated(row%forwardEfficiency)) then
!!!   !$$$         deallocate(row%forwardEfficiency, stat=ier)
!!!   !$$$         if (ier.ne.0) goto 98
!!!   !$$$      endif
!!!   !$$$      allocate(row%forwardEfficiency(numReceptor), stat=ier)
!!!   !$$$      if (ier.ne.0) goto 99
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end
!---------------------------------------------------------------------
!!! subroutine allocCalDataRow(row, numScan, error)
!!!   use sdm_CalData
!!!   type(CalDataRow) :: row
!!!   integer :: numScan, ier
!!!   logical :: error
!!!   character, parameter :: sdmTable*8 = 'calData'
!!!   !
!!!   ! scanSet
!!!   if (allocated(row%scanSet)) then
!!!     deallocate(row%scanSet, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%scanSet(numScan), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end
!---------------------------------------------------------------------
!!! subroutine allocCalReductionRow(row, numApplied, numParam,   &
!!!     numInvalidConditions, error)
!!!   use sdm_CalReduction
!!!   type(CalReductionRow) :: row
!!!   integer :: numApplied, numParam, numInvalidConditions, ier
!!!   logical :: error
!!!   character, parameter :: sdmTable*8 = 'calReduction'
!!!   ! calAppliedArray
!!!   if (allocated(row%calAppliedArray)) then
!!!     deallocate(row%calAppliedArray, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%calAppliedArray(numApplied), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! paramSet
!!!   if (allocated(row%paramSet)) then
!!!     deallocate(row%paramSet, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%paramSet(numParam), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   ! InvalidConditions
!!!   if (allocated(row%InvalidConditions)) then
!!!     deallocate(row%InvalidConditions, stat=ier)
!!!     if (ier.ne.0) goto 98
!!!   endif
!!!   allocate(row%InvalidConditions(numInvalidConditions), stat=ier)
!!!   if (ier.ne.0) goto 99
!!!   return
!!!   !
!!! 98 call sdmmessageI(8,4,sdmTable ,'Deallocation error ier ',ier)
!!!   error = .true.
!!!   return
!!!   !
!!! 99 call sdmmessageI(8,4,sdmTable ,'Allocation error ier ',ier)
!!!   error = .true.
!!!   return
!!! end

###########################################################################
#
# Shell verification. Try to be robust => very simple.
#
GAG_SHELL_TEST="shell test" || echo "source-gag.sh error: You must be under a sh-compatible shell!"
GAG_SHELL_TEST="shell test" || exit 1
unset GAG_SHELL_TEST
#
###########################################################################
#
# Main function definition
#
gagsou() {
    #
    # Variable and function definitions
    #
    GAGSOU_AUTHOR='J. Pety <pety@iram.fr>'
    GAGSOU_VERSION=`echo '$Revision$' | cut -d' ' -f2`
    GAGSOU_PROJECT='GILDAS  <http://www.iram.fr/IRAMFR/GILDAS>'
    GAGSOU_PROGNAME="gagsou"
    #
    gagsou_usage() {
	cat <<EOF 1>&2

Source the GILDAS environment of either the source tree (defined by
\$gagsrcdir) or the executable tree (defined by \$gagexedir). When the
\$gaghome enviroment variable exists, $GAGSOU_PROGNAME first defines the
\$gagsrcdir or the \$gagexedir using standard conventions (see build
script). Else $GAGSOU_PROGNAME assumes that \$gagsrcdir or \$gagexedir have
been defined elsewhere by the user. The default behavior (ie neither -e or
-s is set) is to source the executable tree as this facility is intended
first for users.

usage: $GAGSOU_PROGNAME [options] [version]

options:
  -h          Show this help page
  -v          Show version information
  -c compiler Replace default compiler by this one
  -o config   Add config to the config list
  -n config   Remove config from the default config list
  -u use-dir  Set gildas directory to use as a complement of local Gildas.
  -d version  On-the-fly selection of a default version. Useful in aliases.
  -e          Load executable tree environment
  -s          Load source     tree environment
  -m          Do not load environment (just define \$gagsrcdir and
		  \$gagexedir if needed)

EOF
	gagsou_clean
    }
    #
    gagsou_showversion() {
	echo
	echo "$GAGSOU_PROGNAME version $GAGSOU_VERSION, by $GAGSOU_AUTHOR"
	echo "Project: $GAGSOU_PROJECT"
	echo
	gagsou_clean
    }
    #
    gagsou_message() {
	echo "$1"
    }
    #
    gagsou_error() {
	echo  1>&2
	echo "Error: $1" 1>&2
	echo  1>&2
	gagsou_clean
	return 1
    }
    #
    gagsou_clean() {
	unset IN_COMPILER IN_CONFIG IN_USE IN_VERSION DEF_VERSION
	unset GAGSOU_AUTHOR GAGSOU_PROJECT GAGSOU_PROGNAME
	unset gagsou_usage gagsou_showversion gagsou_message gagsou_error gagsou_clean
	unset dosource executable
    }
    #
    #######################################################################
    #
    # Option parsing
    #
    IN_COMPILER="default" # Default compiler will be setup by gagdefsys
    IN_CONFIG=            # Default config will be setup by gagdefsys
    IN_USE="default"      # Default use-dir is empty
    DEF_VERSION="default" # Default version will be setup by gagdefver
    dosource=1            # Default is to source environment
    executable=1          # Default is to select the executable tree.
    temp=`getopt "hvesmc:o:n:u:d:" "$@"`
    if [ $? -ne 0 ]; then gagsou_usage; return 2; fi
    eval set -- "$temp"
    unset temp
    while [ $1 != -- ]; do
	case $1 in
	-c) IN_COMPILER=$2; shift ;;
	-o) IN_CONFIG="$IN_CONFIG -o $2"; shift;;
	-n) IN_CONFIG="$IN_CONFIG -n $2"; shift;;
	-u) IN_USE=$2; shift ;;
	-d) DEF_VERSION=$2; shift ;;
	-e) executable=1 ;;
	-s) executable=0 ;;
	-m) dosource=0 ;;
	-v) gagsou_showversion; return 0 ;;
	-h) gagsou_usage; return 0 ;;
	esac
	shift # Next flag
    done
    shift # Skip double dash
    case $# in
	0) IN_VERSION=$DEF_VERSION ;;
	1) IN_VERSION=$1 ;;
	*) gagsou_usage; return 2 ;;
    esac
    set abc; shift # This line to avoid remanence effect in a portable way
    #
    #######################################################################
    #
    # Define gagadmdir
    #
    if [ -d "$gaghome/gildas-admin" ]; then
	gagadmdir=$gaghome/gildas-admin
    elif [ -d "$gagsrcdir/admin" ]; then
	gagadmdir=$gagsrcdir/admin
    else
	gagsou_error "Failed to define \$gagadmdir. Please define it by hand." || return $?
    fi
    export gagadmdir
    #
    # Define gagsrcdir, gagexedir and GAG_ROOT_DIR only when gaghome exists.
    # In all cases, try to source the environment.
    #
    if [ -z "$gaghome" ]; then
	#
	# Define system
	#
	. $gagadmdir/define-system.sh                      # Load gagdefsys function
	if [ $executable -eq 1 ]; then
	    gagdefsys -c $IN_COMPILER $IN_CONFIG || return $?  # Use it
	else
	    gagdefsys -s -c $IN_COMPILER $IN_CONFIG || return $?  # Use it
	fi
	unset gagdefsys                                    # Remove gagdefsys function
	#
	# Setup environment
	#
	if [ $executable -eq 1 ]; then
	    if [ -d "$gagexedir/$GAG_EXEC_SYSTEM" ]; then
		if [ $dosource -eq 1 ]; then
		    GAGRC=$gagexedir/etc/bash_profile
		    if [ -e "$GAGRC" ]; then
			source $GAGRC
		    else
			gagsou_error "Configuration file $GAGRC does not exist" || return $?
		    fi
		fi
	    else
		gagsou_error "No GILDAS version: $GAG_EXEC_SYSTEM in $gagexedir" || return $?
	    fi
	else
	    if [ -d "$gagsrcdir" ]; then
		if [ $dosource -eq 1 ]; then
                    source $gagadmdir/gildas-env.sh -c "$IN_COMPILER" $IN_CONFIG -u "$IN_USE" || return $?
		fi
	    else
		gagsou_error "No GILDAS version in $gagsrcdir" || return $?
	    fi
	fi
    else
	#
	# Define system and version
	#
	. $gagadmdir/define-system.sh                     # Load gagdefsys function
	. $gagadmdir/define-version.sh                    # Load gagdefver function
	if [ $executable -eq 1 ]; then
	    gagdefsys -c $IN_COMPILER $IN_CONFIG || return 1  # Use them
	else
	    gagdefsys -s -c $IN_COMPILER $IN_CONFIG || return 1  # Use them
	fi
	gagdefver $IN_VERSION -n || return 1              # Use them
	unset gagdefsys gagdefver                         # Remove them
	#
	# Setup environment
	#
	if [ $executable -eq 1 ]; then
	    ogagexedir=$gagexedir
	    if [ -h "$EXEDIR" ] && [ -e "$EXEDIR" ]; then
		gagexedir=`(\cd -P $EXEDIR; \pwd;)`  # Translate link to absolute path
	    else
		gagexedir=$EXEDIR
	    fi
	    if [ -d "$gagexedir/$GAG_EXEC_SYSTEM" ]; then
		GAG_ROOT_DIR=$gagexedir
		if [ $dosource -eq 1 ]; then
		    GAGRC=$gagexedir/etc/bash_profile
		    if [ -e "$GAGRC" ]; then
			source $GAGRC
		    else
			gagsou_error "Configuration file $GAGRC does not exist" || return $?
		    fi
		fi
	    else
		gagsou_error "No GILDAS version: $GAG_VERS ($GAG_EXEC_SYSTEM) in $gaghome" || return $?
	    fi
	else
	    ogagsrcdir=$gagsrcdir
	    if [ -h "$SRCDIR" ] && [ -e "$SRCDIR" ]; then
		gagsrcdir=`(\cd -P $SRCDIR; \pwd;)` # Translate link to absolute path
	    else
		gagsrcdir=$SRCDIR
	    fi
	    if [ -d "$gagsrcdir" ]; then
		if [ $dosource -eq 1 ]; then
		    source $gagadmdir/gildas-env.sh -c "$IN_COMPILER" $IN_CONFIG -u "$IN_USE" || return $?
		fi
	    else
		gagsou_error "No GILDAS version: $GAG_VERS ($GAG_EXEC_SYSTEM) in $gaghome" || return $?
	    fi
	    export ogagsrcdir gagsrcdir
	fi
    fi
    #
    #######################################################################
    #
    # Cleaning
    #
    gagsou_clean
}
#
###########################################################################
#
gagsou $@
set abc; shift # This line to avoid remanence effect in a portable way
#
###########################################################################
